/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/platform","vs/base/common/path","vs/base/common/errors","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/types","vs/base/common/resources","vs/platform/log/common/log","vs/base/common/network","vs/base/node/pfs","vs/base/common/strings","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/buffer","vs/base/common/objects","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/registry/common/platform","vs/base/common/json","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/configuration/common/configurationRegistry","vs/base/common/map","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","child_process","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/codicons","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ne=function(Y){for(var e=[],S=0,L=Y.length;S<L;S++)e[S]=te[Y[S]];return e};define(te[87],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function S(L,R){if(!L)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=S}),define(te[63],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const S=Object.prototype.hasOwnProperty;function L(n){const p=[];for(let m in n)S.call(n,m)&&p.push(n[m]);return p}e.values=L;function R(n,p){for(let m in n)if(S.call(n,m)&&p({key:m,value:n[m]},function(){delete n[m]})===!1)return}e.forEach=R;function k(n,p){const m=Object.create(null);for(const d of n){const h=p(d);let C=m[h];C||(C=m[h]=[]),C.push(d)}return m}e.groupBy=k;function A(n){const p=Object.create(null);return n&&n.forEach((m,d)=>{p[d]=m}),p}e.fromMap=A;function P(n,p){const m=[],d=[];for(let h of n)p.has(h)||m.push(h);for(let h of p)n.has(h)||d.push(h);return{removed:m,added:d}}e.diffSets=P;function v(n,p){const m=[],d=[];for(let[h,C]of n)p.has(h)||m.push(C);for(let[h,C]of p)n.has(h)||d.push(C);return{removed:m,added:d}}e.diffMaps=v;class w{constructor(){this.map=new Map}add(p,m){let d=this.map.get(p);d||(d=new Set,this.map.set(p,d)),d.add(m)}delete(p,m){const d=this.map.get(p);!d||(d.delete(m),d.size===0&&this.map.delete(p))}forEach(p,m){const d=this.map.get(p);!d||d.forEach(m)}}e.SetMap=w}),define(te[64],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function S(A){return(P,v,w)=>{let n=null,p=null;if(typeof w.value=="function"?(n="value",p=w.value):typeof w.get=="function"&&(n="get",p=w.get),!p)throw new Error("not supported");w[n]=A(p,v)}}e.createDecorator=S;function L(A,P,v){let w=null,n=null;if(typeof v.value=="function"?(w="value",n=v.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(w="get",n=v.get),!n)throw new Error("not supported");const p=`$memoize$${P}`;v[w]=function(...m){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,m)}),this[p]}}e.memoize=L;function R(A,P,v){return S((w,n)=>{const p=`$debounce$${n}`,m=`$debounce$result$${n}`;return function(...d){this[m]||(this[m]=v?v():void 0),clearTimeout(this[p]),P&&(this[m]=P(this[m],...d),d=[this[m]]),this[p]=setTimeout(()=>{w.apply(this,d),this[m]=v?v():void 0},A)}})}e.debounce=R;function k(A,P,v){return S((w,n)=>{const p=`$throttle$timer$${n}`,m=`$throttle$result$${n}`,d=`$throttle$lastRun$${n}`,h=`$throttle$pending$${n}`;return function(...C){if(this[m]||(this[m]=v?v():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),P&&(this[m]=P(this[m],...C)),this[h])return;const D=this[d]+A;D<=Date.now()?(this[d]=Date.now(),w.apply(this,[this[m]]),this[m]=v?v():void 0):(this[h]=!0,this[p]=setTimeout(()=>{this[h]=!1,this[d]=Date.now(),w.apply(this,[this[m]]),this[m]=v?v():void 0},D-Date.now()))}})}e.throttle=k}),define(te[9],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=S,e.errorHandler=new S;function L(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=L;function R(c){v(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=R;function k(c){v(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=k;function A(c){if(c instanceof Error){let{name:t,message:r}=c;const i=c.stacktrace||c.stack;return{$isError:!0,name:t,message:r,stack:i}}return c}e.transformErrorForSerialization=A;const P="Canceled";function v(c){return c instanceof Error&&c.name===P&&c.message===P}e.isPromiseCanceledError=v;class w extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=w;function n(){const c=new Error(P);return c.name=c.message,c}e.canceled=n;function p(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=p;function m(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=m;function d(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function h(c){const t=new Error(`${c} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function C(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=C;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class I extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=I;function g(c){const t=c;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=g;function s(c,t=Object.create(null)){const r=new Error(c);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=s}),define(te[22],ne([0,1,9]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(F,U=0){return F[F.length-(1+U)]}e.tail=L;function R(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=R;function k(F,U,z=(W,K)=>W===K){if(F===U)return!0;if(!F||!U||F.length!==U.length)return!1;for(let W=0,K=F.length;W<K;W++)if(!z(F[W],U[W]))return!1;return!0}e.equals=k;function A(F,U,z){let W=0,K=F.length-1;for(;W<=K;){const $=(W+K)/2|0,G=z(F[$],U);if(G<0)W=$+1;else if(G>0)K=$-1;else return $}return-(W+1)}e.binarySearch=A;function P(F,U){let z=0,W=F.length;if(W===0)return 0;for(;z<W;){const K=Math.floor((z+W)/2);U(F[K])?W=K:z=K+1}return z}e.findFirstInSorted=P;function v(F,U,z){if(F=F|0,F>=U.length)throw new TypeError("invalid index");let W=U[Math.floor(U.length*Math.random())],K=[],$=[],G=[];for(let X of U){const Z=z(X,W);Z<0?K.push(X):Z>0?$.push(X):G.push(X)}return F<K.length?v(F,K,z):F<K.length+G.length?G[0]:v(F-(K.length+G.length),$,z)}e.quickSelect=v;function w(F,U){const z=[];let W;for(const K of F.slice(0).sort(U))!W||U(W[0],K)!==0?(W=[K],z.push(W)):W.push(K);return z}e.groupBy=w;function n(F,U,z){const W=[];function K(X,Z,ee){if(Z===0&&ee.length===0)return;const se=W[W.length-1];se&&se.start+se.deleteCount===X?(se.deleteCount+=Z,se.toInsert.push(...ee)):W.push({start:X,deleteCount:Z,toInsert:ee})}let $=0,G=0;for(;;){if($===F.length){K($,0,U.slice(G));break}if(G===U.length){K($,F.length-$,[]);break}const X=F[$],Z=U[G],ee=z(X,Z);ee===0?($+=1,G+=1):ee<0?(K($,1,[]),$+=1):ee>0&&(K($,0,[Z]),G+=1)}return W}e.sortedDiff=n;function p(F,U,z){const W=n(F,U,z),K=[],$=[];for(const G of W)K.push(...F.slice(G.start,G.start+G.deleteCount)),$.push(...G.toInsert);return{removed:K,added:$}}e.delta=p;function m(F,U,z){if(z===0)return[];const W=F.slice(0,z).sort(U);return h(F,U,W,z,F.length),W}e.top=m;function d(F,U,z,W,K){return z===0?Promise.resolve([]):new Promise(($,G)=>{(async()=>{const X=F.length,Z=F.slice(0,z).sort(U);for(let ee=z,se=Math.min(z+W,X);ee<X;ee=se,se=Math.min(se+W,X)){if(ee>z&&await new Promise(ue=>setTimeout(ue)),K&&K.isCancellationRequested)throw(0,S.canceled)();h(F,U,Z,ee,se)}return Z})().then($,G)})}e.topAsync=d;function h(F,U,z,W,K){for(const $=z.length;W<K;W++){const G=F[W];if(U(G,z[$-1])<0){z.pop();const X=P(z,Z=>U(G,Z)<0);z.splice(X,0,G)}}}function C(F){return F.filter(U=>!!U)}e.coalesce=C;function D(F){let U=0;for(let z=0;z<F.length;z++)F[z]&&(F[U]=F[z],U+=1);F.length=U}e.coalesceInPlace=D;function b(F,U,z){F.splice(z,0,F.splice(U,1)[0])}e.move=b;function I(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=I;function g(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=g;function s(F,U){if(!U)return F.filter((W,K)=>F.indexOf(W)===K);const z=Object.create(null);return F.filter(W=>{const K=U(W);return z[K]?!1:(z[K]=!0,!0)})}e.distinct=s;function c(F){const U=new Set;return F.filter(z=>U.has(z)?!1:(U.add(z),!0))}e.distinctES6=c;function t(F){const U=Object.create(null);return z=>{const W=F(z);return U[W]?!1:(U[W]=!0,!0)}}e.uniqueFilter=t;function r(F,U){for(let z=F.length-1;z>=0;z--){const W=F[z];if(U(W))return z}return-1}e.lastIndex=r;function i(F,U){return F.length>0?F[0]:U}e.firstOrDefault=i;function a(F,U,z=(W,K)=>W===K){let W=0;for(let K=0,$=Math.min(F.length,U.length);K<$&&z(F[K],U[K]);K++)W++;return W}e.commonPrefixLength=a;function l(F){return[].concat(...F)}e.flatten=l;function o(F,U){let z=typeof U=="number"?F:0;typeof U=="number"?z=F:(z=0,U=F);const W=[];if(z<=U)for(let K=z;K<U;K++)W.push(K);else for(let K=z;K>U;K--)W.push(K);return W}e.range=o;function u(F,U,z){return F.reduce((W,K)=>(W[U(K)]=z?z(K):K,W),Object.create(null))}e.index=u;function y(F,U){return F.push(U),()=>E(F,U)}e.insert=y;function E(F,U){const z=F.indexOf(U);if(z>-1)return F.splice(z,1),U}e.remove=E;function f(F,U,z){const W=F.slice(0,U),K=F.slice(U);return W.concat(z,K)}e.arrayInsert=f;function T(F,U){let z;if(typeof U=="number"){let W=U;z=()=>{const K=Math.sin(W++)*179426549;return K-Math.floor(K)}}else z=Math.random;for(let W=F.length-1;W>0;W-=1){const K=Math.floor(z()*(W+1)),$=F[W];F[W]=F[K],F[K]=$}}e.shuffle=T;function O(F,U){const z=F.indexOf(U);z>-1&&(F.splice(z,1),F.unshift(U))}e.pushToStart=O;function x(F,U){const z=F.indexOf(U);z>-1&&(F.splice(z,1),F.push(U))}e.pushToEnd=x;function j(F,U){return Array.isArray(F)?F.map(U):U(F)}e.mapArrayOrNot=j;function H(F){return Array.isArray(F)?F:[F]}e.asArray=H;function V(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=V;function N(F,U){for(const z of F){const W=U(z);if(W!==void 0)return W}}e.mapFind=N;function _(F,U){let z=Number.MAX_SAFE_INTEGER,W=0;return F.forEach((K,$)=>{const G=U(K);G<z&&(z=G,W=$)}),W}e.minIndex=_;function M(F,U){let z=Number.MIN_SAFE_INTEGER,W=0;return F.forEach((K,$)=>{const G=U(K);G>z&&(z=G,W=$)}),W}e.maxIndex=M;class B{constructor(U){this.items=U,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(U){let z=this.firstIdx;for(;z<this.items.length&&U(this.items[z]);)z++;const W=z===this.firstIdx?null:this.items.slice(this.firstIdx,z);return this.firstIdx=z,W}takeFromEndWhile(U){let z=this.lastIdx;for(;z>=0&&U(this.items[z]);)z--;const W=z===this.lastIdx?null:this.items.slice(z+1,this.lastIdx+1);return this.lastIdx=z,W}}e.ArrayQueue=B}),define(te[65],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(L){const R=this;let k=!1,A;return function(){return k||(k=!0,A=L.apply(R,arguments)),A}}e.once=S}),define(te[53],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(L){function R(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}L.is=R;const k=Object.freeze([]);function A(){return k}L.empty=A;function*P(c){yield c}L.single=P;function v(c){return c||k}L.from=v;function w(c){return!c||c[Symbol.iterator]().next().done===!0}L.isEmpty=w;function n(c){return c[Symbol.iterator]().next().value}L.first=n;function p(c,t){for(const r of c)if(t(r))return!0;return!1}L.some=p;function m(c,t){for(const r of c)if(t(r))return r}L.find=m;function*d(c,t){for(const r of c)t(r)&&(yield r)}L.filter=d;function*h(c,t){let r=0;for(const i of c)yield t(i,r++)}L.map=h;function*C(...c){for(const t of c)for(const r of t)yield r}L.concat=C;function*D(c){for(const t of c)for(const r of t)yield r}L.concatNested=D;function b(c,t,r){let i=r;for(const a of c)i=t(i,a);return i}L.reduce=b;function*I(c,t,r=c.length){for(t<0&&(t+=c.length),r<0?r+=c.length:r>c.length&&(r=c.length);t<r;t++)yield c[t]}L.slice=I;function g(c,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,c];const i=c[Symbol.iterator]();for(let a=0;a<t;a++){const l=i.next();if(l.done)return[r,L.empty()];r.push(l.value)}return[r,{[Symbol.iterator](){return i}}]}L.consume=g;function s(c,t,r=(i,a)=>i===a){const i=c[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const l=i.next(),o=a.next();if(l.done!==o.done)return!1;if(l.done)return!0;if(!r(l.value,o.value))return!1}}L.equals=s})(S=e.Iterable||(e.Iterable={}))}),define(te[32],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function A(t,r=!1){let i=0,a=t.length,l="",o=0,u=16,y=0;function E(V){let N=0,_=0;for(;N<V;){const M=t.charCodeAt(i);if(M>=48&&M<=57)_=_*16+M-48;else if(M>=65&&M<=70)_=_*16+M-65+10;else if(M>=97&&M<=102)_=_*16+M-97+10;else break;i++,N++}return N<V&&(_=-1),_}function f(V){i=V,l="",o=0,u=16,y=0}function T(){const V=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&w(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&w(t.charCodeAt(i)))for(i++;i<t.length&&w(t.charCodeAt(i));)i++;else return y=3,t.substring(V,i);let N=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&w(t.charCodeAt(i))){for(i++;i<t.length&&w(t.charCodeAt(i));)i++;N=i}else y=3;return t.substring(V,N)}function O(){let V="",N=i;for(;;){if(i>=a){V+=t.substring(N,i),y=2;break}const _=t.charCodeAt(i);if(_===34){V+=t.substring(N,i),i++;break}if(_===92){if(V+=t.substring(N,i),i++,i>=a){y=2;break}switch(t.charCodeAt(i++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:const B=E(4);B>=0?V+=String.fromCharCode(B):y=4;break;default:y=5}N=i;continue}if(_>=0&&_<=31)if(v(_)){V+=t.substring(N,i),y=2;break}else y=6;i++}return V}function x(){if(l="",y=0,o=i,i>=a)return o=a,u=17;let V=t.charCodeAt(i);if(P(V)){do i++,l+=String.fromCharCode(V),V=t.charCodeAt(i);while(P(V));return u=15}if(v(V))return i++,l+=String.fromCharCode(V),V===13&&t.charCodeAt(i)===10&&(i++,l+=`
`),u=14;switch(V){case 123:return i++,u=1;case 125:return i++,u=2;case 91:return i++,u=3;case 93:return i++,u=4;case 58:return i++,u=6;case 44:return i++,u=5;case 34:return i++,l=O(),u=10;case 47:const N=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<a&&!v(t.charCodeAt(i));)i++;return l=t.substring(N,i),u=12}if(t.charCodeAt(i+1)===42){i+=2;const _=a-1;let M=!1;for(;i<_;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,M=!0;break}i++}return M||(i++,y=1),l=t.substring(N,i),u=13}return l+=String.fromCharCode(V),i++,u=16;case 45:if(l+=String.fromCharCode(V),i++,i===a||!w(t.charCodeAt(i)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=T(),u=11;default:for(;i<a&&j(V);)i++,V=t.charCodeAt(i);if(o!==i){switch(l=t.substring(o,i),l){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return l+=String.fromCharCode(V),i++,u=16}}function j(V){if(P(V)||v(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let V;do V=x();while(V>=12&&V<=15);return V}return{setPosition:f,getPosition:()=>i,scan:r?H:x,getToken:()=>u,getTokenValue:()=>l,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>y}}e.createScanner=A;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function v(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function p(t,r){const i=[],a=new Object;let l;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function y(E,f,T,O){o.value=E,o.offset=f,o.length=T,o.type=O,o.colonOffset=void 0,l=o}try{g(t,{onObjectBegin:(E,f)=>{if(r<=E)throw a;l=void 0,u=r>E,i.push("")},onObjectProperty:(E,f,T)=>{if(r<f||(y(E,f,T,"property"),i[i.length-1]=E,r<=f+T))throw a},onObjectEnd:(E,f)=>{if(r<=E)throw a;l=void 0,i.pop()},onArrayBegin:(E,f)=>{if(r<=E)throw a;l=void 0,i.push(0)},onArrayEnd:(E,f)=>{if(r<=E)throw a;l=void 0,i.pop()},onLiteralValue:(E,f,T)=>{if(r<f||(y(E,f,T,c(E)),r<=f+T))throw a},onSeparator:(E,f,T)=>{if(r<=f)throw a;if(E===":"&&l&&l.type==="property")l.colonOffset=f,u=!1,l=void 0;else if(E===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(u=!0,i[i.length-1]=""),l=void 0}}})}catch(E){if(E!==a)throw E}return{path:i,previousNode:l,isAtPropertyKey:u,matches:E=>{let f=0;for(let T=0;f<E.length&&T<i.length;T++)if(E[f]===i[T]||E[f]==="*")f++;else if(E[f]!=="**")return!1;return f===E.length}}}e.getLocation=p;function m(t,r=[],i=k.DEFAULT){let a=null,l=[];const o=[];function u(E){Array.isArray(l)?l.push(E):a!==null&&(l[a]=E)}return g(t,{onObjectBegin:()=>{const E={};u(E),o.push(l),l=E,a=null},onObjectProperty:E=>{a=E},onObjectEnd:()=>{l=o.pop()},onArrayBegin:()=>{const E=[];u(E),o.push(l),l=E,a=null},onArrayEnd:()=>{l=o.pop()},onLiteralValue:u,onError:(E,f,T)=>{r.push({error:E,offset:f,length:T})}},i),l[0]}e.parse=m;function d(t,r=[],i=k.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(E){a.type==="property"&&(a.length=E-a.offset,a=a.parent)}function o(E){return a.children.push(E),E}g(t,{onObjectBegin:E=>{a=o({type:"object",offset:E,length:-1,parent:a,children:[]})},onObjectProperty:(E,f,T)=>{a=o({type:"property",offset:f,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:E,offset:f,length:T,parent:a})},onObjectEnd:(E,f)=>{a.length=E+f-a.offset,a=a.parent,l(E+f)},onArrayBegin:(E,f)=>{a=o({type:"array",offset:E,length:-1,parent:a,children:[]})},onArrayEnd:(E,f)=>{a.length=E+f-a.offset,a=a.parent,l(E+f)},onLiteralValue:(E,f,T)=>{o({type:c(E),offset:f,length:T,parent:a,value:E}),l(f+T)},onSeparator:(E,f,T)=>{a.type==="property"&&(E===":"?a.colonOffset=f:E===","&&l(f))},onError:(E,f,T)=>{r.push({error:E,offset:f,length:T})}},i);const y=a.children[0];return y&&delete y.parent,y}e.parseTree=d;function h(t,r){if(!t)return;let i=t;for(let a of r)if(typeof a=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let l=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===a){i=o.children[1],l=!0;break}if(!l)return}else{const l=a;if(i.type!=="array"||l<0||!Array.isArray(i.children)||l>=i.children.length)return;i=i.children[l]}return i}e.findNodeAtLocation=h;function C(t){if(!t.parent||!t.parent.children)return[];const r=C(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=C;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const r=Object.create(null);for(let i of t.children){const a=i.children[1];a&&(r[i.children[0].value]=D(a))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function b(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=b;function I(t,r,i=!1){if(b(t,r,i)){const a=t.children;if(Array.isArray(a))for(let l=0;l<a.length&&a[l].offset<=r;l++){const o=I(a[l],r,i);if(o)return o}return t}}e.findNodeAtOffset=I;function g(t,r,i=k.DEFAULT){const a=A(t,!1);function l($){return $?()=>$(a.getTokenOffset(),a.getTokenLength()):()=>!0}function o($){return $?G=>$(G,a.getTokenOffset(),a.getTokenLength()):()=>!0}const u=l(r.onObjectBegin),y=o(r.onObjectProperty),E=l(r.onObjectEnd),f=l(r.onArrayBegin),T=l(r.onArrayEnd),O=o(r.onLiteralValue),x=o(r.onSeparator),j=l(r.onComment),H=o(r.onError),V=i&&i.disallowComments,N=i&&i.allowTrailingComma;function _(){for(;;){const $=a.scan();switch(a.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:V||M(11);break;case 2:M(12);break;case 6:M(16);break}switch($){case 12:case 13:V?M(10):j();break;case 16:M(1);break;case 15:case 14:break;default:return $}}}function M($,G=[],X=[]){if(H($),G.length+X.length>0){let Z=a.getToken();for(;Z!==17;){if(G.indexOf(Z)!==-1){_();break}else if(X.indexOf(Z)!==-1)break;Z=_()}}}function B($){const G=a.getTokenValue();return $?O(G):y(G),_(),!0}function F(){switch(a.getToken()){case 11:let $=0;try{$=JSON.parse(a.getTokenValue()),typeof $!="number"&&(M(2),$=0)}catch(G){M(2)}O($);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return _(),!0}function U(){return a.getToken()!==10?(M(3,[],[2,5]),!1):(B(!1),a.getToken()===6?(x(":"),_(),K()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function z(){u(),_();let $=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if($||M(4,[],[]),x(","),_(),a.getToken()===2&&N)break}else $&&M(6,[],[]);U()||M(4,[],[2,5]),$=!0}return E(),a.getToken()!==2?M(7,[2],[]):_(),!0}function W(){f(),_();let $=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if($||M(4,[],[]),x(","),_(),a.getToken()===4&&N)break}else $&&M(6,[],[]);K()||M(4,[],[4,5]),$=!0}return T(),a.getToken()!==4?M(8,[4],[]):_(),!0}function K(){switch(a.getToken()){case 3:return W();case 1:return z();case 10:return B(!0);default:return F()}}return _(),a.getToken()===17?i.allowEmptyContent?!0:(M(4,[],[]),!1):K()?(a.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=g;function s(t,r){let i=A(t),a=[],l,o=0,u;do switch(u=i.getPosition(),l=i.scan(),l){case 12:case 13:case 17:o!==u&&a.push(t.substring(o,u)),r!==void 0&&a.push(i.getTokenValue().replace(/[^\r\n]/g,r)),o=i.getPosition();break}while(l!==17);return a.join("")}e.stripComments=s;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(te[46],ne([0,1,32]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(v,w,n){let p,m,d,h,C;if(w){for(h=w.offset,C=h+w.length,d=h;d>0&&!P(v,d-1);)d--;let o=C;for(;o<v.length&&!P(v,o);)o++;m=v.substring(d,o),p=k(m,n)}else m=v,p=0,d=0,h=0,C=v.length;const D=A(n,v);let b=!1,I=0,g;n.insertSpaces?g=R(" ",n.tabSize||4):g="	";const s=(0,S.createScanner)(m,!1);let c=!1;function t(){return D+R(g,p+I)}function r(){let o=s.scan();for(b=!1;o===15||o===14;)b=b||o===14,o=s.scan();return c=o===16||s.getTokenError()!==0,o}const i=[];function a(o,u,y){!c&&u<C&&y>h&&v.substring(u,y)!==o&&i.push({offset:u,length:y-u,content:o})}let l=r();if(l!==17){const o=s.getTokenOffset()+d,u=R(g,p);a(u,d,o)}for(;l!==17;){let o=s.getTokenOffset()+s.getTokenLength()+d,u=r(),y="";for(;!b&&(u===12||u===13);){const f=s.getTokenOffset()+d;a(" ",o,f),o=s.getTokenOffset()+s.getTokenLength()+d,y=u===12?t():"",u=r()}if(u===2)l!==1&&(I--,y=t());else if(u===4)l!==3&&(I--,y=t());else{switch(l){case 3:case 1:I++,y=t();break;case 5:case 12:y=t();break;case 13:b?y=t():y=" ";break;case 6:y=" ";break;case 10:if(u===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?y=" ":u!==5&&u!==17&&(c=!0);break;case 16:c=!0;break}b&&(u===12||u===13)&&(y=t())}const E=s.getTokenOffset()+d;a(y,o,E),l=u}return i}e.format=L;function R(v,w){let n="";for(let p=0;p<w;p++)n+=v;return n}function k(v,w){let n=0,p=0;const m=w.tabSize||4;for(;n<v.length;){const d=v.charAt(n);if(d===" ")p++;else if(d==="	")p+=m;else break;n++}return Math.floor(p/m)}function A(v,w){for(let n=0;n<w.length;n++){const p=w.charAt(n);if(p==="\r")return n+1<w.length&&w.charAt(n+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return v&&v.eol||`
`}e.getEOL=A;function P(v,w){return`\r
`.indexOf(v.charAt(w))!==-1}e.isEOL=P}),define(te[40],ne([0,1,32,46]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(w,n,p){return k(w,n,void 0,p)}e.removeProperty=R;function k(w,n,p,m,d){const h=n.slice(),C=[],D=(0,S.parseTree)(w,C);let b,I;for(;h.length>0&&(I=h.pop(),b=(0,S.findNodeAtLocation)(D,h),b===void 0&&p!==void 0);)typeof I=="string"?p={[I]:p}:p=[p];if(b)if(b.type==="object"&&typeof I=="string"&&Array.isArray(b.children)){const g=(0,S.findNodeAtLocation)(b,[I]);if(g!==void 0)if(p===void 0){if(!g.parent)throw new Error("Malformed AST");const s=b.children.indexOf(g.parent);let c,t=g.parent.offset+g.parent.length;if(s>0){const r=b.children[s-1];c=r.offset+r.length}else c=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return A(w,{offset:c,length:t-c,content:""},m)}else return A(w,{offset:g.offset,length:g.length,content:JSON.stringify(p)},m);else{if(p===void 0)return[];const s=`${JSON.stringify(I)}: ${JSON.stringify(p)}`,c=d?d(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(c>0){const r=b.children[c-1];t={offset:r.offset+r.length,length:0,content:","+s}}else b.children.length===0?t={offset:b.offset+1,length:0,content:s}:t={offset:b.offset+1,length:0,content:s+","};return A(w,t,m)}}else if(b.type==="array"&&typeof I=="number"&&Array.isArray(b.children))if(p!==void 0){const g=`${JSON.stringify(p)}`;let s;if(b.children.length===0||I===0)s={offset:b.offset+1,length:0,content:b.children.length===0?g:g+","};else{const c=I===-1||I>b.children.length?b.children.length:I,t=b.children[c-1];s={offset:t.offset+t.length,length:0,content:","+g}}return A(w,s,m)}else{const g=I,s=b.children[g];let c;if(b.children.length===1)c={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===g){const t=b.children[g-1],r=t.offset+t.length,i=b.offset+b.length;c={offset:r,length:i-2-r,content:""}}else c={offset:s.offset,length:b.children[g+1].offset-s.offset,content:""};return A(w,c,m)}else throw new Error(`Can not add ${typeof I!="number"?"index":"property"} to parent of type ${b.type}`);else{if(p===void 0)throw new Error("Can not delete in empty document");return A(w,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(p)},m)}}e.setProperty=k;function A(w,n,p){let m=P(w,n),d=n.offset,h=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;d>0&&!(0,L.isEOL)(m,d-1);)d--;for(;h<m.length&&!(0,L.isEOL)(m,h);)h++}const C=(0,L.format)(m,{offset:d,length:h-d},p);for(let b=C.length-1;b>=0;b--){const I=C[b];m=P(m,I),d=Math.min(d,I.offset),h=Math.max(h,I.offset+I.length),h+=I.content.length-I.length}const D=w.length-(m.length-h)-d;return[{offset:d,length:D,content:m.substring(d,h)}]}e.withFormatting=A;function P(w,n){return w.substring(0,n.offset)+n.content+w.substring(n.offset+n.length)}e.applyEdit=P;function v(w,n){let p=n.slice(0).sort((d,h)=>{const C=d.offset-h.offset;return C===0?d.length-h.length:C}),m=w.length;for(let d=p.length-1;d>=0;d--){let h=p[d];if(h.offset+h.length<=m)w=P(w,h);else throw new Error("Overlapping edit");m=h.offset}return w}e.applyEdits=v}),define(te[2],ne([0,1,65,53]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let k=null;function A(r){k=r}if(e.setDisposableTracker=A,R){const r="__is_disposable_tracked__";A(new class{trackDisposable(i){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[r]||console.log(a)},3e3)}setParent(i,a){if(i&&i!==I.None)try{i[r]=!0}catch{}}markAsDisposed(i){if(i&&i!==I.None)try{i[r]=!0}catch{}}markAsSingleton(i){}})}function P(r){return k?.trackDisposable(r),r}function v(r){k?.markAsDisposed(r)}function w(r,i){k?.setParent(r,i)}function n(r,i){if(!!k)for(const a of r)k.setParent(a,i)}function p(r){return k?.markAsSingleton(r),r}e.markAsSingleton=p;class m extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=m;function d(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=d;function h(r){if(L.Iterable.is(r)){let i=[];for(const a of r)if(a)try{a.dispose()}catch(l){i.push(l)}if(i.length===1)throw i[0];if(i.length>1)throw new m(i);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=h;function C(...r){const i=D(()=>h(r));return n(r,i),i}e.combinedDisposable=C;function D(r){const i=P({dispose:(0,S.once)(()=>{v(i),r()})});return i}e.toDisposable=D;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(v(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return w(i,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class I{constructor(){this._store=new b,P(this),w(this._store,this)}dispose(){v(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=I,I.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&w(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,v(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&w(i,null),i}}e.MutableDisposable=g;class s{constructor(){this.references=new Map}acquire(i,...a){let l=this.references.get(i);l||(l={counter:0,object:this.createReferencedObject(i,...a)},this.references.set(i,l));const{object:o}=l,u=(0,S.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(i,l.object),this.references.delete(i))});return l.counter++,{object:o,dispose:u}}}e.ReferenceCollection=s;class c{constructor(i){this.referenceCollection=i}async acquire(i,...a){const l=this.referenceCollection.acquire(i,...a);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(o){throw l.dispose(),o}}}e.AsyncReferenceCollection=c;class t{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=t}),define(te[88],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(k){this.element=k,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class L{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){let k=this._first;for(;k!==S.Undefined;){const A=k.next;k.prev=S.Undefined,k.next=S.Undefined,k=A}this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,A){const P=new S(k);if(this._first===S.Undefined)this._first=P,this._last=P;else if(A){const w=this._last;this._last=P,P.prev=w,w.next=P}else{const w=this._first;this._first=P,P.next=w,w.prev=P}this._size+=1;let v=!1;return()=>{v||(v=!0,this._remove(P))}}shift(){if(this._first!==S.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==S.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==S.Undefined&&k.next!==S.Undefined){const A=k.prev;A.next=k.next,k.next.prev=A}else k.prev===S.Undefined&&k.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):k.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):k.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==S.Undefined;)yield k.element,k=k.next}}e.LinkedList=L}),function(){function Y(R){const k=[];typeof R=="number"&&k.push("code/timeOrigin",R);function A(v){k.push(v,Date.now())}function P(){const v=[];for(let w=0;w<k.length;w+=2)v.push({name:k[w],startTime:k[w+1]});return v}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const A of performance.getEntriesByType("mark"))k.push({name:A.name,startTime:Math.round(R+A.startTime)});return k}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function S(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=S(L))}(),define(te[7],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const S="en";let L=!1,R=!1,k=!1,A=!1,P=!1,v=!1,w=!1,n,p=S,m,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const C=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=C&&h?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=h?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!C)d=navigator.userAgent,L=d.indexOf("Windows")>=0,R=d.indexOf("Macintosh")>=0,w=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=d.indexOf("Linux")>=0,v=!0,n=navigator.language,p=n;else if(typeof h=="object"){L=h.platform==="win32",R=h.platform==="darwin",k=h.platform==="linux",A=k&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,n=S,p=S;const i=h.env.VSCODE_NLS_CONFIG;if(i)try{const a=JSON.parse(i),l=a.availableLanguages["*"];n=a.locale,p=l||S,m=a._translationsConfigFile}catch(a){}P=!0}else console.error("Unable to resolve platform.");var D;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function b(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let I=0;R?I=1:L?I=3:k&&(I=2),e.isWindows=L,e.isMacintosh=R,e.isLinux=k,e.isLinuxSnap=A,e.isNative=P,e.isWeb=v,e.isIOS=w,e.platform=I,e.userAgent=d,e.language=p;var g;(function(i){function a(){return e.language}i.value=a;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=l;function o(){return e.language==="en"}i.isDefault=o})(g=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeSetImmediateId)for(let y=0,E=l.length;y<E;y++){const f=l[y];if(f.id===u.data.vscodeSetImmediateId){l.splice(y,1),f.callback();return}}});let o=0;return u=>{const y=++o;l.push({id:y,callback:u}),e.globals.postMessage({vscodeSetImmediateId:y},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const a=Promise.resolve();return l=>a.then(l)}();var s;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||w?2:L?1:3;let c=!0,t=!1;function r(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,c=new Uint16Array(i.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=r}),define(te[34],ne([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof S.globals.vscode!="undefined"&&typeof S.globals.vscode.process!="undefined"){const R=S.globals.vscode.process;L={get platform(){return R.platform},get env(){return R.env},cwd(){return R.cwd()},nextTick(k){return(0,S.setImmediate)(k)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}}:L={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},nextTick(R){return(0,S.setImmediate)(R)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(te[8],ne([0,1,34]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,R=97,k=90,A=122,P=46,v=47,w=92,n=58,p=63;class m extends Error{constructor(s,c,t){let r;typeof c=="string"&&c.indexOf("not ")===0?(r="must not be",c=c.replace(/^not /,"")):r="must be";const i=s.indexOf(".")!==-1?"property":"argument";let a=`The "${s}" ${i} ${r} of type ${c}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function d(g,s){if(typeof g!="string")throw new m(s,"string",g)}function h(g){return g===v||g===w}function C(g){return g===v}function D(g){return g>=L&&g<=k||g>=R&&g<=A}function b(g,s,c,t){let r="",i=0,a=-1,l=0,o=0;for(let u=0;u<=g.length;++u){if(u<g.length)o=g.charCodeAt(u);else{if(t(o))break;o=v}if(t(o)){if(!(a===u-1||l===1))if(l===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const y=r.lastIndexOf(c);y===-1?(r="",i=0):(r=r.slice(0,y),i=r.length-1-r.lastIndexOf(c)),a=u,l=0;continue}else if(r.length!==0){r="",i=0,a=u,l=0;continue}}s&&(r+=r.length>0?`${c}..`:"..",i=2)}else r.length>0?r+=`${c}${g.slice(a+1,u)}`:r=g.slice(a+1,u),i=u-a-1;a=u,l=0}else o===P&&l!==-1?++l:l=-1}return r}function I(g,s){if(s===null||typeof s!="object")throw new m("pathObject","Object",s);const c=s.dir||s.root,t=s.base||`${s.name||""}${s.ext||""}`;return c?c===s.root?`${c}${t}`:`${c}${g}${t}`:t}e.win32={resolve(...g){let s="",c="",t=!1;for(let r=g.length-1;r>=-1;r--){let i;if(r>=0){if(i=g[r],d(i,"path"),i.length===0)continue}else s.length===0?i=S.cwd():(i=S.env[`=${s}`]||S.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==s.toLowerCase()&&i.charCodeAt(2)===w)&&(i=`${s}\\`));const a=i.length;let l=0,o="",u=!1;const y=i.charCodeAt(0);if(a===1)h(y)&&(l=1,u=!0);else if(h(y))if(u=!0,h(i.charCodeAt(1))){let E=2,f=E;for(;E<a&&!h(i.charCodeAt(E));)E++;if(E<a&&E!==f){const T=i.slice(f,E);for(f=E;E<a&&h(i.charCodeAt(E));)E++;if(E<a&&E!==f){for(f=E;E<a&&!h(i.charCodeAt(E));)E++;(E===a||E!==f)&&(o=`\\\\${T}\\${i.slice(f,E)}`,l=E)}}}else l=1;else D(y)&&i.charCodeAt(1)===n&&(o=i.slice(0,2),l=2,a>2&&h(i.charCodeAt(2))&&(u=!0,l=3));if(o.length>0)if(s.length>0){if(o.toLowerCase()!==s.toLowerCase())continue}else s=o;if(t){if(s.length>0)break}else if(c=`${i.slice(l)}\\${c}`,t=u,u&&s.length>0)break}return c=b(c,!t,"\\",h),t?`${s}\\${c}`:`${s}${c}`||"."},normalize(g){d(g,"path");const s=g.length;if(s===0)return".";let c=0,t,r=!1;const i=g.charCodeAt(0);if(s===1)return C(i)?"\\":g;if(h(i))if(r=!0,h(g.charCodeAt(1))){let l=2,o=l;for(;l<s&&!h(g.charCodeAt(l));)l++;if(l<s&&l!==o){const u=g.slice(o,l);for(o=l;l<s&&h(g.charCodeAt(l));)l++;if(l<s&&l!==o){for(o=l;l<s&&!h(g.charCodeAt(l));)l++;if(l===s)return`\\\\${u}\\${g.slice(o)}\\`;l!==o&&(t=`\\\\${u}\\${g.slice(o,l)}`,c=l)}}}else c=1;else D(i)&&g.charCodeAt(1)===n&&(t=g.slice(0,2),c=2,s>2&&h(g.charCodeAt(2))&&(r=!0,c=3));let a=c<s?b(g.slice(c),!r,"\\",h):"";return a.length===0&&!r&&(a="."),a.length>0&&h(g.charCodeAt(s-1))&&(a+="\\"),t===void 0?r?`\\${a}`:a:r?`${t}\\${a}`:`${t}${a}`},isAbsolute(g){d(g,"path");const s=g.length;if(s===0)return!1;const c=g.charCodeAt(0);return h(c)||s>2&&D(c)&&g.charCodeAt(1)===n&&h(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let s,c;for(let i=0;i<g.length;++i){const a=g[i];d(a,"path"),a.length>0&&(s===void 0?s=c=a:s+=`\\${a}`)}if(s===void 0)return".";let t=!0,r=0;if(typeof c=="string"&&h(c.charCodeAt(0))){++r;const i=c.length;i>1&&h(c.charCodeAt(1))&&(++r,i>2&&(h(c.charCodeAt(2))?++r:t=!1))}if(t){for(;r<s.length&&h(s.charCodeAt(r));)r++;r>=2&&(s=`\\${s.slice(r)}`)}return e.win32.normalize(s)},relative(g,s){if(d(g,"from"),d(s,"to"),g===s)return"";const c=e.win32.resolve(g),t=e.win32.resolve(s);if(c===t||(g=c.toLowerCase(),s=t.toLowerCase(),g===s))return"";let r=0;for(;r<g.length&&g.charCodeAt(r)===w;)r++;let i=g.length;for(;i-1>r&&g.charCodeAt(i-1)===w;)i--;const a=i-r;let l=0;for(;l<s.length&&s.charCodeAt(l)===w;)l++;let o=s.length;for(;o-1>l&&s.charCodeAt(o-1)===w;)o--;const u=o-l,y=a<u?a:u;let E=-1,f=0;for(;f<y;f++){const O=g.charCodeAt(r+f);if(O!==s.charCodeAt(l+f))break;O===w&&(E=f)}if(f!==y){if(E===-1)return t}else{if(u>y){if(s.charCodeAt(l+f)===w)return t.slice(l+f+1);if(f===2)return t.slice(l+f)}a>y&&(g.charCodeAt(r+f)===w?E=f:f===2&&(E=3)),E===-1&&(E=0)}let T="";for(f=r+E+1;f<=i;++f)(f===i||g.charCodeAt(f)===w)&&(T+=T.length===0?"..":"\\..");return l+=E,T.length>0?`${T}${t.slice(l,o)}`:(t.charCodeAt(l)===w&&++l,t.slice(l,o))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const s=e.win32.resolve(g);if(s.length<=2)return g;if(s.charCodeAt(0)===w){if(s.charCodeAt(1)===w){const c=s.charCodeAt(2);if(c!==p&&c!==P)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(D(s.charCodeAt(0))&&s.charCodeAt(1)===n&&s.charCodeAt(2)===w)return`\\\\?\\${s}`;return g},dirname(g){d(g,"path");const s=g.length;if(s===0)return".";let c=-1,t=0;const r=g.charCodeAt(0);if(s===1)return h(r)?g:".";if(h(r)){if(c=t=1,h(g.charCodeAt(1))){let l=2,o=l;for(;l<s&&!h(g.charCodeAt(l));)l++;if(l<s&&l!==o){for(o=l;l<s&&h(g.charCodeAt(l));)l++;if(l<s&&l!==o){for(o=l;l<s&&!h(g.charCodeAt(l));)l++;if(l===s)return g;l!==o&&(c=t=l+1)}}}}else D(r)&&g.charCodeAt(1)===n&&(c=s>2&&h(g.charCodeAt(2))?3:2,t=c);let i=-1,a=!0;for(let l=s-1;l>=t;--l)if(h(g.charCodeAt(l))){if(!a){i=l;break}}else a=!1;if(i===-1){if(c===-1)return".";i=c}return g.slice(0,i)},basename(g,s){s!==void 0&&d(s,"ext"),d(g,"path");let c=0,t=-1,r=!0,i;if(g.length>=2&&D(g.charCodeAt(0))&&g.charCodeAt(1)===n&&(c=2),s!==void 0&&s.length>0&&s.length<=g.length){if(s===g)return"";let a=s.length-1,l=-1;for(i=g.length-1;i>=c;--i){const o=g.charCodeAt(i);if(h(o)){if(!r){c=i+1;break}}else l===-1&&(r=!1,l=i+1),a>=0&&(o===s.charCodeAt(a)?--a==-1&&(t=i):(a=-1,t=l))}return c===t?t=l:t===-1&&(t=g.length),g.slice(c,t)}for(i=g.length-1;i>=c;--i)if(h(g.charCodeAt(i))){if(!r){c=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":g.slice(c,t)},extname(g){d(g,"path");let s=0,c=-1,t=0,r=-1,i=!0,a=0;g.length>=2&&g.charCodeAt(1)===n&&D(g.charCodeAt(0))&&(s=t=2);for(let l=g.length-1;l>=s;--l){const o=g.charCodeAt(l);if(h(o)){if(!i){t=l+1;break}continue}r===-1&&(i=!1,r=l+1),o===P?c===-1?c=l:a!==1&&(a=1):c!==-1&&(a=-1)}return c===-1||r===-1||a===0||a===1&&c===r-1&&c===t+1?"":g.slice(c,r)},format:I.bind(null,"\\"),parse(g){d(g,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return s;const c=g.length;let t=0,r=g.charCodeAt(0);if(c===1)return h(r)?(s.root=s.dir=g,s):(s.base=s.name=g,s);if(h(r)){if(t=1,h(g.charCodeAt(1))){let E=2,f=E;for(;E<c&&!h(g.charCodeAt(E));)E++;if(E<c&&E!==f){for(f=E;E<c&&h(g.charCodeAt(E));)E++;if(E<c&&E!==f){for(f=E;E<c&&!h(g.charCodeAt(E));)E++;E===c?t=E:E!==f&&(t=E+1)}}}}else if(D(r)&&g.charCodeAt(1)===n){if(c<=2)return s.root=s.dir=g,s;if(t=2,h(g.charCodeAt(2))){if(c===3)return s.root=s.dir=g,s;t=3}}t>0&&(s.root=g.slice(0,t));let i=-1,a=t,l=-1,o=!0,u=g.length-1,y=0;for(;u>=t;--u){if(r=g.charCodeAt(u),h(r)){if(!o){a=u+1;break}continue}l===-1&&(o=!1,l=u+1),r===P?i===-1?i=u:y!==1&&(y=1):i!==-1&&(y=-1)}return l!==-1&&(i===-1||y===0||y===1&&i===l-1&&i===a+1?s.base=s.name=g.slice(a,l):(s.name=g.slice(a,i),s.base=g.slice(a,l),s.ext=g.slice(i,l))),a>0&&a!==t?s.dir=g.slice(0,a-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let s="",c=!1;for(let t=g.length-1;t>=-1&&!c;t--){const r=t>=0?g[t]:S.cwd();d(r,"path"),r.length!==0&&(s=`${r}/${s}`,c=r.charCodeAt(0)===v)}return s=b(s,!c,"/",C),c?`/${s}`:s.length>0?s:"."},normalize(g){if(d(g,"path"),g.length===0)return".";const s=g.charCodeAt(0)===v,c=g.charCodeAt(g.length-1)===v;return g=b(g,!s,"/",C),g.length===0?s?"/":c?"./":".":(c&&(g+="/"),s?`/${g}`:g)},isAbsolute(g){return d(g,"path"),g.length>0&&g.charCodeAt(0)===v},join(...g){if(g.length===0)return".";let s;for(let c=0;c<g.length;++c){const t=g[c];d(t,"path"),t.length>0&&(s===void 0?s=t:s+=`/${t}`)}return s===void 0?".":e.posix.normalize(s)},relative(g,s){if(d(g,"from"),d(s,"to"),g===s||(g=e.posix.resolve(g),s=e.posix.resolve(s),g===s))return"";const c=1,t=g.length,r=t-c,i=1,a=s.length-i,l=r<a?r:a;let o=-1,u=0;for(;u<l;u++){const E=g.charCodeAt(c+u);if(E!==s.charCodeAt(i+u))break;E===v&&(o=u)}if(u===l)if(a>l){if(s.charCodeAt(i+u)===v)return s.slice(i+u+1);if(u===0)return s.slice(i+u)}else r>l&&(g.charCodeAt(c+u)===v?o=u:u===0&&(o=0));let y="";for(u=c+o+1;u<=t;++u)(u===t||g.charCodeAt(u)===v)&&(y+=y.length===0?"..":"/..");return`${y}${s.slice(i+o)}`},toNamespacedPath(g){return g},dirname(g){if(d(g,"path"),g.length===0)return".";const s=g.charCodeAt(0)===v;let c=-1,t=!0;for(let r=g.length-1;r>=1;--r)if(g.charCodeAt(r)===v){if(!t){c=r;break}}else t=!1;return c===-1?s?"/":".":s&&c===1?"//":g.slice(0,c)},basename(g,s){s!==void 0&&d(s,"ext"),d(g,"path");let c=0,t=-1,r=!0,i;if(s!==void 0&&s.length>0&&s.length<=g.length){if(s===g)return"";let a=s.length-1,l=-1;for(i=g.length-1;i>=0;--i){const o=g.charCodeAt(i);if(o===v){if(!r){c=i+1;break}}else l===-1&&(r=!1,l=i+1),a>=0&&(o===s.charCodeAt(a)?--a==-1&&(t=i):(a=-1,t=l))}return c===t?t=l:t===-1&&(t=g.length),g.slice(c,t)}for(i=g.length-1;i>=0;--i)if(g.charCodeAt(i)===v){if(!r){c=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":g.slice(c,t)},extname(g){d(g,"path");let s=-1,c=0,t=-1,r=!0,i=0;for(let a=g.length-1;a>=0;--a){const l=g.charCodeAt(a);if(l===v){if(!r){c=a+1;break}continue}t===-1&&(r=!1,t=a+1),l===P?s===-1?s=a:i!==1&&(i=1):s!==-1&&(i=-1)}return s===-1||t===-1||i===0||i===1&&s===t-1&&s===c+1?"":g.slice(s,t)},format:I.bind(null,"/"),parse(g){d(g,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return s;const c=g.charCodeAt(0)===v;let t;c?(s.root="/",t=1):t=0;let r=-1,i=0,a=-1,l=!0,o=g.length-1,u=0;for(;o>=t;--o){const y=g.charCodeAt(o);if(y===v){if(!l){i=o+1;break}continue}a===-1&&(l=!1,a=o+1),y===P?r===-1?r=o:u!==1&&(u=1):r!==-1&&(u=-1)}if(a!==-1){const y=i===0&&c?1:i;r===-1||u===0||u===1&&r===a-1&&r===i+1?s.base=s.name=g.slice(y,a):(s.name=g.slice(y,r),s.base=g.slice(y,a),s.ext=g.slice(r,a))}return i>0?s.dir=g.slice(0,i-1):c&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=S.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S.platform==="win32"?e.win32.join:e.posix.join,e.resolve=S.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=S.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=S.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=S.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=S.platform==="win32"?e.win32.extname:e.posix.extname,e.format=S.platform==="win32"?e.win32.format:e.posix.format,e.parse=S.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=S.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=S.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var L in S)(typeof exports=="object"?exports:Y)[L]=S[L]}}(typeof self!="undefined"?self:this,function(){return function(Y){var e={};function S(L){if(e[L])return e[L].exports;var R=e[L]={i:L,l:!1,exports:{}};return Y[L].call(R.exports,R,R.exports,S),R.l=!0,R.exports}return S.m=Y,S.c=e,S.d=function(L,R,k){S.o(L,R)||Object.defineProperty(L,R,{enumerable:!0,get:k})},S.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},S.t=function(L,R){if(1&R&&(L=S(L)),8&R||4&R&&typeof L=="object"&&L&&L.__esModule)return L;var k=Object.create(null);if(S.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:L}),2&R&&typeof L!="string")for(var A in L)S.d(k,A,function(P){return L[P]}.bind(null,A));return k},S.n=function(L){var R=L&&L.__esModule?function(){return L.default}:function(){return L};return S.d(R,"a",R),R},S.o=function(L,R){return Object.prototype.hasOwnProperty.call(L,R)},S.p="",S(S.s=0)}([function(Y,e,S){(function(L){var R;e=Y.exports=X,R=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],v=e.src=[],w=0,n=w++;v[n]="0|[1-9]\\d*";var p=w++;v[p]="[0-9]+";var m=w++;v[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=w++;v[d]="("+v[n]+")\\.("+v[n]+")\\.("+v[n]+")";var h=w++;v[h]="("+v[p]+")\\.("+v[p]+")\\.("+v[p]+")";var C=w++;v[C]="(?:"+v[n]+"|"+v[m]+")";var D=w++;v[D]="(?:"+v[p]+"|"+v[m]+")";var b=w++;v[b]="(?:-("+v[C]+"(?:\\."+v[C]+")*))";var I=w++;v[I]="(?:-?("+v[D]+"(?:\\."+v[D]+")*))";var g=w++;v[g]="[0-9A-Za-z-]+";var s=w++;v[s]="(?:\\+("+v[g]+"(?:\\."+v[g]+")*))";var c=w++,t="v?"+v[d]+v[b]+"?"+v[s]+"?";v[c]="^"+t+"$";var r="[v=\\s]*"+v[h]+v[I]+"?"+v[s]+"?",i=w++;v[i]="^"+r+"$";var a=w++;v[a]="((?:<|>)?=?)";var l=w++;v[l]=v[p]+"|x|X|\\*";var o=w++;v[o]=v[n]+"|x|X|\\*";var u=w++;v[u]="[v=\\s]*("+v[o]+")(?:\\.("+v[o]+")(?:\\.("+v[o]+")(?:"+v[b]+")?"+v[s]+"?)?)?";var y=w++;v[y]="[v=\\s]*("+v[l]+")(?:\\.("+v[l]+")(?:\\.("+v[l]+")(?:"+v[I]+")?"+v[s]+"?)?)?";var E=w++;v[E]="^"+v[a]+"\\s*"+v[u]+"$";var f=w++;v[f]="^"+v[a]+"\\s*"+v[y]+"$";var T=w++;v[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=w++;v[O]="(?:~>?)";var x=w++;v[x]="(\\s*)"+v[O]+"\\s+",P[x]=new RegExp(v[x],"g");var j=w++;v[j]="^"+v[O]+v[u]+"$";var H=w++;v[H]="^"+v[O]+v[y]+"$";var V=w++;v[V]="(?:\\^)";var N=w++;v[N]="(\\s*)"+v[V]+"\\s+",P[N]=new RegExp(v[N],"g");var _=w++;v[_]="^"+v[V]+v[u]+"$";var M=w++;v[M]="^"+v[V]+v[y]+"$";var B=w++;v[B]="^"+v[a]+"\\s*("+r+")$|^$";var F=w++;v[F]="^"+v[a]+"\\s*("+t+")$|^$";var U=w++;v[U]="(\\s*)"+v[a]+"\\s*("+r+"|"+v[u]+")",P[U]=new RegExp(v[U],"g");var z=w++;v[z]="^\\s*("+v[u]+")\\s+-\\s+("+v[u]+")\\s*$";var W=w++;v[W]="^\\s*("+v[y]+")\\s+-\\s+("+v[y]+")\\s*$";var K=w++;v[K]="(<|>)?=?\\s*\\*";for(var $=0;$<35;$++)R($,v[$]),P[$]||(P[$]=new RegExp(v[$]));function G(Q,re){if(Q instanceof X)return Q;if(typeof Q!="string"||Q.length>k||!(re?P[i]:P[c]).test(Q))return null;try{return new X(Q,re)}catch(ae){return null}}function X(Q,re){if(Q instanceof X){if(Q.loose===re)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof X))return new X(Q,re);R("SemVer",Q,re),this.loose=re;var ae=Q.trim().match(re?P[i]:P[c]);if(!ae)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+ae[1],this.minor=+ae[2],this.patch=+ae[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ae[4]?this.prerelease=ae[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var pe=+ye;if(pe>=0&&pe<A)return pe}return ye}):this.prerelease=[],this.build=ae[5]?ae[5].split("."):[],this.format()}e.parse=G,e.valid=function(Q,re){var ae=G(Q,re);return ae?ae.version:null},e.clean=function(Q,re){var ae=G(Q.trim().replace(/^[=v]+/,""),re);return ae?ae.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(Q){return R("SemVer.compare",this.version,this.loose,Q),Q instanceof X||(Q=new X(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},X.prototype.compareMain=function(Q){return Q instanceof X||(Q=new X(Q,this.loose)),ee(this.major,Q.major)||ee(this.minor,Q.minor)||ee(this.patch,Q.patch)},X.prototype.comparePre=function(Q){if(Q instanceof X||(Q=new X(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var re=0;do{var ae=this.prerelease[re],ye=Q.prerelease[re];if(R("prerelease compare",re,ae,ye),ae===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(ae===void 0)return-1;if(ae!==ye)return ee(ae,ye)}while(++re)},X.prototype.inc=function(Q,re){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ae=this.prerelease.length;--ae>=0;)typeof this.prerelease[ae]=="number"&&(this.prerelease[ae]++,ae=-2);ae===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,re,ae,ye){typeof ae=="string"&&(ye=ae,ae=void 0);try{return new X(Q,ae).inc(re,ye).version}catch(pe){return null}},e.diff=function(Q,re){if(me(Q,re))return null;var ae=G(Q),ye=G(re);if(ae.prerelease.length||ye.prerelease.length){for(var pe in ae)if((pe==="major"||pe==="minor"||pe==="patch")&&ae[pe]!==ye[pe])return"pre"+pe;return"prerelease"}for(var pe in ae)if((pe==="major"||pe==="minor"||pe==="patch")&&ae[pe]!==ye[pe])return pe},e.compareIdentifiers=ee;var Z=/^[0-9]+$/;function ee(Q,re){var ae=Z.test(Q),ye=Z.test(re);return ae&&ye&&(Q=+Q,re=+re),ae&&!ye?-1:ye&&!ae?1:Q<re?-1:Q>re?1:0}function se(Q,re,ae){return new X(Q,ae).compare(new X(re,ae))}function ue(Q,re,ae){return se(Q,re,ae)>0}function ge(Q,re,ae){return se(Q,re,ae)<0}function me(Q,re,ae){return se(Q,re,ae)===0}function Se(Q,re,ae){return se(Q,re,ae)!==0}function be(Q,re,ae){return se(Q,re,ae)>=0}function Ce(Q,re,ae){return se(Q,re,ae)<=0}function Ee(Q,re,ae,ye){var pe;switch(re){case"===":typeof Q=="object"&&(Q=Q.version),typeof ae=="object"&&(ae=ae.version),pe=Q===ae;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof ae=="object"&&(ae=ae.version),pe=Q!==ae;break;case"":case"=":case"==":pe=me(Q,ae,ye);break;case"!=":pe=Se(Q,ae,ye);break;case">":pe=ue(Q,ae,ye);break;case">=":pe=be(Q,ae,ye);break;case"<":pe=ge(Q,ae,ye);break;case"<=":pe=Ce(Q,ae,ye);break;default:throw new TypeError("Invalid operator: "+re)}return pe}function De(Q,re){if(Q instanceof De){if(Q.loose===re)return Q;Q=Q.value}if(!(this instanceof De))return new De(Q,re);R("comparator",Q,re),this.loose=re,this.parse(Q),this.semver===Fe?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(Q,re){return ee(re,Q)},e.major=function(Q,re){return new X(Q,re).major},e.minor=function(Q,re){return new X(Q,re).minor},e.patch=function(Q,re){return new X(Q,re).patch},e.compare=se,e.compareLoose=function(Q,re){return se(Q,re,!0)},e.rcompare=function(Q,re,ae){return se(re,Q,ae)},e.sort=function(Q,re){return Q.sort(function(ae,ye){return e.compare(ae,ye,re)})},e.rsort=function(Q,re){return Q.sort(function(ae,ye){return e.rcompare(ae,ye,re)})},e.gt=ue,e.lt=ge,e.eq=me,e.neq=Se,e.gte=be,e.lte=Ce,e.cmp=Ee,e.Comparator=De;var Fe={};function Re(Q,re){if(Q instanceof Re)return Q.loose===re?Q:new Re(Q.raw,re);if(Q instanceof De)return new Re(Q.value,re);if(!(this instanceof Re))return new Re(Q,re);if(this.loose=re,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function(ae){return this.parseRange(ae.trim())},this).filter(function(ae){return ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function Te(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function Ke(Q,re,ae,ye,pe,Ae,Ie,Ue,Le,Oe,Me,q,ie){return((re=Te(ae)?"":Te(ye)?">="+ae+".0.0":Te(pe)?">="+ae+"."+ye+".0":">="+re)+" "+(Ue=Te(Le)?"":Te(Oe)?"<"+(+Le+1)+".0.0":Te(Me)?"<"+Le+"."+(+Oe+1)+".0":q?"<="+Le+"."+Oe+"."+Me+"-"+q:"<="+Ue)).trim()}function Ye(Q,re){for(var ae=0;ae<Q.length;ae++)if(!Q[ae].test(re))return!1;if(re.prerelease.length){for(ae=0;ae<Q.length;ae++)if(R(Q[ae].semver),Q[ae].semver!==Fe&&Q[ae].semver.prerelease.length>0){var ye=Q[ae].semver;if(ye.major===re.major&&ye.minor===re.minor&&ye.patch===re.patch)return!0}return!1}return!0}function $e(Q,re,ae){try{re=new Re(re,ae)}catch(ye){return!1}return re.test(Q)}function je(Q,re,ae,ye){var pe,Ae,Ie,Ue,Le;switch(Q=new X(Q,ye),re=new Re(re,ye),ae){case">":pe=ue,Ae=Ce,Ie=ge,Ue=">",Le=">=";break;case"<":pe=ge,Ae=be,Ie=ue,Ue="<",Le="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(Q,re,ye))return!1;for(var Oe=0;Oe<re.set.length;++Oe){var Me=re.set[Oe],q=null,ie=null;if(Me.forEach(function(oe){oe.semver===Fe&&(oe=new De(">=0.0.0")),q=q||oe,ie=ie||oe,pe(oe.semver,q.semver,ye)?q=oe:Ie(oe.semver,ie.semver,ye)&&(ie=oe)}),q.operator===Ue||q.operator===Le||(!ie.operator||ie.operator===Ue)&&Ae(Q,ie.semver)||ie.operator===Le&&Ie(Q,ie.semver))return!1}return!0}De.prototype.parse=function(Q){var re=this.loose?P[B]:P[F],ae=Q.match(re);if(!ae)throw new TypeError("Invalid comparator: "+Q);this.operator=ae[1],this.operator==="="&&(this.operator=""),ae[2]?this.semver=new X(ae[2],this.loose):this.semver=Fe},De.prototype.toString=function(){return this.value},De.prototype.test=function(Q){return R("Comparator.test",Q,this.loose),this.semver===Fe||(typeof Q=="string"&&(Q=new X(Q,this.loose)),Ee(Q,this.operator,this.semver,this.loose))},De.prototype.intersects=function(Q,re){if(!(Q instanceof De))throw new TypeError("a Comparator is required");var ae;if(this.operator==="")return ae=new Re(Q.value,re),$e(this.value,ae,re);if(Q.operator==="")return ae=new Re(this.value,re),$e(Q.semver,ae,re);var ye=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),Ae=this.semver.version===Q.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),Ue=Ee(this.semver,"<",Q.semver,re)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),Le=Ee(this.semver,">",Q.semver,re)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return ye||pe||Ae&&Ie||Ue||Le},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(Q){var re=this.loose;Q=Q.trim(),R("range",Q,re);var ae=re?P[W]:P[z];Q=Q.replace(ae,Ke),R("hyphen replace",Q),Q=Q.replace(P[U],"$1$2$3"),R("comparator trim",Q,P[U]),Q=(Q=(Q=Q.replace(P[x],"$1~")).replace(P[N],"$1^")).split(/\s+/).join(" ");var ye=re?P[B]:P[F],pe=Q.split(" ").map(function(Ae){return function(Ie,Ue){return R("comp",Ie),Ie=function(Le,Oe){return Le.trim().split(/\s+/).map(function(Me){return function(q,ie){R("caret",q,ie);var oe=ie?P[M]:P[_];return q.replace(oe,function(le,ce,fe,ve,we){var he;return R("caret",q,le,ce,fe,ve,we),Te(ce)?he="":Te(fe)?he=">="+ce+".0.0 <"+(+ce+1)+".0.0":Te(ve)?he=ce==="0"?">="+ce+"."+fe+".0 <"+ce+"."+(+fe+1)+".0":">="+ce+"."+fe+".0 <"+(+ce+1)+".0.0":we?(R("replaceCaret pr",we),we.charAt(0)!=="-"&&(we="-"+we),he=ce==="0"?fe==="0"?">="+ce+"."+fe+"."+ve+we+" <"+ce+"."+fe+"."+(+ve+1):">="+ce+"."+fe+"."+ve+we+" <"+ce+"."+(+fe+1)+".0":">="+ce+"."+fe+"."+ve+we+" <"+(+ce+1)+".0.0"):(R("no pr"),he=ce==="0"?fe==="0"?">="+ce+"."+fe+"."+ve+" <"+ce+"."+fe+"."+(+ve+1):">="+ce+"."+fe+"."+ve+" <"+ce+"."+(+fe+1)+".0":">="+ce+"."+fe+"."+ve+" <"+(+ce+1)+".0.0"),R("caret return",he),he})}(Me,Oe)}).join(" ")}(Ie,Ue),R("caret",Ie),Ie=function(Le,Oe){return Le.trim().split(/\s+/).map(function(Me){return function(q,ie){var oe=ie?P[H]:P[j];return q.replace(oe,function(le,ce,fe,ve,we){var he;return R("tilde",q,le,ce,fe,ve,we),Te(ce)?he="":Te(fe)?he=">="+ce+".0.0 <"+(+ce+1)+".0.0":Te(ve)?he=">="+ce+"."+fe+".0 <"+ce+"."+(+fe+1)+".0":we?(R("replaceTilde pr",we),we.charAt(0)!=="-"&&(we="-"+we),he=">="+ce+"."+fe+"."+ve+we+" <"+ce+"."+(+fe+1)+".0"):he=">="+ce+"."+fe+"."+ve+" <"+ce+"."+(+fe+1)+".0",R("tilde return",he),he})}(Me,Oe)}).join(" ")}(Ie,Ue),R("tildes",Ie),Ie=function(Le,Oe){return R("replaceXRanges",Le,Oe),Le.split(/\s+/).map(function(Me){return function(q,ie){q=q.trim();var oe=ie?P[f]:P[E];return q.replace(oe,function(le,ce,fe,ve,we,he){R("xRange",q,le,ce,fe,ve,we,he);var Pe=Te(fe),ke=Pe||Te(ve),Ne=ke||Te(we);return ce==="="&&Ne&&(ce=""),Pe?le=ce===">"||ce==="<"?"<0.0.0":"*":ce&&Ne?(ke&&(ve=0),Ne&&(we=0),ce===">"?(ce=">=",ke?(fe=+fe+1,ve=0,we=0):Ne&&(ve=+ve+1,we=0)):ce==="<="&&(ce="<",ke?fe=+fe+1:ve=+ve+1),le=ce+fe+"."+ve+"."+we):ke?le=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ne&&(le=">="+fe+"."+ve+".0 <"+fe+"."+(+ve+1)+".0"),R("xRange return",le),le})}(Me,Oe)}).join(" ")}(Ie,Ue),R("xrange",Ie),Ie=function(Le,Oe){return R("replaceStars",Le,Oe),Le.trim().replace(P[K],"")}(Ie,Ue),R("stars",Ie),Ie}(Ae,re)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(Ae){return!!Ae.match(ye)})),pe=pe.map(function(Ae){return new De(Ae,re)})},Re.prototype.intersects=function(Q,re){if(!(Q instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(ae){return ae.every(function(ye){return Q.set.some(function(pe){return pe.every(function(Ae){return ye.intersects(Ae,re)})})})})},e.toComparators=function(Q,re){return new Re(Q,re).set.map(function(ae){return ae.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new X(Q,this.loose));for(var re=0;re<this.set.length;re++)if(Ye(this.set[re],Q))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(Q,re,ae){var ye=null,pe=null;try{var Ae=new Re(re,ae)}catch(Ie){return null}return Q.forEach(function(Ie){Ae.test(Ie)&&(ye&&pe.compare(Ie)!==-1||(pe=new X(ye=Ie,ae)))}),ye},e.minSatisfying=function(Q,re,ae){var ye=null,pe=null;try{var Ae=new Re(re,ae)}catch(Ie){return null}return Q.forEach(function(Ie){Ae.test(Ie)&&(ye&&pe.compare(Ie)!==1||(pe=new X(ye=Ie,ae)))}),ye},e.validRange=function(Q,re){try{return new Re(Q,re).range||"*"}catch(ae){return null}},e.ltr=function(Q,re,ae){return je(Q,re,"<",ae)},e.gtr=function(Q,re,ae){return je(Q,re,">",ae)},e.outside=je,e.prerelease=function(Q,re){var ae=G(Q,re);return ae&&ae.prerelease.length?ae.prerelease:null},e.intersects=function(Q,re,ae){return Q=new Re(Q,ae),re=new Re(re,ae),Q.intersects(re)},e.coerce=function(Q){if(Q instanceof X)return Q;if(typeof Q!="string")return null;var re=Q.match(P[T]);return re==null?null:G((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,S(1))},function(Y,e){var S,L,R=Y.exports={};function k(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(D){if(S===setTimeout)return setTimeout(D,0);if((S===k||!S)&&setTimeout)return S=setTimeout,setTimeout(D,0);try{return S(D,0)}catch(b){try{return S.call(null,D,0)}catch(I){return S.call(this,D,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:k}catch(D){S=k}try{L=typeof clearTimeout=="function"?clearTimeout:A}catch(D){L=A}})();var v,w=[],n=!1,p=-1;function m(){n&&v&&(n=!1,v.length?w=v.concat(w):p=-1,w.length&&d())}function d(){if(!n){var D=P(m);n=!0;for(var b=w.length;b;){for(v=w,w=[];++p<b;)v&&v[p].run();p=-1,b=w.length}v=null,n=!1,function(I){if(L===clearTimeout)return clearTimeout(I);if((L===A||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(I);try{L(I)}catch(g){try{return L.call(null,I)}catch(s){return L.call(this,I)}}}(D)}}function h(D,b){this.fun=D,this.array=b}function C(){}R.nextTick=function(D){var b=new Array(arguments.length-1);if(arguments.length>1)for(var I=1;I<arguments.length;I++)b[I-1]=arguments[I];w.push(new h(D,b)),w.length!==1||n||P(d)},h.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=C,R.addListener=C,R.once=C,R.off=C,R.removeListener=C,R.removeAllListeners=C,R.emit=C,R.prependListener=C,R.prependOnceListener=C,R.listeners=function(D){return[]},R.binding=function(D){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(D){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(te[89],ne([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=S.globals.performance&&typeof S.globals.performance.now=="function";class R{constructor(A){this._highResolution=L&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new R(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?S.globals.performance.now():Date.now()}}e.StopWatch=R}),define(te[3],ne([0,1,9,65,2,88,89]),function(Y,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(g){g.None=()=>R.Disposable.None;function s(V){return(N,_=null,M)=>{let B=!1,F;return F=V(U=>{if(!B)return F?F.dispose():B=!0,N.call(_,U)},null,M),B&&F.dispose(),F}}g.once=s;function c(V,N){return o((_,M=null,B)=>V(F=>_.call(M,N(F)),null,B))}g.map=c;function t(V,N){return o((_,M=null,B)=>V(F=>{N(F),_.call(M,F)},null,B))}g.forEach=t;function r(V,N){return o((_,M=null,B)=>V(F=>N(F)&&_.call(M,F),null,B))}g.filter=r;function i(V){return V}g.signal=i;function a(...V){return(N,_=null,M)=>(0,R.combinedDisposable)(...V.map(B=>B(F=>N.call(_,F),null,M)))}g.any=a;function l(V,N,_){let M=_;return c(V,B=>(M=N(M,B),M))}g.reduce=l;function o(V){let N;const _=new m({onFirstListenerAdd(){N=V(_.fire,_)},onLastListenerRemove(){N.dispose()}});return _.event}function u(V,N,_=100,M=!1,B){let F,U,z,W=0;const K=new m({leakWarningThreshold:B,onFirstListenerAdd(){F=V($=>{W++,U=N(U,$),M&&!z&&(K.fire(U),U=void 0),clearTimeout(z),z=setTimeout(()=>{const G=U;U=void 0,z=void 0,(!M||W>1)&&K.fire(G),W=0},_)})},onLastListenerRemove(){F.dispose()}});return K.event}g.debounce=u;function y(V,N=(_,M)=>_===M){let _=!0,M;return r(V,B=>{const F=_||!N(B,M);return _=!1,M=B,F})}g.latch=y;function E(V,N){return[g.filter(V,N),g.filter(V,_=>!N(_))]}g.split=E;function f(V,N=!1,_=[]){let M=_.slice(),B=V(z=>{M?M.push(z):U.fire(z)});const F=()=>{M&&M.forEach(z=>U.fire(z)),M=null},U=new m({onFirstListenerAdd(){B||(B=V(z=>U.fire(z)))},onFirstListenerDidAdd(){M&&(N?setTimeout(F):F())},onLastListenerRemove(){B&&B.dispose(),B=null}});return U.event}g.buffer=f;class T{constructor(N){this.event=N}map(N){return new T(c(this.event,N))}forEach(N){return new T(t(this.event,N))}filter(N){return new T(r(this.event,N))}reduce(N,_){return new T(l(this.event,N,_))}latch(){return new T(y(this.event))}debounce(N,_=100,M=!1,B){return new T(u(this.event,N,_,M,B))}on(N,_,M){return this.event(N,_,M)}once(N,_,M){return s(this.event)(N,_,M)}}function O(V){return new T(V)}g.chain=O;function x(V,N,_=M=>M){const M=(...z)=>U.fire(_(...z)),B=()=>V.on(N,M),F=()=>V.removeListener(N,M),U=new m({onFirstListenerAdd:B,onLastListenerRemove:F});return U.event}g.fromNodeEventEmitter=x;function j(V,N,_=M=>M){const M=(...z)=>U.fire(_(...z)),B=()=>V.addEventListener(N,M),F=()=>V.removeEventListener(N,M),U=new m({onFirstListenerAdd:B,onLastListenerRemove:F});return U.event}g.fromDOMEventEmitter=j;function H(V){return new Promise(N=>s(V)(N))}g.toPromise=H})(P=e.Event||(e.Event={}));class v{constructor(s){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${s}_${v._idPool++}`}start(s){this._stopWatch=new A.StopWatch(!0),this._listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this._elapsedOverall+=s,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${s.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}v._idPool=0;let w=-1;function n(g){const s=w;return w=g,{dispose(){w=s}}}e.setGlobalLeakWarningThreshold=n;class p{constructor(s,c=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s){let c=w;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),c<=0||s<c)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let i,a=0;for(const[l,o]of this._stacks)(!i||a<o)&&(i=l,a=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${a}):`),console.warn(i)}return()=>{const i=this._stacks.get(t)||0;this._stacks.set(t,i-1)}}}class m{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=w>0?new p(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new v(this._options._profName):void 0}get event(){return this._event||(this._event=(s,c,t)=>{this._listeners||(this._listeners=new k.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(c?[s,c]:s);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,c);const a=this._leakageMon?.check(this._listeners.size),l=(0,R.toDisposable)(()=>{a&&a(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof R.DisposableStore?t.add(l):Array.isArray(t)&&t.push(l),l}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,s]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,t]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,t):c[0].call(c[1],t)}catch(r){(0,S.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=m;class d extends m{async fireAsync(s,c,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,s]);for(;this._asyncDeliveryQueue.size>0&&!c.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),a=[],l={...i,waitUntil:o=>{if(Object.isFrozen(a))throw new Error("waitUntil can NOT be called asynchronous");t&&(o=t(o,typeof r=="function"?r:r[0])),a.push(o)}};try{typeof r=="function"?r.call(void 0,l):r[0].call(r[1],l)}catch(o){(0,S.onUnexpectedError)(o);continue}Object.freeze(a),await Promise.allSettled(a).then(o=>{for(const u of o)u.status==="rejected"&&(0,S.onUnexpectedError)(u.reason)})}}}}e.AsyncEmitter=d;class h extends m{constructor(s){super(s);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}e.PauseableEmitter=h;class C extends h{constructor(s){super(s);this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}e.DebounceEmitter=C;class D{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const c={event:s,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const t=()=>{this.hasListeners&&this.unhook(c);const r=this.events.indexOf(c);this.events.splice(r,1)};return(0,R.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(c=>this.emitter.fire(c))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=D;class b{constructor(){this.buffers=[]}wrapEvent(s){return(c,t,r)=>s(i=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>c.call(t,i)):c.call(t,i)},void 0,r)}bufferEvents(s){const c=[];this.buffers.push(c);const t=s();return this.buffers.pop(),c.forEach(r=>r()),t}}e.EventBufferer=b;class I{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=R.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=I}),define(te[29],ne([0,1,3]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(P,v){const w=setTimeout(P.bind(v),0);return{dispose(){clearTimeout(w)}}});var R;(function(P){function v(w){return w===P.None||w===P.Cancelled||w instanceof k?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}P.isCancellationToken=v,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(R=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(v){this._token=void 0,this._parentListener=void 0,this._parentListener=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=R.Cancelled}dispose(v=!1){v&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=A}),define(te[54],ne([0,1,3]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new S.Emitter}add(p){const m=this._icons.get(p.id);m?p.description?m.description=p.description:console.error(`Duplicate registration of codicon ${p.id}`):(this._icons.set(p.id,p),this._onDidRegister.fire(p))}get(p){return this._icons.get(p)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new L;e.iconRegistry=R;function k(n,p){return new P(n,p)}e.registerCodicon=k;function A(n){return n?n.replace(/\$\((.*?)\)/g,(p,m)=>` ${m} `).trim():""}e.getCodiconAriaLabel=A;class P{constructor(p,m,d){this.id=p,this.definition=m,this.description=d,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function v(n,p){const m=["codicon","codicon-"+n];return p&&m.push("codicon-modifier-"+p),m}e.getClassNamesArray=v;var w;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const p=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function m(C){if(C instanceof P)return["codicon","codicon-"+C.id];const D=p.exec(C.id);if(!D)return m(P.error);let[,b,I]=D;const g=["codicon","codicon-"+b];return I&&g.push("codicon-modifier-"+I.substr(1)),g}n.asClassNameArray=m;function d(C){return m(C).join(" ")}n.asClassName=d;function h(C){return"."+m(C).join(".")}n.asCSSSelector=h})(w=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(te[47],ne([0,1,9,2]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(g){const s=g;return s?[s.on,s.pause,s.resume,s.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=R;function k(g){const s=g;return s?R(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=k;function A(g,s){return new P(g,s)}e.newWriteableStream=A;class P{constructor(s,c){this.reducer=s,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(c=>c(s))}emitError(s){this.listeners.error.length===0?(0,S.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(c=>c(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,c){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(s,c){if(this.state.destroyed)return;let t;switch(s){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(c);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function v(g,s){const c=[];let t;for(;(t=g.read())!==null;)c.push(t);return s(c)}e.consumeReadable=v;function w(g,s,c){const t=[];let r;for(;(r=g.read())!==null&&t.length<c;)t.push(r);return r===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return g.read()}}}e.peekReadable=w;function n(g,s){return new Promise((c,t)=>{const r=[];p(g,{onData:i=>{s&&r.push(i)},onError:i=>{s?t(i):c(void 0)},onEnd:()=>{c(s?s(r):void 0)}})})}e.consumeStream=n;function p(g,s){g.on("error",c=>s.onError(c)),g.on("end",()=>s.onEnd()),g.on("data",c=>s.onData(c))}e.listenStream=p;function m(g,s){return new Promise((c,t)=>{const r=new L.DisposableStore,i=[],a=u=>{if(i.push(u),i.length>s)return r.dispose(),g.pause(),c({stream:g,buffer:i,ended:!1})},l=u=>t(u),o=()=>c({stream:g,buffer:i,ended:!0});r.add((0,L.toDisposable)(()=>g.removeListener("error",l))),g.on("error",l),r.add((0,L.toDisposable)(()=>g.removeListener("end",o))),g.on("end",o),r.add((0,L.toDisposable)(()=>g.removeListener("data",a))),g.on("data",a)})}e.peekStream=m;function d(g,s){const c=A(s);return c.end(g),c}e.toStream=d;function h(){const g=A(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=h;function C(g){let s=!1;return{read:()=>s?null:(s=!0,g)}}e.toReadable=C;function D(g,s,c){const t=A(c);return p(g,{onData:r=>t.write(s.data(r)),onError:r=>t.error(s.error?s.error(r):r),onEnd:()=>t.end()}),t}e.transform=D;function b(g,s,c){let t=!1;return{read:()=>{const r=s.read();return t?r:(t=!0,r!==null?c([g,r]):g)}}}e.prefixedReadable=b;function I(g,s,c){let t=!1;const r=A(c);return p(s,{onData:i=>t?r.write(i):(t=!0,r.write(c([g,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(g)),r.end()}}),r}e.prefixedStream=I}),define(te[19],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function S(q){return!q||typeof q!="string"?!0:q.trim().length===0}e.isFalsyOrWhitespace=S;const L=/{(\d+)}/g;function R(q,...ie){return ie.length===0?q:q.replace(L,function(oe,le){const ce=parseInt(le,10);return isNaN(ce)||ce<0||ce>=ie.length?oe:ie[ce]})}e.format=R;const k=/{([^}]+)}/g;function A(q,ie){return q.replace(k,(oe,le)=>ie[le]??oe)}e.format2=A;function P(q){return q.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=P;function v(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=v;function w(q,ie){let oe=0;const le=ie.charCodeAt(0);for(let ce=q.length-1;ce>=0;ce--)q.charCodeAt(ce)===le&&oe++;return oe}e.count=w;function n(q,ie,oe="\u2026"){return q.length<=ie?q:`${q.substr(0,ie)}${oe}`}e.truncate=n;function p(q,ie=" "){const oe=m(q,ie);return d(oe,ie)}e.trim=p;function m(q,ie){if(!q||!ie)return q;const oe=ie.length;if(oe===0||q.length===0)return q;let le=0;for(;q.indexOf(ie,le)===le;)le=le+oe;return q.substring(le)}e.ltrim=m;function d(q,ie){if(!q||!ie)return q;const oe=ie.length,le=q.length;if(oe===0||le===0)return q;let ce=le,fe=-1;for(;fe=q.lastIndexOf(ie,ce-1),!(fe===-1||fe+oe!==ce);){if(fe===0)return"";ce=fe}return q.substring(0,ce)}e.rtrim=d;function h(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function C(q){return q.replace(/\*/g,"")}e.stripWildcards=C;function D(q,ie,oe={}){if(!q)throw new Error("Cannot create regex from empty string");ie||(q=v(q)),oe.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let le="";return oe.global&&(le+="g"),oe.matchCase||(le+="i"),oe.multiline&&(le+="m"),oe.unicode&&(le+="u"),new RegExp(q,le)}e.createRegExp=D;function b(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function I(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=I;function g(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}e.regExpFlags=g;function s(q){return q.split(/\r\n|\r|\n/)}e.splitLines=s;function c(q){for(let ie=0,oe=q.length;ie<oe;ie++){const le=q.charCodeAt(ie);if(le!==32&&le!==9)return ie}return-1}e.firstNonWhitespaceIndex=c;function t(q,ie=0,oe=q.length){for(let le=ie;le<oe;le++){const ce=q.charCodeAt(le);if(ce!==32&&ce!==9)return q.substring(ie,le)}return q.substring(ie,oe)}e.getLeadingWhitespace=t;function r(q,ie=q.length-1){for(let oe=ie;oe>=0;oe--){const le=q.charCodeAt(oe);if(le!==32&&le!==9)return oe}return-1}e.lastNonWhitespaceIndex=r;function i(q,ie){return q<ie?-1:q>ie?1:0}e.compare=i;function a(q,ie,oe=0,le=q.length,ce=0,fe=ie.length){for(;oe<le&&ce<fe;oe++,ce++){let he=q.charCodeAt(oe),Pe=ie.charCodeAt(ce);if(he<Pe)return-1;if(he>Pe)return 1}const ve=le-oe,we=fe-ce;return ve<we?-1:ve>we?1:0}e.compareSubstring=a;function l(q,ie){return o(q,ie,0,q.length,0,ie.length)}e.compareIgnoreCase=l;function o(q,ie,oe=0,le=q.length,ce=0,fe=ie.length){for(;oe<le&&ce<fe;oe++,ce++){let he=q.charCodeAt(oe),Pe=ie.charCodeAt(ce);if(he===Pe)continue;const ke=he-Pe;if(!(ke===32&&y(Pe))&&!(ke===-32&&y(he)))return u(he)&&u(Pe)?ke:a(q.toLowerCase(),ie.toLowerCase(),oe,le,ce,fe)}const ve=le-oe,we=fe-ce;return ve<we?-1:ve>we?1:0}e.compareSubstringIgnoreCase=o;function u(q){return q>=97&&q<=122}e.isLowerAsciiLetter=u;function y(q){return q>=65&&q<=90}e.isUpperAsciiLetter=y;function E(q){return u(q)||y(q)}function f(q,ie){return q.length===ie.length&&T(q,ie)}e.equalsIgnoreCase=f;function T(q,ie,oe=q.length){for(let le=0;le<oe;le++){const ce=q.charCodeAt(le),fe=ie.charCodeAt(le);if(ce!==fe){if(E(ce)&&E(fe)){const ve=Math.abs(ce-fe);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(ce).toLowerCase()!==String.fromCharCode(fe).toLowerCase())return!1}}return!0}function O(q,ie){const oe=ie.length;return ie.length>q.length?!1:T(q,ie,oe)}e.startsWithIgnoreCase=O;function x(q,ie){let oe,le=Math.min(q.length,ie.length);for(oe=0;oe<le;oe++)if(q.charCodeAt(oe)!==ie.charCodeAt(oe))return oe;return le}e.commonPrefixLength=x;function j(q,ie){let oe,le=Math.min(q.length,ie.length);const ce=q.length-1,fe=ie.length-1;for(oe=0;oe<le;oe++)if(q.charCodeAt(ce-oe)!==ie.charCodeAt(fe-oe))return oe;return le}e.commonSuffixLength=j;function H(q){return 55296<=q&&q<=56319}e.isHighSurrogate=H;function V(q){return 56320<=q&&q<=57343}e.isLowSurrogate=V;function N(q,ie){return(q-55296<<10)+(ie-56320)+65536}e.computeCodePoint=N;function _(q,ie,oe){const le=q.charCodeAt(oe);if(H(le)&&oe+1<ie){const ce=q.charCodeAt(oe+1);if(V(ce))return N(le,ce)}return le}e.getNextCodePoint=_;function M(q,ie){const oe=q.charCodeAt(ie-1);if(V(oe)&&ie>1){const le=q.charCodeAt(ie-2);if(H(le))return N(le,oe)}return oe}function B(q,ie){const oe=pe.getInstance(),le=ie,ce=q.length,fe=_(q,ce,ie);ie+=fe>=65536?2:1;let ve=oe.getGraphemeBreakType(fe);for(;ie<ce;){const we=_(q,ce,ie),he=oe.getGraphemeBreakType(we);if(ae(ve,he))break;ie+=we>=65536?2:1,ve=he}return ie-le}e.nextCharLength=B;function F(q,ie){const oe=pe.getInstance(),le=ie,ce=M(q,ie);ie-=ce>=65536?2:1;let fe=oe.getGraphemeBreakType(ce);for(;ie>0;){const ve=M(q,ie),we=oe.getGraphemeBreakType(ve);if(ae(we,fe))break;ie-=ve>=65536?2:1,fe=we}return le-ie}e.prevCharLength=F;function U(q,ie){const oe=pe.getInstance(),le=q.length,ce=ie,fe=_(q,le,ie),ve=oe.getGraphemeBreakType(fe);ie+=fe>=65536?2:1;let we=ve;for(;ie<le;){const Pe=_(q,le,ie),ke=oe.getGraphemeBreakType(Pe);if(ae(we,ke))break;ie+=Pe>=65536?2:1,we=ke}const he=ie;for(ie=ce,we=ve;ie>0;){const Pe=M(q,ie),ke=oe.getGraphemeBreakType(Pe);if(ae(ke,we))break;ie-=Pe>=65536?2:1,we=ke}return[ie,he]}function z(q,ie){return ie>0&&V(q.charCodeAt(ie))?U(q,ie-1):U(q,ie)}e.getCharContainingOffset=z;function W(q){const ie=q.length;let oe=0,le=0;for(;le<ie;){const ve=_(q,ie,le);le+=ve>=65536?2:1,ve<128?oe+=1:ve<2048?oe+=2:ve<65536?oe+=3:oe+=4}const ce=new Uint8Array(oe);le=0;let fe=0;for(;le<ie;){const ve=_(q,ie,le);le+=ve>=65536?2:1,ve<128?ce[fe++]=ve:ve<2048?(ce[fe++]=192|(ve&1984)>>>6,ce[fe++]=128|(ve&63)>>>0):ve<65536?(ce[fe++]=224|(ve&61440)>>>12,ce[fe++]=128|(ve&4032)>>>6,ce[fe++]=128|(ve&63)>>>0):(ce[fe++]=240|(ve&1835008)>>>18,ce[fe++]=128|(ve&258048)>>>12,ce[fe++]=128|(ve&4032)>>>6,ce[fe++]=128|(ve&63)>>>0)}return ce}e.encodeUTF8=W;function K(q){const ie=q.byteLength,oe=[];let le=0;for(;le<ie;){const ce=q[le];let fe;if(ce>=240&&le+3<ie?fe=(q[le++]&7)<<18>>>0|(q[le++]&63)<<12>>>0|(q[le++]&63)<<6>>>0|(q[le++]&63)<<0>>>0:ce>=224&&le+2<ie?fe=(q[le++]&15)<<12>>>0|(q[le++]&63)<<6>>>0|(q[le++]&63)<<0>>>0:ce>=192&&le+1<ie?fe=(q[le++]&31)<<6>>>0|(q[le++]&63)<<0>>>0:fe=q[le++],fe>=0&&fe<=55295||fe>=57344&&fe<=65535)oe.push(String.fromCharCode(fe));else if(fe>=65536&&fe<=1114111){const ve=fe-65536,we=55296+((ve&1047552)>>>10),he=56320+((ve&1023)>>>0);oe.push(String.fromCharCode(we)),oe.push(String.fromCharCode(he))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=K;const $=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function G(q){return $.test(q)}e.containsRTL=G;const X=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Z(q){return X.test(q)}e.containsEmoji=Z;const ee=/^[\t\n\r\x20-\x7E]*$/;function se(q){return ee.test(q)}e.isBasicASCII=se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ue(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}e.containsUnusualLineTerminators=ue;function ge(q){for(let ie=0,oe=q.length;ie<oe;ie++)if(me(q.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=ge;function me(q){return q=+q,q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}e.isFullWidthCharacter=me;function Se(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129003||q>=129280&&q<=129535||q>=129648&&q<=129750}e.isEmojiImprecise=Se;function be(q,ie){if(q.length<ie)return q;const oe=/\b/g;let le=0;for(;oe.test(q)&&!(q.length-oe.lastIndex<ie);)le=oe.lastIndex,oe.lastIndex+=1;return q.substring(le).replace(/^\s/,"")}e.lcut=be;const Ce=/\x1B\x5B[12]?K/g,Ee=/\x1b\[\d+m/g,De=/\x1b\[0?m/g;function Fe(q){return q&&(q=q.replace(Ce,""),q=q.replace(Ee,""),q=q.replace(De,"")),q}e.removeAnsiEscapeCodes=Fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function Te(q){return Re(q)?q.substr(1):q}e.stripUTF8BOM=Te;function Ke(q,ie){if(!q||!ie||q.length<ie.length)return!1;const oe=ie.length,le=q.toLowerCase();let ce=0,fe=-1;for(;ce<oe;){const ve=le.indexOf(ie[ce],fe+1);if(ve<0)return!1;fe=ve,ce++}return!0}e.fuzzyContains=Ke;function Ye(q,ie=!1){return q?(ie&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}e.containsUppercaseCharacter=Ye;function $e(q){return q.charAt(0).toUpperCase()+q.slice(1)}e.uppercaseFirstLetter=$e;function je(q,ie=1){if(ie===0)return"";let oe=-1;do oe=q.indexOf(`
`,oe+1),ie--;while(ie>0&&oe>=0);return oe===-1?q:(q[oe-1]==="\r"&&oe--,q.substr(0,oe))}e.getNLines=je;function Q(q){const ie=90-65+1;return q=q%(2*ie),q<ie?String.fromCharCode(97+q):String.fromCharCode(65+q-ie)}e.singleLetterHash=Q;function re(q){return pe.getInstance().getGraphemeBreakType(q)}e.getGraphemeBreakType=re;function ae(q,ie){return q===0?ie!==5&&ie!==7:q===2&&ie===3?!1:q===4||q===2||q===3||ie===4||ie===2||ie===3?!0:!(q===8&&(ie===8||ie===9||ie===11||ie===12)||(q===11||q===9)&&(ie===9||ie===10)||(q===12||q===10)&&ie===10||ie===5||ie===13||ie===7||q===1||q===13&&ie===14||q===6&&ie===6)}e.breakBetweenGraphemeBreakType=ae;var ye;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(ye=e.GraphemeBreakType||(e.GraphemeBreakType={}));class pe{constructor(){this._data=Ae()}static getInstance(){return pe._INSTANCE||(pe._INSTANCE=new pe),pe._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const oe=this._data,le=oe.length/3;let ce=1;for(;ce<=le;)if(ie<oe[3*ce])ce=2*ce;else if(ie>oe[3*ce+1])ce=2*ce+1;else return oe[3*ce+2];return 0}}pe._INSTANCE=null;function Ae(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ie(q,ie){if(q===0)return 0;const oe=Ue(q,ie);if(oe!==void 0)return oe;const le=M(ie,q);return q-=Le(le),q}e.getLeftDeleteOffset=Ie;function Ue(q,ie){let oe=M(ie,q);for(q-=Le(oe);Oe(oe)||oe===65039||oe===8419;){if(q===0)return;oe=M(ie,q),q-=Le(oe)}if(!!Se(oe)){if(q>=0){const le=M(ie,q);le===8205&&(q-=Le(le))}return q}}function Le(q){return q>=65536?2:1}function Oe(q){return 127995<=q&&q<=127999}var Me;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={}))}),define(te[25],ne([0,1,19,47]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined",k=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let P,v;class w{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return R?new w(Buffer.allocUnsafe(u)):new w(new Uint8Array(u))}static wrap(u){return R&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new w(u)}static fromString(u,y){return!(y?.dontUseNodeBuffer||!1)&&R?new w(Buffer.from(u)):k?(P||(P=new TextEncoder),new w(P.encode(u))):new w(S.encodeUTF8(u))}static concat(u,y){if(typeof y=="undefined"){y=0;for(let T=0,O=u.length;T<O;T++)y+=u[T].byteLength}const E=w.alloc(y);let f=0;for(let T=0,O=u.length;T<O;T++){const x=u[T];E.set(x,f),f+=x.byteLength}return E}toString(){return R?this.buffer.toString():A?(v||(v=new TextDecoder),v.decode(this.buffer)):S.decodeUTF8(this.buffer)}slice(u,y){return new w(this.buffer.subarray(u,y))}set(u,y){u instanceof w?this.buffer.set(u.buffer,y):this.buffer.set(u,y)}readUInt32BE(u){return m(this.buffer,u)}writeUInt32BE(u,y){d(this.buffer,u,y)}readUInt32LE(u){return h(this.buffer,u)}writeUInt32LE(u,y){C(this.buffer,u,y)}readUInt8(u){return D(this.buffer,u)}writeUInt8(u,y){b(this.buffer,u,y)}}e.VSBuffer=w;function n(o,u){return o[u+0]<<0>>>0|o[u+1]<<8>>>0}e.readUInt16LE=n;function p(o,u,y){o[y+0]=u&255,u=u>>>8,o[y+1]=u&255}e.writeUInt16LE=p;function m(o,u){return o[u]*2**24+o[u+1]*2**16+o[u+2]*2**8+o[u+3]}e.readUInt32BE=m;function d(o,u,y){o[y+3]=u,u=u>>>8,o[y+2]=u,u=u>>>8,o[y+1]=u,u=u>>>8,o[y]=u}e.writeUInt32BE=d;function h(o,u){return o[u+0]<<0>>>0|o[u+1]<<8>>>0|o[u+2]<<16>>>0|o[u+3]<<24>>>0}e.readUInt32LE=h;function C(o,u,y){o[y+0]=u&255,u=u>>>8,o[y+1]=u&255,u=u>>>8,o[y+2]=u&255,u=u>>>8,o[y+3]=u&255}e.writeUInt32LE=C;function D(o,u){return o[u]}e.readUInt8=D;function b(o,u,y){o[y]=u}e.writeUInt8=b;function I(o){return L.consumeReadable(o,u=>w.concat(u))}e.readableToBuffer=I;function g(o){return L.toReadable(o)}e.bufferToReadable=g;function s(o){return L.consumeStream(o,u=>w.concat(u))}e.streamToBuffer=s;async function c(o){return o.ended?w.concat(o.buffer):w.concat([...o.buffer,await s(o.stream)])}e.bufferedStreamToBuffer=c;function t(o){return L.toStream(o,u=>w.concat(u))}e.bufferToStream=t;function r(o){return L.transform(o,{data:u=>typeof u=="string"?w.fromString(u):w.wrap(u)},u=>w.concat(u))}e.streamToBufferReadableStream=r;function i(o){return L.newWriteableStream(u=>w.concat(u),o)}e.newWriteableBufferStream=i;function a(o,u){return L.prefixedReadable(o,u,y=>w.concat(y))}e.prefixedBufferReadable=a;function l(o,u){return L.prefixedStream(o,u,y=>w.concat(y))}e.prefixedBufferStream=l}),define(te[14],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function S(u){return Array.isArray(u)}e.isArray=S;function L(u){return typeof u=="string"}e.isString=L;function R(u){return Array.isArray(u)&&u.every(y=>L(y))}e.isStringArray=R;function k(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=k;function A(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=A;function P(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=P;function v(u){return u===!0||u===!1}e.isBoolean=v;function w(u){return typeof u=="undefined"}e.isUndefined=w;function n(u){return!p(u)}e.isDefined=n;function p(u){return w(u)||u===null}e.isUndefinedOrNull=p;function m(u,y){if(!u)throw new Error(y?`Unexpected type, expected '${y}'`:"Unexpected type")}e.assertType=m;function d(u){if(p(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=d;function h(...u){const y=[];for(let E=0;E<u.length;E++){const f=u[E];if(p(f))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);y.push(f)}return y}e.assertAllDefined=h;const C=Object.prototype.hasOwnProperty;function D(u){if(!k(u))return!1;for(let y in u)if(C.call(u,y))return!1;return!0}e.isEmptyObject=D;function b(u){return typeof u=="function"}e.isFunction=b;function I(...u){return u.length>0&&u.every(b)}e.areFunctions=I;function g(u,y){const E=Math.min(u.length,y.length);for(let f=0;f<E;f++)s(u[f],y[f])}e.validateConstraints=g;function s(u,y){if(L(y)){if(typeof u!==y)throw new Error(`argument does not match constraint: typeof ${y}`)}else if(b(y)){try{if(u instanceof y)return}catch{}if(!p(u)&&u.constructor===y||y.length===1&&y.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function c(u){let y=[],E=Object.getPrototypeOf(u);for(;Object.prototype!==E;)y=y.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return y}e.getAllPropertyNames=c;function t(u){const y=[];for(const E of c(u))typeof u[E]=="function"&&y.push(E);return y}e.getAllMethodNames=t;function r(u,y){const E=T=>function(){const O=Array.prototype.slice.call(arguments,0);return y(T,O)};let f={};for(const T of u)f[T]=E(T);return f}e.createProxyObject=r;function i(u){return u===null?void 0:u}e.withNullAsUndefined=i;function a(u){return typeof u=="undefined"?null:u}e.withUndefinedAsNull=a;function l(u){return class{constructor(){return new Proxy({},{get(y,E){if(y[E])return y[E];throw new Error(`Not Implemented: ${u}->${String(E)}`)}})}}}e.NotImplementedProxy=l;function o(u){throw new Error("Unreachable")}e.assertNever=o}),define(te[41],ne([0,1,7,19,8,14]),function(Y,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(i){return i===47||i===92}e.isPathSeparator=A;function P(i){return i.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=P;function v(i){return i.indexOf("/")===-1&&(i=P(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=v;function w(i,a=R.posix.sep){if(!i)return"";const l=i.length,o=i.charCodeAt(0);if(A(o)){if(A(i.charCodeAt(1))&&!A(i.charCodeAt(2))){let y=3;const E=y;for(;y<l&&!A(i.charCodeAt(y));y++);if(E!==y&&!A(i.charCodeAt(y+1))){for(y+=1;y<l;y++)if(A(i.charCodeAt(y)))return i.slice(0,y+1).replace(/[\\/]/g,a)}}return a}else if(b(o)&&i.charCodeAt(1)===58)return A(i.charCodeAt(2))?i.slice(0,2)+a:i.slice(0,2);let u=i.indexOf("://");if(u!==-1){for(u+=3;u<l;u++)if(A(i.charCodeAt(u)))return i.slice(0,u+1)}return""}e.getRoot=w;function n(i){if(!S.isWindows||!i||i.length<5)return!1;let a=i.charCodeAt(0);if(a!==92||(a=i.charCodeAt(1),a!==92))return!1;let l=2;const o=l;for(;l<i.length&&(a=i.charCodeAt(l),a!==92);l++);return!(o===l||(a=i.charCodeAt(l+1),isNaN(a)||a===92))}e.isUNC=n;const p=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(i,a=S.isWindows){const l=a?p:m;return!(!i||i.length===0||/^\s+$/.test(i)||(l.lastIndex=0,l.test(i))||a&&d.test(i)||i==="."||i===".."||a&&i[i.length-1]==="."||a&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=h;function C(i,a,l){const o=i===a;return!l||o?o:!i||!a?!1:(0,L.equalsIgnoreCase)(i,a)}e.isEqual=C;function D(i,a,l,o=R.sep){if(i===a)return!0;if(!i||!a||a.length>i.length)return!1;if(l){if(!(0,L.startsWithIgnoreCase)(i,a))return!1;if(a.length===i.length)return!0;let y=a.length;return a.charAt(a.length-1)===o&&y--,i.charAt(y)===o}return a.charAt(a.length-1)!==o&&(a+=o),i.indexOf(a)===0}e.isEqualOrParent=D;function b(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=b;function I(i,a){return S.isWindows&&i.endsWith(":")&&(i+=R.sep),(0,R.isAbsolute)(i)||(i=(0,R.join)(a,i)),i=(0,R.normalize)(i),S.isWindows?(i=(0,L.rtrim)(i,R.sep),i.endsWith(":")&&(i+=R.sep)):(i=(0,L.rtrim)(i,R.sep),i||(i=R.sep)),i}e.sanitizeFilePath=I;function g(i){const a=(0,R.normalize)(i);return S.isWindows?i.length>3?!1:s(a)&&(i.length===2||a.charCodeAt(2)===92):a===R.posix.sep}e.isRootOrDriveLetter=g;function s(i){return S.isWindows?b(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=s;function c(i){return s(i)?i[0]:void 0}e.getDriveLetter=c;function t(i,a,l){return a.length>i.length?-1:i===a?0:(l&&(i=i.toLowerCase(),a=a.toLowerCase()),i.indexOf(a))}e.indexOfPath=t;function r(i){const a=i.split(":");let l,o,u;if(a.forEach(y=>{const E=Number(y);(0,k.isNumber)(E)?o===void 0?o=E:u===void 0&&(u=E):l=l?[l,y].join(":"):y}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:o!==void 0?o:void 0,column:u!==void 0?u:o!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(te[26],ne([0,1,14]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(C){if(!C||typeof C!="object"||C instanceof RegExp)return C;const D=Array.isArray(C)?[]:{};return Object.keys(C).forEach(b=>{C[b]&&typeof C[b]=="object"?D[b]=L(C[b]):D[b]=C[b]}),D}e.deepClone=L;function R(C){if(!C||typeof C!="object")return C;const D=[C];for(;D.length>0;){const b=D.shift();Object.freeze(b);for(const I in b)if(k.call(b,I)){const g=b[I];typeof g=="object"&&!Object.isFrozen(g)&&D.push(g)}}return C}e.deepFreeze=R;const k=Object.prototype.hasOwnProperty;function A(C,D){return P(C,D,new Set)}e.cloneAndChange=A;function P(C,D,b){if((0,S.isUndefinedOrNull)(C))return C;const I=D(C);if(typeof I!="undefined")return I;if((0,S.isArray)(C)){const g=[];for(const s of C)g.push(P(s,D,b));return g}if((0,S.isObject)(C)){if(b.has(C))throw new Error("Cannot clone recursive data-structure");b.add(C);const g={};for(let s in C)k.call(C,s)&&(g[s]=P(C[s],D,b));return b.delete(C),g}return C}function v(C,D,b=!0){return(0,S.isObject)(C)?((0,S.isObject)(D)&&Object.keys(D).forEach(I=>{I in C?b&&((0,S.isObject)(C[I])&&(0,S.isObject)(D[I])?v(C[I],D[I],b):C[I]=D[I]):C[I]=D[I]}),C):D}e.mixin=v;function w(C,D){if(C===D)return!0;if(C==null||D===null||D===void 0||typeof C!=typeof D||typeof C!="object"||Array.isArray(C)!==Array.isArray(D))return!1;let b,I;if(Array.isArray(C)){if(C.length!==D.length)return!1;for(b=0;b<C.length;b++)if(!w(C[b],D[b]))return!1}else{const g=[];for(I in C)g.push(I);g.sort();const s=[];for(I in D)s.push(I);if(s.sort(),!w(g,s))return!1;for(b=0;b<g.length;b++)if(!w(C[g[b]],D[g[b]]))return!1}return!0}e.equals=w;function n(C){const D=new Set;return JSON.stringify(C,(b,I)=>{if((0,S.isObject)(I)||Array.isArray(I)){if(D.has(I))return"[Circular]";D.add(I)}return I})}e.safeStringify=n;function p(C,D,b){const I=D(C);return typeof I=="undefined"?b:I}e.getOrDefault=p;function m(C,D){const b=Object.create(null);return!C||!D||Object.keys(D).forEach(g=>{const s=C[g],c=D[g];w(s,c)||(b[g]=c)}),b}e.distinct=m;function d(C,D){const b=D.toLowerCase(),I=Object.keys(C).find(g=>g.toLowerCase()===b);return I?C[I]:C[D]}e.getCaseInsensitive=d;function h(C,D){const b=Object.create(null);for(const I of Object.keys(C))D(I,C[I])&&(b[I]=C[I]);return b}e.filter=h}),define(te[5],ne([0,1,7,8]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,k=/^\//,A=/^\/\//;function P(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!R.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!k.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(i,a){return!i&&!a?"file":i}function w(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==p&&(a=p+a):a=p;break}return a}const n="",p="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{constructor(a,l,o,u,y,E=!1){typeof a=="object"?(this.scheme=a.scheme||n,this.authority=a.authority||n,this.path=a.path||n,this.query=a.query||n,this.fragment=a.fragment||n):(this.scheme=v(a,E),this.authority=l||n,this.path=w(this.scheme,o||n),this.query=u||n,this.fragment=y||n,P(this,E))}static isUri(a){return a instanceof d?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return g(this,!1)}with(a){if(!a)return this;let{scheme:l,authority:o,path:u,query:y,fragment:E}=a;return l===void 0?l=this.scheme:l===null&&(l=n),o===void 0?o=this.authority:o===null&&(o=n),u===void 0?u=this.path:u===null&&(u=n),y===void 0?y=this.query:y===null&&(y=n),E===void 0?E=this.fragment:E===null&&(E=n),l===this.scheme&&o===this.authority&&u===this.path&&y===this.query&&E===this.fragment?this:new C(l,o,u,y,E)}static parse(a,l=!1){const o=m.exec(a);return o?new C(o[2]||n,r(o[4]||n),r(o[5]||n),r(o[7]||n),r(o[9]||n),l):new C(n,n,n,n,n)}static file(a){let l=n;if(S.isWindows&&(a=a.replace(/\\/g,p)),a[0]===p&&a[1]===p){const o=a.indexOf(p,2);o===-1?(l=a.substring(2),a=p):(l=a.substring(2,o),a=a.substring(o)||p)}return new C("file",l,a,n,n)}static from(a){const l=new C(a.scheme,a.authority,a.path,a.query,a.fragment);return P(l,!0),l}static joinPath(a,...l){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return S.isWindows&&a.scheme==="file"?o=d.file(L.win32.join(g(a,!0),...l)).path:o=L.posix.join(a.path,...l),a.with({path:o})}toString(a=!1){return s(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof d)return a;{const l=new C(a);return l._formatted=a.external,l._fsPath=a._sep===h?a.fsPath:null,l}}else return a}}e.URI=d;const h=S.isWindows?1:void 0;class C extends d{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(a=!1){return a?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=h),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(i,a){let l,o=-1;for(let u=0;u<i.length;u++){const y=i.charCodeAt(u);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||a&&y===47)o!==-1&&(l+=encodeURIComponent(i.substring(o,u)),o=-1),l!==void 0&&(l+=i.charAt(u));else{l===void 0&&(l=i.substr(0,u));const E=D[y];E!==void 0?(o!==-1&&(l+=encodeURIComponent(i.substring(o,u)),o=-1),l+=E):o===-1&&(o=u)}}return o!==-1&&(l+=encodeURIComponent(i.substring(o))),l!==void 0?l:i}function I(i){let a;for(let l=0;l<i.length;l++){const o=i.charCodeAt(l);o===35||o===63?(a===void 0&&(a=i.substr(0,l)),a+=D[o]):a!==void 0&&(a+=i[l])}return a!==void 0?a:i}function g(i,a){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,S.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=g;function s(i,a){const l=a?I:b;let o="",{scheme:u,authority:y,path:E,query:f,fragment:T}=i;if(u&&(o+=u,o+=":"),(y||u==="file")&&(o+=p,o+=p),y){let O=y.indexOf("@");if(O!==-1){const x=y.substr(0,O);y=y.substr(O+1),O=x.indexOf(":"),O===-1?o+=l(x,!1):(o+=l(x.substr(0,O),!1),o+=":",o+=l(x.substr(O+1),!1)),o+="@"}y=y.toLowerCase(),O=y.indexOf(":"),O===-1?o+=l(y,!1):(o+=l(y.substr(0,O),!1),o+=y.substr(O))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const O=E.charCodeAt(1);O>=65&&O<=90&&(E=`/${String.fromCharCode(O+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const O=E.charCodeAt(0);O>=65&&O<=90&&(E=`${String.fromCharCode(O+32)}:${E.substr(2)}`)}o+=l(E,!0)}return f&&(o+="?",o+=l(f,!1)),T&&(o+="#",o+=a?T:b(T,!1)),o}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,a=>c(a)):i}}),define(te[90],ne([0,1,5]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(w){const n=w;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=L;function R(w){const n=[];let p;try{const m=JSON.parse(w.arguments),d=m[m.length-1];d&&d.__$stack&&(m.pop(),p=d.__$stack),n.push(...m)}catch(m){n.push("Unable to log remote console arguments",w.arguments)}return{args:n,stack:p}}e.parse=R;function k(w){if(typeof w!="string")return k(R(w).stack);const n=w;if(n){const p=A(n),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(m&&m.length===4)return{uri:S.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=k;function A(w){if(!w)return w;const n=w.indexOf(`
`);return n===-1?w:w.substring(0,n)}function P(w,n){const{args:p,stack:m}=R(w),d=typeof p[0]=="string"&&p.length===1;let h=A(m);h&&(h=`(${h.trim()})`);let C=[];if(typeof p[0]=="string"?h&&d?C=[`%c[${n}] %c${p[0]} %c${h}`,v("blue"),v(""),v("grey")]:C=[`%c[${n}] %c${p[0]}`,v("blue"),v(""),...p.slice(1)]:C=[`%c[${n}]%`,v("blue"),...p],h&&!d&&C.push(h),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,C)}e.log=P;function v(w){return`color: ${w}`}});var ut=this&&this.__classPrivateFieldSet||function(Y,e,S,L,R){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!R:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?R.call(Y,S):R?R.value=S:e.set(Y,S),S},ze=this&&this.__classPrivateFieldGet||function(Y,e,S,L){if(S==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return S==="m"?L:S==="a"?L.call(Y):L?L.value:e.get(Y)};define(te[38],ne([0,1,5,19]),function(Y,e,S,L){"use strict";var R,k,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,r,i){let a=t.get(r);return a===void 0&&(a=i,t.set(r,a)),a}e.getOrSet=P;function v(t){const r=[];return t.forEach((i,a)=>{r.push(`${a} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=v;function w(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=w;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),a=this._value.charCodeAt(this._pos);return i-a}value(){return this._value[this._pos]}}e.StringIterator=n;class p{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=p;class m{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var d;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(d||(d={}));class h{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class C{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class D{constructor(r){this._iter=r}static forUris(r=()=>!1){return new D(new h(r))}static forPaths(){return new D(new m)}static forStrings(){return new D(new n)}static forConfigKeys(){return new D(new p)}clear(){this._root=void 0}set(r,i){const a=this._iter.reset(r);let l;for(this._root||(this._root=new C,this._root.segment=a.value()),l=this._root;;){const u=a.cmp(l.segment);if(u>0)l.left||(l.left=new C,l.left.segment=a.value()),l=l.left;else if(u<0)l.right||(l.right=new C,l.right.segment=a.value()),l=l.right;else if(a.hasNext())a.next(),l.mid||(l.mid=new C,l.mid.segment=a.value()),l=l.mid;else break}const o=l.value;return l.value=i,l.key=r,o}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let a=this._root;for(;a;){const l=i.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(i.hasNext())i.next(),a=a.mid;else break}return a}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const a=this._iter.reset(r),l=[];let o=this._root;for(;o;){const u=a.cmp(o.segment);if(u>0)l.push([1,o]),o=o.left;else if(u<0)l.push([-1,o]),o=o.right;else if(a.hasNext())a.next(),l.push([0,o]),o=o.mid;else{for(i?(o.left=void 0,o.mid=void 0,o.right=void 0):o.value=void 0;l.length>0&&o.isEmpty();){let[y,E]=l.pop();switch(y){case 1:E.left=void 0;break;case 0:E.mid=void 0;break;case-1:E.right=void 0;break}o=E}break}}}findSubstr(r){const i=this._iter.reset(r);let a=this._root,l;for(;a;){const o=i.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(i.hasNext())i.next(),l=a.value||l,a=a.mid;else break}return a&&a.value||l}findSuperstr(r){const i=this._iter.reset(r);let a=this._root;for(;a;){const l=i.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(i.hasNext())i.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(r){for(const[i,a]of this)r(a,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const a=i.pop();a&&(a.value&&(yield[a.key,a.value]),a.left&&i.push(a.left),a.mid&&i.push(a.mid),a.right&&i.push(a.right))}}}e.TernarySearchTree=D;class b{constructor(r,i){this[R]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=i??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[a,l]of this.map)r(l,S.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield S.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[S.URI.parse(r[0]),r[1]]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[S.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var I;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class g{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const a=this._map.get(r);if(!!a)return i!==0&&this.touch(a,i),a.value}set(r,i,a=0){let l=this._map.get(r);if(l)l.value=i,a!==0&&this.touch(l,a);else{switch(l={key:r,value:i,next:void 0,previous:void 0},a){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(r,l),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const a=this._state;let l=this._head;for(;l;){if(i?r.bind(i)(l.value,l.key,this):r(l.value,l.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const r=this,i=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const o={value:a.key,done:!1};return a=a.next,o}else return{value:void 0,done:!0}}};return l}values(){const r=this,i=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const o={value:a.value,done:!1};return a=a.next,o}else return{value:void 0,done:!0}}};return l}entries(){const r=this,i=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const o={value:[a.key,a.value],done:!1};return a=a.next,o}else return{value:void 0,done:!0}}};return l}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,a=this.size;for(;i&&a>r;)this._map.delete(i.key),i=i.next,a--;this._head=i,this._size=a,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,a=r.previous;if(!i||!a)throw new Error("Invalid list");i.previous=a,a.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const a=r.next,l=r.previous;r===this._tail?(l.next=void 0,this._tail=l):(a.previous=l,l.next=a),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const a=r.next,l=r.previous;r===this._head?(a.previous=void 0,this._head=a):(a.previous=l,l.next=a),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,a)=>{r.push([a,i])}),r}fromJSON(r){this.clear();for(const[i,a]of r)this.set(i,a)}}e.LinkedMap=g;class s extends g{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class c{constructor(r){A.set(this,void 0),ut(this,A,r,"f")}get size(){return ze(this,A,"f").size}forEach(r,i){ze(this,A,"f").forEach(r,i)}get(r){return ze(this,A,"f").get(r)}has(r){return ze(this,A,"f").has(r)}entries(){return ze(this,A,"f").entries()}keys(){return ze(this,A,"f").keys()}values(){return ze(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return ze(this,A,"f").entries()}}e.ReadonlyMapView=c}),define(te[91],ne([0,1,25,19,5]),function(Y,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(n){return JSON.stringify(n,v)}e.stringify=k;function A(n){let p=JSON.parse(n);return p=w(p),p}e.parse=A;var P;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function v(n,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:(0,L.regExpFlags)(p)}:p}function w(n,p=0){if(!n||p>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return R.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof S.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let m=0;m<n.length;++m)n[m]=w(n[m],p+1);else for(const m in n)Object.hasOwnProperty.call(n,m)&&(n[m]=w(n[m],p+1))}return n}e.revive=w}),define(te[17],ne([0,1,5,7]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(R=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(v){this._preferredWebSchema=v}setDelegate(v){this._delegate=v}set(v,w,n){this._hosts[v]=w,this._ports[v]=n}setConnectionToken(v,w){this._connectionTokens[v]=w}rewrite(v){if(this._delegate)return this._delegate(v);const w=v.authority;let n=this._hosts[w];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const p=this._ports[w],m=this._connectionTokens[w];let d=`path=${encodeURIComponent(v.path)}`;return typeof m=="string"&&(d+=`&tkn=${encodeURIComponent(m)}`),S.URI.from({scheme:L.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${n}:${p}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new k;class A{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(v,w,n){const p=this.toUri(v,w);if(p.scheme===R.vscodeRemote)return e.RemoteAuthorities.rewrite(p);let m=!1;return L.isNative&&(n||L.isPreferringBrowserCodeLoad)&&p.scheme===R.file&&(m=!0),p.scheme===R.file&&typeof L.globals.importScripts=="function"&&L.globals.origin==="vscode-file://vscode-app"&&(m=!0),m?p.with({scheme:R.vscodeFileResource,authority:p.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):p}asFileUri(v,w){const n=this.toUri(v,w);return n.scheme===R.vscodeFileResource?n.with({scheme:R.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(v,w){return S.URI.isUri(v)?v:S.URI.parse(w.toUrl(v))}}e.FileAccess=new A}),define(te[66],ne([0,1,38]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new S.LRUCache(1e4);function R(w){return v(w,"NFC",L)}e.normalizeNFC=R;const k=new S.LRUCache(1e4);function A(w){return v(w,"NFD",k)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function v(w,n,p){if(!w)return w;const m=p.get(w);if(m)return m;let d;return P.test(w)?d=w.normalize(n):d=w,p.set(w,d),d}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(n){return A(n).replace(w,"")}}()}),define(te[15],ne([0,1,41,8,5,19,17,7]),function(Y,e,S,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function v(d){return(0,R.uriToFsPath)(d,!0)}e.originalFSPath=v;class w{constructor(h){this._ignorePathCasing=h}compare(h,C,D=!1){return h===C?0:(0,k.compare)(this.getComparisonKey(h,D),this.getComparisonKey(C,D))}isEqual(h,C,D=!1){return h===C?!0:!h||!C?!1:this.getComparisonKey(h,D)===this.getComparisonKey(C,D)}getComparisonKey(h,C=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:C?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,C,D=!1){if(h.scheme===C.scheme){if(h.scheme===A.Schemas.file)return S.isEqualOrParent(v(h),v(C),this._ignorePathCasing(h))&&h.query===C.query&&(D||h.fragment===C.fragment);if((0,e.isEqualAuthority)(h.authority,C.authority))return S.isEqualOrParent(h.path,C.path,this._ignorePathCasing(h),"/")&&h.query===C.query&&(D||h.fragment===C.fragment)}return!1}joinPath(h,...C){return R.URI.joinPath(h,...C)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return L.posix.basename(h.path)}extname(h){return L.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let C;return h.scheme===A.Schemas.file?C=R.URI.file(L.dirname(v(h))).path:(C=L.posix.dirname(h.path),h.authority&&C.length&&C.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),C="/")),h.with({path:C})}normalizePath(h){if(!h.path.length)return h;let C;return h.scheme===A.Schemas.file?C=R.URI.file(L.normalize(v(h))).path:C=L.posix.normalize(h.path),h.with({path:C})}relativePath(h,C){if(h.scheme!==C.scheme||!(0,e.isEqualAuthority)(h.authority,C.authority))return;if(h.scheme===A.Schemas.file){const I=L.relative(v(h),v(C));return P.isWindows?S.toSlashes(I):I}let D=h.path||"/",b=C.path||"/";if(this._ignorePathCasing(h)){let I=0;for(const g=Math.min(D.length,b.length);I<g&&!(D.charCodeAt(I)!==b.charCodeAt(I)&&D.charAt(I).toLowerCase()!==b.charAt(I).toLowerCase());I++);D=b.substr(0,I)+D.substr(I)}return L.posix.relative(D,b)}resolvePath(h,C){if(h.scheme===A.Schemas.file){const D=R.URI.file(L.resolve(v(h),C));return h.with({authority:D.authority,path:D.path})}return C=S.toPosixPath(C),h.with({path:L.posix.resolve(h.path,C)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,C){return h===C||(0,k.equalsIgnoreCase)(h,C)}hasTrailingPathSeparator(h,C=L.sep){if(h.scheme===A.Schemas.file){const D=v(h);return D.length>S.getRoot(D).length&&D[D.length-1]===C}else{const D=h.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,C=L.sep){return(0,e.hasTrailingPathSeparator)(h,C)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,C=L.sep){let D=!1;if(h.scheme===A.Schemas.file){const b=v(h);D=b!==void 0&&b.length===S.getRoot(b).length&&b[b.length-1]===C}else{C="/";const b=h.path;D=b.length===1&&b.charCodeAt(b.length-1)===47}return!D&&!(0,e.hasTrailingPathSeparator)(h,C)?h.with({path:h.path+"/"}):h}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(d=>d.scheme===A.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new w(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(d,h){const C=[];for(let D=0;D<d.length;D++){const b=h(d[D]);d.some((I,g)=>g===D?!1:(0,e.isEqualOrParent)(b,h(I)))||C.push(d[D])}return C}e.distinctParents=n;var p;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function h(C){const D=new Map;C.path.substring(C.path.indexOf(";")+1,C.path.lastIndexOf(";")).split(";").forEach(g=>{const[s,c]=g.split(":");s&&c&&D.set(s,c)});const I=C.path.substring(0,C.path.indexOf(";"));return I&&D.set(d.META_DATA_MIME,I),D}d.parseMetaData=h})(p=e.DataUri||(e.DataUri={}));function m(d,h,C){if(h){let D=d.path;return D&&D[0]!==L.posix.sep&&(D=L.posix.sep+D),d.with({scheme:C,authority:h,path:D})}return d.with({scheme:C})}e.toLocalResource=m}),define(te[6],ne([0,1,29,9,3,2,15]),function(Y,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(_){return!!_&&typeof _.then=="function"}e.isThenable=P;function v(_){const M=new S.CancellationTokenSource,B=_(M.token),F=new Promise((U,z)=>{const W=M.token.onCancellationRequested(()=>{W.dispose(),M.dispose(),z((0,L.canceled)())});Promise.resolve(B).then(K=>{W.dispose(),M.dispose(),U(K)},K=>{W.dispose(),M.dispose(),z(K)})});return new class{cancel(){M.cancel()}then(U,z){return F.then(U,z)}catch(U){return this.then(void 0,U)}finally(U){return F.finally(U)}}}e.createCancelablePromise=v;function w(_,M,B){return Promise.race([_,new Promise(F=>M.onCancellationRequested(()=>F(B)))])}e.raceCancellation=w;async function n(_){let M=-1;const B=_.map((U,z)=>U.then(W=>(M=z,W))),F=await Promise.race(B);return _.forEach((U,z)=>{z!==M&&U.cancel()}),F}e.raceCancellablePromises=n;function p(_,M,B){let F;const U=setTimeout(()=>{F?.(void 0),B?.()},M);return Promise.race([_.finally(()=>clearTimeout(U)),new Promise(z=>F=z)])}e.raceTimeout=p;function m(_){return new Promise((M,B)=>{const F=_();P(F)?F.then(M,B):M(F)})}e.asPromise=m;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const B=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(B,B).then(F)})}return new Promise((B,F)=>{this.queuedPromise.then(B,F)})}return this.activePromise=M(),new Promise((B,F)=>{this.activePromise.then(U=>{this.activePromise=null,B(U)},U=>{this.activePromise=null,F(U)})})}}e.Throttler=d;class h{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=h;class C{constructor(){this.promiseMap=new Map}queue(M,B){const U=(this.promiseMap.get(M)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.promiseMap.get(M)===U&&this.promiseMap.delete(M)});return this.promiseMap.set(M,U),U}}e.SequencerByKey=C;class D{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,B=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,U)=>{this.doResolve=F,this.doReject=U}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},B),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=D;class b{constructor(M){this.delayer=new D(M),this.throttler=new d}trigger(M,B){return this.delayer.trigger(()=>this.throttler.queue(M),B)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class I{constructor(){this._isOpen=!1,this._promise=new Promise((M,B)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=I;class g extends I{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=g;function s(_,M){return M?new Promise((B,F)=>{const U=setTimeout(()=>{z.dispose(),B()},_),z=M.onCancellationRequested(()=>{clearTimeout(U),z.dispose(),F((0,L.canceled)())})}):v(B=>s(_,B))}e.timeout=s;function c(_,M=0){const B=setTimeout(_,M);return(0,k.toDisposable)(()=>clearTimeout(B))}e.disposableTimeout=c;function t(_){const M=[];let B=0;const F=_.length;function U(){return B<F?_[B++]():null}function z(W){W!=null&&M.push(W);const K=U();return K?K.then(z):Promise.resolve(M)}return Promise.resolve(null).then(z)}e.sequence=t;function r(_,M=F=>!!F,B=null){let F=0;const U=_.length,z=()=>{if(F>=U)return Promise.resolve(B);const W=_[F++];return Promise.resolve(W()).then($=>M($)?Promise.resolve($):z())};return z()}e.first=r;function i(_,M=F=>!!F,B=null){if(_.length===0)return Promise.resolve(B);let F=_.length;const U=()=>{F=-1;for(const z of _)z.cancel?.()};return new Promise((z,W)=>{for(const K of _)K.then($=>{--F>=0&&M($)?(U(),z($)):F===0&&z(B)}).catch($=>{--F>=0&&(U(),W($))})})}e.firstParallel=i;class a{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((B,F)=>{this.outstandingPromises.push({factory:M,c:B,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const B=M.factory();B.then(M.c,M.e),B.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=a;class l extends a{constructor(){super(1)}}e.Queue=l;class o{constructor(){this.queues=new Map}queueFor(M,B=A.extUri){const F=B.getComparisonKey(M);let U=this.queues.get(F);return U||(U=new l,R.Event.once(U.onFinished)(()=>{U?.dispose(),this.queues.delete(F)}),this.queues.set(F,U)),U}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=o;class u{constructor(M,B){this._token=-1,typeof M=="function"&&typeof B=="number"&&this.setIfNotSet(M,B)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,B){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},B)}setIfNotSet(M,B){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},B))}}e.TimeoutTimer=u;class y{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,B){this.cancel(),this._token=setInterval(()=>{M()},B)}}e.IntervalTimer=y;class E{constructor(M,B){this.timeoutToken=-1,this.runner=M,this.timeout=B,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=E;class f extends E{constructor(M,B){super(M,B);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=f;class T extends k.Disposable{constructor(M,B,F,U){super();this.maxWorkChunkSize=M,this.maxPendingWork=B,this.throttleDelay=F,this.handler=U,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(M){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+M.length>this.maxPendingWork)return!1}else if(this.pending+M.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...M),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new E(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=T,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const _=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const B=setTimeout(()=>M(_));let F=!1;return{dispose(){F||(F=!0,clearTimeout(B))}}}}else e.runWhenIdle=(_,M)=>{const B=requestIdleCallback(_,typeof M=="number"?{timeout:M}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(B))}}}}();class O{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(B){this._error=B}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=O;async function x(_,M,B){let F;for(let U=0;U<B;U++)try{return await _()}catch(z){F=z,await s(M)}throw F}e.retry=x;class j{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(M,B,F){return this._pending={taskId:M,cancel:()=>F?.(),promise:B},B.then(()=>this.donePending(M),()=>this.donePending(M)),B}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let B,F;const U=new Promise((z,W)=>{B=z,F=W});this._next={run:M,promise:U,promiseResolve:B,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=j;class H{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,B)=>{this.completeCallback=M,this.errorCallback=B})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(B=>{this.completeCallback(M),this.resolved=!0,B()})}error(M){return new Promise(B=>{this.errorCallback(M),this.rejected=!0,B()})}cancel(){new Promise(M=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=V;var N;(function(_){async function M(B){let F;const U=await Promise.all(B.map(z=>z.then(W=>W,W=>{F||(F=W)})));if(typeof F!="undefined")throw F;return U}_.settled=M})(N=e.Promises||(e.Promises={}))}),define(te[67],ne([0,1,19,41,8,38,6]),function(Y,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const v="**",w="/",n="[/\\\\]",p="[^/\\\\]",m=/\//g;function d(U){switch(U){case 0:return"";case 1:return`${p}*?`;default:return`(?:${n}|${p}+${n}|${n}${p}+)*?`}}function h(U,z){if(!U)return[];const W=[];let K=!1,$=!1,G="";for(const X of U){switch(X){case z:if(!K&&!$){W.push(G),G="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":$=!0;break;case"]":$=!1;break}G+=X}return G&&W.push(G),W}e.splitGlobAware=h;function C(U){if(!U)return"";let z="";const W=h(U,w);if(W.every(K=>K===v))z=".*";else{let K=!1;W.forEach(($,G)=>{if($===v){K||(z+=d(2),K=!0);return}let X=!1,Z="",ee=!1,se="";for(const ue of $){if(ue!=="}"&&X){Z+=ue;continue}if(ee&&(ue!=="]"||!se)){let ge;ue==="-"?ge=ue:(ue==="^"||ue==="!")&&!se?ge="^":ue===w?ge="":ge=S.escapeRegExpCharacters(ue),se+=ge;continue}switch(ue){case"{":X=!0;continue;case"[":ee=!0;continue;case"}":z+=`(?:${h(Z,",").map(Se=>C(Se)).join("|")})`,X=!1,Z="";break;case"]":z+="["+se+"]",ee=!1,se="";break;case"?":z+=p;continue;case"*":z+=d(1);continue;default:z+=S.escapeRegExpCharacters(ue)}}G<W.length-1&&(W[G+1]!==v||G+2<W.length)&&(z+=n),K=!1})}return z}const D=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.LRUCache(1e4),r=function(){return!1},i=function(){return null};function a(U,z){if(!U)return i;let W;typeof U!="string"?W=U.pattern:W=U,W=W.trim();const K=`${W}_${!!z.trimForExclusions}`;let $=t.get(K);if($)return l($,U);let G;if(D.test(W)){const X=W.substr(4);$=function(Z,ee){return typeof Z=="string"&&Z.endsWith(X)?W:null}}else(G=b.exec(o(W,z)))?$=u(G[1],W):(z.trimForExclusions?g:I).test(W)?$=y(W,z):(G=s.exec(o(W,z)))?$=E(G[1].substr(1),W,!0):(G=c.exec(o(W,z)))?$=E(G[1],W,!1):$=f(W);return t.set(K,$),l($,U)}function l(U,z){return typeof z=="string"?U:function(W,K){return L.isEqualOrParent(W,z.base)?U(R.relative(z.base,W),K):null}}function o(U,z){return z.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function u(U,z){const W=`/${U}`,K=`\\${U}`,$=function(X,Z){return typeof X!="string"?null:Z?Z===U?z:null:X===U||X.endsWith(W)||X.endsWith(K)?z:null},G=[U];return $.basenames=G,$.patterns=[z],$.allBasenames=G,$}function y(U,z){const W=F(U.slice(1,-1).split(",").map(Z=>a(Z,z)).filter(Z=>Z!==i),U),K=W.length;if(!K)return i;if(K===1)return W[0];const $=function(Z,ee){for(let se=0,ue=W.length;se<ue;se++)if(W[se](Z,ee))return U;return null},G=W.find(Z=>!!Z.allBasenames);G&&($.allBasenames=G.allBasenames);const X=W.reduce((Z,ee)=>ee.allPaths?Z.concat(ee.allPaths):Z,[]);return X.length&&($.allPaths=X),$}function E(U,z,W){const K=R.sep===R.posix.sep,$=K?U:U.replace(m,R.sep),G=R.sep+$,X=R.posix.sep+U,Z=W?function(ee,se){return typeof ee=="string"&&(ee===$||ee.endsWith(G)||!K&&(ee===U||ee.endsWith(X)))?z:null}:function(ee,se){return typeof ee=="string"&&(ee===$||!K&&ee===U)?z:null};return Z.allPaths=[(W?"*/":"./")+U],Z}function f(U){try{const z=new RegExp(`^${C(U)}$`);return function(W){return z.lastIndex=0,typeof W=="string"&&z.test(W)?U:null}}catch(z){return i}}function T(U,z,W){return!U||typeof z!="string"?!1:O(U)(z,void 0,W)}e.match=T;function O(U,z={}){if(!U)return r;if(typeof U=="string"||V(U)){const W=a(U,z);if(W===i)return r;const K=function($,G){return!!W($,G)};return W.allBasenames&&(K.allBasenames=W.allBasenames),W.allPaths&&(K.allPaths=W.allPaths),K}return M(U,z)}e.parse=O;function x(U){if(!U)return;let z;return W=>(z||(z=(U()||Promise.resolve([])).then(K=>K?H(K):{})),z.then(K=>!!K[W]))}e.hasSiblingPromiseFn=x;function j(U){if(!U)return;let z;return W=>{if(!z){const K=U();z=K?H(K):{}}return!!z[W]}}e.hasSiblingFn=j;function H(U){const z={};for(const W of U)z[W]=!0;return z}function V(U){const z=U;return z&&typeof z.base=="string"&&typeof z.pattern=="string"}e.isRelativePattern=V;function N(U){return U.allBasenames||[]}e.getBasenameTerms=N;function _(U){return U.allPaths||[]}e.getPathTerms=_;function M(U,z){const W=F(Object.getOwnPropertyNames(U).map(Z=>B(Z,U[Z],z)).filter(Z=>Z!==i)),K=W.length;if(!K)return i;if(!W.some(Z=>!!Z.requiresSiblings)){if(K===1)return W[0];const Z=function(ue,ge){for(let me=0,Se=W.length;me<Se;me++){const be=W[me](ue,ge);if(be)return be}return null},ee=W.find(ue=>!!ue.allBasenames);ee&&(Z.allBasenames=ee.allBasenames);const se=W.reduce((ue,ge)=>ge.allPaths?ue.concat(ge.allPaths):ue,[]);return se.length&&(Z.allPaths=se),Z}const $=function(Z,ee,se){let ue;for(let ge=0,me=W.length;ge<me;ge++){const Se=W[ge];Se.requiresSiblings&&se&&(ee||(ee=R.basename(Z)),ue||(ue=ee.substr(0,ee.length-R.extname(Z).length)));const be=Se(Z,ee,ue,se);if(be)return be}return null},G=W.find(Z=>!!Z.allBasenames);G&&($.allBasenames=G.allBasenames);const X=W.reduce((Z,ee)=>ee.allPaths?Z.concat(ee.allPaths):Z,[]);return X.length&&($.allPaths=X),$}function B(U,z,W){if(z===!1)return i;const K=a(U,W);if(K===i)return i;if(typeof z=="boolean")return K;if(z){const $=z.when;if(typeof $=="string"){const G=(X,Z,ee,se)=>{if(!se||!K(X,Z))return null;const ue=$.replace("$(basename)",ee),ge=se(ue);return(0,A.isThenable)(ge)?ge.then(me=>me?U:null):ge?U:null};return G.requiresSiblings=!0,G}}return K}function F(U,z){const W=U.filter(Z=>!!Z.basenames);if(W.length<2)return U;const K=W.reduce((Z,ee)=>{const se=ee.basenames;return se?Z.concat(se):Z},[]);let $;if(z){$=[];for(let Z=0,ee=K.length;Z<ee;Z++)$.push(z)}else $=W.reduce((Z,ee)=>{const se=ee.patterns;return se?Z.concat(se):Z},[]);const G=function(Z,ee){if(typeof Z!="string")return null;if(!ee){let ue;for(ue=Z.length;ue>0;ue--){const ge=Z.charCodeAt(ue-1);if(ge===47||ge===92)break}ee=Z.substr(ue)}const se=K.indexOf(ee);return se!==-1?$[se]:null};G.basenames=K,G.patterns=$,G.allBasenames=K;const X=U.filter(Z=>!Z.basenames);return X.push(G),X}}),define(te[92],ne([0,1,8,19,67,17,15]),function(Y,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let v=[],w=[],n=[];function p(r,i=!1){const a=m(r);v.push(a),a.userConfigured?n.push(a):w.push(a),i&&!a.userConfigured&&v.forEach(l=>{l.mime===a.mime||l.userConfigured||(a.extension&&l.extension===a.extension&&console.warn(`Overwriting extension <<${a.extension}>> to now point to mime <<${a.mime}>>`),a.filename&&l.filename===a.filename&&console.warn(`Overwriting filename <<${a.filename}>> to now point to mime <<${a.mime}>>`),a.filepattern&&l.filepattern===a.filepattern&&console.warn(`Overwriting filepattern <<${a.filepattern}>> to now point to mime <<${a.mime}>>`),a.firstline&&l.firstline===a.firstline&&console.warn(`Overwriting firstline <<${a.firstline}>> to now point to mime <<${a.mime}>>`))})}e.registerTextMime=p;function m(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(S.posix.sep)>=0:!1}}function d(r){r?(v=v.filter(i=>!i.userConfigured),n=[]):(v=[],w=[],n=[])}e.clearTextMimes=d;function h(r,i){let a;if(r)switch(r.scheme){case k.Schemas.file:a=r.fsPath;break;case k.Schemas.data:a=A.DataUri.parseMetaData(r).get(A.DataUri.META_DATA_LABEL);break;default:a=r.path}if(!a)return[P.unknown];a=a.toLowerCase();const l=(0,S.basename)(a),o=C(a,l,n);if(o)return[o,P.text];const u=C(a,l,w);if(u)return[u,P.text];if(i){const y=D(i);if(y)return[y,P.text]}return[P.unknown]}e.guessMimeTypes=h;function C(r,i,a){let l=null,o=null,u=null;for(let y=a.length-1;y>=0;y--){const E=a[y];if(i===E.filenameLowercase){l=E;break}if(E.filepattern&&(!o||E.filepattern.length>o.filepattern.length)){const f=E.filepatternOnPath?r:i;(0,R.match)(E.filepatternLowercase,f)&&(o=E)}E.extension&&(!u||E.extension.length>u.extension.length)&&i.endsWith(E.extensionLowercase)&&(u=E)}return l?l.mime:o?o.mime:u?u.mime:null}function D(r){if((0,L.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let i=v.length-1;i>=0;i--){const a=v[i];if(!a.firstline)continue;const l=r.match(a.firstline);if(l&&l.length>0)return a.mime}return null}function b(r){return r?typeof r=="string"?r===P.binary||r===P.text||r===P.unknown:r.length===1&&b(r[0]):!0}e.isUnspecific=b;const I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function g(r){const i=(0,S.extname)(r);return I[i.toLowerCase()]}e.getMediaMime=g;function s(r){for(const i in I)if(I[i]===r)return i}e.getExtensionForMimeType=s;const c=/^(.+)\/(.+?)(;.+)?$/;function t(r,i){const a=c.exec(r);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:i?void 0:r}e.normalizeMimeType=t}),define(te[93],ne([0,1,5]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class R{constructor(p){this._uriTransformer=p}transformIncoming(p){const m=this._uriTransformer.transformIncoming(p);return m===p?p:L(S.URI.from(m))}transformOutgoing(p){const m=this._uriTransformer.transformOutgoing(p);return m===p?p:L(S.URI.from(m))}transformOutgoingURI(p){const m=this._uriTransformer.transformOutgoing(p);return m===p?p:S.URI.from(m)}transformOutgoingScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function k(n,p,m){if(!n||m>200)return null;if(typeof n=="object"){if(n instanceof S.URI)return p.transformOutgoing(n);for(let d in n)if(Object.hasOwnProperty.call(n,d)){const h=k(n[d],p,m+1);h!==null&&(n[d]=h)}}return null}function A(n,p){const m=k(n,p,0);return m===null?n:m}e.transformOutgoingURIs=A;function P(n,p,m,d){if(!n||d>200)return null;if(typeof n=="object"){if(n.$mid===1)return m?S.URI.revive(p.transformIncoming(n)):p.transformIncoming(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const C=P(n[h],p,m,d+1);C!==null&&(n[h]=C)}}return null}function v(n,p){const m=P(n,p,!1,0);return m===null?n:m}e.transformIncomingURIs=v;function w(n,p){const m=P(n,p,!0,0);return m===null?n:m}e.transformAndReviveIncomingURIs=w}),define(te[30],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(v){return S.test(v)}e.isUUID=L;const R=new Uint8Array(16),k=[];for(let v=0;v<256;v++)k.push(v.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(v){for(let w=0;w<v.length;w++)v[w]=Math.floor(Math.random()*256);return v};function P(){A(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let v=0,w="";return w+=k[R[v++]],w+=k[R[v++]],w+=k[R[v++]],w+=k[R[v++]],w+="-",w+=k[R[v++]],w+=k[R[v++]],w+="-",w+=k[R[v++]],w+=k[R[v++]],w+="-",w+=k[R[v++]],w+=k[R[v++]],w+="-",w+=k[R[v++]],w+=k[R[v++]],w+=k[R[v++]],w+=k[R[v++]],w+=k[R[v++]],w+=k[R[v++]],w}e.generateUuid=P}),define(te[68],ne([0,1,207]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(k="utf8"){this.stringDecoder=new S.StringDecoder(k),this.remaining=null}write(k){const A=[],P=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(P.length<1)return A;let v=0,w,n=v;for(;n<P.length;)if(w=P.charCodeAt(n),w===13||w===10){if(A.push(P.substring(v,n)),n++,n<P.length){const p=w;w=P.charCodeAt(n),(p===13&&w===10||p===10&&w===13)&&n++}v=n}else n++;return this.remaining=v<P.length?P.substr(v):null,A}end(){return this.remaining}}e.LineDecoder=L}),define(te[94],ne([0,1,35]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(P){const v=P.replace(/\-/g,":").toLowerCase();return!L.has(v)}function k(){return new Promise(async(P,v)=>{const w=setTimeout(()=>v("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await A())}catch(n){v(n)}finally{clearTimeout(w)}})}e.getMac=k;function A(){return new Promise((P,v)=>{try{const w=(0,S.networkInterfaces)();for(let n in w){const p=w[n];if(p){for(const{mac:m}of p)if(R(m))return P(m)}}v("Unable to retrieve mac address (unexpected format)")}catch(w){v(w)}})}}),define(te[95],ne([0,1,9,30,35,38,94]),function(Y,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,p=0;const m=(0,R.networkInterfaces)();for(let d in m){const h=m[d];if(h)for(const{mac:C,internal:D}of h)D||(p+=1,this._isVirtualMachineMacAdress(C.toUpperCase())&&(n+=1))}this._value=p>0?n/p:0}return this._value}};let P;async function v(){return P||(P=(async()=>await w()||L.generateUuid())()),P}e.getMachineId=v;async function w(){try{const n=await new Promise((m,d)=>{Y(["crypto"],m,d)}),p=await(0,A.getMac)();return n.createHash("sha256").update(p,"utf8").digest("hex")}catch(n){S.onUnexpectedError(n);return}}}),define(te[18],ne([0,1,48,35,208,8,6,7,41,30,66,15,5]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var d;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(d=e.RimRafMode||(e.RimRafMode={}));async function h(N,_=d.UNLINK){if((0,v.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return _===d.UNLINK?D(N):C(N)}async function C(N){try{const _=(0,k.join)((0,L.tmpdir)(),(0,w.generateUuid)());try{await e.Promises.rename(N,_)}catch(M){return D(N)}D(_).catch(M=>{})}catch(_){if(_.code!=="ENOENT")throw _}}async function D(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function b(N){if((0,v.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");S.rmdirSync(N,{recursive:!0})}e.rimrafSync=b;async function I(N,_){return c(await(_?g(N):(0,R.promisify)(S.readdir)(N)))}async function g(N){try{return await(0,R.promisify)(S.readdir)(N,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const _=[],M=await I(N);for(const B of M){let F=!1,U=!1,z=!1;try{const W=await e.Promises.lstat((0,k.join)(N,B));F=W.isFile(),U=W.isDirectory(),z=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}_.push({name:B,isFile:()=>F,isDirectory:()=>U,isSymbolicLink:()=>z})}return _}function s(N){return c(S.readdirSync(N))}e.readdirSync=s;function c(N){return N.map(_=>typeof _=="string"?P.isMacintosh?(0,n.normalizeNFC)(_):_:(_.name=P.isMacintosh?(0,n.normalizeNFC)(_.name):_.name,_))}async function t(N){const _=await I(N),M=[];for(const B of _)await i.existsDirectory((0,k.join)(N,B))&&M.push(B);return M}function r(N,_=1e3){return new Promise(M=>{let B=!1;const F=setInterval(()=>{B||(B=!0,S.access(N,U=>{B=!1,U&&(clearInterval(F),M(void 0))}))},_)})}e.whenDeleted=r;var i;(function(N){async function _(F){let U;try{if(U=await e.Promises.lstat(F),!U.isSymbolicLink())return{stat:U}}catch(z){}try{return{stat:await e.Promises.stat(F),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(P.isWindows&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw W}throw z}}N.stat=_;async function M(F){try{const{stat:U,symbolicLink:z}=await N.stat(F);return U.isFile()&&z?.dangling!==!0}catch(U){}return!1}N.existsFile=M;async function B(F){try{const{stat:U,symbolicLink:z}=await N.stat(F);return U.isDirectory()&&z?.dangling!==!0}catch(U){}return!1}N.existsDirectory=B})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new A.ResourceQueue;function l(N,_,M){return a.queueFor(m.URI.file(N),p.extUriBiasedIgnorePathCase).queue(()=>{const B=E(M);return new Promise((F,U)=>u(N,_,B,z=>z?U(z):F()))})}let o=!0;function u(N,_,M,B){if(!o)return S.writeFile(N,_,{mode:M.mode,flag:M.flag},B);S.open(N,M.flag,M.mode,(F,U)=>{if(F)return B(F);S.writeFile(U,_,z=>{if(z)return S.close(U,()=>B(z));S.fdatasync(U,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),o=!1),S.close(U,K=>B(K))))})})}function y(N,_,M){const B=E(M);if(!o)return S.writeFileSync(N,_,{mode:B.mode,flag:B.flag});const F=S.openSync(N,B.flag,B.mode);try{S.writeFileSync(F,_);try{S.fdatasyncSync(F)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),o=!1}}finally{S.closeSync(F)}}e.writeFileSync=y;function E(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function f(N,_){if(N===_)return;async function M(B){try{const F=await e.Promises.lstat(B);if(F.isDirectory()||F.isSymbolicLink())return;await e.Promises.utimes(B,F.atime,new Date)}catch(F){}}try{await e.Promises.rename(N,_),await M(_)}catch(B){if(N.toLowerCase()!==_.toLowerCase()&&B.code==="EXDEV"||N.endsWith("."))await T(N,_,{preserveSymlinks:!1}),await h(N,d.MOVE),await M(_);else throw B}}async function T(N,_,M){return x(N,_,{root:{source:N,target:_},options:M,handledSourcePaths:new Set})}const O=511;async function x(N,_,M){if(M.handledSourcePaths.has(N))return;M.handledSourcePaths.add(N);const{stat:B,symbolicLink:F}=await i.stat(N);if(F){if(M.options.preserveSymlinks)try{return await V(N,_,M)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(F.dangling)return}return B.isDirectory()?j(N,_,B.mode&O,M):H(N,_,B.mode&O)}async function j(N,_,M,B){await e.Promises.mkdir(_,{recursive:!0,mode:M});const F=await I(N);for(const U of F)await x((0,k.join)(N,U),(0,k.join)(_,U),B)}async function H(N,_,M){await e.Promises.copyFile(N,_),await e.Promises.chmod(_,M)}async function V(N,_,M){let B=await e.Promises.readlink(N);(0,v.isEqualOrParent)(B,M.root.source,!P.isLinux)&&(B=(0,k.join)(M.root.target,B.substr(M.root.source.length+1))),await e.Promises.symlink(B,_)}e.Promises=new class{get access(){return(0,R.promisify)(S.access)}get stat(){return(0,R.promisify)(S.stat)}get lstat(){return(0,R.promisify)(S.lstat)}get utimes(){return(0,R.promisify)(S.utimes)}get read(){return(0,R.promisify)(S.read)}get readFile(){return(0,R.promisify)(S.readFile)}get write(){return(0,R.promisify)(S.write)}get appendFile(){return(0,R.promisify)(S.appendFile)}get fdatasync(){return(0,R.promisify)(S.fdatasync)}get truncate(){return(0,R.promisify)(S.truncate)}get rename(){return(0,R.promisify)(S.rename)}get copyFile(){return(0,R.promisify)(S.copyFile)}get open(){return(0,R.promisify)(S.open)}get close(){return(0,R.promisify)(S.close)}get symlink(){return(0,R.promisify)(S.symlink)}get readlink(){return(0,R.promisify)(S.readlink)}get chmod(){return(0,R.promisify)(S.chmod)}get mkdir(){return(0,R.promisify)(S.mkdir)}get unlink(){return(0,R.promisify)(S.unlink)}get rmdir(){return(0,R.promisify)(S.rmdir)}get realpath(){return(0,R.promisify)(S.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return I}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return h}get move(){return f}get copy(){return T}}}),define(te[96],ne([0,1,48,19,8,18]),function(Y,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(n){const p=(0,R.dirname)(n);if(n===p)return n;const m=((0,R.basename)(n)||n).toLowerCase();try{const h=(0,k.readdirSync)(p).filter(C=>C.toLowerCase()===m);if(h.length===1){const C=A(p);if(C)return(0,R.join)(C,h[0])}else if(h.length>1){const C=h.indexOf(m);if(C>=0){const D=A(p);if(D)return(0,R.join)(D,h[C])}}}catch(d){}return null}e.realcaseSync=A;async function P(n){try{return await k.Promises.realpath(n)}catch(p){const m=w(n);return await k.Promises.access(m,S.constants.R_OK),m}}e.realpath=P;function v(n){try{return S.realpathSync(n)}catch(p){const m=w(n);return S.accessSync(m,S.constants.R_OK),m}}e.realpathSync=v;function w(n){return(0,L.rtrim)((0,R.normalize)(n),R.sep)}}),define(te[97],ne([0,1,18,35,8]),function(Y,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var v;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(v||(v={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class p{constructor(c,t,r){this.exePath=c,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:s=!1}={}){return s?w===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:s=!1,findPreview:c=!1}={}){const t=m({useAlternateBitness:s});if(!t)return null;const r=R.join(t,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(r))return null;let i=-1,a=null;for(const u of await S.Promises.readdir(r)){let y=-1;if(c){const f=u.indexOf("-");if(f<0)continue;const T=u.substring(0,f);if(!k.test(T)||u.substring(f+1)!=="preview")continue;y=parseInt(T,10)}else{if(!k.test(u))continue;y=parseInt(u,10)}if(y<=i)continue;const E=R.join(r,u,"pwsh.exe");!await S.SymlinkSupport.existsFile(E)||(a=E,i=y)}if(!a)return null;const l=t.includes("x86")?" (x86)":"",o=c?" Preview":"";return new p(a,`PowerShell${o}${l}`,!0)}async function h({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const c=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=s?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await S.Promises.readdir(c))if(t.test(i)){const a=R.join(c,i,"pwsh.exe");return new p(a,r)}return null}function C(){const s=R.join(L.homedir(),".dotnet","tools","pwsh.exe");return new p(s,".NET Core PowerShell Global Tool")}function D(){const s=R.join(process.env.windir,w===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(s,"Windows PowerShell",!0)}async function*b(){let s=await d();s&&(yield s),s=await d({useAlternateBitness:!0}),s&&(yield s),s=await h(),s&&(yield s),s=C(),s&&(yield s),s=await d({findPreview:!0}),s&&(yield s),s=await h({findPreview:!0}),s&&(yield s),s=await d({useAlternateBitness:!0,findPreview:!0}),s&&(yield s),s=D(),s&&(yield s)}async function*I(){for await(const s of b())await s.exists()&&(yield s)}e.enumeratePowerShellInstallations=I;async function g(){for await(const s of I())return s;return null}e.getFirstAvailablePowerShellInstallation=g}),define(te[98],ne([0,1,42,17]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(A){return new Promise((P,v)=>{let w;const n=new Map;function p(d,h,C,D,b){const I=n.get(h);if(d===A||I){const g={name:m(C),cmd:C,pid:d,ppid:h,load:D,mem:b};n.set(d,g),d===A&&(w=g),I&&(I.children||(I.children=[]),I.children.push(g),I.children.length>1&&(I.children=I.children.sort((s,c)=>s.pid-c.pid)))}}function m(d){const h=/--disable-blink-features=Auxclick/,C=/\\watcher\\win32\\CodeHelper\.exe/,D=/--crashes-directory/,b=/\\pipe\\winpty-control/,I=/conhost\.exe/,g=/--type=([a-zA-Z-]+)/;if(C.exec(d))return"watcherService ";if(D.exec(d))return"electron-crash-reporter";if(b.exec(d))return"winpty-process";if(I.exec(d))return"console-window-host (Windows internal process)";let s=g.exec(d);if(s&&s.length===2)return s[1]==="renderer"?h.exec(d)?"shared-process":"window":s[1];const c=/[a-zA-Z-]+\.js/g;let t="";do s=c.exec(d),s&&(t+=s+" ");while(s);return t&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron_node ${t}`:d}if(process.platform==="win32"){const d=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,C)=>{Y(["windows-process-tree"],h,C)}).then(h=>{h.getProcessList(A,C=>{h.getProcessCpuUsage(C,D=>{const b=new Map;D.forEach(I=>{const g=d(I.commandLine||"");b.set(I.pid,{name:m(g),cmd:g,pid:I.pid,ppid:I.ppid,load:I.cpu||0,mem:I.memory||0})}),w=b.get(A),w?(b.forEach(I=>{const g=b.get(I.ppid);g&&(g.children||(g.children=[]),g.children.push(I))}),b.forEach(I=>{I.children&&(I.children=I.children.sort((g,s)=>g.pid-s.pid))}),P(w)):v(new Error(`Root process ${A} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let d=function(){let h=[w];const C=[];for(;h.length;){const b=h.shift();b&&(C.push(b.pid),b.children&&(h=h.concat(b.children)))}let D=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Y).fsPath);D+=" "+C.join(" "),(0,S.exec)(D,{},(b,I,g)=>{if(b||g)v(b||new Error(g.toString()));else{const s=I.toString().split(`
`);for(let c=0;c<C.length;c++){const t=n.get(C[c]);t.load=parseFloat(s[c])}if(!w){v(new Error(`Root process ${A} not found`));return}P(w)}})};(0,S.exec)("which ps",{},(h,C,D)=>{if(h||D)if(process.platform!=="linux")v(h||new Error(D.toString()));else{const b=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",Y).fsPath);(0,S.exec)(b,{},(I,g,s)=>{I||s?v(I||new Error(s.toString())):(k(g,p),d())})}else{const b=C.toString().trim(),I="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${b} ${I}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,s,c)=>{g||c&&!c.includes("screen size is bogus")?v(g||new Error(c.toString())):(k(s,p),process.platform==="linux"?d():w?P(w):v(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=R;function k(A,P){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=A.toString().split(`
`);for(const n of w){const p=v.exec(n.trim());p&&p.length===6&&P(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}}),define(te[99],ne([0,1,8,48,7,66,2,18]),function(Y,e,S,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function v(p,m,d){return n({path:p,isDirectory:!1},m,d)}e.watchFile=v;function w(p,m,d){return n({path:p,isDirectory:!0},m,d)}e.watchFolder=w,e.CHANGE_BUFFER_DELAY=100;function n(p,m,d){const h=(0,S.basename)(p.path),C=new Map;let D=!1,b=[(0,A.toDisposable)(()=>{C.forEach(I=>(0,A.dispose)(I)),C.clear()})];try{const I=(0,L.watch)(p.path);b.push((0,A.toDisposable)(()=>{I.removeAllListeners(),I.close()}));const g=new Set;p.isDirectory&&P.Promises.readdir(p.path).then(s=>s.forEach(c=>g.add(c))),I.on("error",(s,c)=>{D||d(`Failed to watch ${p.path} for changes using fs.watch() (${s}, ${c})`)}),I.on("change",(s,c)=>{if(D)return;let t="";if(c&&(t=c.toString(),R.isMacintosh&&(t=(0,k.normalizeNFC)(t))),!t||s!=="change"&&s!=="rename")return;const r=p.isDirectory?(0,S.join)(p.path,t):p.path;if(p.isDirectory)if(s==="rename"){const i=C.get(r);i&&(0,A.dispose)(i);const a=setTimeout(async()=>{C.delete(r);const l=await P.Promises.exists(r);if(D)return;let o;l?g.has(t)?o="changed":(o="added",g.add(t)):(g.delete(t),o="deleted"),m(o,r)},e.CHANGE_BUFFER_DELAY);C.set(r,(0,A.toDisposable)(()=>clearTimeout(a)))}else{let i;g.has(t)?i="changed":(i="added",g.add(t)),m(i,r)}else if(s==="rename"||t!==h){const i=setTimeout(async()=>{const a=await P.Promises.exists(r);D||(a?(m("changed",r),b=[n(p,m,d)]):m("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,A.dispose)(b),b=[(0,A.toDisposable)(()=>clearTimeout(i))]}else m("changed",r)})}catch(I){P.Promises.exists(p.path).then(g=>{g&&!D&&d(`Failed to watch ${p.path} for changes using fs.watch() (${I.toString()})`)})}return(0,A.toDisposable)(()=>{D=!0,b=(0,A.dispose)(b)})}});var de=this&&this.__decorate||function(Y,e,S,L){var R=arguments.length,k=R<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,S):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(Y,e,S,L);else for(var P=Y.length-1;P>=0;P--)(A=Y[P])&&(k=(R<3?A(k):R>3?A(e,S,k):A(e,S))||k);return R>3&&k&&Object.defineProperty(e,S,k),k};define(te[36],ne([0,1,3,2,6,29,9,25,22,14,91,19,64]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var d;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(d=e.RequestType||(e.RequestType={}));function h(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var C;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(C=e.ResponseType||(e.ResponseType={}));function D(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(b||(b={}));class I{constructor(U){this.buffer=U,this.pos=0}read(U){const z=this.buffer.slice(this.pos,this.pos+U);return this.pos+=z.byteLength,z}}class g{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var s;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(s||(s={}));function c(F){const U=P.VSBuffer.alloc(4);return U.writeUInt32BE(F,0),U}function t(F){return F.read(4).readUInt32BE(0)}function r(F){const U=P.VSBuffer.alloc(1);return U.writeUInt8(F,0),U}const i={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object)},a=typeof Buffer!="undefined";function l(F,U){if(typeof U=="undefined")F.write(i.Undefined);else if(typeof U=="string"){const z=P.VSBuffer.fromString(U);F.write(i.String),F.write(c(z.byteLength)),F.write(z)}else if(a&&Buffer.isBuffer(U)){const z=P.VSBuffer.wrap(U);F.write(i.Buffer),F.write(c(z.byteLength)),F.write(z)}else if(U instanceof P.VSBuffer)F.write(i.VSBuffer),F.write(c(U.byteLength)),F.write(U);else if(Array.isArray(U)){F.write(i.Array),F.write(c(U.length));for(const z of U)l(F,z)}else{const z=P.VSBuffer.fromString(JSON.stringify(U));F.write(i.Object),F.write(c(z.byteLength)),F.write(z)}}function o(F){switch(F.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return F.read(t(F)).toString();case s.Buffer:return F.read(t(F)).buffer;case s.VSBuffer:return F.read(t(F));case s.Array:{const z=t(F),W=[];for(let K=0;K<z;K++)W.push(o(F));return W}case s.Object:return JSON.parse(F.read(t(F)).toString())}}class u{constructor(U,z,W=null,K=1e3){this.protocol=U,this.ctx=z,this.logger=W,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage($=>this.onRawMessage($)),this.sendResponse({type:200})}registerChannel(U,z){this.channels.set(U,z),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const z=this.send([U.type]);this.logger&&this.logger.logOutgoing(z,0,1,D(U.type));return}case 201:case 202:case 204:case 203:{const z=this.send([U.type,U.id],U.data);this.logger&&this.logger.logOutgoing(z,U.id,1,D(U.type),U.data);return}}}send(U,z=void 0){const W=new g;return l(W,U),l(W,z),this.sendBuffer(W.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(z){return 0}}onRawMessage(U){const z=new I(U),W=o(z),K=o(z),$=W[0];switch($){case 100:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${h($)}: ${W[2]}.${W[3]}`,K),this.onPromise({type:$,id:W[1],channelName:W[2],name:W[3],arg:K});case 102:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${h($)}: ${W[2]}.${W[3]}`,K),this.onEventListen({type:$,id:W[1],channelName:W[2],name:W[3],arg:K});case 101:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${h($)}`),this.disposeActiveRequest({type:$,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${h($)}`),this.disposeActiveRequest({type:$,id:W[1]})}}onPromise(U){const z=this.channels.get(U.channelName);if(!z){this.collectPendingRequest(U);return}const W=new k.CancellationTokenSource;let K;try{K=z.call(this.ctx,U.name,U.arg,W.token)}catch(X){K=Promise.reject(X)}const $=U.id;K.then(X=>{this.sendResponse({id:$,data:X,type:201}),this.activeRequests.delete(U.id)},X=>{X instanceof Error?this.sendResponse({id:$,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.sendResponse({id:$,data:X,type:203}),this.activeRequests.delete(U.id)});const G=(0,L.toDisposable)(()=>W.cancel());this.activeRequests.set(U.id,G)}onEventListen(U){const z=this.channels.get(U.channelName);if(!z){this.collectPendingRequest(U);return}const W=U.id,$=z.listen(this.ctx,U.name,U.arg)(G=>this.sendResponse({id:W,data:G,type:204}));this.activeRequests.set(U.id,$)}disposeActiveRequest(U){const z=this.activeRequests.get(U.id);z&&(z.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let z=this.pendingRequests.get(U.channelName);z||(z=[],this.pendingRequests.set(U.channelName,z));const W=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:U,timeoutTimer:W})}flushPendingRequests(U){const z=this.pendingRequests.get(U);if(z){for(const W of z)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var y;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(U,z=null){this.protocol=U,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=z}getChannel(U){const z=this;return{call(W,K,$){return z.isDisposed?Promise.reject(A.canceled()):z.requestPromise(U,W,K,$)},listen(W,K){return z.isDisposed?Promise.reject(A.canceled()):z.requestEvent(U,W,K)}}}requestPromise(U,z,W,K=k.CancellationToken.None){const $=this.lastRequestId++,X={id:$,type:100,channelName:U,name:z,arg:W};if(K.isCancellationRequested)return Promise.reject(A.canceled());let Z;return new Promise((se,ue)=>{if(K.isCancellationRequested)return ue(A.canceled());const ge=()=>{const Ce=Ee=>{switch(Ee.type){case 201:this.handlers.delete($),se(Ee.data);break;case 202:this.handlers.delete($);const De=new Error(Ee.data.message);De.stack=Ee.data.stack,De.name=Ee.data.name,ue(De);break;case 203:this.handlers.delete($),ue(Ee.data);break}};this.handlers.set($,Ce),this.sendRequest(X)};let me=null;this.state===b.Idle?ge():(me=(0,R.createCancelablePromise)(Ce=>this.whenInitialized()),me.then(()=>{me=null,ge()}));const Se=()=>{me?(me.cancel(),me=null):this.sendRequest({id:$,type:101}),ue(A.canceled())},be=K.onCancellationRequested(Se);Z=(0,L.combinedDisposable)((0,L.toDisposable)(Se),be),this.activeRequests.add(Z)}).finally(()=>{this.activeRequests.delete(Z)})}requestEvent(U,z,W){const K=this.lastRequestId++,G={id:K,type:102,channelName:U,name:z,arg:W};let X=null;const Z=new S.Emitter({onFirstListenerAdd:()=>{X=(0,R.createCancelablePromise)(se=>this.whenInitialized()),X.then(()=>{X=null,this.activeRequests.add(Z),this.sendRequest(G)})},onLastListenerRemove:()=>{X?(X.cancel(),X=null):(this.activeRequests.delete(Z),this.sendRequest({id:K,type:103}))}}),ee=se=>Z.fire(se.data);return this.handlers.set(K,ee),Z.event}sendRequest(U){switch(U.type){case 100:case 102:{const z=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger&&this.logger.logOutgoing(z,U.id,0,`${h(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const z=this.send([U.type,U.id]);this.logger&&this.logger.logOutgoing(z,U.id,0,h(U.type));return}}}send(U,z=void 0){const W=new g;return l(W,U),l(W,z),this.sendBuffer(W.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(z){return 0}}onBuffer(U){const z=new I(U),W=o(z),K=o(z),$=W[0];switch($){case 200:return this.logger&&this.logger.logIncoming(U.byteLength,0,0,D($)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],0,D($),K),this.onResponse({type:W[0],id:W[1],data:K})}}onResponse(U){if(U.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const z=this.handlers.get(U.id);z&&z(U)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}de([m.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class f{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:z,onDidClientDisconnect:W})=>{S.Event.once(z.onMessage)($=>{const G=new I($),X=o(G),Z=new u(z,X),ee=new E(z);this.channels.forEach((ue,ge)=>Z.registerChannel(ge,ue));const se={channelServer:Z,channelClient:ee,ctx:X};this._connections.add(se),this._onDidAddConnection.fire(se),W(()=>{Z.dispose(),ee.dispose(),this._connections.delete(se),this._onDidRemoveConnection.fire(se)})})})}get connections(){const U=[];return this._connections.forEach(z=>U.push(z)),U}getChannel(U,z){const W=this;return{call(K,$,G){let X;if((0,w.isFunction)(z)){let ee=(0,v.getRandomElement)(W.connections.filter(z));X=ee?Promise.resolve(ee):S.Event.toPromise(S.Event.filter(W.onDidAddConnection,z))}else X=z.routeCall(W,K,$);const Z=X.then(ee=>ee.channelClient.getChannel(U));return O(Z).call(K,$,G)},listen(K,$){if((0,w.isFunction)(z))return W.getMulticastEvent(U,z,K,$);const G=z.routeEvent(W,K,$).then(X=>X.channelClient.getChannel(U));return O(G).listen(K,$)}}}getMulticastEvent(U,z,W,K){const $=this;let G=new L.DisposableStore;const X=new S.Emitter({onFirstListenerAdd:()=>{G=new L.DisposableStore;const Z=new S.EventMultiplexer,ee=new Map,se=ge=>{const Se=ge.channelClient.getChannel(U).listen(W,K),be=Z.add(Se);ee.set(ge,be)},ue=ge=>{const me=ee.get(ge);!me||(me.dispose(),ee.delete(ge))};$.connections.filter(z).forEach(se),S.Event.filter($.onDidAddConnection,z)(se,void 0,G),$.onDidRemoveConnection(ue,void 0,G),Z.event(X.fire,X,G),G.add(Z)},onLastListenerRemove:()=>{G.dispose()}});return X.event}registerChannel(U,z){this.channels.set(U,z),this._connections.forEach(W=>{W.channelServer.registerChannel(U,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=f;class T{constructor(U,z,W=null){const K=new g;l(K,z),U.send(K.buffer),this.channelClient=new E(U,W),this.channelServer=new u(U,z,W)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,z){this.channelServer.registerChannel(U,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function O(F){return{call(U,z,W){return F.then(K=>K.call(U,z,W))},listen(U,z){const W=new S.Relay;return F.then(K=>W.input=K.listen(U,z)),W.event}}}e.getDelayedChannel=O;function x(F){let U=!1;return{call(z,W,K){return U?F.call(z,W,K):(0,R.timeout)(0).then(()=>U=!0).then(()=>F.call(z,W,K))},listen(z,W){if(U)return F.listen(z,W);const K=new S.Relay;return(0,R.timeout)(0).then(()=>U=!0).then(()=>K.input=F.listen(z,W)),K.event}}}e.getNextTickChannel=x;class j{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const z of U.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await S.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=j;var H;(function(F){function U(K,$){const G=K,X=$&&$.disableMarshalling,Z=new Map;for(const ee in G)W(ee)&&Z.set(ee,S.Event.buffer(G[ee],!0));return new class{listen(ee,se){const ue=Z.get(se);if(ue)return ue;throw new Error(`Event not found: ${se}`)}call(ee,se,ue){const ge=G[se];if(typeof ge=="function"){if(!X&&Array.isArray(ue))for(let me=0;me<ue.length;me++)ue[me]=(0,n.revive)(ue[me]);return ge.apply(G,ue)}throw new Error(`Method not found: ${se}`)}}}F.fromService=U;function z(K,$){const G=$&&$.disableMarshalling;return new Proxy({},{get(X,Z){if(typeof Z=="string")return $?.properties?.has(Z)?$.properties.get(Z):W(Z)?K.listen(Z):async function(...ee){let se;$&&!(0,w.isUndefinedOrNull)($.context)?se=[$.context,...ee]:se=ee;const ue=await K.call(Z,se);return G?ue:(0,n.revive)(ue)};throw new Error(`Property not found: ${String(Z)}`)}})}F.toService=z;function W(K){return K[0]==="o"&&K[1]==="n"&&p.isUpperAsciiLetter(K.charCodeAt(2))}})(H=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let U=F.toString();if(U!=="[object Object]")return U}return F}function _(F){return Array.isArray(F)?F.map(N):N(F)}function M(F,U,z,W,K,$,G){G=_(G);const X=V[K],Z=X[W%X.length];let ee=[`%c[${F}]%c[${String(U).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${$}`,"color: darkgreen","color: grey","color: grey",`color: ${Z}`];/\($/.test($)?(ee=ee.concat(G),ee.push(")")):ee.push(G),console.log.apply(console,ee)}e.logWithColors=M;class B{constructor(U,z){this._outgoingPrefix=U,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,z,W,K,$){this._totalOutgoing+=U,M(this._outgoingPrefix,this._totalOutgoing,U,z,W,K,$)}logIncoming(U,z,W,K,$){this._totalIncoming+=U,M(this._incomingPrefix,this._totalIncoming,U,z,W,K,$)}}e.IPCLogger=B}),define(te[100],ne([0,1,3,36,25]),function(Y,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(v){this.port=v,this.onMessage=S.Event.fromDOMEventEmitter(this.port,"message",w=>R.VSBuffer.wrap(w.data)),v.start()}send(v){this.port.postMessage(v.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class A extends L.IPCClient{constructor(v,w){const n=new k(v);super(n,w);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=A}),define(te[101],ne([0,1,102,3,36,100]),function(Y,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends R.IPCServer{static getOnDidClientConnect(){const v=L.Event.fromNodeEventEmitter(S.ipcRenderer,"vscode:createMessageChannel",(w,n)=>n);return L.Event.map(v,w=>{const{port1:n,port2:p}=new MessageChannel,d={protocol:new k.Protocol(n),onDidClientDisconnect:L.Event.fromDOMEventEmitter(n,"close")};return S.ipcRenderer.postMessage("vscode:createMessageChannelResult",w,[p]),d})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(te[103],ne([0,1,9,25]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function R(P,v){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const w=new XMLHttpRequest;return new Promise((n,p)=>{w.open(P.type||"GET",P.url||"",!0,P.user,P.password),k(w,P),w.responseType="arraybuffer",w.onerror=m=>p(new Error(w.statusText&&"XHR failed: "+w.statusText||"XHR failed")),w.onload=m=>{n({res:{statusCode:w.status,headers:A(w)},stream:(0,L.bufferToStream)(L.VSBuffer.wrap(new Uint8Array(w.response)))})},w.ontimeout=m=>p(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(w.timeout=P.timeout),w.send(P.data),v.onCancellationRequested(()=>{w.abort(),p((0,S.canceled)())})})}e.request=R;function k(P,v){if(v.headers){e:for(let w in v.headers){switch(w){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(w,v.headers[w])}}}function A(P){const v=Object.create(null);for(const w of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(w){const n=w.indexOf(":");v[w.substr(0,n).trim().toLowerCase()]=w.substr(n+1).trim()}return v}}),define(te[69],ne([0,1,2,3,6,14]),function(Y,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var A;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));var P;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(P||(P={}));class v extends S.Disposable{constructor(p,m=Object.create(null)){super();this.database=p,this.options=m,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(v.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((m,d)=>this.accept(d,m)),p.deleted?.forEach(m=>this.accept(m,void 0))}accept(p,m){if(this.state===P.Closed)return;let d=!1;(0,k.isUndefinedOrNull)(m)?d=this.cache.delete(p):this.cache.get(p)!==m&&(this.cache.set(p,m),d=!0),d&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,m){const d=this.cache.get(p);return(0,k.isUndefinedOrNull)(d)?m:d}getBoolean(p,m){const d=this.get(p);return(0,k.isUndefinedOrNull)(d)?m:d==="true"}getNumber(p,m){const d=this.get(p);return(0,k.isUndefinedOrNull)(d)?m:parseInt(d,10)}async set(p,m){if(this.state===P.Closed)return;if((0,k.isUndefinedOrNull)(m))return this.delete(p);const d=String(m);if(this.cache.get(p)!==d)return this.cache.set(p,d),this.pendingInserts.set(p,d),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.flushDelayer.trigger(()=>this.flushPending())}async delete(p){if(!(this.state===P.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(p){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=v,v.DEFAULT_FLUSH_DELAY=100;class w{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert&&p.insert.forEach((m,d)=>this.items.set(d,m)),p.delete&&p.delete.forEach(m=>this.items.delete(m))}async close(){}}e.InMemoryStorageDatabase=w}),define(te[104],ne([12,13]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(te[55],ne([0,1,104]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,R=L*60,k=R*24,A=k*7,P=k*30,v=k*365;function w(p,m){typeof p!="number"&&(p=p.getTime());const d=Math.round((new Date().getTime()-p)/1e3);if(d<-30)return(0,S.localize)(0,null,w(new Date().getTime()+d*1e3,!1));if(d<30)return(0,S.localize)(1,null);let h;return d<L?(h=d,m?h===1?(0,S.localize)(2,null,h):(0,S.localize)(3,null,h):h===1?(0,S.localize)(4,null,h):(0,S.localize)(5,null,h)):d<R?(h=Math.floor(d/L),m?h===1?(0,S.localize)(6,null,h):(0,S.localize)(7,null,h):h===1?(0,S.localize)(8,null,h):(0,S.localize)(9,null,h)):d<k?(h=Math.floor(d/R),m?h===1?(0,S.localize)(10,null,h):(0,S.localize)(11,null,h):h===1?(0,S.localize)(12,null,h):(0,S.localize)(13,null,h)):d<A?(h=Math.floor(d/k),m?h===1?(0,S.localize)(14,null,h):(0,S.localize)(15,null,h):h===1?(0,S.localize)(16,null,h):(0,S.localize)(17,null,h)):d<P?(h=Math.floor(d/A),m?h===1?(0,S.localize)(18,null,h):(0,S.localize)(19,null,h):h===1?(0,S.localize)(20,null,h):(0,S.localize)(21,null,h)):d<v?(h=Math.floor(d/P),m?h===1?(0,S.localize)(22,null,h):(0,S.localize)(23,null,h):h===1?(0,S.localize)(24,null,h):(0,S.localize)(25,null,h)):(h=Math.floor(d/v),m?h===1?(0,S.localize)(26,null,h):(0,S.localize)(27,null,h):h===1?(0,S.localize)(28,null,h):(0,S.localize)(29,null,h))}e.fromNow=w;function n(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(te[105],ne([12,13]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(te[43],ne([0,1,105,14,22]),function(Y,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(w,n){return n&&(w.stack||w.stacktrace)?S.localize(0,null,P(w),A(w.stack)||A(w.stacktrace)):P(w)}function A(w){return Array.isArray(w)?w.join(`
`):w}function P(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?S.localize(1,null,w.message):w.message||S.localize(2,null)}function v(w=null,n=!1){if(!w)return S.localize(3,null);if(Array.isArray(w)){const p=R.coalesce(w),m=v(p[0],n);return p.length>1?S.localize(4,null,m,p.length):m}if(L.isString(w))return w;if(w.detail){const p=w.detail;if(p.error)return k(p.error,n);if(p.exception)return k(p.exception,n)}return w.stack?k(w,n):w.message?w.message:S.localize(5,null)}e.toErrorMessage=v}),define(te[106],ne([12,13]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(te[107],ne([0,1,8,18,42,106,34,14,26,41,7,68,17]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function d(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(s,c){if(n.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};c&&(t.cwd=c);const r=R.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],t);return new Promise(i=>{r.once("error",a=>{i({success:!1,error:a})}),r.once("exit",(a,l)=>{i(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?d(t.status):1})}else if(n.isLinux||n.isMacintosh)try{const t=m.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(r=>{R.execFile(t,[s.pid.toString()],{encoding:"utf8",shell:!0},(i,a,l)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function C(s=A.env){return s.comspec||"cmd.exe"}e.getWindowsShell=C;class D{constructor(c,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=c,this.args=t,this.shell=r,this.options=i;else{const a=c;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(A.env).forEach(l=>{a[l]=A.env[l]}),Object.keys(this.options.env).forEach(l=>{a[l]=this.options.env[l]}),this.options.env=a}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const t=c.lastIndexOf(S.sep);return t!==-1&&(c=c.substring(t+1)),D.WellKnowCommands[c]?c:"other"}start(c){return n.isWindows&&(this.options&&this.options.cwd&&w.isUNC(this.options.cwd)||!this.options&&w.isUNC(A.cwd()))?Promise.reject(new Error(k.localize(0,null))):this.useExec().then(t=>{let r,i;const a=new Promise((l,o)=>{r=l,i=o});if(t){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=R.exec(l,this.options,(o,u,y)=>{this.childProcess=null;const E=o;E&&E.killed?i({killed:this.terminateRequested,stdout:u.toString(),stderr:y.toString()}):this.handleExec(r,c,o,u,y)})}else{let l=null;const o=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,r,c,i);const y={terminated:this.terminateRequested};P.isNumber(u)&&(y.cmdCode=u),r(y)};if(this.shell&&n.isWindows){const u=v.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let y=!1,E=!1;const f=[];let T=this.ensureQuotes(this.cmd);f.push(T.value),y=T.quoted,this.args&&this.args.forEach(x=>{T=this.ensureQuotes(x),f.push(T.value),E=E&&T.quoted});const O=["/s","/c"];y?E?O.push('"'+f.join(" ")+'"'):f.length>1?O.push('"'+f[0]+'" '+f.slice(1).join(" ")):O.push('"'+f[0]+'"'):O.push(f.join(" ")),l=R.spawn(C(),O,u)}else this.cmd&&(l=R.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(P.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",u=>{this.childProcess=null,i({terminated:this.terminateRequested,error:u})}),l.pid&&(this.childProcess.on("close",o),this.handleSpawn(l,r,c,i,!0)))}return a})}handleClose(c,t,r,i){}ensureQuotes(c){return D.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,h(c,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!n.isWindows)return c(!1);const t=R.spawn(C(),["/s","/c"]);t.on("error",r=>c(!0)),t.on("exit",r=>c(!1))})}}e.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class b extends D{constructor(c,t,r,i){super(c,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,t,r,i,a){[i,a].forEach((l,o)=>{const u=new p.LineDecoder;u.write(l).forEach(f=>{t({line:f,source:o===0?0:1})});const E=u.end();E&&t({line:E,source:o===0?0:1})}),c({terminated:this.terminateRequested,error:r})}handleSpawn(c,t,r,i,a){const l=new p.LineDecoder,o=new p.LineDecoder;c.stdout.on("data",u=>{l.write(u).forEach(E=>r({line:E,source:0}))}),c.stderr.on("data",u=>{o.write(u).forEach(E=>r({line:E,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=o}handleClose(c,t,r,i){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&r({line:a,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&r({line:l,source:1})}}e.LineProcess=b;function I(s){let c=[],t=!1;const r=function(i){if(t){c.push(i);return}(!s.send(i,l=>{if(l&&console.error(l),t=!1,c.length>0){const o=c.slice(0);c=[],o.forEach(u=>r(u))}})||n.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=I;var g;(function(s){async function c(t,r,i){if(S.isAbsolute(t))return t;if(r===void 0&&(r=A.cwd()),S.dirname(t)!=="."||(i===void 0&&P.isString(A.env.PATH)&&(i=A.env.PATH.split(S.delimiter)),i===void 0||i.length===0))return S.join(r,t);async function l(o){return await L.Promises.exists(o)?!(await L.Promises.stat(o)).isDirectory():!1}for(let o of i){let u;if(S.isAbsolute(o)?u=S.join(o,t):u=S.join(r,o,t),await l(u))return u;let y=u+".com";if(await l(y)||(y=u+".exe",await l(y)))return y}return S.join(r,t)}s.findExecutable=c})(g=e.win32||(e.win32={}))}),define(te[49],ne([0,1,42,2,6,26,3,107,36,90,29,9,25,7]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends v.ChannelServer{constructor(b){super({send:I=>{try{process.send&&process.send(I.buffer.toString("base64"))}catch(g){}},onMessage:A.Event.fromNodeEventEmitter(process,"message",I=>m.VSBuffer.wrap(Buffer.from(I,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=h;class C{constructor(b,I){this.modulePath=b,this.options=I,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new A.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=I&&I.timeout?I.timeout:6e4;this.disposeDelayer=new R.Delayer(g),this.child=null,this._client=null}getChannel(b){const I=this;return{call(g,s,c){return I.requestPromise(b,g,s,c)},listen(g,s){return I.requestEvent(b,g,s)}}}requestPromise(b,I,g,s=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(p.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(b),t=(0,R.createCancelablePromise)(a=>c.call(I,g,a)),r=s.onCancellationRequested(()=>t.cancel()),i=(0,L.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,I,g){if(!this.disposeDelayer)return A.Event.None;this.disposeDelayer.cancel();let s;const c=new A.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(b).listen(I,g)(c.fire,c),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],I=Object.create(null);I.env={...(0,k.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(I.env={...I.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(I.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(I.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(I.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),I.execArgv===void 0&&(I.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),d.isMacintosh&&I.env&&delete I.env.DYLD_LIBRARY_PATH,this.child=(0,S.fork)(this.modulePath,b,I);const g=new A.Emitter;A.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,w.isRemoteConsoleLog)(l)){(0,w.log)(l,`IPC Library: ${this.options.serverName}`);return}g.fire(m.VSBuffer.wrap(Buffer.from(l,"base64")))});const c=this.options.useQueue?(0,P.createQueuedSender)(this.child):this.child,t=l=>this.child&&this.child.connected&&c.send(l.buffer.toString("base64")),r=g.event,i={send:t,onMessage:r};this._client=new v.ChannelClient(i);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,o)=>{process.removeListener("exit",a),this.activeRequests.forEach(u=>(0,L.dispose)(u)),this.activeRequests.clear(),l!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:o})})}return this._client}getCachedChannel(b){let I=this.channels.get(b);return I||(I=this.client.getChannel(b),this.channels.set(b,I)),I}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(te[108],ne([12,13]),function(Y,e){return Y.create("vs/base/node/zip",e)}),define(te[109],ne([12,13]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[110],ne([12,13]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[111],ne([12,13]),function(Y,e){return Y.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[112],ne([12,13]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[113],ne([12,13]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[114],ne([12,13]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[115],ne([12,13]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[116],ne([12,13]),function(Y,e){return Y.create("vs/platform/files/common/fileService",e)}),define(te[117],ne([12,13]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(te[118],ne([12,13]),function(Y,e){return Y.create("vs/platform/files/common/io",e)}),define(te[119],ne([12,13]),function(Y,e){return Y.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[120],ne([12,13]),function(Y,e){return Y.create("vs/platform/request/common/request",e)}),define(te[121],ne([12,13]),function(Y,e){return Y.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[122],ne([12,13]),function(Y,e){return Y.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[123],ne([12,13]),function(Y,e){return Y.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[124],ne([12,13]),function(Y,e){return Y.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[125],ne([12,13]),function(Y,e){return Y.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[126],ne([12,13]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[127],ne([12,13]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[128],ne([12,13]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[129],ne([0,1,8,15,64,55,17,5,34]),function(Y,e,S,L,R,k,A,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(h,C,D){this._args=h,this.paths=C,this.productService=D}get appRoot(){return(0,S.dirname)(A.FileAccess.asFileUri("",Y).fsPath)}get userHome(){return P.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return P.URI.file((0,S.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,L.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,S.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return P.URI.file((0,S.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,L.joinPath)(P.URI.file((0,S.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return P.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return P.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=v.env.VSCODE_PORTABLE;return h?P.URI.file((0,S.join)(h,"argv.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,L.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,S.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,S.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,S.resolve)(h):(0,S.normalize)((0,S.join)(A.FileAccess.asFileUri("",Y).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,S.resolve)(h):(0,S.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,S.resolve)(h);const C=v.env.VSCODE_EXTENSIONS;if(C)return C;const D=v.env.VSCODE_PORTABLE;return D?(0,S.join)(D,"extensions"):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(C=>/^[^:/?#]+?:\/\//.test(C)?P.URI.parse(C):P.URI.file((0,S.normalize)(C)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?P.URI.parse(h):P.URI.file((0,S.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!v.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,L.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return P.URI.file((0,S.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([R.memoize],w.prototype,"appRoot",null),de([R.memoize],w.prototype,"userHome",null),de([R.memoize],w.prototype,"userDataPath",null),de([R.memoize],w.prototype,"appSettingsHome",null),de([R.memoize],w.prototype,"tmpDir",null),de([R.memoize],w.prototype,"userRoamingDataHome",null),de([R.memoize],w.prototype,"settingsResource",null),de([R.memoize],w.prototype,"userDataSyncHome",null),de([R.memoize],w.prototype,"userDataSyncLogResource",null),de([R.memoize],w.prototype,"sync",null),de([R.memoize],w.prototype,"machineSettingsResource",null),de([R.memoize],w.prototype,"globalStorageHome",null),de([R.memoize],w.prototype,"workspaceStorageHome",null),de([R.memoize],w.prototype,"keybindingsResource",null),de([R.memoize],w.prototype,"keyboardLayoutResource",null),de([R.memoize],w.prototype,"argvResource",null),de([R.memoize],w.prototype,"snippetsHome",null),de([R.memoize],w.prototype,"isExtensionDevelopment",null),de([R.memoize],w.prototype,"untitledWorkspacesHome",null),de([R.memoize],w.prototype,"installSourcePath",null),de([R.memoize],w.prototype,"builtinExtensionsPath",null),de([R.memoize],w.prototype,"extensionsPath",null),de([R.memoize],w.prototype,"extensionDevelopmentLocationURI",null),de([R.memoize],w.prototype,"extensionDevelopmentKind",null),de([R.memoize],w.prototype,"extensionTestsLocationURI",null),de([R.memoize],w.prototype,"debugExtensionHost",null),de([R.memoize],w.prototype,"serviceMachineIdResource",null),de([R.memoize],w.prototype,"telemetryLogResource",null),de([R.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function n(d,h){return m(d["inspect-extensions"],d["inspect-brk-extensions"],5870,h,d.debugId)}e.parseExtensionHostPort=n;function p(d,h){return m(d["inspect-search"],d["inspect-brk-search"],5876,h)}e.parseSearchPort=p;function m(d,h,C,D,b){const g=Number(h||d)||(D?null:C),s=g?Boolean(!!h):!1;return{port:g,break:s,debugId:b}}}),function(){"use strict";function Y(e,S,L,R){function k(P){const v=A(P),w=[v];return e.isAbsolute(v)||w.unshift(R),e.resolve(...w)}function A(P){const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");const w=P["user-data-dir"];if(w)return w;let n=process.env.VSCODE_APPDATA;if(!n)switch(process.platform){case"win32":if(n=process.env.APPDATA,!n){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");n=e.join(p,"AppData","Roaming")}break;case"darwin":n=e.join(S.homedir(),"Library","Application Support");break;case"linux":n=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(n,L)}return{getUserDataPath:k}}if(typeof define=="function")define(te[130],ne([0,209,35,17,15,34]),function(e,S,L,R,k,A){const P=k.dirname(R.FileAccess.asFileUri("",e)),v=e.__$__nodeRequire(k.joinPath(P,"package.json").fsPath);return Y(S,L,v.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),S=require("path"),L=require("os");module.exports=Y(S,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[131],ne([0,1,35,130,129]),function(Y,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends R.AbstractNativeEnvironmentService{constructor(P,v){super(P,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,L.getUserDataPath)(P)},v)}}e.NativeEnvironmentService=k}),define(te[132],ne([0,1,5]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,v=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function w(D){const b=D.match(A);return b?b[1]:null}function n(D){if(D.indexOf("://")===-1){const b=D.match(L);return b?w(b[2]):null}try{const b=S.URI.parse(D);if(b.authority)return w(b.authority)}catch(b){}return null}function p(D,b){const I=new Set;let g;for(;g=P.exec(D);){const c=n(g[1]);c&&I.add(c)}const s=new Set(b);return Array.from(I).map(c=>s.has(c)?c:c.replace(v,"a"))}e.getDomainsOfRemotes=p;function m(D){const b=D.match(k);return b?b[2]:null}function d(D,b,I){return D&&b?(I&&b.endsWith(".git")&&(b=b.substr(0,b.length-4)),b.indexOf("/")===0?`${D}${b}`:`${D}/${b}`):null}function h(D,b){if(D.indexOf("://")===-1){const I=D.match(R);if(I)return d(I[2],I[3],b)}try{const I=S.URI.parse(D);if(I.authority)return d(m(I.authority),I.path,b)}catch(I){}return null}function C(D,b=!1){const I=[];let g;for(;g=P.exec(D);){const s=h(g[1],b);s&&I.push(s)}return I}e.getRemotes=C}),define(te[133],ne([0,1,3,5,93,26,2]),function(Y,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(h,C){return L.URI.revive(C?C.transformIncoming(h):h)}function v(h,C){return C?C.transformOutgoingURI(h):h}function w(h,C){C=C||R.DefaultURITransformer;const D=h.manifest;return{...(0,R.transformAndReviveIncomingURIs)({...h,manifest:void 0},C),manifest:D}}function n(h,C){return C?(0,k.cloneAndChange)(h,D=>D instanceof L.URI?C.transformOutgoingURI(D):void 0):h}class p{constructor(C,D){this.service=C,this.getUriTransformer=D,this.onInstallExtension=S.Event.buffer(C.onInstallExtension,!0),this.onDidInstallExtensions=S.Event.buffer(C.onDidInstallExtensions,!0),this.onUninstallExtension=S.Event.buffer(C.onUninstallExtension,!0),this.onDidUninstallExtension=S.Event.buffer(C.onDidUninstallExtension,!0)}listen(C,D){const b=this.getUriTransformer(C);switch(D){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return S.Event.map(this.onDidInstallExtensions,I=>I.map(g=>({...g,local:g.local?n(g.local,b):g.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(C,D,b){const I=this.getUriTransformer(C);switch(D){case"zip":return this.service.zip(w(b[0],I)).then(g=>v(g,I));case"unzip":return this.service.unzip(P(b[0],I));case"install":return this.service.install(P(b[0],I),b[1]);case"getManifest":return this.service.getManifest(P(b[0],I));case"canInstall":return this.service.canInstall(b[0]);case"installFromGallery":return this.service.installFromGallery(b[0],b[1]);case"uninstall":return this.service.uninstall(w(b[0],I),b[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(w(b[0],I));case"getInstalled":return this.service.getInstalled(b[0]).then(g=>g.map(s=>n(s,I)));case"updateMetadata":return this.service.updateMetadata(w(b[0],I),b[1]).then(g=>n(g,I));case"updateExtensionScope":return this.service.updateExtensionScope(w(b[0],I),b[1]).then(g=>n(g,I));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=p;class m extends A.Disposable{constructor(C){super();this.channel=C,this._onInstallExtension=this._register(new S.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new S.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new S.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new S.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(D=>this._onInstallExtension.fire(D))),this._register(this.channel.listen("onDidInstallExtensions")(D=>this._onDidInstallExtensions.fire(D.map(b=>({...b,local:b.local?w(b.local,null):b.local}))))),this._register(this.channel.listen("onUninstallExtension")(D=>this._onUninstallExtension.fire(D))),this._register(this.channel.listen("onDidUninstallExtension")(D=>this._onDidUninstallExtension.fire(D)))}zip(C){return Promise.resolve(this.channel.call("zip",[C]).then(D=>L.URI.revive(D)))}unzip(C){return Promise.resolve(this.channel.call("unzip",[C]))}install(C,D){return Promise.resolve(this.channel.call("install",[C,D])).then(b=>w(b,null))}getManifest(C){return Promise.resolve(this.channel.call("getManifest",[C]))}async canInstall(C){return!0}installFromGallery(C,D){return Promise.resolve(this.channel.call("installFromGallery",[C,D])).then(b=>w(b,null))}uninstall(C,D){return Promise.resolve(this.channel.call("uninstall",[C,D]))}reinstallFromGallery(C){return Promise.resolve(this.channel.call("reinstallFromGallery",[C]))}getInstalled(C=null){return Promise.resolve(this.channel.call("getInstalled",[C])).then(D=>D.map(b=>w(b,null)))}updateMetadata(C,D){return Promise.resolve(this.channel.call("updateMetadata",[C,D])).then(b=>w(b,null))}updateExtensionScope(C,D){return Promise.resolve(this.channel.call("updateExtensionScope",[C,D])).then(b=>w(b,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=m;class d{constructor(C){this.service=C}listen(C,D){throw new Error("Invalid listen")}call(C,D,b){switch(D){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(b[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=d}),define(te[134],ne([0,1,26]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function R(k,A){const P=v=>{if(typeof v!="string")return;const w=L.exec(v);if(!w)return;const n=A[w[1]]??v;return typeof n=="string"?n:typeof n.message=="string"?n.message:v};return(0,S.cloneAndChange)(k,P)}e.localizeManifest=R}),define(te[135],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class S{constructor(k){this.channel=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,A,P,v){return this.channel.call("promptImportantExtensionsInstallNotification",[k,A,P,v])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=S;class L{constructor(k){this.service=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,P){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(te[70],ne([0,1,115]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function k(m){return m=m.trim(),m==="*"||L.test(m)}e.isValidVersionStr=k;function A(m){if(!k(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=m.match(L);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=A;function P(m){if(!m)return null;let d=m.majorBase,h=m.majorMustEqual,C=m.minorBase,D=m.minorMustEqual,b=m.patchBase,I=m.patchMustEqual;m.hasCaret&&(d===0||(D=!1),I=!1);let g=0;if(m.preRelease){const s=R.exec(m.preRelease);if(s){const[,c,t,r]=s;g=Date.UTC(Number(c),Number(t)-1,Number(r))}}return{majorBase:d,majorMustEqual:h,minorBase:C,minorMustEqual:D,patchBase:b,patchMustEqual:I,isMinimum:m.hasGreaterEquals,notBefore:g}}e.normalizeVersion=P;function v(m,d,h){let C;typeof m=="string"?C=P(A(m)):C=m;let D;d instanceof Date?D=d.getTime():typeof d=="string"&&(D=new Date(d).getTime());let b;if(typeof h=="string"?b=P(A(h)):b=h,!C||!b)return!1;let I=C.majorBase,g=C.minorBase,s=C.patchBase,c=b.majorBase,t=b.minorBase,r=b.patchBase,i=b.notBefore,a=b.majorMustEqual,l=b.minorMustEqual,o=b.patchMustEqual;return b.isMinimum?I>c?!0:I<c?!1:g>t?!0:g<t||D&&D<i?!1:s>=r:(I===1&&c===0&&(!a||!l||!o)&&(c=1,t=0,r=0,a=!0,l=!1,o=!1),I<c?!1:I>c?!a:g<t?!1:g>t?!l:s<r?!1:s>r?!o:!(D&&D<i))}e.isValidVersion=v;function w(m,d,h,C){return h.isBuiltin||typeof h.main=="undefined"?!0:p(m,d,h.engines.vscode,C)}e.isValidExtensionVersion=w;function n(m,d,h){return m==="*"||p(d,h,m)}e.isEngineValid=n;function p(m,d,h,C=[]){let D=P(A(h));if(!D)return C.push(S.localize(0,null,h)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return C.push(S.localize(1,null,h)),!1}else if(!D.majorMustEqual)return C.push(S.localize(2,null,h)),!1;return v(m,d,D)?!0:(C.push(S.localize(3,null,m,h)),!1)}}),define(te[136],ne([0,1,36,49,2,17]),function(Y,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends R.Disposable{constructor(v,w,n,p){super();this.folders=v,this.onDidFilesChange=w,this.onLogMessage=n,this.verboseLogging=p,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const v=this._register(new L.Client(k.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(v.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(v.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.setFolders(this.folders)}setVerboseLogging(v){this.verboseLogging=v,!this.isDisposed&&this.service&&this.service.setVerboseLogging(v)}error(v){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${v}`})}setFolders(v){this.folders=v,this.service&&this.service.setRoots(v)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(te[137],ne([0,1,36,49,2,17]),function(Y,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends R.Disposable{constructor(v,w,n,p,m={}){super();this.folders=v,this.onDidFilesChange=w,this.onLogMessage=n,this.verboseLogging=p,this.watcherOptions=m,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const v=this._register(new L.Client(k.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(v.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(v.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.service.setRoots(this.folders)}error(v){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${v}`})}setVerboseLogging(v){this.verboseLogging=v,this.service&&this.service.setVerboseLogging(v)}setFolders(v){this.folders=v,this.service&&this.service.setRoots(v)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(te[138],ne([0,1,42,68,67,17]),function(Y,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class A{constructor(v,w,n,p,m){this.watchedFolder=v,this.eventCallback=n,this.logCallback=p,this.verboseLogging=m,this.restartCounter=0,Array.isArray(w)?this.ignored=w.map(d=>(0,R.parse)(d)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${v}, excludes: ${w.join(",")}`),this.startWatcher()}startWatcher(){const v=[this.watchedFolder];this.verboseLogging&&v.push("-verbose"),this.handle=(0,S.spawn)(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",Y).fsPath,v);const w=new L.LineDecoder;this.handle.stdout.on("data",n=>{const p=[];for(const m of w.write(n)){const d=m.split("|");if(d.length===2){const h=Number(d[0]),C=d[1];if(h>=0&&h<3){if(this.ignored&&this.ignored.some(D=>D(C))){this.verboseLogging&&this.log(C);continue}p.push({type:A.changeTypeMap[h],path:C})}else this.log(d[1])}}p.length>0&&this.eventCallback(p)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,p)=>this.onExit(n,p))}onError(v){this.error("process error: "+v.toString())}onExit(v,w){this.handle&&(this.error(`terminated unexpectedly (code: ${v}, signal: ${w})`),this.restartCounter<=A.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(v){this.logCallback({type:"error",message:`[File Watcher (C#)] ${v}`})}log(v){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${v}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=A,A.MAX_RESTARTS=5,A.changeTypeMap=[0,1,2]}),define(te[139],ne([0,1,138,8,19]),function(Y,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k{constructor(P,v,w,n){this.onDidFilesChange=v,this.onLogMessage=w,this.verboseLogging=n,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(L.posix.sep)&&(this.folder.path=(0,R.rtrim)(this.folder.path,L.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new S.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=k}),define(te[50],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(R,k=[],A=!1){this.ctor=R,this.staticArguments=k,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=S}),define(te[140],ne([0,1,50]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function R(A,P,v){P instanceof S.SyncDescriptor||(P=new S.SyncDescriptor(P,[],v)),L.push([A,P])}e.registerSingleton=R;function k(){return L}e.getSingletonServiceDescriptors=k}),define(te[141],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=S;class L{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let A of this._nodes.values())A.outgoing.size===0&&k.push(A);return k}insertEdge(k,A){const P=this.lookupOrInsertNode(k),v=this.lookupOrInsertNode(A);P.outgoing.set(this._hashFn(A),v),v.incoming.set(this._hashFn(k),P)}removeNode(k){const A=this._hashFn(k);this._nodes.delete(A);for(let P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(k){const A=this._hashFn(k);let P=this._nodes.get(A);return P||(P=new S(k),this._nodes.set(A,P)),P}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[A,P]of this._nodes)k.push(`${A}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,A]of this._nodes){const P=new Set([k]),v=this._findCycle(A,P);if(v)return v}}_findCycle(k,A){for(let[P,v]of k.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const w=this._findCycle(v,A);if(w)return w;A.delete(P)}}}e.Graph=L}),define(te[4],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function v(w){return w[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=v})(S=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function L(P,v,w,n){v[S.DI_TARGET]===v?v[S.DI_DEPENDENCIES].push({id:P,index:w,optional:n}):(v[S.DI_DEPENDENCIES]=[{id:P,index:w,optional:n}],v[S.DI_TARGET]=v)}function R(P){if(S.serviceIds.has(P))return S.serviceIds.get(P);const v=function(w,n,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(v,w,p,!1)};return v.toString=()=>P,S.serviceIds.set(P,v),v}e.createDecorator=R;function k(P){return P}e.refineServiceDecorator=k;function A(P){return function(v,w,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(P,v,n,!0)}}e.optional=A}),define(te[142],ne([0,1,4]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,S.createDecorator)("checksumService")}),define(te[143],ne([0,1,19,4,7]),function(Y,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=R.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",R.isMacintosh),A.set("isLinux",R.isLinux),A.set("isWindows",R.isWindows),A.set("isWeb",R.isWeb),A.set("isMacNative",R.isMacintosh&&!R.isWeb),A.set("isEdge",k.indexOf("Edg/")>=0),A.set("isFirefox",k.indexOf("Firefox")>=0),A.set("isChrome",k.indexOf("Chrome")>=0),A.set("isSafari",k.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var v;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(v=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return p.INSTANCE}static true(){return m.INSTANCE}static has(f){return d.create(f)}static equals(f,T){return h.create(f,T)}static notEquals(f,T){return b.create(f,T)}static regex(f,T){return r.create(f,T)}static in(f,T){return C.create(f,T)}static not(f){return I.create(f)}static and(...f){return a.create(f)}static or(...f){return l.create(f)}static greater(f,T){return g.create(f,T)}static less(f,T){return c.create(f,T)}static deserialize(f,T=!1){if(!!f)return this._deserializeOrExpression(f,T)}static _deserializeOrExpression(f,T){let O=f.split("||");return l.create(O.map(x=>this._deserializeAndExpression(x,T)))}static _deserializeAndExpression(f,T){let O=f.split("&&");return a.create(O.map(x=>this._deserializeOne(x,T)))}static _deserializeOne(f,T){if(f=f.trim(),f.indexOf("!=")>=0){let O=f.split("!=");return b.create(O[0].trim(),this._deserializeValue(O[1],T))}if(f.indexOf("==")>=0){let O=f.split("==");return h.create(O[0].trim(),this._deserializeValue(O[1],T))}if(f.indexOf("=~")>=0){let O=f.split("=~");return r.create(O[0].trim(),this._deserializeRegexValue(O[1],T))}if(f.indexOf(" in ")>=0){let O=f.split(" in ");return C.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(f)){const O=f.split(">=");return s.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(f)){const O=f.split(">");return g.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(f)){const O=f.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(f)){const O=f.split("<");return c.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(f)?I.create(f.substr(1).trim()):d.create(f)}static _deserializeValue(f,T){if(f=f.trim(),f==="true")return!0;if(f==="false")return!1;let O=/^'([^']*)'$/.exec(f);return O?O[1].trim():f}static _deserializeRegexValue(f,T){if((0,S.isFalsyOrWhitespace)(f)){if(T)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=f.indexOf("/"),x=f.lastIndexOf("/");if(O===x||O<0){if(T)throw new Error(`bad regexp-value '${f}', missing /-enclosure`);return console.warn(`bad regexp-value '${f}', missing /-enclosure`),null}let j=f.slice(O+1,x),H=f[x+1]==="i"?"i":"";try{return new RegExp(j,H)}catch(V){if(T)throw new Error(`bad regexp-value '${f}', parse error: ${V}`);return console.warn(`bad regexp-value '${f}', parse error: ${V}`),null}}}e.ContextKeyExpr=w;function n(E,f){return E.cmp(f)}class p{constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=p,p.INSTANCE=new p;class m{constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return p.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class d{constructor(f){this.key=f,this.type=2}static create(f){const T=A.get(f);return typeof T=="boolean"?T?m.INSTANCE:p.INSTANCE:new d(f)}cmp(f){return f.type!==this.type?this.type-f.type:u(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return I.create(this.key)}}e.ContextKeyDefinedExpr=d;class h{constructor(f,T){this.key=f,this.value=T,this.type=4}static create(f,T){if(typeof T=="boolean")return T?d.create(f):I.create(f);const O=A.get(f);return typeof O=="boolean"?T===(O?"true":"false")?m.INSTANCE:p.INSTANCE:new h(f,T)}cmp(f){return f.type!==this.type?this.type-f.type:y(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(f){return f.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=h;class C{constructor(f,T){this.key=f,this.valueKey=T,this.type=10}static create(f,T){return new C(f,T)}cmp(f){return f.type!==this.type?this.type-f.type:y(this.key,this.valueKey,f.key,f.valueKey)}equals(f){return f.type===this.type?this.key===f.key&&this.valueKey===f.valueKey:!1}evaluate(f){const T=f.getValue(this.valueKey),O=f.getValue(this.key);return Array.isArray(T)?T.indexOf(O)>=0:typeof O=="string"&&typeof T=="object"&&T!==null?P.call(T,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(f){return f.mapIn(this.key,this.valueKey)}negate(){return D.create(this)}}e.ContextKeyInExpr=C;class D{constructor(f){this._actual=f,this.type=11}static create(f){return new D(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new D(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class b{constructor(f,T){this.key=f,this.value=T,this.type=5}static create(f,T){if(typeof T=="boolean")return T?I.create(f):d.create(f);const O=A.get(f);return typeof O=="boolean"?T===(O?"true":"false")?p.INSTANCE:m.INSTANCE:new b(f,T)}cmp(f){return f.type!==this.type?this.type-f.type:y(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(f){return f.mapNotEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class I{constructor(f){this.key=f,this.type=3}static create(f){const T=A.get(f);return typeof T=="boolean"?T?p.INSTANCE:m.INSTANCE:new I(f)}cmp(f){return f.type!==this.type?this.type-f.type:u(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!f.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(f){return f.mapNot(this.key)}negate(){return d.create(this.key)}}e.ContextKeyNotExpr=I;class g{constructor(f,T){this.key=f,this.value=T,this.type=12}static create(f,T){return new g(f,T)}cmp(f){return f.type!==this.type?this.type-f.type:y(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=g;class s{constructor(f,T){this.key=f,this.value=T,this.type=13}static create(f,T){return new s(f,T)}cmp(f){return f.type!==this.type?this.type-f.type:y(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreaterEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=s;class c{constructor(f,T){this.key=f,this.value=T,this.type=14}static create(f,T){return new c(f,T)}cmp(f){return f.type!==this.type?this.type-f.type:y(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmaller(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeySmallerExpr=c;class t{constructor(f,T){this.key=f,this.value=T,this.type=15}static create(f,T){return new t(f,T)}cmp(f){return f.type!==this.type?this.type-f.type:y(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmallerEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(f,T){this.key=f,this.regexp=T,this.type=7}static create(f,T){return new r(f,T)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.key<f.key)return-1;if(this.key>f.key)return 1;const T=this.regexp?this.regexp.source:"",O=f.regexp?f.regexp.source:"";return T<O?-1:T>O?1:0}equals(f){if(f.type===this.type){const T=this.regexp?this.regexp.source:"",O=f.regexp?f.regexp.source:"";return this.key===f.key&&T===O}return!1}evaluate(f){let T=f.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const f=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${f}`}keys(){return[this.key]}map(f){return f.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(f){this._actual=f,this.type=8}static create(f){return new i(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new i(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class a{constructor(f){this.expr=f,this.type=6}static create(f){return a._normalizeArr(f)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let T=0,O=this.expr.length;T<O;T++){const x=n(this.expr[T],f.expr[T]);if(x!==0)return x}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].equals(f.expr[T]))return!1;return!0}return!1}evaluate(f){for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].evaluate(f))return!1;return!0}static _normalizeArr(f){const T=[];let O=!1;for(const x of f)if(!!x){if(x.type===1){O=!0;continue}if(x.type===0)return p.INSTANCE;if(x.type===6){T.push(...x.expr);continue}T.push(x)}if(T.length===0&&O)return m.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];for(T.sort(n);T.length>1;){const x=T[T.length-1];if(x.type!==9)break;T.pop();const j=T.pop(),H=l.create(x.expr.map(V=>a.create([V,j])));H&&(T.push(H),T.sort(n))}return T.length===1?T[0]:new a(T)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(let T of this.expr)f.push(...T.keys());return f}map(f){return new a(this.expr.map(T=>T.map(f)))}negate(){let f=[];for(let T of this.expr)f.push(T.negate());return l.create(f)}}e.ContextKeyAndExpr=a;class l{constructor(f){this.expr=f,this.type=9}static create(f){const T=l._normalizeArr(f);if(T.length!==0)return T.length===1?T[0]:new l(T)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let T=0,O=this.expr.length;T<O;T++){const x=n(this.expr[T],f.expr[T]);if(x!==0)return x}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].equals(f.expr[T]))return!1;return!0}return!1}evaluate(f){for(let T=0,O=this.expr.length;T<O;T++)if(this.expr[T].evaluate(f))return!0;return!1}static _normalizeArr(f){let T=[],O=!1;if(f){for(let x=0,j=f.length;x<j;x++){const H=f[x];if(!!H){if(H.type===0){O=!0;continue}if(H.type===1)return[m.INSTANCE];if(H.type===9){T=T.concat(H.expr);continue}T.push(H)}}if(T.length===0&&O)return[p.INSTANCE];T.sort(n)}return T}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(let T of this.expr)f.push(...T.keys());return f}map(f){return new l(this.expr.map(T=>T.map(f)))}negate(){let f=[];for(let O of this.expr)f.push(O.negate());const T=O=>O.type===9?O.expr:[O];for(;f.length>1;){const O=f.shift(),x=f.shift(),j=[];for(const H of T(O))for(const V of T(x))j.push(w.and(H,V));f.unshift(w.or(...j))}return f[0]}}e.ContextKeyOrExpr=l;class o extends d{constructor(f,T,O){super(f);this._defaultValue=T,typeof O=="object"?o._info.push({...O,key:f}):O!==!0&&o._info.push({key:f,description:O,type:T!=null?typeof T:void 0})}static all(){return o._info.values()}bindTo(f){return f.createKey(this.key,this._defaultValue)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return w.not(this.key)}isEqualTo(f){return w.equals(this.key,f)}notEqualsTo(f){return w.notEquals(this.key,f)}}e.RawContextKey=o,o._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(E,f){return E<f?-1:E>f?1:0}function y(E,f,T,O){return E<T?-1:E>T?1:f<O?-1:f>O?1:0}}),define(te[71],ne([0,1,4]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function L(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=L}),define(te[72],ne([0,1,4]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,S.createDecorator)("downloadService")}),define(te[10],ne([0,1,4]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(te[28],ne([0,1,110,4,17]),function(Y,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=k;var A;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=5]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var P;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var v;(function(p){p.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var w;(function(p){p[p.None=0]="None",p[p.Install=1]="Install",p[p.Update=2]="Update"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(m,d){super(m);this.code=d,this.name=d}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,S.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,S.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,L.createDecorator)("IExtensionManagementCLIService")});var J=this&&this.__param||function(Y,e){return function(S,L){e(S,L,Y)}};define(te[144],ne([0,1,2,28]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let R=class extends S.Disposable{constructor(A){super();this.extensionManagementService=A,this._register(A),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};R=de([J(0,L.IExtensionManagementService)],R),e.DeprecatedExtensionsCleaner=R}),define(te[73],ne([0,1,4]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function R(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var k;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,S.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[74],ne([0,1,19,4]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function R(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=R;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class P{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,m){if(typeof p=="undefined"||p===null)return typeof m=="undefined"||m===null;if(typeof m=="undefined"||m===null)return!1;if(typeof p=="string"||typeof m=="string"){let d=typeof p=="string"?p:p.value,h=typeof m=="string"?m:m.value;return S.equalsIgnoreCase(d,h)}return p._lower===m._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=P;function v(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function w(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[33],ne([0,1,19,74]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(h,C){return h.uuid&&C.uuid?h.uuid===C.uuid:h.id===C.id?!0:(0,S.compareIgnoreCase)(h.id,C.id)===0}e.areSameExtensions=R;class k{constructor(C,D){this.version=D,this.id=C.id,this.uuid=C.uuid}key(){return`${this.id}-${this.version}`}equals(C){return C instanceof k?R(this,C)&&this.version===C.version:!1}}e.ExtensionIdentifierWithVersion=k;function A(h,C){return`${h}.${C}`}e.getExtensionId=A;function P(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function v(h,C){return P(A(h,C))}e.getGalleryExtensionId=v;function w(h,C){const D=[],b=I=>{for(const g of D)if(g.some(s=>R(C(s),C(I))))return g;return null};for(const I of h){const g=b(I);g?g.push(I):D.push([I])}return D}e.groupByExtension=w;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function p(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function m(h){const C=new Set;for(const D of h)D.malicious&&C.add(D.id.id);return C}e.getMaliciousExtensionsSet=m;function d(h,C){const D=[],b=C.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const I=b.shift();if(I&&D.every(g=>!R(g.identifier,{id:I}))){const g=h.filter(s=>R(s.identifier,{id:I}));g.length===1&&(D.push(g[0]),b.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return D}e.getExtensionDependencies=d}),define(te[145],ne([0,1,2,8,74,18]),function(Y,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends S.Disposable{constructor(v,w){super();this.environmentService=v,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(w.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this._register(w.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtensions(v){v.some(w=>!!w.local)&&this.invalidate()}onDidUnInstallExtension(v){v.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(te[11],ne([0,1,117,8,5,4,19,14,38]),function(Y,e,S,L,R,k,A,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,k.createDecorator)("fileService");function w(N){return N.create===!0}e.isFileOpenForWriteOptions=w;var n;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var p;(function(N){N[N.Readonly=1]="Readonly"})(p=e.FilePermission||(e.FilePermission={}));var m;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=d;function h(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=h;function C(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function D(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=D;var b;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor(_,M){super(_);this.code=M}}e.FileSystemProviderError=I;function g(N,_){const M=new I(N.toString(),_);return c(M,_),M}e.createFileSystemProviderError=g;function s(N){return N||g((0,S.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=s;function c(N,_){return N.name=_?`${_} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=c;function t(N){if(!N)return b.Unknown;if(N instanceof I)return N.code;const _=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!_)return b.Unknown;switch(_[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(N){if(N instanceof y)return N.fileOperationResult;switch(t(N)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class a{constructor(_,M,B){this.resource=_,this.operation=M,this.target=B}isOperation(_){return this.operation===_}}e.FileOperationEvent=a;var l;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class o{constructor(_,M){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const B of _)switch(B.type){case 1:this.added||(this.added=v.TernarySearchTree.forUris(()=>M)),this.added.set(B.resource,B);break;case 0:this.updated||(this.updated=v.TernarySearchTree.forUris(()=>M)),this.updated.set(B.resource,B);break;case 2:this.deleted||(this.deleted=v.TernarySearchTree.forUris(()=>M)),this.deleted.set(B.resource,B);break}}contains(_,...M){return this.doContains(_,{includeChildren:!1},...M)}affects(_,...M){return this.doContains(_,{includeChildren:!0},...M)}doContains(_,M,...B){if(!_)return!1;const F=B.length>0;return!!((!F||B.includes(1))&&(this.added?.get(_)||M.includeChildren&&this.added?.findSuperstr(_))||(!F||B.includes(0))&&(this.updated?.get(_)||M.includeChildren&&this.updated?.findSuperstr(_))||(!F||B.includes(2))&&(this.deleted?.findSubstr(_)||M.includeChildren&&this.deleted?.findSuperstr(_)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=o;function u(N,_,M){return!N||!_||N===_||_.length>N.length?!1:(_.charAt(_.length-1)!==L.sep&&(_+=L.sep),M?(0,A.startsWithIgnoreCase)(N,_):N.indexOf(_)===0)}e.isParent=u;class y extends Error{constructor(_,M,B){super(_);this.fileOperationResult=M,this.options=B}}e.FileOperationError=y;class E extends y{constructor(_,M,B){super(_,2,B);this.stat=M}}e.NotModifiedSinceFileOperationError=E;var f;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(f=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=O;async function x(N,_){if(!_.canHandleResource(R.URI.from({scheme:N.scheme})))return new Promise(M=>{const B=_.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===N.scheme&&F.added&&(B.dispose(),M())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class j{static formatSize(_){return(0,P.isNumber)(_)||(_=0),_<j.KB?(0,S.localize)(1,null,_.toFixed(0)):_<j.MB?(0,S.localize)(2,null,(_/j.KB).toFixed(2)):_<j.GB?(0,S.localize)(3,null,(_/j.MB).toFixed(2)):_<j.TB?(0,S.localize)(4,null,(_/j.GB).toFixed(2)):(0,S.localize)(5,null,(_/j.TB).toFixed(2))}}e.ByteSize=j,j.KB=1024,j.MB=j.KB*j.KB,j.GB=j.MB*j.KB,j.TB=j.GB*j.KB;var H;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function V(N){return{maxFileSize:N===0?300*j.MB:16*j.GB,maxHeapSize:N===0?700*j.MB:2*700*j.MB}}e.getPlatformLimits=V}),define(te[146],ne([0,1,147,47,11]),function(Y,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(P){this.fileService=P}checksum(P){return new Promise(async(v,w)=>{const n=(0,S.createHash)("md5"),p=(await this.fileService.readFileStream(P)).value;(0,L.listenStream)(p,{onData:m=>n.update(m.buffer),onError:m=>w(m),onEnd:()=>v(n.digest("base64").replace(/=+$/,""))})})}};k=de([J(0,R.IFileService)],k),e.ChecksumService=k}),define(te[75],ne([0,1,5,11,7]),function(Y,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function k(v){return v.map(w=>({type:w.type,resource:S.URI.file(w.path)}))}e.toFileChanges=k;function A(v){const w=new P;for(const n of v)w.processEvent(n);return w.normalize()}e.normalizeFileChanges=A;class P{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(w){const n=this.mapPathToChange.get(w.path);if(n){const p=n.type,m=w.type;p===1&&m===2?(this.mapPathToChange.delete(w.path),this.normalized.splice(this.normalized.indexOf(n),1)):p===2&&m===1?n.type=0:p===1&&m===0||(n.type=m)}else this.normalized.push(w),this.mapPathToChange.set(w.path,w)}normalize(){const w=[],n=[];return this.normalized.filter(p=>p.type!==2?(w.push(p),!1):!0).sort((p,m)=>p.path.length-m.path.length).filter(p=>n.some(m=>(0,L.isParent)(p.path,m,!R.isLinux))?!1:(n.push(p.path),!0)).concat(w)}}}),define(te[148],ne([0,1,75,2,18,96,99,6,8]),function(Y,e,S,L,R,k,A,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends L.Disposable{constructor(p,m,d,h){super();this.path=p,this.onDidFilesChange=m,this.onLogMessage=d,this.verboseLogging=h,this.fileChangesDelayer=this._register(new P.ThrottledDelayer(A.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(p){this.verboseLogging=p}async startWatching(){try{const{stat:p,symbolicLink:m}=await R.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let d=this.path;if(m)try{d=await(0,k.realpath)(d)}catch(h){if(this.onError(h),m.dangling)return}p.isDirectory()?this._register((0,A.watchFolder)(d,(h,C)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,v.join)(this.path,(0,v.basename)(C))})},h=>this.onError(h))):this._register((0,A.watchFile)(d,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(p){p.code!=="ENOENT"&&this.onError(p)}}onFileChange(p){this.fileChangesBuffer.push(p),this.verboseLogging&&this.onVerbose(`${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const d=(0,S.normalizeFileChanges)(m);if(this.verboseLogging)for(const h of d)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);d.length>0&&this.onDidFilesChange(d)})}onError(p){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${p}`})}onVerbose(p){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${p}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(te[76],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...R){this._entries=new Map;for(let[k,A]of R)this.set(k,A)}set(R,k){const A=this._entries.get(R);return this._entries.set(R,k),A}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=S}),define(te[149],ne([0,1,9,141,50,4,76,6]),function(Y,e,S,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const v=!1;class w extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class n{constructor(h=new A.ServiceCollection,C=!1,D){this._activeInstantiations=new Set,this._services=h,this._strict=C,this._parent=D,this._services.set(k.IInstantiationService,this)}createChild(h){return new n(h,this._strict,this)}invokeFunction(h,...C){let D=m.traceInvocation(h),b=!1;try{return h({get:(g,s)=>{if(b)throw(0,S.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(g,D);if(!c&&s!==k.optional)throw new Error(`[invokeFunction] unknown service '${g}'`);return c}},...C)}finally{b=!0,D.stop()}}createInstance(h,...C){let D,b;return h instanceof R.SyncDescriptor?(D=m.traceCreation(h.ctor),b=this._createInstance(h.ctor,h.staticArguments.concat(C),D)):(D=m.traceCreation(h),b=this._createInstance(h,C,D)),D.stop(),b}_createInstance(h,C=[],D){let b=k._util.getServiceDependencies(h).sort((s,c)=>s.index-c.index),I=[];for(const s of b){let c=this._getOrCreateServiceInstance(s.id,D);if(!c&&this._strict&&!s.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${s.id}.`);I.push(c)}let g=b.length>0?b[0].index:C.length;if(C.length!==g){console.warn(`[createInstance] First service dependency of ${h.name} at position ${g+1} conflicts with ${C.length} static arguments`);let s=g-C.length;s>0?C=C.concat(new Array(s)):C=C.slice(0,g)}return new h(...[...C,...I])}_setServiceInstance(h,C){if(this._services.get(h)instanceof R.SyncDescriptor)this._services.set(h,C);else if(this._parent)this._parent._setServiceInstance(h,C);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let C=this._services.get(h);return!C&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):C}_getOrCreateServiceInstance(h,C){let D=this._getServiceInstanceOrDescriptor(h);return D instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,D,C.branch(h,!0)):(C.branch(h,!1),D)}_safeCreateAndCacheServiceInstance(h,C,D){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,C,D)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,C,D){const b=new L.Graph(s=>s.id.toString());let I=0;const g=[{id:h,desc:C,_trace:D}];for(;g.length;){const s=g.pop();if(b.lookupOrInsertNode(s),I++>1e3)throw new w(b);for(let c of k._util.getServiceDependencies(s.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(c.id);if(!t&&!c.optional&&console.warn(`[createInstance] ${h} depends on ${c.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const r={id:c.id,desc:t,_trace:s._trace.branch(c.id,!0)};b.insertEdge(s,r),g.push(r)}}}for(;;){const s=b.roots();if(s.length===0){if(!b.isEmpty())throw new w(b);break}for(const{data:c}of s){if(this._getServiceInstanceOrDescriptor(c.id)instanceof R.SyncDescriptor){const r=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,r)}b.removeNode(c)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,C,D=[],b,I){if(this._services.get(h)instanceof R.SyncDescriptor)return this._createServiceInstance(C,D,b,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,C,D,b,I);throw new Error(`illegalState - creating UNKNOWN service instance ${C.name}`)}_createServiceInstance(h,C=[],D,b){if(D){const I=new P.IdleValue(()=>this._createInstance(h,C,b));return new Proxy(Object.create(null),{get(g,s){if(s in g)return g[s];let c=I.value,t=c[s];return typeof t!="function"||(t=t.bind(c),g[s]=t),t},set(g,s,c){return I.value[s]=c,!0}})}else return this._createInstance(h,C,b)}}e.InstantiationService=n;var p;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(p||(p={}));class m{constructor(h,C){this.type=h,this.name=C,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return v?new m(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(h){return v?new m(0,h.name):m._None}branch(h,C){let D=new m(2,h.toString());return this._dep.push([h,C,D]),D}stop(){let h=Date.now()-this._start;m._totals+=h;let C=!1;function D(I,g){let s=[],c=new Array(I+1).join("	");for(const[t,r,i]of g._dep)if(r&&i){C=!0,s.push(`${c}CREATES -> ${t}`);let a=D(I+1,i);a&&s.push(a)}else s.push(`${c}uses -> ${t}`);return s.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(h>2||C)&&console.log(b.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(te[150],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class S{constructor(R,k){this.server=R,this.router=k}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,k){this.server.registerChannel(R,k)}}e.MessagePortMainProcessService=S}),define(te[151],ne([0,1,36,50,140,4]),function(Y,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(d,h,C){const D=C.getChannel(d);return P(h)?new h.channelClientCtor(D):S.ProxyChannel.toService(D,h?.proxyOptions)}}function P(m){return!!m?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let v=class extends A{constructor(d,h,C){super(d,h,C)}};v=de([J(2,e.IMainProcessService)],v);function w(m,d,h){(0,R.registerSingleton)(m,new L.SyncDescriptor(v,[d,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=w,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let n=class extends A{constructor(d,h,C){super(d,h,C)}};n=de([J(2,e.ISharedProcessService)],n);function p(m,d,h){(0,R.registerSingleton)(m,new L.SyncDescriptor(n,[d,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=p}),define(te[56],ne([0,1,4]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,S.createDecorator)("localizationsService");function L(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const k of R.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}e.isValidLocalization=L}),define(te[152],ne([0,1,2,56]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends S.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=de([J(0,L.ILocalizationsService)],R),e.LocalizationsUpdater=R}),define(te[16],ne([0,1,4,2,7,3,43]),function(Y,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function P(){return new Date().toISOString()}var v;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;class w extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class n extends w{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(v.Trace)&&this.log(v.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(v.Debug)&&this.log(v.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(v.Info)&&this.log(v.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(v.Warning)&&this.log(v.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(v.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(v.Error,this.format(i))}else this.log(v.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(v.Critical)&&this.log(v.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let a=t[i];if(typeof a=="object")try{a=JSON.stringify(a)}catch(l){}r+=(i>0?" ":"")+a}return r}}e.AbstractMessageLogger=n;class p extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!R.isWindows}trace(t,...r){this.getLevel()<=v.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}debug(t,...r){this.getLevel()<=v.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}info(t,...r){this.getLevel()<=v.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}warn(t,...r){this.getLevel()<=v.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...r):console.warn(`[main ${P()}]`,t,...r))}error(t,...r){this.getLevel()<=v.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}critical(t,...r){this.getLevel()<=v.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class m extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=v.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=v.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=v.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=v.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=v.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=v.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=m;class d extends w{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=v.Trace&&this.adapter.log(v.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=v.Debug&&this.adapter.log(v.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=v.Info&&this.adapter.log(v.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=v.Warning&&this.adapter.log(v.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=v.Error&&this.adapter.log(v.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=v.Critical&&this.adapter.log(v.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,A.toErrorMessage)(t,this.getLevel()<=v.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class h extends w{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=h;class C extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=C;class D extends L.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(i))}))}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,r?.always?v.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),r?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class b{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(t){}getLevel(){return v.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function I(c){if(c.verbose)return v.Trace;if(typeof c.logLevel=="string"){const t=g(c.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function g(c){switch(c){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Critical;case"off":return v.Off}}e.parseLogLevel=g;function s(c){switch(c){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Critical:return"critical";case v.Off:return"off"}}e.LogLevelToString=s}),define(te[153],ne([0,1,10,8,18,9,2,6,16]),function(Y,e,S,L,R,k,A,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let w=class extends A.Disposable{constructor(p,m){super();this.environmentService=p,this.logService=m,this._register(new P.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const p=(0,L.basename)(this.environmentService.logsPath),m=(0,L.dirname)(this.environmentService.logsPath),C=(await R.Promises.readdir(m)).filter(b=>/^\d{8}T\d{6}$/.test(b)).sort().filter(b=>b!==p),D=C.slice(0,Math.max(0,C.length-9));D.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${D.join(", ")}'`),await Promise.all(D.map(b=>R.Promises.rm((0,L.join)(m,b)))))}catch(p){(0,k.onUnexpectedError)(p)}}};w=de([J(0,S.IEnvironmentService),J(1,v.ILogService)],w),e.LogsDataCleaner=w}),define(te[154],ne([0,1,10,8,18,9,2,6,16]),function(Y,e,S,L,R,k,A,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let w=class lt extends A.Disposable{constructor(p,m,d){super();this.backupWorkspacesPath=p,this.environmentService=m,this.logService=d,this._register(new P.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const p=await R.Promises.readFile(this.backupWorkspacesPath,"utf8"),d=JSON.parse(p).emptyWorkspaceInfos.map(C=>C.backupFolder),h=await R.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async C=>{C.length!==lt.NON_EMPTY_WORKSPACE_ID_LENGTH&&d.indexOf(C)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${C}.`),await R.Promises.rm((0,L.join)(this.environmentService.workspaceStorageHome.fsPath,C)))}))}catch(p){(0,k.onUnexpectedError)(p)}}};w.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,w=de([J(1,S.INativeEnvironmentService),J(2,v.ILogService)],w),e.StorageDataCleaner=w}),define(te[155],ne([0,1,18,2,11,28,10,5,15,33,16,30,57,7,6,9]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let b=class extends L.Disposable{constructor(g,s,c,t){super();this.fileService=s,this.extensionGalleryService=c,this.logService=t,this.extensionsDownloadDir=P.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,s){await this.cleanUpPromise;const c=this.getName(g),t=(0,v.joinPath)(this.extensionsDownloadDir,c);if(!await this.fileService.exists(t)){const r=(0,v.joinPath)(this.extensionsDownloadDir,`.${(0,p.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(g,r,s);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(a){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,C.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,r.path),i}}return t}async delete(g){}async rename(g,s,c){try{await S.Promises.rename(g.fsPath,s.fsPath)}catch(t){if(d.isWindows&&t&&t.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${g} to ${s} with 'EPERM' error. Trying again...`),this.rename(g,s,c);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const s=[],c=[];for(const i of g.children){const a=this.parse(i.name);a&&c.push([a,i])}const t=(0,w.groupByExtension)(c,([i])=>i),r=[];for(const i of t)i.sort((a,l)=>m.rcompare(a[0].version,l[0].version)),s.push(...i.slice(1).map(a=>a[1].resource)),r.push(i[0][1]);r.sort((i,a)=>i.mtime-a.mtime),s.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await h.Promises.settled(s.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?new w.ExtensionIdentifierWithVersion(g.identifier,g.version).key().toLowerCase():(0,p.generateUuid)()}parse(g){const s=D.exec(g);return s&&s[1]&&s[2]?new w.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};b=de([J(0,A.INativeEnvironmentService),J(1,R.IFileService),J(2,k.IExtensionGalleryService),J(3,n.ILogService)],b),e.ExtensionsDownloader=b}),define(te[156],ne([0,1,2,16,42,43,8,6,3,17,18,10]),function(Y,e,S,L,R,k,A,P,v,w,n,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends S.Disposable{constructor(h,C){super();this.environmentService=h,this.logService=C,this.processesLimiter=new P.Limiter(5)}async postUninstall(h){const C=this.parseScript(h,"uninstall");return C&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(C.script,"uninstall",C.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),D=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${D}`)))),n.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,D=>this.logService.error("Error while removing extension storage path",D))}parseScript(h,C){const D=`vscode:${C}`;if(h.location.scheme===w.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[D]=="string"){const b=h.manifest.scripts[D].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${D} should be a node script`),null):{script:(0,A.join)(h.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}runLifecycleHook(h,C,D,b,I){return new Promise((g,s)=>{const c=this.start(h,C,D,I);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?s(i):g(void 0)};c.on("error",i=>{r((0,k.toErrorMessage)(i)||"Unknown")}),c.on("exit",(i,a)=>{r(i?`post-${C} process exited with code ${i}`:void 0)}),b&&(t=setTimeout(()=>{t=null,c.kill(),s("timed out")},5e3))})}start(h,C,D,b){const I={silent:!0,execArgv:void 0},g=(0,R.fork)(h,[`--type=extension-post-${C}`,...D],I);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const s=v.Event.fromNodeEventEmitter(g.stdout,"data"),c=v.Event.fromNodeEventEmitter(g.stderr,"data");s(i=>this.logService.info(b.identifier.id,b.manifest.version,`post-${C}`,i)),c(i=>this.logService.error(b.identifier.id,b.manifest.version,`post-${C}`,i));const t=v.Event.any(v.Event.map(s,i=>({data:`%c${i}`,format:[""]})),v.Event.map(c,i=>({data:`%c${i}`,format:["color: red"]})));return v.Event.debounce(t,(i,a)=>i?{data:i.data+a.data,format:[...i.format,...a.format]}:{data:a.data,format:a.format},100)(i=>{console.group(b.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),g}getExtensionStoragePath(h){return(0,A.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};m=de([J(0,p.IEnvironmentService),J(1,L.ILogService)],m),e.ExtensionsLifecycle=m}),define(te[157],ne([0,1,2,10,3,11,5,33,15,16]),function(Y,e,S,L,R,k,A,P,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends S.Disposable{constructor(m,d,h,C){super();this.extensionsManagementService=m,this.logService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(I=>{this.installedExtensions=I.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(I=>this.onInstallExtension(I))),this._register(m.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(m.onDidUninstallExtension(I=>this.onDidUninstallExtension(I)));const D=A.URI.file(h.extensionsPath),b=new v.ExtUri(I=>!d.hasCapability(I,1024));this._register(d.watch(D)),this._register(R.Event.filter(d.onDidChangeFilesRaw,I=>I.changes.some(g=>this.doesChangeAffects(g,D,b)))(()=>this.onDidChange()))}doesChangeAffects(m,d,h){return h.isEqual(h.dirname(m.resource),d)?h.isEqual(m.resource,h.joinPath(d,".obsolete"))?!0:!(m.type!==1&&m.type!==2||h.basename(m.resource).startsWith(".")):!1}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const d of m)this.removeInstallingExtension(d.identifier),d.local&&this.addInstalledExtension(d.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(d=>!(0,P.areSameExtensions)(d,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(d=>!(0,P.areSameExtensions)(d,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(1),d=m.filter(C=>[...this.installingExtensions,...this.installedExtensions].some(D=>(0,P.areSameExtensions)(D,C.identifier))?!1:C.installedTimestamp&&C.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",C.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",C.identifier.id),!1)),h=this.installedExtensions.filter(C=>this.installingExtensions.some(D=>(0,P.areSameExtensions)(D,C))?!1:m.every(D=>!(0,P.areSameExtensions)(D.identifier,C))?(this.logService.info("Detected extension removed from another source",C.id),!0):!1);this.installedExtensions=m.map(C=>C.identifier),(d.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:d,removed:h})}}};n=de([J(1,k.IFileService),J(2,L.INativeEnvironmentService),J(3,w.ILogService)],n),e.ExtensionsWatcher=n}),define(te[158],ne([0,1,18,147,28,2,10,6,33,16,56,22,3,17,8]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let C=class extends k.Disposable{constructor(I,g,s){super();this.extensionManagementService=I,this.logService=s,this._onDidLanguagesChange=this._register(new m.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new D(g,s)),this._register(I.onDidInstallExtensions(c=>this.onDidInstallExtensions(c))),this._register(I.onDidUninstallExtension(({identifier:c})=>this.onDidUninstallExtension(c)))}getLanguageIds(){return this.cache.getLanguagePacks().then(I=>{const g=["en",...Object.keys(I)];return(0,p.distinct)(g)})}onDidInstallExtensions(I){for(const{local:g}of I)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",g.identifier.id),this.update().then(s=>{s&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(I){this.cache.getLanguagePacks().then(g=>{Object.keys(g).some(s=>g[s]&&g[s].extensions.some(c=>(0,v.areSameExtensions)(c.extensionIdentifier,I)))&&(this.logService.debug("Removing language packs from the extension",I.id),this.update().then(s=>{s&&this._onDidLanguagesChange.fire()}))})}async update(){const[I,g]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),s=await this.cache.update(g);return!(0,p.equals)(Object.keys(I),Object.keys(s))}};C=de([J(0,R.IExtensionManagementService),J(1,A.INativeEnvironmentService),J(2,w.ILogService)],C),e.LocalizationsService=C;let D=class extends k.Disposable{constructor(I,g){super();this.logService=g,this.languagePacks={},this.languagePacksFilePath=(0,h.join)(I.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(I){return this.withLanguagePacks(g=>{Object.keys(g).forEach(s=>delete g[s]),this.createLanguagePacksFromExtensions(g,...I)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(I,...g){for(const s of g)s&&s.manifest&&s.manifest.contributes&&s.manifest.contributes.localizations&&s.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(I,s);Object.keys(I).forEach(s=>this.updateHash(I[s]))}createLanguagePacksFromExtension(I,g){const s=g.identifier,c=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const t of c)if(g.location.scheme===d.Schemas.file&&(0,n.isValidLocalization)(t)){let r=I[t.languageId];r||(r={hash:"",extensions:[],translations:{}},I[t.languageId]=r);let i=r.extensions.filter(a=>(0,v.areSameExtensions)(a.extensionIdentifier,s))[0];i?i.version=g.manifest.version:r.extensions.push({extensionIdentifier:s,version:g.manifest.version});for(const a of t.translations)r.translations[a.id]=(0,h.join)(g.location.fsPath,a.path)}}updateHash(I){if(I){const g=(0,L.createHash)("md5");for(const s of I.extensions)g.update(s.extensionIdentifier.uuid||s.extensionIdentifier.id).update(s.version);I.hash=g.digest("hex")}}withLanguagePacks(I=()=>null){return this.languagePacksFileLimiter.queue(()=>{let g=null;return S.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,s=>s.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(s)).then(s=>{try{return JSON.parse(s)}catch(c){return{}}}).then(s=>(g=I(s),s)).then(s=>{for(const t of Object.keys(s))s[t]||delete s[t];this.languagePacks=s,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),S.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>g,s=>this.logService.error(s))})}};D=de([J(0,A.INativeEnvironmentService),J(1,w.ILogService)],D)}),define(te[77],ne([0,1,16,3,5]),function(Y,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(m){this.service=m,this.onDidChangeLogLevel=L.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,d){switch(d){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${d}`)}async call(m,d,h){switch(d){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${d}`)}}e.LogLevelChannel=k;class A{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){A.setLevel(this.channel,m)}static setLevel(m,d){return m.call("setLevel",d)}}e.LogLevelChannelClient=A;class P{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,d){throw new Error(`Event not found: ${d}`)}async call(m,d,h){switch(d){case"createLogger":this.createLogger(R.URI.revive(h[0]),h[1]);return;case"log":return this.log(R.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${d}`)}createLogger(m,d){this.loggers.set(m.toString(),this.loggerService.createLogger(m,d))}consoleLog(m,d){let h=console.log;switch(m){case S.LogLevel.Error:h=console.error;break;case S.LogLevel.Warning:h=console.warn;break;case S.LogLevel.Info:h=console.info;break}h.call(console,...d)}log(m,d){const h=this.loggers.get(m.toString());if(!h)throw new Error("Create the logger before logging");for(const[C,D]of d)switch(C){case S.LogLevel.Trace:h.trace(D);break;case S.LogLevel.Debug:h.debug(D);break;case S.LogLevel.Info:h.info(D);break;case S.LogLevel.Warning:h.warn(D);break;case S.LogLevel.Error:h.error(D);break;case S.LogLevel.Critical:h.critical(D);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class v extends S.AbstractLoggerService{constructor(m,d,h){super(m,d);this.channel=h}createConsoleMainLogger(){return new S.AdapterLogger({log:(m,d)=>{this.channel.call("consoleLog",[m,d])}})}doCreateLogger(m,d,h){return new w(this.channel,m,d,h)}}e.LoggerChannelClient=v;class w extends S.AbstractMessageLogger{constructor(m,d,h,C){super(C?.always);this.channel=m,this.file=d,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[d,C]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,d){const h=[[m,d]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(m){this.channel.call("log",[this.file,m])}}class n extends S.LogService{constructor(m,d){super(d);this.parent=m,this._register(m.onDidChangeLogLevel(h=>d.setLevel(h)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=n}),define(te[58],ne([0,1,4]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,S.createDecorator)("nativeHostService")}),define(te[51],ne([0,1,17,7,34,15]),function(Y,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const P=L.globals.vscode.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const P=(0,k.dirname)(S.FileAccess.asFileUri("",Y));A=Y.__$__nodeRequire((0,k.joinPath)(P,"product.json").fsPath);const v=Y.__$__nodeRequire((0,k.joinPath)(P,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:v.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.59.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(te[78],ne([0,1,118,25,11,9,51]),function(Y,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(p,m,d,h,C,D){let b;try{await v(p,m,d,h,C,D)}catch(I){b=I}finally{b&&C.errorTransformer&&(b=C.errorTransformer(b)),typeof b!="undefined"&&d.error(b),d.end()}}e.readFileIntoStream=P;async function v(p,m,d,h,C,D){w(D);const b=await p.open(m,{create:!1});try{w(D);let I=0,g=0,s=C&&typeof C.length=="number"?C.length:void 0,c=L.VSBuffer.alloc(Math.min(C.bufferSize,typeof s=="number"?s:C.bufferSize)),t=C&&typeof C.position=="number"?C.position:0,r=0;do g=await p.read(b,t,c.buffer,r,c.byteLength-r),t+=g,r+=g,I+=g,typeof s=="number"&&(s-=g),r===c.byteLength&&(await d.write(h(c)),c=L.VSBuffer.alloc(Math.min(C.bufferSize,typeof s=="number"?s:C.bufferSize)),r=0);while(g>0&&(typeof s!="number"||s>0)&&w(D)&&n(I,C));if(r>0){let i=r;typeof s=="number"&&(i=Math.min(r,s)),d.write(h(c.slice(0,i)))}}catch(I){throw(0,R.ensureFileSystemProviderError)(I)}finally{await p.close(b)}}function w(p){if(p.isCancellationRequested)throw(0,k.canceled)();return!0}function n(p,m){if(m?.limits){if(typeof m.limits.memory=="number"&&p>m.limits.memory)throw(0,R.createFileSystemProviderError)((0,S.localize)(0,null,A.default.nameShort),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof m.limits.size=="number"&&p>m.limits.size)throw(0,R.createFileSystemProviderError)((0,S.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[159],ne([0,1,116,160,2,11,3,15,38,22,16,25,47,6,29,17,78,53]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d,h,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=class xe extends R.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new A.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new d.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new k.FileChangesEvent(c,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new d.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new k.FileChangesEvent(c,!0)))),this.watchedResources=v.TernarySearchTree.forUris(c=>{const t=this.getProvider(c.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new d.ResourceQueue)}registerProvider(s,c){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,L.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:c});const t=new R.DisposableStore;return t.add(c.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(c)))),t.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:s}))),typeof c.onDidErrorOccur=="function"&&t.add(c.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,R.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:c}),this.provider.delete(s),(0,R.dispose)(t)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(t){c.push(t)}}),!this.provider.has(s)&&await d.Promises.settled(c)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,c){const t=this.provider.get(s.scheme);return!!(t&&t.capabilities&c)}listCapabilities(){return b.Iterable.map(this.provider,([s,c])=>({scheme:s,capabilities:c.capabilities}))}async withProvider(s){if(!(0,P.isAbsolutePath)(s))throw new k.FileOperationError((0,S.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const c=this.provider.get(s.scheme);if(!c){const t=new Error;throw t.name="ENOPRO",t.message=(0,S.localize)(1,null,s.toString()),t}return c}async withReadProvider(s){const c=await this.withProvider(s);if((0,k.hasOpenReadWriteCloseCapability)(c)||(0,k.hasReadWriteCapability)(c)||(0,k.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const c=await this.withProvider(s);if((0,k.hasOpenReadWriteCloseCapability)(c)||(0,k.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,c){try{return await this.doResolveFile(s,c)}catch(t){throw(0,k.toFileSystemProviderErrorCode)(t)===k.FileSystemProviderErrorCode.FileNotFound?new k.FileOperationError((0,S.localize)(2,null,this.resourceForError(s)),1):(0,k.ensureFileSystemProviderError)(t)}}async doResolveFile(s,c){const t=await this.withProvider(s),r=this.isPathCaseSensitive(t),i=c?.resolveTo,a=c?.resolveSingleChildDescendants,l=c?.resolveMetadata,o=await t.stat(s);let u;return this.toFileStat(t,s,o,void 0,!!l,(y,E)=>(u||(u=v.TernarySearchTree.forUris(()=>!r),u.set(s,!0),(0,w.isNonEmptyArray)(i)&&i.forEach(f=>u.set(f,!0))),Boolean(u.findSuperstr(y.resource)||u.get(y.resource))?!0:y.isDirectory&&a?E===1:!1))}async toFileStat(s,c,t,r,i,a){const{providerExtUri:l}=this.getExtUri(s),o={resource:c,name:l.basename(c),isFile:(t.type&k.FileType.File)!=0,isDirectory:(t.type&k.FileType.Directory)!=0,isSymbolicLink:(t.type&k.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&k.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,k.etag)({mtime:t.mtime,size:t.size})};if(o.isDirectory&&a(o,r)){try{const u=await s.readdir(c),y=await d.Promises.settled(u.map(async([E,f])=>{try{const T=l.joinPath(c,E),O=i?await s.stat(T):{type:f};return await this.toFileStat(s,T,O,u.length,i,a)}catch(T){return this.logService.trace(T),null}}));o.children=(0,w.coalesce)(y)}catch(u){this.logService.trace(u),o.children=[]}return o}return o}async resolveAll(s){return d.Promises.settled(s.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(s){const c=await this.withProvider(s);try{return!!await c.stat(s)}catch(t){return!1}}async canCreateFile(s,c){try{await this.doValidateCreateFile(s,c)}catch(t){return t}return!0}async doValidateCreateFile(s,c){if(!c?.overwrite&&await this.exists(s))throw new k.FileOperationError((0,S.localize)(3,null,this.resourceForError(s)),3,c)}async createFile(s,c=p.VSBuffer.fromString(""),t){await this.doValidateCreateFile(s,t);const r=await this.writeFile(s,c);return this._onDidRunOperation.fire(new k.FileOperationEvent(s,0,r)),r}async writeFile(s,c,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,s,t)||await this.mkdirp(r,i.dirname(s));let l;if((0,k.hasReadWriteCapability)(r)&&!(c instanceof p.VSBuffer))if((0,m.isReadableStream)(c)){const o=await(0,m.peekStream)(c,3);o.ended?l=p.VSBuffer.concat(o.buffer):l=o}else l=(0,m.peekReadable)(c,o=>p.VSBuffer.concat(o),3);else l=c;!(0,k.hasOpenReadWriteCloseCapability)(r)||(0,k.hasReadWriteCapability)(r)&&l instanceof p.VSBuffer?await this.doWriteUnbuffered(r,s,t,l):await this.doWriteBuffered(r,s,t,l instanceof p.VSBuffer?(0,p.bufferToReadable)(l):l)}catch(a){throw new k.FileOperationError((0,S.localize)(4,null,this.resourceForError(s),(0,k.ensureFileSystemProviderError)(a).toString()),(0,k.toFileOperationResult)(a),t)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,c,t){if(!!t?.unlock&&!(s.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(c)));let i;try{i=await s.stat(c)}catch(a){return}if((i.type&k.FileType.Directory)!=0)throw new k.FileOperationError((0,S.localize)(6,null,this.resourceForError(c)),0,t);if(this.throwIfFileIsReadonly(c,i),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==k.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==(0,k.etag)({mtime:t.mtime,size:i.size}))throw new k.FileOperationError((0,S.localize)(7,null),3,t);return i}async readFile(s,c){const t=await this.withReadProvider(s);return c?.atomic?this.doReadFileAtomic(t,s,c):this.doReadFile(t,s,c)}async doReadFileAtomic(s,c,t){return new Promise((r,i)=>{this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(s,c,t);r(a)}catch(a){i(a)}})})}async doReadFile(s,c,t){const r=await this.doReadFileStream(s,c,{...t,preferUnbuffered:!0});return{...r,value:await(0,p.streamToBuffer)(r.value)}}async readFileStream(s,c){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,c)}async doReadFileStream(s,c,t){const r=new h.CancellationTokenSource,i=this.validateReadFile(c,t).then(l=>l,l=>{throw r.cancel(),l});let a;try{return t&&typeof t.etag=="string"&&t.etag!==k.ETAG_DISABLED&&await i,!((0,k.hasOpenReadWriteCloseCapability)(s)||(0,k.hasFileReadStreamCapability)(s))||(0,k.hasReadWriteCapability)(s)&&t?.preferUnbuffered?a=this.readFileUnbuffered(s,c,t):(0,k.hasFileReadStreamCapability)(s)?a=this.readFileStreamed(s,c,r.token,t):a=this.readFileBuffered(s,c,r.token,t),{...await i,value:a}}catch(l){a&&await(0,m.consumeStream)(a);const o=(0,S.localize)(8,null,this.resourceForError(c),(0,k.ensureFileSystemProviderError)(l).toString());throw l instanceof k.NotModifiedSinceFileOperationError?new k.NotModifiedSinceFileOperationError(o,l.stat,t):new k.FileOperationError(o,(0,k.toFileOperationResult)(l),t)}}readFileStreamed(s,c,t,r=Object.create(null)){const i=s.readFileStream(c,r,t);return(0,m.transform)(i,{data:a=>a instanceof p.VSBuffer?a:p.VSBuffer.wrap(a),error:a=>new k.FileOperationError((0,S.localize)(9,null,this.resourceForError(c),(0,k.ensureFileSystemProviderError)(a).toString()),(0,k.toFileOperationResult)(a),r)},a=>p.VSBuffer.concat(a))}readFileBuffered(s,c,t,r=Object.create(null)){const i=(0,p.newWriteableBufferStream)();return(0,D.readFileIntoStream)(s,c,i,a=>a,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new k.FileOperationError((0,S.localize)(10,null,this.resourceForError(c),(0,k.ensureFileSystemProviderError)(a).toString()),(0,k.toFileOperationResult)(a),r)},t),i}readFileUnbuffered(s,c,t){const r=(0,m.newWriteableStream)(i=>p.VSBuffer.concat(i));return(async()=>{try{let i=await s.readFile(c);t&&typeof t.position=="number"&&(i=i.slice(t.position)),t&&typeof t.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(c,i.byteLength,t),r.end(p.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(s,c){const t=await this.resolve(s,{resolveMetadata:!0});if(t.isDirectory)throw new k.FileOperationError((0,S.localize)(11,null,this.resourceForError(s)),0,c);if(c&&typeof c.etag=="string"&&c.etag!==k.ETAG_DISABLED&&c.etag===t.etag)throw new k.NotModifiedSinceFileOperationError((0,S.localize)(12,null),t,c);return this.validateReadFileLimits(s,t.size,c),t}validateReadFileLimits(s,c,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&c>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&c>t.limits.size&&(r=7),typeof r=="number")throw new k.FileOperationError((0,S.localize)(13,null,this.resourceForError(s)),r)}}async canMove(s,c,t){return this.doCanMoveCopy(s,c,"move",t)}async canCopy(s,c,t){return this.doCanMoveCopy(s,c,"copy",t)}async doCanMoveCopy(s,c,t,r){if(s.toString()!==c.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(i,s,a,c,t,r)}catch(i){return i}return!0}async move(s,c,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),a=await this.doMoveCopy(r,s,i,c,"move",!!t),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(s,a==="move"?2:3,l)),l}async copy(s,c,t){const r=await this.withReadProvider(s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),a=await this.doMoveCopy(r,s,i,c,"copy",!!t),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(s,a==="copy"?3:2,l)),l}async doMoveCopy(s,c,t,r,i,a){if(c.toString()===r.toString())return i;const{exists:l,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(s,c,t,r,i,a);if(l&&!o&&a&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),i==="copy"){if(s===t&&(0,k.hasFileFolderCopyCapability)(s))await s.copy(c,r,{overwrite:a});else{const u=await this.resolve(c);u.isDirectory?await this.doCopyFolder(s,u,t,r):await this.doCopyFile(s,c,t,r)}return i}else return s===t?(await s.rename(c,r,{overwrite:a}),i):(await this.doMoveCopy(s,c,t,r,"copy",a),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(s,c,t,r){if((0,k.hasOpenReadWriteCloseCapability)(s)&&(0,k.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(s,c,t,r);if((0,k.hasOpenReadWriteCloseCapability)(s)&&(0,k.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(s,c,t,r);if((0,k.hasReadWriteCapability)(s)&&(0,k.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(s,c,t,r);if((0,k.hasReadWriteCapability)(s)&&(0,k.hasReadWriteCapability)(t))return this.doPipeUnbuffered(s,c,t,r)}async doCopyFolder(s,c,t,r){await t.mkdir(r),Array.isArray(c.children)&&await d.Promises.settled(c.children.map(async i=>{const a=this.getExtUri(t).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(s,await this.resolve(i.resource),t,a):this.doCopyFile(s,i.resource,t,a)}))}async doValidateMoveCopy(s,c,t,r,i,a){let l=!1;if(s===t){const{providerExtUri:u,isPathCaseSensitive:y}=this.getExtUri(s);if(y||(l=u.isEqual(c,r)),l&&i==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(c),this.resourceForError(r)));if(!l&&u.isEqualOrParent(r,c))throw new Error((0,S.localize)(15,null,this.resourceForError(c),this.resourceForError(r)))}const o=await this.exists(r);if(o&&!l){if(!a)throw new k.FileOperationError((0,S.localize)(16,null,this.resourceForError(c),this.resourceForError(r)),4);if(s===t){const{providerExtUri:u}=this.getExtUri(s);if(u.isEqualOrParent(c,r))throw new Error((0,S.localize)(17,null,this.resourceForError(c),this.resourceForError(r)))}}return{exists:o,isSameResourceWithDifferentPathCase:l}}getExtUri(s){const c=this.isPathCaseSensitive(s);return{providerExtUri:c?P.extUri:P.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(c,s);const t=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(s,0,t)),t}async mkdirp(s,c){const t=[],{providerExtUri:r}=this.getExtUri(s);for(;!r.isEqual(c,r.dirname(c));)try{if(((await s.stat(c)).type&k.FileType.Directory)==0)throw new Error((0,S.localize)(18,null,this.resourceForError(c)));break}catch(i){if((0,k.toFileSystemProviderErrorCode)(i)!==k.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(r.basename(c)),c=r.dirname(c)}for(let i=t.length-1;i>=0;i--){c=r.joinPath(c,t[i]);try{await s.mkdir(c)}catch(a){if((0,k.toFileSystemProviderErrorCode)(a)!==k.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(s,c){try{await this.doValidateDelete(s,c)}catch(t){return t}return!0}async doValidateDelete(s,c){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!c?.useTrash&&!(t.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(s)));let i;try{i=await t.stat(s)}catch(l){}if(i)this.throwIfFileIsReadonly(s,i);else throw new k.FileOperationError((0,S.localize)(20,null,this.resourceForError(s)),1);if(!!!c?.recursive){const l=await this.resolve(s);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(s)))}return t}async del(s,c){const t=await this.doValidateDelete(s,c),r=!!c?.useTrash,i=!!c?.recursive;await t.delete(s,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new k.FileOperationEvent(s,1))}onDidChangeFile(s,c){this._onDidChangeFilesRaw.fire({changes:s});let t,r;{for(const i of s)this.watchedResources.has(i.resource)?(t||(t=[]),t.push(i)):(r||(r=[]),r.push(i));t&&this._onDidFilesChange.fire(new k.FileChangesEvent(t,!c))}if(r){const i=c?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(r)&&xe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(s,c={recursive:!1,excludes:[]}){const t=new R.DisposableStore;{let r=!1,i=()=>{r=!0};t.add((0,R.toDisposable)(()=>i())),this.doWatch(s,c).then(a=>{r?(0,R.dispose)(a):i=()=>(0,R.dispose)(a)},a=>this.logService.error(a))}return c.recursive||(this.watchedResources.set(s,(this.watchedResources.get(s)??0)+1),t.add((0,R.toDisposable)(()=>{const r=this.watchedResources.get(s);typeof r=="number"&&(r<=1?this.watchedResources.delete(s):this.watchedResources.set(s,r-1))}))),t}async doWatch(s,c){const t=await this.withProvider(s),r=this.toWatchKey(t,s,c),i=this.activeWatchers.get(r)||{count:0,disposable:t.watch(s,c)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,(0,R.toDisposable)(()=>{i.count--,i.count===0&&((0,R.dispose)(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(s,c,t){const{providerExtUri:r}=this.getExtUri(s);return[r.getComparisonKey(c),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(s=>(0,R.dispose)(s.disposable)),this.activeWatchers.clear()}async doWriteBuffered(s,c,t,r){return this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri).queue(async()=>{const i=await s.open(c,{create:!0,unlock:t?.unlock??!1});try{(0,m.isReadableStream)(r)||(0,m.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(s,i,r):await this.doWriteReadableBufferedQueued(s,i,r)}catch(a){throw(0,k.ensureFileSystemProviderError)(a)}finally{await s.close(i)}})}async doWriteStreamBufferedQueued(s,c,t){let r=0,i;if((0,m.isReadableBufferedStream)(t)){if(t.buffer.length>0){const a=p.VSBuffer.concat(t.buffer);await this.doWriteBuffer(s,c,a,a.byteLength,r,0),r+=a.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(a,l)=>{(0,m.listenStream)(i,{onData:async o=>{i.pause();try{await this.doWriteBuffer(s,c,o,o.byteLength,r,0)}catch(u){return l(u)}r+=o.byteLength,setTimeout(()=>i.resume())},onError:o=>l(o),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(s,c,t){let r=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(s,c,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(s,c,t,r,i,a){let l=0;for(;l<r;)l+=await s.write(c,i+l,t.buffer,a+l,r-l)}async doWriteUnbuffered(s,c,t,r){return this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,c,t,r))}async doWriteUnbufferedQueued(s,c,t,r){let i;r instanceof p.VSBuffer?i=r:(0,m.isReadableStream)(r)?i=await(0,p.streamToBuffer)(r):(0,m.isReadableBufferedStream)(r)?i=await(0,p.bufferedStreamToBuffer)(r):i=(0,p.readableToBuffer)(r),await s.writeFile(c,i.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(s,c,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,c,t,r))}async doPipeBufferedQueued(s,c,t,r){let i,a;try{i=await s.open(c,{create:!1}),a=await t.open(r,{create:!0,unlock:!1});const l=p.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,u=0,y=0;do y=await s.read(i,o,l.buffer,u,l.byteLength-u),await this.doWriteBuffer(t,a,l,y,o,u),o+=y,u+=y,u===l.byteLength&&(u=0);while(y>0)}catch(l){throw(0,k.ensureFileSystemProviderError)(l)}finally{await d.Promises.settled([typeof i=="number"?s.close(i):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(s,c,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,c,t,r))}async doPipeUnbufferedQueued(s,c,t,r){return t.writeFile(r,await s.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,c,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,c,t,r))}async doPipeUnbufferedToBufferedQueued(s,c,t,r){const i=await t.open(r,{create:!0,unlock:!1});try{const a=await s.readFile(c);await this.doWriteBuffer(t,i,p.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,k.ensureFileSystemProviderError)(a)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(s,c,t,r){const i=await(0,p.streamToBuffer)(this.readFileBuffered(s,c,h.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,i)}throwIfFileSystemIsReadonly(s,c){if(s.capabilities&2048)throw new k.FileOperationError((0,S.localize)(22,null,this.resourceForError(c)),6);return s}throwIfFileIsReadonly(s,c){if((c.permissions??0)&k.FilePermission.Readonly)throw new k.FileOperationError((0,S.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===C.Schemas.file?s.fsPath:s.toString(!0)}};I.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},I=de([J(0,n.ILogService)],I),e.FileService=I}),define(te[161],ne([0,1,2,11,3,7,18,8,15,41,6,16,119,75,137,139,136,148,47,78,22,25]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d,h,C,D,b,I,g,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends S.Disposable{constructor(i,a){super();this.logService=i,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=R.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new R.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:a,symbolicLink:l}=await A.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(a,l),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(i){try{const a=await A.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),l=[];return await Promise.all(a.map(async o=>{try{let u;o.isSymbolicLink()?u=(await this.stat((0,v.joinPath)(i,o.name))).type:u=this.toType(o),l.push([o.name,u])}catch(u){this.logService.trace(u)}})),l}catch(a){throw this.toFileSystemProviderError(a)}}toType(i,a){let l;return a?.dangling?l=L.FileType.Unknown:i.isFile()?l=L.FileType.File:i.isDirectory()?l=L.FileType.Directory:l=L.FileType.Unknown,a&&(l|=L.FileType.SymbolicLink),l}async readFile(i){try{const a=this.toFilePath(i);return await A.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(i,a,l){const o=(0,I.newWriteableStream)(u=>c.VSBuffer.concat(u.map(y=>c.VSBuffer.wrap(y))).buffer);return(0,g.readFileIntoStream)(this,i,o,u=>u.buffer,{...a,bufferSize:this.BUFFER_SIZE},l),o}async writeFile(i,a,l){let o;try{const u=this.toFilePath(i);if(!l.create||!l.overwrite){if(await A.Promises.exists(u)){if(!l.overwrite)throw(0,L.createFileSystemProviderError)((0,m.localize)(0,null),L.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,L.createFileSystemProviderError)((0,m.localize)(1,null),L.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:l.unlock}),await this.write(o,0,a,0,a.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(i,u)}finally{typeof o=="number"&&await this.close(o)}}async open(i,a){try{const l=this.toFilePath(i);if((0,L.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:y}=await A.SymlinkSupport.stat(l);y.mode&128||await A.Promises.chmod(l,y.mode|128)}catch(y){this.logService.trace(y)}let o;if((0,L.isFileOpenForWriteOptions)(a)){if(k.isWindows)try{await A.Promises.truncate(l,0),o="r+"}catch(y){y.code!=="ENOENT"&&this.logService.trace(y)}o||(o="w")}else o="r";const u=await A.Promises.open(l,o);return this.mapHandleToPos.set(u,0),(0,L.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(u,i),u}catch(l){throw(0,L.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(i,l):this.toFileSystemProviderError(l)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await A.Promises.fdatasync(i)}catch(a){this.canFlush=!1,this.logService.error(a)}return await A.Promises.close(i)}catch(a){throw this.toFileSystemProviderError(a)}}async read(i,a,l,o,u){const y=this.normalizePos(i,a);let E=null;try{const f=await A.Promises.read(i,l,o,u,y);return typeof f=="number"?E=f:E=f.bytesRead,E}catch(f){throw this.toFileSystemProviderError(f)}finally{this.updatePos(i,y,E)}}normalizePos(i,a){return a===this.mapHandleToPos.get(i)?null:a}updatePos(i,a,l){const o=this.mapHandleToPos.get(i);typeof o=="number"&&(typeof a=="number"||(typeof l=="number"?this.mapHandleToPos.set(i,o+l):this.mapHandleToPos.delete(i)))}async write(i,a,l,o,u){return(0,n.retry)(()=>this.doWrite(i,a,l,o,u),100,3)}async doWrite(i,a,l,o,u){const y=this.normalizePos(i,a);let E=null;try{const f=await A.Promises.write(i,l,o,u,y);return typeof f=="number"?E=f:E=f.bytesWritten,E}catch(f){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),f)}finally{this.updatePos(i,y,E)}}async mkdir(i){try{await A.Promises.mkdir(this.toFilePath(i))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(i,a){try{const l=this.toFilePath(i);await this.doDelete(l,a)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(i,a){a.recursive?await A.Promises.rm(i,A.RimRafMode.MOVE):await A.Promises.unlink(i)}async rename(i,a,l){const o=this.toFilePath(i),u=this.toFilePath(a);if(o!==u)try{await this.validateTargetDeleted(i,a,"move",l.overwrite),await A.Promises.move(o,u)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,m.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(u)),y.toString()))),this.toFileSystemProviderError(y)}}async copy(i,a,l){const o=this.toFilePath(i),u=this.toFilePath(a);if(o!==u)try{await this.validateTargetDeleted(i,a,"copy",l.overwrite),await A.Promises.copy(o,u,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,m.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(u)),y.toString()))),this.toFileSystemProviderError(y)}}async validateTargetDeleted(i,a,l,o){const u=this.toFilePath(i),y=this.toFilePath(a);let E=!1;if(!!(this.capabilities&1024)||(E=(0,w.isEqual)(u,y,!0)),E&&l==="copy")throw(0,L.createFileSystemProviderError)((0,m.localize)(4,null),L.FileSystemProviderErrorCode.FileExists);if(!E&&await A.Promises.exists(y)){if(!o)throw(0,L.createFileSystemProviderError)((0,m.localize)(5,null),L.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(i,a){return a.recursive?this.watchRecursive(i,a.excludes):this.watchNonRecursive(i)}watchRecursive(i,a){const l={path:this.toFilePath(i),excludes:a},o=(0,s.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,S.toDisposable)(()=>{o(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof D.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,S.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,a;this.options?.watcher?.usePolling?(i=h.FileWatcher,a=this.options?.watcher):this.recursiveFoldersToWatch.length===1?k.isWindows?i=C.FileWatcher:i=h.FileWatcher:i=D.FileWatcher,this.recursiveWatcher=new i(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,d.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===p.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)}))}}watchNonRecursive(i){const a=new b.FileWatcher(this.toFilePath(i),o=>this._onDidChangeFile.fire((0,d.toFileChanges)(o)),o=>{o.type==="error"&&this._onDidWatchErrorOccur.fire(o.message),this.logService[o.type](o.message)},this.logService.getLevel()===p.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)});return(0,S.combinedDisposable)(a,l)}toFilePath(i){return(0,P.normalize)(i.fsPath)}toFileSystemProviderError(i){if(i instanceof L.FileSystemProviderError)return i;let a;switch(i.code){case"ENOENT":a=L.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=L.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=L.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=L.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=L.FileSystemProviderErrorCode.NoPermissions;break;default:a=L.FileSystemProviderErrorCode.Unknown}return(0,L.createFileSystemProviderError)(i,a)}async toFileSystemProviderWriteError(i,a){let l=this.toFileSystemProviderError(a);if(i&&l.code===L.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await A.SymlinkSupport.stat(this.toFilePath(i));o.mode&128||(l=(0,L.createFileSystemProviderError)(a,L.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return l}dispose(){super.dispose(),(0,S.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,S.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(te[27],ne([0,1,4]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService")}),define(te[162],ne([0,1,8,9,2,18,27,6,16]),function(Y,e,S,L,R,k,A,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let w=class extends R.Disposable{constructor(p,m,d){super();this.productService=m,this.logService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,p&&this._register(new P.RunOnceScheduler(()=>{this.cleanUpCodeCaches(p)},30*1e3)).schedule()}async cleanUpCodeCaches(p){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),d=(0,S.dirname)(p),h=(0,S.basename)(p),C=await k.Promises.readdir(d);await Promise.all(C.map(async D=>{if(D===h)return;const b=(0,S.join)(d,D),I=await k.Promises.stat(b);if(I.isDirectory()&&m-I.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${D}.`),k.Promises.rm(b)}))}catch(m){(0,L.onUnexpectedError)(m)}}};w=de([J(1,A.IProductService),J(2,v.ILogService)],w),e.CodeCacheCleaner=w}),define(te[163],ne([0,1,8,18,27,2,9,16,10,6]),function(Y,e,S,L,R,k,A,P,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends k.Disposable{constructor(m,d,h){super();this.environmentService=m,this.logService=d,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new w.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),d=JSON.parse(await L.Promises.readFile((0,S.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let I of Object.keys(d)){const g=d[I];m[`${g.hash}.${I}`]=!0}const h=(0,S.join)(this.environmentService.userDataPath,"clp");if(!await L.Promises.exists(h))return;const D=await L.Promises.readdir(h);for(const I of D){if(m[I]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${I}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${I}`),await L.Promises.rm((0,S.join)(h,I))}const b=Date.now();for(const I of Object.keys(m)){const g=(0,S.join)(h,I),s=await L.Promises.readdir(g);for(const c of s){if(c==="tcf.json")continue;const t=(0,S.join)(g,c),r=await L.Promises.stat(t);r.isDirectory()&&b-r.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,S.join)(I,c)}`),await L.Promises.rm(t))}}}catch(m){(0,A.onUnexpectedError)(m)}}};n=de([J(0,v.INativeEnvironmentService),J(1,P.ILogService),J(2,R.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(te[31],ne([0,1,14,87]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(A,P){L.ok(S.isString(A)),L.ok(S.isObject(P)),L.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new R}),define(te[79],ne([0,1,31,3]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class k{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(v,w){this.schemasById[R(v)]=w,this._onDidChangeSchema.fire(v)}notifySchemaChanged(v){this._onDidChangeSchema.fire(v)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new k;S.Registry.add(e.Extensions.JSONContribution,A)}),define(te[37],ne([0,1,109,3,31,14,79]),function(Y,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var v;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(v=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=R.Registry.as(A.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(I,g=!0){this.registerConfigurations([I],g)}registerConfigurations(I,g=!0){const s=[];I.forEach(c=>{s.push(...this.validateAndRegisterProperties(c,g,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(I){const g=[],s=c=>{if(c.properties)for(const t in c.properties)g.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,c.properties[t]);c.allOf&&c.allOf.forEach(t=>s(t))};for(const c of I){s(c);const t=this.configurationContributors.indexOf(c);t!==-1&&this.configurationContributors.splice(t,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(g)}registerDefaultConfigurations(I){const g=[],s=[];for(const c of I)for(const t in c)if(g.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...c[t]};const r={type:"object",default:this.defaultValues[t],description:S.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};s.push(m(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=c[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(g)}deregisterDefaultConfigurations(I){const g=[];for(const s of I)for(const c in s)if(g.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const t=this.configurationProperties[c];t&&(this.updatePropertyDefaultValue(c,t),this.updateSchema(c,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(g)}notifyConfigurationSchemaUpdated(...I){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(I){for(const g of I)this.overrideIdentifiers.add(g);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(I,g=!0,s,c=3){c=k.isUndefinedOrNull(I.scope)?c:I.scope;let t=[],r=I.properties;if(r)for(let a in r){if(g&&C(a)){delete r[a];continue}const l=r[a];if(this.updatePropertyDefaultValue(a,l),e.OVERRIDE_PROPERTY_PATTERN.test(a)?l.scope=void 0:(l.scope=k.isUndefinedOrNull(l.scope)?c:l.scope,l.restricted=k.isUndefinedOrNull(l.restricted)?!!s?.restrictedConfigurations?.includes(a):l.restricted),r[a].hasOwnProperty("included")&&!r[a].included){this.excludedConfigurationProperties[a]=r[a],delete r[a];continue}else this.configurationProperties[a]=r[a];!r[a].deprecationMessage&&r[a].markdownDeprecationMessage&&(r[a].deprecationMessage=r[a].markdownDeprecationMessage),t.push(a)}let i=I.allOf;if(i)for(let a of i)t.push(...this.validateAndRegisterProperties(a,g,s,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(I){const g=s=>{let c=s.properties;if(c)for(const r in c)this.updateSchema(r,c[r]);let t=s.allOf;t&&t.forEach(g)};g(I)}updateSchema(I,g){switch(e.allSettings.properties[I]=g,g.scope){case 1:e.applicationSettings.properties[I]=g;break;case 2:e.machineSettings.properties[I]=g;break;case 6:e.machineOverridableSettings.properties[I]=g;break;case 3:e.windowSettings.properties[I]=g;break;case 4:e.resourceSettings.properties[I]=g;break;case 5:e.resourceSettings.properties[I]=g,this.resourceLanguageSettingsSchema.properties[I]=g;break}}removeFromSchema(I,g){switch(delete e.allSettings.properties[I],g.scope){case 1:delete e.applicationSettings.properties[I];break;case 2:delete e.machineSettings.properties[I];break;case 6:delete e.machineOverridableSettings.properties[I];break;case 3:delete e.windowSettings.properties[I];break;case 4:case 5:delete e.resourceSettings.properties[I];break}}updateOverridePropertyPatternKey(){for(const I of this.overrideIdentifiers.values()){const g=`[${I}]`,s={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(g,s),e.allSettings.properties[g]=s,e.applicationSettings.properties[g]=s,e.machineSettings.properties[g]=s,e.machineOverridableSettings.properties[g]=s,e.windowSettings.properties[g]=s,e.resourceSettings.properties[g]=s}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(I,g){let s=this.defaultValues[I];k.isUndefined(s)&&(s=g.default),k.isUndefined(s)&&(s=d(g.type)),g.default=s}}const p="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(p);function m(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=m;function d(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const h=new n;R.Registry.add(e.Extensions.Configuration,h);function C(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?S.localize(5,null,b):h.getConfigurationProperties()[b]!==void 0?S.localize(6,null,b):null:S.localize(4,null)}e.validateProperty=C;function D(){const b=[],I=h.getConfigurationProperties();for(const g of Object.keys(I))b.push([g,I[g].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=D}),define(te[23],ne([0,1,26,14,5,31,4,37]),function(Y,e,S,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function v(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof R.URI)}e.isConfigurationOverrides=v;var w;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function p(r,i){const a=i?r?i.keys.filter(T=>r.keys.indexOf(T)===-1):[...i.keys]:[],l=r?i?r.keys.filter(T=>i.keys.indexOf(T)===-1):[...r.keys]:[],o=[];if(i&&r){for(const T of r.keys)if(i.keys.indexOf(T)!==-1){const O=b(r.contents,T),x=b(i.contents,T);S.equals(O,x)||o.push(T)}}const u=[],y=T=>{const O={};for(const x of T)for(const j of x.identifiers)O[c(j)]=x;return O},E=i?y(i.overrides):{},f=r?y(r.overrides):{};if(Object.keys(E).length)for(const T of a){const O=E[T];O&&u.push([(0,P.overrideIdentifierFromKey)(T),O.keys])}if(Object.keys(f).length)for(const T of l){const O=f[T];O&&u.push([(0,P.overrideIdentifierFromKey)(T),O.keys])}if(Object.keys(E).length&&Object.keys(f).length)for(const T of o){const O=f[T],x=E[T];if(O&&x){const j=p({contents:O.contents,keys:O.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});u.push([(0,P.overrideIdentifierFromKey)(T),[...j.added,...j.removed,...j.updated]])}}return{added:a,removed:l,updated:o,overrides:u}}e.compare=p;function m(r,i){const a=[];for(const l of Object.keys(r))if(P.OVERRIDE_PROPERTY_PATTERN.test(l)){const o={};for(const u in r[l])o[u]=r[l][u];a.push({identifiers:[(0,P.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(o),contents:d(o,i)})}return a}e.toOverrides=m;function d(r,i){const a=Object.create(null);for(let l in r)h(a,l,r[l],i);return a}e.toValuesTree=d;function h(r,i,a,l){const o=i.split("."),u=o.pop();let y=r;for(let E=0;E<o.length;E++){let f=o[E],T=y[f];switch(typeof T){case"undefined":T=y[f]=Object.create(null);break;case"object":break;default:l(`Ignoring ${i} as ${o.slice(0,E+1).join(".")} is ${JSON.stringify(T)}`);return}y=T}if(typeof y=="object"&&y!==null)try{y[u]=a}catch(E){l(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(y)}`)}else l(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(y)}`)}e.addToValueTree=h;function C(r,i){const a=i.split(".");D(r,a)}e.removeFromValueTree=C;function D(r,i){const a=i.shift();if(i.length===0){delete r[a];return}if(Object.keys(r).indexOf(a)!==-1){const l=r[a];typeof l=="object"&&!Array.isArray(l)&&(D(l,i),Object.keys(l).length===0&&delete r[a])}}function b(r,i,a){function l(y,E){let f=y;for(const T of E){if(typeof f!="object"||f===null)return;f=f[T]}return f}const o=i.split("."),u=l(r,o);return typeof u=="undefined"?a:u}e.getConfigurationValue=b;function I(r,i,a){Object.keys(i).forEach(l=>{l!=="__proto__"&&(l in r?L.isObject(r[l])&&L.isObject(i[l])?I(r[l],i[l],a):a&&(r[l]=i[l]):r[l]=i[l])})}e.merge=I;function g(){const r=k.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=g;function s(){const r=Object.create(null),i=k.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let a in i){let l=i[a].default;h(r,a,l,o=>console.error(`Conflict in default settings: ${o}`))}return r}e.getDefaultValues=s;function c(r){return`[${r}]`}e.keyFromOverrideIdentifier=c;function t(r,i,a){const l=r.inspect(i),o=r.inspect(a);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:l.defaultValue}e.getMigratedSettingValue=t}),define(te[164],ne([0,1,32,38,22,14,26,5,37,23,31,2,3]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,w.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?(0,w.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const a of R.distinct([...Object.keys(this.contents),...Object.keys(r)])){let l=this.contents[a],o=r[a];o&&(typeof l=="object"&&typeof o=="object"?(l=A.deepClone(l),this.mergeContents(l,o)):l=o),i[a]=l}return new d(i,this.keys,this.overrides)}merge(...t){const r=A.deepClone(this.contents),i=A.deepClone(this.overrides),a=[...this.keys];for(const l of t){this.mergeContents(r,l.contents);for(const o of l.overrides){const[u]=i.filter(y=>R.equals(y.identifiers,o.identifiers));u?this.mergeContents(u.contents,o.contents):i.push(A.deepClone(o))}for(const o of l.keys)a.indexOf(o)===-1&&a.push(o)}return new d(r,a,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&k.isObject(t[i])&&k.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=A.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,w.addToValueTree)(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,w.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=d;class h extends d{constructor(){const t=(0,w.getDefaultValues)(),r=(0,w.getConfigurationKeys)(),i=[];for(const a of Object.keys(t))v.OVERRIDE_PROPERTY_PATTERN.test(a)&&i.push({identifiers:[(0,v.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(t[a]),contents:(0,w.toValuesTree)(t[a],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,r,i)}}e.DefaultConfigurationModel=h;class C{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!k.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:a,overrides:l,restricted:o}=this.doParseRaw(t,r);this._configurationModel=new d(i,a,l),this._restrictedConfigurations=o||[]}doParseContent(t){let r={},i=null,a=[],l=[],o=[];function u(E){Array.isArray(a)?a.push(E):i&&(a[i]=E)}let y={onObjectBegin:()=>{let E={};u(E),l.push(a),a=E,i=null},onObjectProperty:E=>{i=E},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{let E=[];u(E),l.push(a),a=E,i=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:u,onError:(E,f,T)=>{o.push({error:E,offset:f,length:T})}};if(t)try{S.visit(t,y),r=a[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return r}doParseRaw(t,r){const i=n.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,i,!0,r);t=a.raw;const l=(0,w.toValuesTree)(t,y=>console.error(`Conflict in settings file ${this._name}: ${y}`)),o=Object.keys(t),u=(0,w.toOverrides)(t,y=>console.error(`Conflict in settings file ${this._name}: ${y}`));return{contents:l,keys:o,overrides:u,restricted:a.restricted}}filter(t,r,i,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:t,restricted:[]};const l={},o=[];for(let u in t)if(v.OVERRIDE_PROPERTY_PATTERN.test(u)&&i){const y=this.filter(t[u],r,!1,a);l[u]=y.raw,o.push(...y.restricted)}else{const y=r[u],E=y?typeof y.scope!="undefined"?y.scope:3:void 0;y?.restricted&&o.push(u),(E===void 0||a.scopes===void 0||a.scopes.includes(E))&&(a.skipRestricted&&y?.restricted||(l[u]=t[u]))}return{raw:l,restricted:o}}}e.ConfigurationModelParser=C;class D extends p.Disposable{constructor(t,r,i,a){super();this.userSettingsResource=t,this.scopes=r,this.fileService=a,this._onDidChange=this._register(new m.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new C(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(m.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class b{constructor(t,r,i=new d,a=new d,l=new L.ResourceMap,o=new d,u=new L.ResourceMap,y=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=a,this._folderConfigurations=l,this._memoryConfiguration=o,this._memoryConfigurationByResource=u,this._freeze=y,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let a;i.resource?(a=this._memoryConfigurationByResource.get(i.resource),a||(a=new d,this._memoryConfigurationByResource.set(i.resource,a))):a=this._memoryConfiguration,r===void 0?a.removeValue(t):a.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const a=this.getConsolidateConfigurationModel(r,i),l=this.getFolderConfigurationModelForResource(r.resource,i),o=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,u=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),y=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),f=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=l?r.overrideIdentifier?l.freeze().override(r.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,x=r.overrideIdentifier?o.override(r.overrideIdentifier).getValue(t):o.getValue(t),j=a.getValue(t),H=R.distinct(R.flatten(a.overrides.map(V=>V.identifiers))).filter(V=>a.getOverrideValue(t,V)!==void 0);return{defaultValue:u,userValue:y,userLocalValue:E,userRemoteValue:f,workspaceValue:T,workspaceFolderValue:O,memoryValue:x,value:j,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:y!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:f!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:l?.freeze().getValue(t),override:r.overrideIdentifier?l?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:o.getValue(t),override:r.overrideIdentifier?o.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(a=>v.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const l=(0,v.overrideIdentifierFromKey)(a),o=this._defaultConfiguration.getKeysForOverrideIdentifier(l),u=t.getKeysForOverrideIdentifier(l),y=[...u.filter(E=>o.indexOf(E)===-1),...o.filter(E=>u.indexOf(E)===-1),...o.filter(E=>!A.equals(this._defaultConfiguration.override(l).getValue(E),t.override(l).getValue(E)))];return[l,y]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:a,overrides:l}=(0,w.compare)(this.localUserConfiguration,t),o=[...r,...i,...a];return o.length&&this.updateLocalUserConfiguration(t),{keys:o,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:a,overrides:l}=(0,w.compare)(this.remoteUserConfiguration,t);let o=[...r,...i,...a];return o.length&&this.updateRemoteUserConfiguration(t),{keys:o,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:a,overrides:l}=(0,w.compare)(this.workspaceConfiguration,t);let o=[...r,...i,...a];return o.length&&this.updateWorkspaceConfiguration(t),{keys:o,overrides:l}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:a,updated:l,removed:o,overrides:u}=(0,w.compare)(i,r);let y=[...a,...l,...o];return(y.length||!i)&&this.updateFolderConfiguration(t,r),{keys:y,overrides:u}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:a,removed:l,overrides:o}=(0,w.compare)(r,void 0);return{keys:[...i,...a,...l],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const a=r.getFolder(t);a&&(i=this.getFolderConsolidatedConfiguration(a.uri)||i);const l=this._memoryConfigurationByResource.get(t);l&&(i=i.merge(l))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(r=i.merge(a),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:a,keys:l}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:a,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((o,u)=>(o.set(P.URI.revive(u[0]),this.parseConfigurationModel(u[1])),o),new L.ResourceMap);return new b(r,i,new d,a,l,new d,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new d(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function I(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,r=new Map;for(const a of c)a.keys.forEach(l=>t.add(l)),a.overrides.forEach(([l,o])=>{const u=(0,L.getOrSet)(r,l,new Set);o.forEach(y=>u.add(y))});const i=[];return r.forEach((a,l)=>i.push([l,[...a.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=I;class g{constructor(t,r,i,a){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=a,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(u=>l.add(u)),t.overrides.forEach(([,u])=>u.forEach(y=>l.add(y))),this.affectedKeys=[...l.values()];const o=new d;this.affectedKeys.forEach(u=>o.setValue(u,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!A.equals(i,a)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=(0,w.toValuesTree)({[r]:!0},()=>{}),a;for(;typeof i=="object"&&(a=Object.keys(i)[0]);){if(t=t[a],!t)return!1;i=i[a]}return!0}}e.ConfigurationChangeEvent=g;class s extends g{constructor(t,r,i,a){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=s}),define(te[165],ne([0,1,31,37,2,23,164,3,6,15]),function(Y,e,S,L,R,k,A,P,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends R.Disposable{constructor(m,d){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new P.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new A.UserSettings(this.settingsResource,void 0,w.extUriBiasedIgnorePathCase,d)),this.configuration=new A.Configuration(new A.DefaultConfigurationModel,new A.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(S.Registry.as(L.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new A.Configuration(new A.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,d){const h=typeof m=="string"?m:void 0,C=(0,k.isConfigurationOverrides)(m)?m:(0,k.isConfigurationOverrides)(d)?d:{};return this.configuration.getValue(h,C,void 0)}updateValue(m,d,h,C){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const d=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(h,d,1)}onDidDefaultConfigurationChange(m){const d=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new A.DefaultConfigurationModel,m);this.trigger(h,d,6)}trigger(m,d,h){const C=new A.ConfigurationChangeEvent(m,{data:d},this.configuration);C.source=h,C.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(C)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(te[166],ne([0,1,23,16,103]),function(Y,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(P,v){this.configurationService=P,this.logService=v}request(P,v){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,R.request)(P,v)}async resolveProxy(P){}};k=de([J(0,S.IConfigurationService),J(1,L.ILogService)],k),e.RequestService=k}),define(te[39],ne([0,1,120,4,37,31,25]),function(Y,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function P(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=P;function v(h){return h.res.statusCode===204}async function w(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);return v(h)?null:(await(0,A.streamToBuffer)(h.stream)).toString()}e.asText=w;async function n(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);if(v(h))return null;const D=(await(0,A.streamToBuffer)(h.stream)).toString();try{return JSON.parse(D)}catch(b){throw b.message+=`:
`+D,b}}e.asJson=n;function p(h){d(h)}e.updateProxyConfigurationsScope=p;let m;function d(h){const C=k.Registry.as(R.Extensions.Configuration);m&&C.deregisterConfigurations([m]),m={id:"http",order:15,title:(0,S.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,S.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,S.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,S.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,S.localize)(4,null),(0,S.localize)(5,null),(0,S.localize)(6,null),(0,S.localize)(7,null)],default:"override",description:(0,S.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,S.localize)(9,null),restricted:!0}}},C.registerConfiguration(m)}d(2)}),define(te[167],ne([0,1,39,29,11,17]),function(Y,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(v,w){this.requestService=v,this.fileService=w}async download(v,w,n=L.CancellationToken.None){if(v.scheme===k.Schemas.file||v.scheme===k.Schemas.vscodeRemote){await this.fileService.copy(v,w);return}const p={type:"GET",url:v.toString()},m=await this.requestService.request(p,n);if(m.res.statusCode===200)await this.fileService.writeFile(w,m.stream);else{const d=await(0,S.asText)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${d}`)}}};A=de([J(0,S.IRequestService),J(1,R.IFileService)],A),e.DownloadService=A}),define(te[168],ne([0,1,27,11,22,63,39,29,16,15,132,2]),function(Y,e,S,L,R,k,A,P,v,w,n,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let m=class extends p.Disposable{constructor(h,C,D,b){super();this.fileService=h,this.productService=C,this.requestService=D,this.logService=b,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,k.forEach)(this.productService.configBasedExtensionTips,({value:I})=>this.allConfigBasedTips.set(I.configPath,I))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const C=[];for(const[D,b]of this.allConfigBasedTips)try{const I=await this.fileService.readFile((0,w.joinPath)(h,D)),g=new Map;(0,k.forEach)(b.recommendations,({key:c,value:t})=>{if((0,R.isNonEmptyArray)(t.remotes))for(const r of t.remotes)g.set(r,{extensionId:c,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else C.push({extensionId:c,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const s=(0,n.getDomainsOfRemotes)(I.value.toString(),[...g.keys()]);for(const c of s){const t=g.get(c);t&&C.push(t)}}catch(I){}return C}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},P.CancellationToken.None);if(h.res.statusCode!==200)return[];const C=await(0,A.asJson)(h);return C?C.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};m=de([J(0,L.IFileService),J(1,S.IProductService),J(2,A.IRequestService),J(3,v.ILogService)],m),e.ExtensionTipsService=m}),define(te[44],ne([0,1,30,25]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(k,A,P){let v=P&&P.get("storage.serviceMachineId",0)||null;if(v)return v;try{const n=(await A.readFile(k.serviceMachineIdResource)).value.toString();v=(0,S.isUUID)(n)?n:null}catch(w){v=null}if(!v){v=(0,S.generateUuid)();try{await A.writeFile(k.serviceMachineIdResource,L.VSBuffer.fromString(v))}catch(w){}}return P&&P.store("storage.serviceMachineId",v,0,1),v}e.getServiceMachineId=R}),define(te[20],ne([0,1,4,3,2,14,69,6]),function(Y,e,S,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const v="__$__targetStorageMarker";e.IStorageService=(0,S.createDecorator)("storageService");var w;(function(C){C[C.NONE=0]="NONE",C[C.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(C){C[C.GLOBAL=0]="GLOBAL",C[C.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var p;(function(C){C[C.USER=0]="USER",C[C.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));class m extends R.Disposable{constructor(D={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super();this.options=D,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new P.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,P.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(D,b){b===v?(D===0?this._globalKeyTargets=void 0:D===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:D})):this._onDidChangeValue.fire({scope:D,key:b,target:this.getKeyTargets(D)[b]})}emitWillSaveState(D){this._onWillSaveState.fire({reason:D})}get(D,b,I){return this.getStorage(b)?.get(D,I)}getBoolean(D,b,I){return this.getStorage(b)?.getBoolean(D,I)}getNumber(D,b,I){return this.getStorage(b)?.getNumber(D,I)}store(D,b,I,g){if((0,k.isUndefinedOrNull)(b)){this.remove(D,I);return}this.withPausedEmitters(()=>{this.updateKeyTarget(D,I,g),this.getStorage(I)?.set(D,b)})}remove(D,b){this.withPausedEmitters(()=>{this.updateKeyTarget(D,b,void 0),this.getStorage(b)?.delete(D)})}withPausedEmitters(D){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{D()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(D,b){const I=[],g=this.getKeyTargets(D);for(const s of Object.keys(g))g[s]===b&&I.push(s);return I}updateKeyTarget(D,b,I){const g=this.getKeyTargets(b);typeof I=="number"?g[D]!==I&&(g[D]=I,this.getStorage(b)?.set(v,JSON.stringify(g))):typeof g[D]=="number"&&(delete g[D],this.getStorage(b)?.set(v,JSON.stringify(g)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(D){return D===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(D){const b=this.get(v,D);if(b)try{return JSON.parse(b)}catch(I){}return Object.create(null)}isNew(D){return this.getBoolean(e.IS_NEW_KEY,D)===!0}async flush(){this._onWillSaveState.fire({reason:w.NONE}),await P.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const D=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return h(D,b,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=m,m.DEFAULT_FLUSH_INTERVAL=60*1e3;class d extends m{constructor(){super();this.globalStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(D=>this.emitDidChangeValue(1,D))),this._register(this.globalStorage.onDidChangeStorage(D=>this.emitDidChangeValue(0,D)))}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(D){}}e.InMemoryStorageService=d;async function h(C,D,b,I){const g=l=>{try{return JSON.parse(l)}catch(o){return l}},s=new Map,c=new Map;C.forEach((l,o)=>{s.set(o,l),c.set(o,g(l))});const t=new Map,r=new Map;D.forEach((l,o)=>{t.set(o,l),r.set(o,g(l))}),console.group(`Storage: Global (path: ${b})`);let i=[];s.forEach((l,o)=>{i.push({key:o,value:l})}),console.table(i),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${I})`);let a=[];t.forEach((l,o)=>{a.push({key:o,value:l})}),console.table(a),console.groupEnd(),console.log(r)}e.logStorage=h}),define(te[169],ne([0,1,3,2,28,33,20,14]),function(Y,e,S,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let v=class extends L.Disposable{constructor(p){super();this._onDidChangeEnablement=new S.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new w(p)),this._register(this.storageManger.onDidChange(m=>this._onDidChangeEnablement.fire({extensions:m,source:"storage"})))}async enableExtension(p,m){return this._removeFromDisabledExtensions(p)?(this._onDidChangeEnablement.fire({extensions:[p],source:m}),!0):!1}async disableExtension(p,m){return this._addToDisabledExtensions(p)?(this._onDidChangeEnablement.fire({extensions:[p],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(R.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(p){let m=this.getDisabledExtensions();return m.every(d=>!(0,k.areSameExtensions)(d,p))?(m.push(p),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(p){let m=this.getDisabledExtensions();for(let d=0;d<m.length;d++){const h=m[d];if((0,k.areSameExtensions)(h,p))return m.splice(d,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(p){this._setExtensions(R.DISABLED_EXTENSIONS_STORAGE_PATH,p)}_getExtensions(p){return this.storageManger.get(p,0)}_setExtensions(p,m){this.storageManger.set(p,m,0)}};v=de([J(0,A.IStorageService)],v),e.GlobalExtensionEnablementService=v;class w extends L.Disposable{constructor(p){super();this.storageService=p,this.storage=Object.create(null),this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event,this._register(p.onDidChangeValue(m=>this.onDidStorageChange(m)))}get(p,m){let d;return m===0?((0,P.isUndefinedOrNull)(this.storage[p])&&(this.storage[p]=this._get(p,m)),d=this.storage[p]):d=this._get(p,m),JSON.parse(d)}set(p,m,d){let h=JSON.stringify(m.map(({id:D,uuid:b})=>({id:D,uuid:b})));this._get(p,d)!==h&&(d===0&&(m.length?this.storage[p]=h:delete this.storage[p]),this._set(p,m.length?h:void 0,d))}onDidStorageChange(p){if(p.scope===0&&!(0,P.isUndefinedOrNull)(this.storage[p.key])&&this._get(p.key,p.scope)!==this.storage[p.key]){const d=this.get(p.key,p.scope);delete this.storage[p.key];const h=this.get(p.key,p.scope),C=d.filter(b=>!h.some(I=>(0,k.areSameExtensions)(b,I))),D=h.filter(b=>!d.some(I=>(0,k.areSameExtensions)(I,b)));(C.length||D.length)&&this._onDidChange.fire([...C,...D])}}_get(p,m){return this.storageService.get(p,m,"[]")}_set(p,m,d){m?this.storageService.store(p,m,d,1):this.storageService.remove(p,d)}}e.StorageManager=w}),define(te[170],ne([0,1,3,2]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class R extends L.Disposable{constructor(w,n){super();this.channel=w,this.workspace=n}async getItems(){const w={workspace:this.workspace},n=await this.channel.call("getItems",w);return new Map(n)}updateItems(w){const n={workspace:this.workspace};return w.insert&&(n.insert=Array.from(w.insert.entries())),w.delete&&(n.delete=Array.from(w.delete.values())),this.channel.call("updateItems",n)}}class k extends R{constructor(w){super(w,void 0);this._onDidChangeItemsExternal=this._register(new S.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(w=>this.onDidChangeGlobalStorage(w)))}onDidChangeGlobalStorage(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this._onDidChangeItemsExternal.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}async close(){this.dispose()}}class A extends R{constructor(w,n){super(w,n);this.onDidChangeItemsExternal=S.Event.None}async close(){const w={workspace:this.workspace};return this.channel.call("close",w)}}class P extends L.Disposable{constructor(w,n){super();this.channel=w,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new k(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(te[171],ne([0,1,2,20,69,6,160,170,15]),function(Y,e,S,L,R,k,A,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class w extends L.AbstractStorageService{constructor(p,m,d){super();this.mainProcessService=m,this.environmentService=d,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new S.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(p)}createGlobalStorage(){const p=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),m=new R.Storage(p.globalStorage);return this._register(m.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),m}createWorkspaceStorage(p){const m=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),p);if(m.workspaceStorage){const d=new R.Storage(m.workspaceStorage);return this.workspaceStorageDisposable.value=d.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)),this.workspaceStorageId=p?.id,d}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,A.mark)("code/willInitStorage");try{await k.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,A.mark)("code/didInitStorage")}}getStorage(p){return p===0?this.globalStorage:this.workspaceStorage}getLogDetails(p){return p===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,v.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(L.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(p){const m=this.workspaceStorage,d=m?.items??new Map;m&&(await m.close(),m.dispose()),this.workspaceStorage=this.createWorkspaceStorage(p),await this.workspaceStorage.init();for(const[h,C]of d)this.workspaceStorage.set(h,C)}}e.NativeStorageService=w}),define(te[172],ne([0,1,7,34,30,5]),function(Y,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(w){if(S.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function P(w,n,p,m,d,h,C,D,b,I){const g=Object.create(null);g["common.machineId"]=C,g.sessionID=(0,R.generateUuid)()+Date.now(),g.commitHash=d,g.version=h,g["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,S.PlatformToString)(S.platform),g["common.nodePlatform"]=L.platform,g["common.nodeArch"]=m,g["common.product"]=I||"desktop";const s=v(D||[]);s&&(g["common.msftInternal"]=s);let c=0;const t=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),S.isLinuxSnap&&(g["common.snap"]="true");const r=A(p);r&&(g["common.platformDetail"]=r);try{const i=await w.readFile(k.URI.file(b));g["common.source"]=i.value.toString().slice(0,30)}catch(i){}return g}e.resolveCommonProperties=P;function v(w){const n=L.env.USERDNSDOMAIN;if(!n)return!1;const p=n.toLowerCase();return w.some(m=>p===m)}e.verifyMicrosoftInternalDomain=v}),define(te[24],ne([0,1,4]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(te[173],ne([0,1,35,95,71,8,32,98,27,7,5,24,53,17,11,18]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function D(c,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,a=new Map,l=2e4;function o(E,f,T,O){const x=f.substring(E.length+1);return new Promise(async j=>{let H;try{H=await C.Promises.readdir(f,{withFileTypes:!0})}catch(_){j();return}if(O.count>=l){O.count+=H.length,O.maxReached=!0,j();return}let V=H.length;if(V===0){j();return}let N=H;O.count+H.length>l&&(O.maxReached=!0,V=l-O.count,N=H.slice(0,V)),O.count+=H.length;for(const _ of N)if(_.isDirectory()){if(T.includes(_.name)||await o(E,(0,k.join)(f,_.name),T,O),--V==0){j();return}}else{const M=_.name.lastIndexOf(".");if(M>=0){const B=_.name.substring(M+1);B&&i.set(B,(i.get(B)??0)+1)}for(const B of r)B.relativePathPattern?.test(x)!==!1&&B.filePattern.test(_.name)&&a.set(B.tag,(a.get(B.tag)??0)+1);if(--V==0){j();return}}})}const u={count:0,maxReached:!1};await o(c,c,t,u);const y=await g(c);return{configFiles:b(a),fileTypes:b(i),fileCount:u.count,maxFilesReached:u.maxReached,launchConfigFiles:y}}e.collectWorkspaceStats=D;function b(c){return[...m.Iterable.map(c.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function I(){const c={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(L.virtualMachineHint.value()*100)}%`},t=S.cpus();return t&&t.length>0&&(c.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),c}e.getMachineInfo=I;async function g(c){try{const t=new Map,r=(0,k.join)(c,".vscode","launch.json"),i=await C.Promises.readFile(r),a=[],l=(0,A.parse)(i.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if((0,A.getNodeType)(l)==="object"&&l.configurations)for(const o of l.configurations){const u=o.type;u&&(t.has(u)?t.set(u,t.get(u)+1):t.set(u,1))}return b(t)}catch(t){return[]}}e.collectLaunchConfigs=g;let s=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const i=S.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(S.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||r.push(`Load (avg):       ${S.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(L.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([(0,P.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async i=>{let[a,l]=i,o=this.formatProcessList(t,a);return r.forEach(u=>{if((0,R.isRemoteDiagnosticError)(u))o+=`
${u.errorMessage}`,l+=`
${u.errorMessage}`;else if(o+=`

Remote: ${u.hostName}`,u.processes&&(o+=`
${this.formatProcessList(t,u.processes)}`),u.workspaceMetadata){l+=`
|  Remote: ${u.hostName}`;for(const y of Object.keys(u.workspaceMetadata)){const E=u.workspaceMetadata[y];let f=`${E.fileCount} files`;E.maxFilesReached&&(f=`more than ${f}`),l+=`|    Folder (${y}): ${f}`,l+=this.formatWorkspaceStats(E)}}}),{processInfo:o,workspaceInfo:l}})}async getSystemInfo(t,r){const{memory:i,vmHint:a,os:l,cpus:o}=I(),u={os:l,memory:i,cpus:o,vmHint:a,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return w.isWindows||(u.load=`${S.loadavg().map(y=>Math.round(y)).join(", ")}`),w.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(t,r){const i=[];return(0,P.listProcesses)(t.mainPID).then(async a=>(i.push(""),i.push(this.formatEnvironment(t)),i.push(""),i.push(this.formatProcessList(t,a)),t.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(t))),r.forEach(l=>{if((0,R.isRemoteDiagnosticError)(l))i.push(`
${l.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${l.hostName}`),i.push(this.formatMachineInfo(l.machineInfo)),l.processes&&i.push(this.formatProcessList(t,l.processes)),l.workspaceMetadata)for(const o of Object.keys(l.workspaceMetadata)){const u=l.workspaceMetadata[o];let y=`${u.fileCount} files`;u.maxFilesReached&&(y=`more than ${y}`),i.push(`Folder (${o}): ${y}`),i.push(this.formatWorkspaceStats(u))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(t){const r=[],i=60;let a=0;const l=(E,f)=>{const T=` ${E}(${f})`;a+T.length>i?(r.push(o),o="|                 ",a=o.length):a+=T.length,o+=T};let o="|      File types:";const u=10;let y=t.fileTypes.length>u?u:t.fileTypes.length;for(let E=0;E<y;E++){const f=t.fileTypes[E];l(f.name,f.count)}if(r.push(o),t.configFiles.length>=0&&(o="|      Conf files:",a=0,t.configFiles.forEach(E=>{l(E.name,E.count)}),r.push(o)),t.launchConfigFiles.length>0){let E="|      Launch Configs:";t.launchConfigFiles.forEach(f=>{E+=f.count>1?` ${f.name}(${f.count})`:` ${f.name}`}),r.push(E)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(i=>i.length));return Object.keys(t).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${t[i]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],i=[];return t.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(l=>{const o=n.URI.revive(l);if(o.scheme===d.Schemas.file){const u=o.fsPath;i.push(D(u,["node_modules",".git"]).then(y=>{let E=`${y.fileCount} files`;y.maxFilesReached&&(E=`more than ${E}`),r.push(`|    Folder (${(0,k.basename)(u)}): ${E}`),r.push(this.formatWorkspaceStats(y))}).catch(y=>{r.push(`|      Error: Unable to collect workspace stats for folder ${u} (${y.toString()})`)}))}else r.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(t,r){const i=new Map;t.windows.forEach(l=>i.set(l.pid,l.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,i,a,r,0),a.join(`
`)}formatProcessItem(t,r,i,a,l){const o=l===0;let u;o?u=a.pid===t?`${this.productService.applicationName} main`:"remote agent":(u=`${"  ".repeat(l)} ${a.name}`,a.name==="window"&&(u=`${u} (${r.get(a.pid)})`));const y=process.platform==="win32"?a.mem:S.totalmem()*(a.mem/100);i.push(`${a.load.toFixed(0).padStart(5," ")}	${(y/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(a.children)&&a.children.forEach(E=>this.formatProcessItem(t,r,i,E,l+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const i=n.URI.revive(r);if(i.scheme!==d.Schemas.file)continue;const a=i.fsPath;try{const l=await D(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),l.fileTypes.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:o.name,count:o.count})}),l.launchConfigFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:o.name,count:o.count})}),l.configFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};s=de([J(0,p.ITelemetryService),J(1,v.IProductService)],s),e.DiagnosticsService=s}),define(te[174],ne([0,1,9,28,33,26,24,39,70,10,29,16,11,5,27,20,44,4]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d,h,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var I;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished"})(I||(I={}));function g(..._){return String(_.reduce((M,B)=>M|B,0))}var s;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const c={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},t={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},i={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:I.None,criteria:[],assetTypes:[]};class a{constructor(M=i){this.state=M}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(M,B=this.state.pageSize){return new a({...this.state,pageNumber:M,pageSize:B})}withFilter(M,...B){const F=[...this.state.criteria,...B.length?B.map(U=>({filterType:M,value:U})):[{filterType:M}]];return new a({...this.state,criteria:F})}withSortBy(M){return new a({...this.state,sortBy:M})}withSortOrder(M){return new a({...this.state,sortOrder:M})}withFlags(...M){return new a({...this.state,flags:M.reduce((B,F)=>B|F,0)})}withAssetTypes(...M){return new a({...this.state,assetTypes:M})}get raw(){const{criteria:M,pageNumber:B,pageSize:F,sortBy:U,sortOrder:z,flags:W,assetTypes:K}=this.state;return{filters:[{criteria:M,pageNumber:B,pageSize:F,sortBy:U,sortOrder:z}],assetTypes:K,flags:W}}get searchText(){const M=this.state.criteria.filter(B=>B.filterType===s.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(M=>String(M.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function l(_,M){const B=(_||[]).filter(F=>F.statisticName===M)[0];return B?B.value:0}function o(_){const M="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(F=>F.assetType.indexOf(M)===0).reduce((F,U)=>{const z=f(_,U.assetType);return z&&F.push([U.assetType.substring(M.length),z]),F},[])}function u(_){if(_.properties){const M=_.properties.filter(U=>U.key===c.Repository),B=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=M.filter(U=>B.test(U.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return f(_,c.Repository)}function y(_){return{uri:`${_.fallbackAssetUri}/${c.VSIX}?redirect=true`,fallbackUri:`${_.fallbackAssetUri}/${c.VSIX}`}}function E(_){const M=f(_,c.Icon);if(M)return M;const B=L.DefaultIconPath;return{uri:B,fallbackUri:B}}function f(_,M){return _.files.filter(F=>F.assetType===M)[0]?{uri:`${_.assetUri}/${M}`,fallbackUri:`${_.fallbackAssetUri}/${M}`}:null}function T(_,M){const B=_.properties?_.properties.filter(U=>U.key===M):[],F=B.length>0&&B[0].value;return F?F.split(",").map(U=>(0,R.adoptToGalleryExtensionId)(U)):[]}function O(_){const M=_.properties?_.properties.filter(B=>B.key===t.Engine):[];return M.length>0&&M[0].value||""}function x(_){const M=_.properties?_.properties.filter(F=>F.key===t.LocalizedLanguages):[],B=M.length>0&&M[0].value||"";return B?B.split(","):[]}function j(_){return _.indexOf("preview")!==-1}function H(_,M,B,F,U){const z={manifest:f(M,c.Manifest),readme:f(M,c.Details),changelog:f(M,c.Changelog),license:f(M,c.License),repository:u(M),download:y(M),icon:E(M),coreTranslations:o(M)};return{identifier:{id:(0,R.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:M.version,date:M.lastUpdated,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,description:_.shortDescription||"",installCount:l(_.statistics,"install"),rating:l(_.statistics,"averagerating"),ratingCount:l(_.statistics,"ratingcount"),assetUri:d.URI.parse(M.assetUri),webExtension:!!_.tags?.includes(L.WEB_EXTENSION_TAG),assetTypes:M.files.map(({assetType:W})=>W),assets:z,properties:{dependencies:T(M,t.Dependency),extensionPack:T(M,t.ExtensionPack),engine:O(M),localizedLanguages:x(M)},telemetryData:{index:(F.pageNumber-1)*F.pageSize+B,querySource:U},preview:j(_.flags)}}let V=class{constructor(M,B,F,U,z,W,K){this.requestService=M,this.logService=B,this.environmentService=F,this.telemetryService=U,this.fileService=z,this.productService=W;const $=W.extensionsGallery;this.extensionsGalleryUrl=$&&$.serviceUrl,this.extensionsControlUrl=$&&$.controlUrl,this.commonHeadersPromise=N(W.version,this.environmentService,this.fileService,K)}api(M=""){return`${this.extensionsGalleryUrl}${M}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(M,B){const F=[];let{total:U,firstPage:z,getPage:W}=await this.query({names:M,pageSize:M.length},B);F.push(...z);for(let K=1;F.length<U&&(z=await W(K,B),z.length);K++)F.push(...z);return F}async getCompatibleExtension(M,B){return this.getCompatibleExtensionByEngine(M,B)}async getCompatibleExtensionByEngine(M,B){const F=(0,L.isIExtensionIdentifier)(M)?null:M;if(F&&F.properties.engine&&(0,v.isEngineValid)(F.properties.engine,this.productService.version,this.productService.date))return F;const{id:U,uuid:z}=F?F.identifier:M;let W=new a().withFlags(I.IncludeAssetUri,I.IncludeStatistics,I.IncludeCategoryAndTags,I.IncludeFiles,I.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");z?W=W.withFilter(s.ExtensionId,z):W=W.withFilter(s.ExtensionName,U);const{galleryExtensions:K}=await this.queryGallery(W,n.CancellationToken.None),[$]=K;if(!$||!$.versions.length)return null;if(B){const X=$.versions.filter(Z=>Z.version===B)[0];if(X){const Z=H($,X,0,W);if(Z.properties.engine&&(0,v.isEngineValid)(Z.properties.engine,this.productService.version,this.productService.date))return Z}return null}const G=await this.getLastValidExtensionVersion($,$.versions);return G?H($,G,0,W):null}async query(M,B){const F=n.CancellationToken.isCancellationToken(M)?{}:M,U=n.CancellationToken.isCancellationToken(M)?M:B;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let z=F.text||"";const W=(0,k.getOrDefault)(F,ee=>ee.pageSize,50);let K=new a().withFlags(I.IncludeLatestVersionOnly,I.IncludeAssetUri,I.IncludeStatistics,I.IncludeCategoryAndTags,I.IncludeFiles,I.IncludeVersionProperties).withPage(1,W).withFilter(s.Target,"Microsoft.VisualStudio.Code");z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ee,se,ue)=>(K=K.withFilter(s.Category,ue||se),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ee,se,ue)=>(K=K.withFilter(s.Tag,ue||se),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(s.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),K=K.withFilter(s.SearchText,z)),K=K.withSortBy(0)):F.ids?K=K.withFilter(s.ExtensionId,...F.ids):F.names?K=K.withFilter(s.ExtensionName,...F.names):K=K.withSortBy(4),typeof F.sortBy=="number"&&(K=K.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(K=K.withSortOrder(F.sortOrder));const{galleryExtensions:$,total:G}=await this.queryGallery(K,U),X=$.map((ee,se)=>H(ee,ee.versions[0],se,K,F.source)),Z=async(ee,se)=>{if(se.isCancellationRequested)throw(0,S.canceled)();const ue=K.withPage(ee+1),{galleryExtensions:ge}=await this.queryGallery(ue,se);return ge.map((me,Se)=>H(me,me.versions[0],Se,ue,F.source))};return{firstPage:X,total:G,pageSize:K.pageSize,getPage:Z}}async queryGallery(M,B){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,I.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,g(I.Unpublished));const F=await this.commonHeadersPromise,U=JSON.stringify(M.raw),z={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(U.length)},W=new Date().getTime();let K,$,G=0;try{if(K=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:U,headers:z},B),K.res.statusCode&&K.res.statusCode>=400&&K.res.statusCode<500)return{galleryExtensions:[],total:G};const X=await(0,P.asJson)(K);if(X){const Z=X.results[0],ee=Z.extensions,se=Z.resultMetadata&&Z.resultMetadata.filter(ue=>ue.metadataType==="ResultCount")[0];return G=se&&se.metadataItems.filter(ue=>ue.name==="TotalCount")[0].count||0,{galleryExtensions:ee,total:G}}return{galleryExtensions:[],total:G}}catch(X){throw $=X,X}finally{this.telemetryService.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(U.length),duration:new Date().getTime()-W,success:!!K&&(0,P.isSuccess)(K),responseBodySize:K?.res.headers["Content-Length"],statusCode:K?String(K.res.statusCode):void 0,errorCode:$?(0,S.isPromiseCanceledError)($)?"canceled":(0,S.getErrorMessage)($).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(G)})}}async reportStatistic(M,B,F,U){if(!this.isEnabled())return;const W={...await this.commonHeadersPromise,Accept:"*/*;api-version=4.0-preview.1"};try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${M}/extensions/${B}/${F}/stats?statType=${U}`),headers:W},n.CancellationToken.None)}catch(K){}}async download(M,B,F){this.logService.trace("ExtensionGalleryService#download",M.identifier.id);const U=(0,R.getGalleryExtensionTelemetryData)(M),z=new Date().getTime(),W=X=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...U,duration:X}),K=F===1?"install":F===2?"update":"",$=K?{uri:`${M.assets.download.uri}&${K}=true`,fallbackUri:`${M.assets.download.fallbackUri}?${K}=true`}:M.assets.download,G=await this.getAsset($);await this.fileService.writeFile(B,G.stream),W(new Date().getTime()-z)}async getReadme(M,B){if(M.assets.readme){const F=await this.getAsset(M.assets.readme,{},B);return await(0,P.asText)(F)||""}return""}async getManifest(M,B){if(M.assets.manifest){const F=await this.getAsset(M.assets.manifest,{},B),U=await(0,P.asText)(F);return U?JSON.parse(U):null}return null}async getCoreTranslation(M,B){const F=M.assets.coreTranslations.filter(U=>U[0]===B.toUpperCase())[0];if(F){const U=await this.getAsset(F[1]),z=await(0,P.asText)(U);return z?JSON.parse(z):null}return null}async getChangelog(M,B){if(M.assets.changelog){const F=await this.getAsset(M.assets.changelog,{},B);return await(0,P.asText)(F)||""}return""}async getAllVersions(M,B){let F=new a().withFlags(I.IncludeVersions,I.IncludeCategoryAndTags,I.IncludeFiles,I.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");M.identifier.uuid?F=F.withFilter(s.ExtensionId,M.identifier.uuid):F=F.withFilter(s.ExtensionName,M.identifier.id);const U=[],{galleryExtensions:z}=await this.queryGallery(F,n.CancellationToken.None);return z.length&&(B?await Promise.all(z[0].versions.map(async W=>{let K;try{K=await this.getEngine(W)}catch($){}K&&(0,v.isEngineValid)(K,this.productService.version,this.productService.date)&&U.push({version:W.version,date:W.lastUpdated})})):U.push(...z[0].versions.map(W=>({version:W.version,date:W.lastUpdated})))),U}async getAsset(M,B={},F=n.CancellationToken.None){const U=await this.commonHeadersPromise,z={type:"GET"},W={...U,...B.headers||{}};B={...B,...z,headers:W};const K=M.uri,$=M.fallbackUri,G={...B,url:K};try{const X=await this.requestService.request(G,F);if(X.res.statusCode===200)return X;const Z=await(0,P.asText)(X);throw new Error(`Expected 200, got back ${X.res.statusCode} instead.

${Z}`)}catch(X){if((0,S.isPromiseCanceledError)(X))throw X;const Z=(0,S.getErrorMessage)(X);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:K,message:Z});const ee={...B,url:$};return this.requestService.request(ee,F)}}async getLastValidExtensionVersion(M,B){const F=this.getLastValidExtensionVersionFromProperties(M,B);return F||this.getLastValidExtensionVersionRecursively(M,B)}getLastValidExtensionVersionFromProperties(M,B){for(const F of B){const U=O(F);if(!U)return null;if((0,v.isEngineValid)(U,this.productService.version,this.productService.date))return F}return null}async getEngine(M){const B=O(M);if(B)return B;const F=f(M,c.Manifest);if(!F)throw new Error("Manifest was not found");const U={"Accept-Encoding":"gzip"},z=await this.getAsset(F,{headers:U}),W=await(0,P.asJson)(z);if(W)return W.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(M,B){if(!B.length)return null;const F=B[0],U=await this.getEngine(F);return(0,v.isEngineValid)(U,this.productService.version,this.productService.date)?{...F,properties:[...F.properties||[],{key:t.Engine,value:U}]}:this.getLastValidExtensionVersionRecursively(M,B.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const M=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const B=await(0,P.asJson)(M),F=new Map;if(B)for(const U of B.malicious){const z=F.get(U)||{id:{id:U},malicious:!0,slow:!1};z.malicious=!0,F.set(U,z)}return[...F.values()]}};V=de([J(0,P.IRequestService),J(1,p.ILogService),J(2,w.IEnvironmentService),J(3,A.ITelemetryService),J(4,m.IFileService),J(5,h.IProductService),J(6,(0,b.optional)(C.IStorageService))],V),e.ExtensionGalleryService=V;async function N(_,M,B,F){const U={"X-Market-Client-Id":`VSCode ${_}`,"User-Agent":`VSCode ${_}`},z=await(0,D.getServiceMachineId)(M,B,F);return U["X-Market-User-Id"]=z,U}e.resolveMarketplaceHeaders=N}),define(te[175],ne([0,1,5,8,27,10,34,11,7,22,28,63,39,16,168,6,24,73,111,20,3,58]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d,h,C,D,b,I,g,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let i=class extends h.ExtensionTipsService{constructor(l,o,u,y,E,f,T,O,x,j){super(T,O,x,j);this.environmentService=l,this.telemetryService=o,this.extensionManagementService=u,this.storageService=y,this.nativeHostService=E,this.extensionRecommendationNotificationService=f,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,p.forEach)(O.exeBasedExtensionTips,({key:H,value:V})=>{const N=[],_=[],M=[];(0,p.forEach)(V.recommendations,({key:B,value:F})=>{F.important?V.important?N.push({extensionId:B,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):_.push({extensionId:B,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):M.push({extensionId:B,extensionName:F.name,isExtensionPack:!!F.isExtensionPack})}),N.length&&this.highImportanceExecutableTips.set(H,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:N}),_.length&&this.mediumImportanceExecutableTips.set(H,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:_}),M.length&&this.allOtherExecutableTips.set(H,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:M})}),(0,C.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const l=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...l,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const l=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(l,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,u)}groupImportantTipsByExe(l,o){const u=new Map;l.forEach(O=>u.set(O.extensionId.toLowerCase(),O));const{installed:y,uninstalled:E}=this.groupByInstalled([...u.keys()],o);for(const O of y){const x=u.get(O);x&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:x.exeName})}for(const O of E){const x=u.get(O);x&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:x.exeName})}const f=this.getPromptedExecutableTips(),T=new Map;for(const O of E){const x=u.get(O);if(x&&(!f[x.exeName]||!f[x.exeName].includes(x.extensionId))){let j=T.get(x.exeName);j||(j=[],T.set(x.exeName,j)),j.push(x)}}return T}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[l,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(l);break;case"incompatibleWindow":const y=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(y(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const E=this._register((0,C.disposableTimeout)(()=>{E.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const l=this.getLastPromptedMediumExeTime(),o=Date.now()-l,u=7*24*60*60*1e3;if(o<u){const f=this._register((0,C.disposableTimeout)(()=>{f.dispose(),this.promptMediumImportanceExeBasedTip()},u-o));return}const[y,E]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(E).then(f=>{switch(f){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(y),this.addToRecommendedExecutables(E[0].exeName,E);const T=this._register((0,C.disposableTimeout)(()=>{T.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(y),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const O=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const x=this._register((0,C.disposableTimeout)(()=>{x.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(l){const o=l.map(({extensionId:y})=>y.toLowerCase()),u=(0,I.localize)(0,null,l[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,u,`@exe:"${l[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let l=this.storageService.getNumber(r,0);return l||(l=Date.now(),this.updateLastPromptedMediumExeTime(l)),l}updateLastPromptedMediumExeTime(l){this.storageService.store(r,l,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(l,o){const u=this.getPromptedExecutableTips();u[l]=o.map(({extensionId:y})=>y.toLowerCase()),this.storageService.store(t,JSON.stringify(u),0,0)}groupByInstalled(l,o){const u=[],y=[],E=o.reduce((f,T)=>(f.add(T.identifier.id.toLowerCase()),f),new Set);return l.forEach(f=>{E.has(f.toLowerCase())?u.push(f):y.push(f)}),{installed:u,uninstalled:y}}async getValidExecutableBasedExtensionTips(l){const o=[],u=new Map;for(const y of l.keys()){const E=l.get(y);if(!E||!(0,w.isNonEmptyArray)(E.recommendations))continue;const f=[];v.isWindows?E.windowsPath&&f.push(E.windowsPath.replace("%USERPROFILE%",A.env.USERPROFILE).replace("%ProgramFiles(x86)%",A.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",A.env.ProgramFiles).replace("%APPDATA%",A.env.APPDATA).replace("%WINDIR%",A.env.WINDIR)):(f.push((0,L.join)("/usr/local/bin",y)),f.push((0,L.join)("/usr/bin",y)),f.push((0,L.join)(this.environmentService.userHome.fsPath,y)));for(const T of f){let O=u.get(T);if(O===void 0&&(O=await this.fileService.exists(S.URI.file(T)),u.set(T,O)),O)for(const{extensionId:x,extensionName:j,isExtensionPack:H}of E.recommendations)o.push({extensionId:x,extensionName:j,isExtensionPack:H,exeName:y,exeFriendlyName:E.exeFriendlyName,windowsPath:E.windowsPath})}}return o}};i=de([J(0,k.INativeEnvironmentService),J(1,D.ITelemetryService),J(2,n.IExtensionManagementService),J(3,g.IStorageService),J(4,c.INativeHostService),J(5,b.IExtensionRecommendationNotificationService),J(6,P.IFileService),J(7,R.IProductService),J(8,m.IRequestService),J(9,d.ILogService)],i),e.ExtensionTipsService=i}),define(te[80],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class S{constructor(k){this.appender=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,{eventName:P,data:v}){return this.appender.log(P,v),Promise.resolve(null)}}e.TelemetryAppenderChannel=S;class L{constructor(k){this.channel=k}log(k,A){return this.channel.call("log",{eventName:k,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(te[81],ne([0,1,51,121,19,4,23,37,2,26,31]),function(Y,e,S,L,R,k,A,P,v,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(h,C){this._configurationService=C,this._experimentProperties={},this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appender=h.appender,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let D of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(D),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(D=>{const b=/^[a-f0-9]+$/i.test(D["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})}))}setExperimentProperty(h,C){this._experimentProperties[h]=C}setEnabled(h){this._enabled=h}_updateUserOptIn(){const h=this._configurationService?.getValue(m);this._userOptIn=h?h.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const h=await this._commonProperties;let C=h.sessionID,D=h["common.instanceId"],b=h["common.machineId"],I=h["common.firstSessionDate"],g=h["common.msftInternal"];return{sessionId:C,instanceId:D,machineId:b,firstSessionDate:I,msftInternal:g}}dispose(){this._disposables.dispose()}publicLog(h,C,D){return this.isOptedIn?this._commonProperties.then(b=>{C=(0,w.mixin)(C,b),C=(0,w.mixin)(C,this._experimentProperties),C=(0,w.cloneAndChange)(C,I=>{if(typeof I=="string")return this._cleanupInfo(I,D)}),this._appender.log(h,C)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(h,C,D){return this.publicLog(h,C,D)}publicLogError(h,C){return this.sendErrorTelemetry?this.publicLog(h,C,!0):Promise.resolve(void 0)}publicLogError2(h,C){return this.publicLogError(h,C)}_cleanupInfo(h,C){let D=h;if(C){const b=[];for(let c of this._cleanupPatterns)for(;;){const t=c.exec(h);if(!t)break;b.push([t.index,c.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(D="";;){const c=g.exec(h);if(!c)break;!I.test(c[0])&&b.every(([t,r])=>c.index<t||c.index>=r)&&(D+=h.substring(s,c.index)+"<REDACTED: user-file-path>",s=g.lastIndex)}s<h.length&&(D+=h.substr(s))}for(let b of this._cleanupPatterns)D=D.replace(b,"");return D}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=de([J(1,(0,k.optional)(A.IConfigurationService))],p),e.TelemetryService=p;const m="telemetry";n.Registry.as(P.Extensions.Configuration).registerConfiguration({id:m,order:110,type:"object",title:(0,L.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,L.localize)(2,null,S.default.privacyStatementUrl):(0,L.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(te[59],ne([0,1,23,26,14,6]),function(Y,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(h,C){return Promise.resolve(void 0)}publicLog2(h,C){return this.publicLog(h,C)}publicLogError(h,C){return Promise.resolve(void 0)}publicLogError2(h,C){return this.publicLogError(h,C)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class A{async publicLog(C,D,b){}async publicLogError(C,D,b){}}e.NullEndpointTelemetryService=A;function P(...h){return{log:(C,D)=>h.forEach(b=>b.log(C,D)),flush:()=>k.Promises.settled(h.map(C=>C.flush()))}}e.combinedAppender=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(h,C){return C.onDidChangeConfiguration(D=>{D.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:(0,S.ConfigurationTargetToString)(D.source),configurationKeys:m(D.sourceConfig)})})}e.configurationTelemetry=v;function w(h){const C=Object.create(null),D=Object.create(null),b=Object.create(null);p(h,b);for(let I in b){I=I.length>150?I.substr(I.length-149):I;const g=b[I];typeof g=="number"?D[I]=g:typeof g=="boolean"?D[I]=g?1:0:typeof g=="string"?C[I]=g.substring(0,1023):typeof g!="undefined"&&g!==null&&(C[I]=g)}return{properties:C,measurements:D}}e.validateTelemetryData=w;function n(h){if(!h)return"none";let C="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(b=>{h.indexOf(`${b}+`)===0&&(C=b)}),C}e.cleanRemoteAuthority=n;function p(h,C,D=0,b){if(!!h)for(let I of Object.getOwnPropertyNames(h)){const g=h[I],s=b?b+I:I;Array.isArray(g)?C[s]=(0,L.safeStringify)(g):g instanceof Date?C[s]=g.toISOString():(0,R.isObject)(g)?D<2?p(g,C,D+1,s+"."):C[s]=(0,L.safeStringify)(g):C[s]=g}}function m(h){if(!h)return[];const C=[];return d(C,"",h),C}function d(h,C,D){D&&typeof D=="object"&&!Array.isArray(D)?Object.keys(D).forEach(b=>d(h,C?`${C}.${b}`:b,D[b])):h.push(C)}}),define(te[176],ne([0,1,2,10,16,59]),function(Y,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends S.Disposable{constructor(v,w){super();this.logger=this._register(v.createLogger(w.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(v,w){this.logger.trace(`telemetry/${v}`,(0,k.validateTelemetryData)(w))}};A=de([J(0,R.ILoggerService),J(1,L.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(te[177],ne([0,1,9,26,59]),function(Y,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function k(P){const v=await new Promise((n,p)=>{Y(["applicationinsights"],n,p)});let w;return v.defaultClient?(w=new v.TelemetryClient(P),w.channel.setUseDiskRetryCaching(!0)):(v.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),w=v.defaultClient),P.indexOf("AIF-")===0&&(w.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),w}class A{constructor(v,w,n){this._eventPrefix=v,this._defaultData=w,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(v){if(!!this._aiClient){if(typeof this._aiClient!="string"){v(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=k(this._aiClient)),this._asyncAIClient.then(w=>{v(w)},w=>{(0,S.onUnexpectedError)(w),console.error(w)})}}log(v,w){!this._aiClient||(w=(0,L.mixin)(w,this._defaultData),w=(0,R.validateTelemetryData)(w),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+v,properties:w.properties,measurements:w.measurements})))}flush(){return this._aiClient?new Promise(v=>{this._withAIClient(w=>{w.flush({callback:()=>{this._aiClient=void 0,v(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(te[178],ne([0,1,49,80,17,81,23,24]),function(Y,e,S,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let v=class{constructor(n,p){this.configurationService=n,this.telemetryService=p,this.customTelemetryServices=new Map}async getCustomTelemetryService(n){if(!this.customTelemetryServices.has(n.id)){const{machineId:p,sessionId:m}=await this.telemetryService.getTelemetryInfo(),d=Object.create(null);d["common.vscodemachineid"]=p,d["common.vscodesessionid"]=m;const h=[n.id,JSON.stringify(d),n.aiKey],D=new S.Client(R.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:h,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),b=new L.TelemetryAppenderClient(D);this.customTelemetryServices.set(n.id,new k.TelemetryService({appender:b,sendErrorTelemetry:n.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(n.id)}async publicLog(n,p,m){await(await this.getCustomTelemetryService(n)).publicLog(p,m)}async publicLogError(n,p,m){await(await this.getCustomTelemetryService(n)).publicLogError(p,m)}};v=de([J(0,A.IConfigurationService),J(1,P.ITelemetryService)],v),e.CustomEndpointTelemetryService=v}),define(te[82],ne([0,1,4]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.TitleMode="terminal.integrated.titleMode",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence"})(A=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Log="log",d.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,S.createDecorator)("ptyService");var v;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(v=e.HeartbeatConstants||(e.HeartbeatConstants={}));var w;(function(d){d.TerminalView="view",d.Editor="editor"})(w=e.TerminalLocation||(e.TerminalLocation={}));var n;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(n=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var p;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(p=e.FlowControlConstants||(e.FlowControlConstants={}));var m;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(m=e.ProfileSource||(e.ProfileSource={}))}),define(te[179],ne([0,1,4]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,S.createDecorator)("localPtyService")}),define(te[180],ne([0,1,35,8,34,18,14,26,7]),function(Y,e,S,L,R,k,A,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function w(){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let m=0;return p&&p.length===4&&(m=parseInt(p[3])),m}e.getWindowsBuildNumber=w;async function n(p,m,d,h=R.env,C=k.Promises.exists){if(L.isAbsolute(p))return await C(p)?p:void 0;if(m===void 0&&(m=R.cwd()),L.dirname(p)!=="."){const g=L.join(m,p);return await C(g)?g:void 0}const b=(0,P.getCaseInsensitive)(h,"PATH");if(d===void 0&&(0,A.isString)(b)&&(d=b.split(L.delimiter)),d===void 0||d.length===0){const g=L.join(m,p);return await C(g)?g:void 0}for(let g of d){let s;if(L.isAbsolute(g)?s=L.join(g,p):s=L.join(m,g,p),await C(s))return s;if(v.isWindows){let c=s+".com";if(await C(c)||(c=s+".exe",await C(c)))return c}}const I=L.join(m,p);return await C(I)?I:void 0}e.findExecutable=n}),define(te[181],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var S;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(S=e.ColorScheme||(e.ColorScheme={}))}),define(te[83],ne([0,1,4,2,31,3,181,54]),function(Y,e,S,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,S.createDecorator)("themeService");var v;(function(D){function b(I){return I&&typeof I=="object"&&typeof I.id=="string"}D.isThemeColor=b})(v=e.ThemeColor||(e.ThemeColor={}));function w(D){return{id:D}}e.themeColorFromId=w;var n;(function(D){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||v.isThemeColor(r.color))}D.isThemeIcon=b;const I=new RegExp(`^\\$\\((${P.CSSIcon.iconNameExpression}(?:${P.CSSIcon.iconModifierExpression})?)\\)$`);function g(r){const i=I.exec(r);if(!i)return;let[,a]=i;return{id:a}}D.fromString=g;function s(r,i){let a=r.id;const l=a.lastIndexOf("~");return l!==-1&&(a=a.substring(0,l)),i&&(a=`${a}~${i}`),{id:a}}D.modify=s;function c(r,i){return r.id===i.id&&r.color?.id===i.color?.id}D.isEqual=c;function t(r,i){return{id:r.id,color:i?w(i):void 0}}D.asThemeIcon=t,D.asClassNameArray=P.CSSIcon.asClassNameArray,D.asClassName=P.CSSIcon.asClassName,D.asCSSSelector=P.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=P.Codicon.file,e.FolderThemeIcon=P.Codicon.folder;function p(D){switch(D){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=p,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new k.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,L.toDisposable)(()=>{const I=this.themingParticipants.indexOf(b);this.themingParticipants.splice(I,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new m;R.Registry.add(e.Extensions.ThemingContribution,d);function h(D){return d.onColorThemeChange(D)}e.registerThemingParticipant=h;class C extends L.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(I=>this.onThemeChange(I)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,I){let g=this.theme.getColor(b);return g&&I&&(g=I(g,this.theme)),g?g.toString():null}}e.Themable=C}),define(te[182],ne([0,1,37,122,31,54,83]),function(Y,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(k.iconRegistry.all,b=>b.id),markdownEnumDescriptions:Array.from(k.iconRegistry.all,b=>`$(${b.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},v={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},w=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),p=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),m={id:"terminal",order:100,title:(0,L.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(19,null)}},{type:"string",markdownDescription:(0,L.localize)(20,null)}],default:[],markdownDeprecationMessage:p},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"null"},v]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(23,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},v]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(24,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},v]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(26,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(27,null),type:"boolean",default:!0}}};function d(){R.Registry.as(S.Extensions.Configuration).registerConfiguration(m),C()}e.registerTerminalPlatformConfiguration=d;let h;function C(b){const I=R.Registry.as(S.Extensions.Configuration);h&&I.deregisterConfigurations([h]);let g,s;if(b){const c=b.profiles.map(t=>({name:t.profileName,description:D(t)}));g=c.map(t=>t.name),s=c.map(t=>t.description)}h={id:"terminal",order:100,title:(0,L.localize)(28,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(29,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:b?.os===3?g:void 0,markdownEnumDescriptions:b?.os===3?s:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(30,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:b?.os===2?g:void 0,markdownEnumDescriptions:b?.os===2?s:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(31,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:b?.os===1?g:void 0,markdownEnumDescriptions:b?.os===1?s:void 0}}},I.registerConfiguration(h)}e.registerTerminalDefaultProfileConfiguration=C;function D(b){let I=`$(${A.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:k.Codicon.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?I+=`
- args: "${b.args}"`:I+=`
- args: [${b.args.length===0?"":b.args.join("','")}]`),b.overrideName!==void 0&&(I+=`
- overrideName: ${b.overrideName}`),b.color&&(I+=`
- color: ${b.color}`),b.env&&(I+=`
- env: ${JSON.stringify(b.env)}`),I}}),define(te[183],ne([0,1,8,97,180,42,18,54,7,83]),function(Y,e,S,L,R,k,A,P,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function p(t,r,i,a,l,o,u,y){return l=l||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},v.isWindows?m(i,l,o,a.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:a.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:a.getValue("terminal.integrated.defaultProfile.windows"),y,u):g(l,o,i,t&&typeof t=="object"?{...t}:a.getValue(v.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:a.getValue(v.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),y,u)}e.detectAvailableProfiles=p;async function m(t,r,i,a,l,o,u,y){const E=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${process.env.windir}\\${E?"Sysnative":"System32"}`;let T=!1;(0,R.getWindowsBuildNumber)()>=16299&&(T=!0),await C(u);const O=new Map;t&&(O.set("PowerShell",{source:"PowerShell",icon:P.Codicon.terminalPowershell,isAutoDetected:!0}),O.set("Windows PowerShell",{path:`${f}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:P.Codicon.terminalPowershell,isAutoDetected:!0}),O.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),O.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),O.set("Command Prompt",{path:`${f}\\cmd.exe`,icon:P.Codicon.terminalCmd,isAutoDetected:!0})),s(l,O);const x=await d(O.entries(),o,r,i,y);if(t||!t&&a)try{const j=await b(`${f}\\${T?"wsl":"bash"}.exe`,o);for(const H of j)(!l||!(H.profileName in l))&&x.push(H)}catch(j){i?.info("WSL is not installed, so could not detect WSL profiles")}return x}async function d(t,r,i,a,l){const o=[];for(const[u,y]of t){if(y===null)continue;let E,f,T;if("source"in y){const j=n?.get(y.source);if(!j)continue;E=j.paths,f=y.args||j.args,y.icon?T=h(y.icon):j.icon&&(T=j.icon)}else E=Array.isArray(y.path)?y.path:[y.path],f=v.isWindows||Array.isArray(y.args)?y.args:void 0,T=h(y.icon)||void 0;const O=await l?.(E)||E.slice(),x=await c(u,r,O,i,f,y.env,y.overrideName,y.isAutoDetected,a);x?(x.isAutoDetected=y.isAutoDetected,x.icon=T,x.color=y.color,o.push(x)):a?.trace("profile not validated",u,E)}return o}function h(t){return typeof t=="string"?{id:t}:t}async function C(t){n&&!t||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:t||await D(),icon:w.ThemeIcon.asThemeIcon(P.Codicon.terminalPowershell)}))}async function D(){const t=[];for await(const r of(0,L.enumeratePowerShellInstallations)())t.push(r.exePath);return t}async function b(t,r){const i=[],a=await new Promise((u,y)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le"},(E,f)=>{if(E)return y("Problem occurred when getting wsl distros");u(f)})});if(!a)return[];const l=new RegExp(/[\r?\n]/),o=a.split(l).filter(u=>u.trim().length>0&&u!=="");for(const u of o){if(u===""||u.startsWith("docker-desktop"))continue;const y=`${u} (WSL)`,E={profileName:y,path:t,args:["-d",`${u}`],isDefault:y===r,icon:I(u)};i.push(E)}return i}function I(t){return t.includes("Ubuntu")?w.ThemeIcon.asThemeIcon(P.Codicon.terminalUbuntu):t.includes("Debian")?w.ThemeIcon.asThemeIcon(P.Codicon.terminalDebian):w.ThemeIcon.asThemeIcon(P.Codicon.terminalLinux)}async function g(t,r,i,a,l,o,u){const y=new Map;if(i){const E=(await t.readFile("/etc/shells")).toString(),f=o||E.split(`
`).filter(O=>O.trim().indexOf("#")!==0&&O.trim().length>0),T=new Map;for(const O of f){let x=(0,S.basename)(O),j=T.get(x)||0;j++,j>1&&(x=`${x} (${j})`),T.set(x,j),y.set(x,{path:O,isAutoDetected:!0})}}return s(a,y),await d(y.entries(),l,t,r,u)}function s(t,r){if(!!t)for(const[i,a]of Object.entries(t))a===null||!("path"in a)&&!("source"in a)?r.delete(i):r.set(i,a)}async function c(t,r,i,a,l,o,u,y,E){if(i.length===0)return Promise.resolve(void 0);const f=i.shift();if(f==="")return c(t,r,i,a,l,o,u,y);const T={profileName:t,path:f,args:l,env:o,overrideName:u,isAutoDetected:y,isDefault:t===r};if((0,S.basename)(f)===f){const x=process.env.PATH?process.env.PATH.split(S.delimiter):void 0;return await(0,R.findExecutable)(f,void 0,x,void 0,a.existsFile)?T:c(t,r,i,a,l)}return await a.existsFile((0,S.normalize)(f))?T:c(t,r,i,a,l,o,u,y)}}),define(te[184],ne([0,1,2,16,82,49,17,36,3,77,24,183,23,182]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var h;(function(I){I[I.MaxRestarts=5]="MaxRestarts"})(h||(h={}));let C=0,D=0,b=class extends S.Disposable{constructor(g,s,c,t){super();this._reconnectConstants=g,this._configurationService=s,this._logService=c,this._telemetryService=t,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new v.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new v.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new v.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new v.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new v.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new v.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new v.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new v.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new v.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new v.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new v.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new v.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new v.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new v.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._pendingResolveVariablesRequests=new Map,(0,d.registerTerminalPlatformConfiguration)(),this._register((0,S.toDisposable)(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const g=new k.Client(A.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:C,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.GraceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.ShortGraceTime}});this._onPtyHostStart.fire(),P.ProxyChannel.toService(g.getChannel(R.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(g.onDidProcessExit(r=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(r.code),this._isDisposed||(this._restartCount<=h.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const c=g.getChannel(R.TerminalIpcChannels.Log);w.LogLevelChannelClient.setLevel(c,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{w.LogLevelChannelClient.setLevel(c,this._logService.getLevel())}));const t=P.ProxyChannel.toService(g.getChannel(R.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(r=>this._onProcessData.fire(r))),this._register(t.onProcessExit(r=>this._onProcessExit.fire(r))),this._register(t.onProcessReady(r=>this._onProcessReady.fire(r))),this._register(t.onProcessTitleChanged(r=>this._onProcessTitleChanged.fire(r))),this._register(t.onProcessShellTypeChanged(r=>this._onProcessShellTypeChanged.fire(r))),this._register(t.onProcessOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r))),this._register(t.onProcessResolvedShellLaunchConfig(r=>this._onProcessResolvedShellLaunchConfig.fire(r))),this._register(t.onProcessReplay(r=>this._onProcessReplay.fire(r))),this._register(t.onProcessOrphanQuestion(r=>this._onProcessOrphanQuestion.fire(r))),[g,t]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(g,s,c,t,r,i,a,l,o,u){const y=setTimeout(()=>this._handleUnresponsiveCreateProcess(),R.HeartbeatConstants.CreateProcessTimeout),E=await this._proxy.createProcess(g,s,c,t,r,i,a,l,o,u);return clearTimeout(y),C=Math.max(C,E),E}updateTitle(g,s,c){return this._proxy.updateTitle(g,s,c)}updateIcon(g,s,c){return this._proxy.updateIcon(g,s,c)}attachToProcess(g){return this._proxy.attachToProcess(g)}detachFromProcess(g){return this._proxy.detachFromProcess(g)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(g){return this._proxy.start(g)}shutdown(g,s){return this._proxy.shutdown(g,s)}input(g,s){return this._proxy.input(g,s)}processBinary(g,s){return this._proxy.processBinary(g,s)}resize(g,s,c){return this._proxy.resize(g,s,c)}acknowledgeDataEvent(g,s){return this._proxy.acknowledgeDataEvent(g,s)}getInitialCwd(g){return this._proxy.getInitialCwd(g)}getCwd(g){return this._proxy.getCwd(g)}getLatency(g){return this._proxy.getLatency(g)}orphanQuestionReply(g){return this._proxy.orphanQuestionReply(g)}getDefaultSystemShell(g){return this._proxy.getDefaultSystemShell(g)}async getProfiles(g,s,c,t=!1){return(0,p.detectAvailableProfiles)(s,c,t,this._configurationService,void 0,this._logService,this._resolveVariables.bind(this,g))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(g){return this._proxy.getWslPath(g)}setTerminalLayoutInfo(g){return this._proxy.setTerminalLayoutInfo(g)}async getTerminalLayoutInfo(g){return await this._proxy.getTerminalLayoutInfo(g)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),R.HeartbeatConstants.BeatInterval*R.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${R.HeartbeatConstants.BeatInterval*R.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),R.HeartbeatConstants.BeatInterval*R.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(R.HeartbeatConstants.BeatInterval*R.HeartbeatConstants.FirstWaitMultiplier+R.HeartbeatConstants.BeatInterval*R.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${R.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(g,s){return new Promise(c=>{const t=++D;this._pendingResolveVariablesRequests.set(t,c),this._onPtyHostRequestResolveVariables.fire({id:t,workspaceId:g,originalText:s})})}async acceptPtyHostResolvedVariables(g,s){const c=this._pendingResolveVariablesRequests.get(g);c?(c(s),this._pendingResolveVariablesRequests.delete(g)):this._logService.warn(`Resolved variables received without matching request ${g}`)}};b=de([J(1,m.IConfigurationService),J(2,L.ILogService),J(3,n.ITelemetryService)],b),e.PtyHostService=b}),define(te[52],ne([0,1,40]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(A,P,v,w){const n=(0,S.setProperty)(A,P,v,w)[0];return n&&(A=A.substring(0,n.offset)+n.content+A.substring(n.offset+n.length)),A}e.edit=L;function R(A,P,v){let w=v;for(;w>=0;){if(A.charAt(w)===P.charAt(P.length-1)&&P.length===1)return w+1;if(w--,P.length===2&&w>=0&&A.charAt(w)===P.charAt(0))return w+2}return 0}e.getLineStartOffset=R;function k(A,P,v){let w=v;for(;w>=0;)if(A.charAt(w)===P.charAt(P.length-1)&&P.length===1||(w++,P.length===2&&w>=0&&A.charAt(w)===P.charAt(1)))return w;return A.length-1}e.getLineEndOffset=k}),define(te[185],ne([0,1,26,57]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(p,m,d,h,C){const D=[],b=[],I=[];if(!m){const T=p.filter(({identifier:O})=>C.every(x=>x.toLowerCase()!==O.id.toLowerCase()));return{local:{added:D,removed:b,updated:I},remote:T.length>0?{added:T,updated:[],removed:[],all:T}:null}}p=p.map(w),m=m.map(w),d=d?d.map(w):null;const g=new Map,s=T=>{T.uuid&&g.set(T.id.toLowerCase(),T.uuid)};p.forEach(({identifier:T})=>s(T)),m.forEach(({identifier:T})=>s(T)),d&&d.forEach(({identifier:T})=>s(T));const c=T=>{const O=T.identifier.uuid||g.get(T.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${T.identifier.id.toLowerCase()}`},t=(T,O)=>(T.set(c(O),O),T),r=p.reduce(t,new Map),i=m.reduce(t,new Map),a=m.reduce((T,O)=>{const x=c(O);O=(0,S.deepClone)(O);const j=r.get(x);return j&&(j.installed&&(O.installed=!0),O.version||(O.version=j.version)),t(T,O)},new Map),l=d?d.reduce(t,new Map):null,o=h.reduce(t,new Map),u=C.reduce((T,O)=>{const x=g.get(O.toLowerCase());return T.add(x?`uuid:${x}`:`id:${O.toLowerCase()}`)},new Set),y=k(r,i,u);if(y.added.size>0||y.removed.size>0||y.updated.size>0){const T=k(l,r,u),O=k(l,i,u),x=(j,H)=>{const V=r.get(j);if(V){const N=i.get(j);return{...H?N:V,version:(N.version&&L.gt(N.version,V.version),V.version),state:A(V,N,l?.get(j))}}};for(const j of O.removed.values()){const H=r.get(j);H&&b.push(H.identifier)}for(const j of O.added.values())if(T.added.has(j)){if(y.updated.has(j)){const H=x(j,!0);H&&(I.push(n(H,j)),a.set(j,H))}}else{const H=i.get(j);H.installed&&D.push(n(H,j))}for(const j of O.updated.values()){const H=x(j,!0);H&&(I.push(n(H,j)),a.set(j,H))}for(const j of T.added.values())O.added.has(j)||a.set(j,r.get(j));for(const j of T.updated.values())if(!O.removed.has(j)&&!O.updated.has(j)){const H=x(j,!1);H&&(a.get(j)?.installed&&(H.installed=!0),a.set(j,H))}for(const j of T.removed.values())!o.has(j)&&!O.updated.has(j)&&l?.get(j)?.installed&&a.delete(j)}const E=[],f=k(i,a,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(f.added.size>0||f.updated.size>0||f.removed.size>0)&&a.forEach((T,O)=>E.push(n(T,O))),{local:{added:D,removed:b,updated:I},remote:E.length?{added:[...f.added].map(T=>a.get(T)),updated:[...f.updated].map(T=>a.get(T)),removed:[...f.removed].map(T=>i.get(T)),all:E}:null}}e.merge=R;function k(p,m,d,{checkInstalledProperty:h,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const D=p?[...p.keys()].filter(c=>!d.has(c)):[],b=[...m.keys()].filter(c=>!d.has(c)),I=b.filter(c=>D.indexOf(c)===-1).reduce((c,t)=>(c.add(t),c),new Set),g=D.filter(c=>b.indexOf(c)===-1).reduce((c,t)=>(c.add(t),c),new Set),s=new Set;for(const c of D){if(g.has(c))continue;const t=p.get(c),r=m.get(c);(!r||t.disabled!==r.disabled||!v(t.state,r.state)||C&&t.version!==r.version||h&&t.installed!==r.installed)&&s.add(c)}return{added:I,removed:g,updated:s}}function A(p,m,d){const h=p.state,C=m.state,D=d?.state;if(!m.version||h&&L.gt(p.version,m.version))return h;if(C&&L.gt(m.version,p.version)||!h)return C;if(!C)return h;const b=(0,S.deepClone)(h),I=D?P(D,C):{added:Object.keys(C).reduce((s,c)=>(s.add(c),s),new Set),removed:new Set,updated:new Set},g=D?P(D,h):{added:Object.keys(h).reduce((s,c)=>(s.add(c),s),new Set),removed:new Set,updated:new Set};for(const s of[...I.added.values(),...I.updated.values()])b[s]=C[s];for(const s of I.removed.values())g.updated.has(s)||delete b[s];return b}function P(p,m){const d=Object.keys(p),h=Object.keys(m),C=h.filter(I=>d.indexOf(I)===-1).reduce((I,g)=>(I.add(g),I),new Set),D=d.filter(I=>h.indexOf(I)===-1).reduce((I,g)=>(I.add(g),I),new Set),b=new Set;for(const I of d){if(D.has(I))continue;const g=p[I],s=m[I];(0,S.equals)(g,s)||b.add(I)}return{added:C,removed:D,updated:b}}function v(p={},m={}){const{added:d,removed:h,updated:C}=P(p,m);return d.size===0&&h.size===0&&C.size===0}function w(p){return{...p,disabled:!!p.disabled,installed:!!p.installed}}function n(p,m){const d={identifier:{id:p.identifier.id,uuid:m.startsWith("uuid:")?m.substring("uuid:".length):void 0}};return p.version&&(d.version=p.version),p.disabled&&(d.disabled=!0),p.installed&&(d.installed=!0),p.state&&(d.state=p.state),d}}),define(te[84],ne([0,1,22,3,2,33,4,27,20]),function(Y,e,S,L,R,k,A,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,A.createDecorator)("IExtensionsStorageSyncService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class Ze extends R.Disposable{constructor(m,d){super();this.storageService=m,this.productService=d,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(m){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(m.id)}@${m.version}`}static fromKey(m){const d=w.exec(m);if(d&&d[1])return{id:d[1],version:d[2]}}initialize(){const m=this.storageService.keys(0,1);for(const d of m){const h=Ze.fromKey(d);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(m){if(m.scope!==0)return;if(this.extensionsWithKeysForSync.has(m.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const d=Ze.fromKey(m.key);if(d){this.extensionsWithKeysForSync.add(d.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(m,d){this.storageService.store(Ze.toKey(m),JSON.stringify(d),0,1)}getKeysForSync(m){const d=this.productService.extensionSyncedKeys?.[m.id.toLowerCase()],h=this.storageService.get(Ze.toKey(m),0),C=h?JSON.parse(h):void 0;return C&&d?(0,S.distinct)([...C,...d]):C||d}};n=de([J(0,v.IStorageService),J(1,P.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(te[85],ne([0,1,22,23,4]),function(Y,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,v){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return w=w.filter(n=>n!==P&&n!==`-${P}`),v&&w.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,1)}updateSynchronizedExtensions(P,v){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return w=w.filter(n=>n!==P&&n!==`-${P}`),v&&w.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,1)}getIgnoredExtensions(P){const v=P.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),w=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),n=[],p=[];if(Array.isArray(w))for(const m of w)m.startsWith("-")?p.push(m.substring(1)):n.push(m);return(0,S.distinct)([...v,...n].filter(m=>p.indexOf(m)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(v=>v.toLowerCase())}};k=de([J(0,L.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(te[186],ne([0,1,26,32,22,143,52]),function(Y,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(s){return(0,L.parse)(s)||[]}e.parseKeybindings=P;async function v(s,c,t,r,i){const a=P(s),l=P(c),o=t?P(t):null,u=[...a,...l,...o||[]].map(_=>_.key),y=await i.resolveUserBindings(u);let E=n(a,l,o,y);if(!E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:s,hasChanges:!1,hasConflicts:!1};if(!E.hasLocalForwarded&&E.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};const f=m(a),T=m(l),O=o?m(o):null,x=h(f,T,y),j=O?h(O,f,y):{added:[...f.keys()].reduce((_,M)=>(_.add(M),_),new Set),removed:new Set,updated:new Set},H=O?h(O,T,y):{added:[...T.keys()].reduce((_,M)=>(_.add(M),_),new Set),removed:new Set,updated:new Set},V=w(x,j,H);let N=s;for(const _ of V.removed.values())V.conflicts.has(_)||(N=I(N,_,r));for(const _ of V.added.values()){if(V.conflicts.has(_))continue;const M=T.get(_);if(M.some(B=>B.command!==`-${_}`&&E.conflicts.has(y[B.key]))){V.conflicts.add(_);continue}N=b(N,M,r)}for(const _ of V.updated.values()){if(V.conflicts.has(_))continue;const M=T.get(_);if(M.some(B=>B.command!==`-${_}`&&E.conflicts.has(y[B.key]))){V.conflicts.add(_);continue}N=g(N,_,M,r)}return{mergeContent:N,hasChanges:!0,hasConflicts:V.conflicts.size>0}}e.merge=v;function w(s,c,t){const r=new Set,i=new Set,a=new Set,l=new Set;for(const o of c.removed.values())t.updated.has(o)&&l.add(o);for(const o of t.removed.values())l.has(o)||(c.updated.has(o)?l.add(o):i.add(o));for(const o of c.added.values())l.has(o)||t.added.has(o)&&s.updated.has(o)&&l.add(o);for(const o of t.added.values())l.has(o)||(c.added.has(o)?s.updated.has(o)&&l.add(o):r.add(o));for(const o of c.updated.values())l.has(o)||t.updated.has(o)&&s.updated.has(o)&&l.add(o);for(const o of t.updated.values())l.has(o)||(c.updated.has(o)?s.updated.has(o)&&l.add(o):a.add(o));return{added:r,removed:i,updated:a,conflicts:l}}function n(s,c,t,r){const i=new Set,a=p(s,r),l=p(c,r),o=t?p(t,r):null,u=d(a,l);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const y=o?d(o,a):{added:[...a.keys()].reduce((j,H)=>(j.add(H),j),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const E=o?d(o,l):{added:[...l.keys()].reduce((j,H)=>(j.add(H),j),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:f,removed:T,updated:O,conflicts:x}=w(u,y,E);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:f,removed:T,updated:O,conflicts:x}}function p(s,c){const t=new Map;for(const r of s){const i=c[r.key];let a=t.get(i);a||(a=[],t.set(i,a)),a.push(r)}return t}function m(s){const c=new Map;for(const t of s){const r=t.command[0]==="-"?t.command.substring(1):t.command;let i=c.get(r);i||(i=[],c.set(r,i)),i.push(t)}return c}function d(s,c){const t=[...s.keys()],r=[...c.keys()],i=r.filter(o=>t.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),a=t.filter(o=>r.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),l=new Set;for(const o of t){if(a.has(o))continue;const u=s.get(o).map(E=>({...E,key:o})),y=c.get(o).map(E=>({...E,key:o}));(0,R.equals)(u,y,(E,f)=>D(E,f))||l.add(o)}return{added:i,removed:a,updated:l}}function h(s,c,t){const r=[...s.keys()],i=[...c.keys()],a=i.filter(u=>r.indexOf(u)===-1).reduce((u,y)=>(u.add(y),u),new Set),l=r.filter(u=>i.indexOf(u)===-1).reduce((u,y)=>(u.add(y),u),new Set),o=new Set;for(const u of r){if(l.has(u))continue;const y=s.get(u).map(f=>({...f,key:t[f.key]})),E=c.get(u).map(f=>({...f,key:t[f.key]}));C(y,E)||o.add(u)}return{added:a,removed:l,updated:o}}function C(s,c){return!(!(0,R.equals)(s.filter(({command:t})=>t[0]!=="-"),c.filter(({command:t})=>t[0]!=="-"),(t,r)=>D(t,r))||!(0,R.equals)(s.filter(({command:t})=>t[0]==="-"),c.filter(({command:t})=>t[0]==="-"),(t,r)=>D(t,r)))}function D(s,c){if(s.command!==c.command||s.key!==c.key)return!1;const t=k.ContextKeyExpr.deserialize(s.when),r=k.ContextKeyExpr.deserialize(c.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!S.equals(s.args,c.args))}function b(s,c,t){for(const r of c)s=A.edit(s,[-1],r,t);return s}function I(s,c,t){const r=P(s);for(let i=r.length-1;i>=0;i--)(r[i].command===c||r[i].command===`-${c}`)&&(s=A.edit(s,[i],void 0,t));return s}function g(s,c,t,r){const i=P(s),a=i.findIndex(l=>l.command===c||l.command===`-${c}`);for(let l=i.length-1;l>=0;l--)(i[l].command===c||i[l].command===`-${c}`)&&(s=A.edit(s,[l],void 0,r));for(let l=t.length-1;l>=0;l--)s=A.edit(s,[a],t[l],r);return s}}),define(te[187],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function S(k,A,P){const v={},w={},n=new Set;if(!A)return{local:{added:v,updated:w,removed:[...n.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const p=L(k,A);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{local:{added:v,updated:w,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=L(P,k),d=L(P,A),h={},C={},D=new Set,b=new Set;for(const I of m.removed.values())d.updated.has(I)?v[I]=A[I]:D.add(I);for(const I of d.removed.values())b.has(I)||(m.updated.has(I)?b.add(I):n.add(I));for(const I of m.updated.values())b.has(I)||(d.updated.has(I)?p.updated.has(I)&&b.add(I):C[I]=k[I]);for(const I of d.updated.values())b.has(I)||(m.updated.has(I)?p.updated.has(I)&&b.add(I):k[I]!==void 0&&(w[I]=A[I]));for(const I of m.added.values())b.has(I)||(d.added.has(I)?p.updated.has(I)&&b.add(I):h[I]=k[I]);for(const I of d.added.values())b.has(I)||(m.added.has(I)?p.updated.has(I)&&b.add(I):v[I]=A[I]);return{local:{added:v,removed:[...n.values()],updated:w},remote:{added:h,removed:[...D.values()],updated:C},conflicts:[...b.values()]}}e.merge=S;function L(k,A){const P=k?Object.keys(k):[],v=A?Object.keys(A):[],w=v.filter(m=>P.indexOf(m)===-1).reduce((m,d)=>(m.add(d),m),new Set),n=P.filter(m=>v.indexOf(m)===-1).reduce((m,d)=>(m.add(d),m),new Set),p=new Set;for(const m of P){if(n.has(m))continue;const d=k[m],h=A[m];d!==h&&p.add(m)}return{added:w,removed:n,updated:p}}function R(k,A){const{added:P,removed:v,updated:w}=L(k,A);return P.size===0&&v.size===0&&w.size===0}e.areSame=R}),define(te[21],ne([0,1,4,28,31,37,127,79,15,22,14]),function(Y,e,S,L,R,k,A,P,v,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function p(){const o=R.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(u=>!!o[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=p;function m(){const o=R.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(o).filter(f=>!!o[f].ignoreSync),y=Object.keys(o).filter(f=>o[f].scope===2||o[f].scope===6),E=p();return(0,w.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...y,...E])}e.getDefaultIgnoredSettings=m;function d(){const o="vscode://schemas/ignoredSettings",u=R.Registry.as(k.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const y=R.Registry.as(P.Extensions.JSONContribution),E=()=>{const f=p(),T=m().filter(H=>H!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(k.allSettings.properties).filter(H=>T.indexOf(H)===-1),x=T.filter(H=>f.indexOf(H)===-1),j={items:{type:"string",enum:[...O,...x.map(H=>`-${H}`)]}};y.registerSchema(o,j)};return u.onDidUpdateConfiguration(()=>E())}e.registerConfiguration=d;function h(o){return o&&(0,n.isObject)(o)&&(0,n.isString)(o.id)&&(0,n.isArray)(o.scopes)}e.isAuthenticationProvider=h;var C;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(C=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function D(o,u,y){return y.joinPath(u.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=D,e.IUserDataSyncStoreManagementService=(0,S.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,S.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,S.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function b(o){const u={};return u[e.HEADER_EXECUTION_ID]=o,u}e.createSyncHeaders=b;var I;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.NoRef="NoRef",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(I=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class g extends Error{constructor(u,y,E,f){super(u);this.code=y,this.resource=E,this.operationId=f,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class s extends g{constructor(u,y,E,f){super(u,E,void 0,f);this.url=y}}e.UserDataSyncStoreError=s;class c extends g{constructor(u,y){super(u,y)}}e.UserDataAutoSyncError=c,function(o){function u(y){if(y instanceof o)return y;const E=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(y.name);if(E&&E[1]){const f=E[2]==="unknown"?void 0:E[2],T=E[3]==="unknown"?void 0:E[3];return new o(y.message,E[1],f,T)}return new o(y.message,I.Unknown)}o.toUserDataSyncError=u}(g=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var r;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var i;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function a(o){return`sync.enable.${o}`}e.getEnablementKey=a,e.IUserDataSyncResourceEnablementService=(0,S.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,S.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,S.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,S.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,S.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,S.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function l(o,u){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(y=>(0,v.isEqualOrParent)(o,(0,v.joinPath)(u.userDataSyncHome,y,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=l}),define(te[45],ne([0,1,2,11,25,5,21,10,15,6,3,24,32,123,23,14,19,22,44,20,29]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d,h,C,D,b,I,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function c(l){return!!(l&&l.version!==void 0&&typeof l.version=="number"&&l.content!==void 0&&typeof l.content=="string"&&(Object.keys(l).length===2||Object.keys(l).length===3&&l.machineId!==void 0&&typeof l.machineId=="string"))}e.isSyncData=c;let t=class extends S.Disposable{constructor(o,u,y,E,f,T,O,x,j,H){super();this.resource=o,this.fileService=u,this.environmentService=y,this.userDataSyncStoreService=f,this.userDataSyncBackupStoreService=T,this.userDataSyncResourceEnablementService=O,this.telemetryService=x,this.logService=j,this.configurationService=H,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new n.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new n.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new w.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new n.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,D.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(y.userDataSyncHome,1024)?v.extUri:v.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(y.userDataSyncHome,o),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,A.PREVIEW_DIR_NAME),this.lastSyncResource=(0,A.getLastSyncResourceUri)(o,y,this.extUri),this.currentMachineIdPromise=(0,I.getServiceMachineId)(y,u,E)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const o=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(o.remoteUserData,o.lastSyncUserData,!0);this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const o=await this.getLastSyncUserData();(o?(await this.doGenerateSyncResourcePreview(o,o,!0,s.CancellationToken.None)).resourcePreviews.some(({remoteChange:y})=>y!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(o){if(this._status!==o){const u=this._status;o==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&o==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=o,this._onDidChangStatus.fire(o)}}async sync(o,u={}){await this._sync(o,!0,u)}async preview(o,u={}){return this._sync(o,!1,u)}async apply(o,u={}){try{this.syncHeaders={...u};const y=await this.doApply(o);return this.setStatus(y),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(o,u,y){try{if(this.syncHeaders={...y},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let E="idle";try{const f=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(o,f);return E=await this.performSync(T,f,u),E==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):E==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(E)}}finally{this.syncHeaders={}}}async replace(o){const u=await this.resolveContent(o);if(!u)return!1;const y=this.parseSyncData(u);if(!y)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const E=await this.getLastSyncUserData(),f=await this.getLatestRemoteUserData(null,E),T=await this.isRemoteDataFromCurrentMachine(f),O=await this.generateSyncPreview({ref:f.ref,syncData:y},E,T,s.CancellationToken.None),x=[];for(const j of O){const H=await this.getAcceptResult(j,j.remoteResource,void 0,s.CancellationToken.None),{remoteChange:V}=await this.getAcceptResult(j,j.previewResource,j.remoteContent,s.CancellationToken.None);x.push([j,{...H,remoteChange:V!==0?V:2}])}await this.applyResult(f,E,x,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(o){const u=await this.currentMachineIdPromise;return!!o.syncData?.machineId&&o.syncData.machineId===u}async getLatestRemoteUserData(o,u){if(u){const y=o&&o.latest?o.latest[this.resource]:void 0;if(u.ref===y||y===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(o,u,y){if(o.syncData&&o.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new A.UserDataSyncError((0,d.localize)(0,null,this.resource,this.version,o.syncData.version),A.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(o,u,y)}catch(E){if(E instanceof A.UserDataSyncError)switch(E.code){case A.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(o,u,y);case A.UserDataSyncErrorCode.Conflict:case A.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),o=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(o,u,y)}throw E}}async doSync(o,u,y){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,w.createCancelablePromise)(f=>this.doGenerateSyncResourcePreview(o,u,y,f)));const E=await this.syncPreviewPromise;return this.updateConflicts(E.resourcePreviews),E.resourcePreviews.some(({mergeState:f})=>f==="conflict")?"hasConflicts":y?await this.doApply(!1):"syncing"}catch(E){throw this.syncPreviewPromise=null,E}}async merge(o){return await this.updateSyncResourcePreview(o,async u=>{const y=await this.getMergeResult(u,s.CancellationToken.None);await this.fileService.writeFile(u.previewResource,R.VSBuffer.fromString(y?.content||""));const E=y&&!y.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,s.CancellationToken.None):void 0;return u.acceptResult=E,u.mergeState=y.hasConflicts?"conflict":E?"accepted":"preview",u.localChange=E?E.localChange:y.localChange,u.remoteChange=E?E.remoteChange:y.remoteChange,u}),this.syncPreviewPromise}async accept(o,u){return await this.updateSyncResourcePreview(o,async y=>{const E=await this.getAcceptResult(y,o,u,s.CancellationToken.None);return y.acceptResult=E,y.mergeState="accepted",y.localChange=E.localChange,y.remoteChange=E.remoteChange,y}),this.syncPreviewPromise}async discard(o){return await this.updateSyncResourcePreview(o,async u=>{const y=await this.getMergeResult(u,s.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,R.VSBuffer.fromString(y.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=y.localChange,u.remoteChange=y.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(o,u){if(!this.syncPreviewPromise)return;let y=await this.syncPreviewPromise;const E=y.resourcePreviews.findIndex(({localResource:f,remoteResource:T,previewResource:O})=>this.extUri.isEqual(f,o)||this.extUri.isEqual(T,o)||this.extUri.isEqual(O,o));E!==-1&&(this.syncPreviewPromise=(0,w.createCancelablePromise)(async f=>{const T=[...y.resourcePreviews];return T[E]=await u(T[E]),{...y,resourcePreviews:T}}),y=await this.syncPreviewPromise,this.updateConflicts(y.resourcePreviews),y.resourcePreviews.some(({mergeState:f})=>f==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(o){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:y})=>y==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:y})=>y!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(y=>[y,y.acceptResult]),o),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(o){}}updateConflicts(o){const u=o.filter(({mergeState:y})=>y==="conflict");(0,b.equals)(this._conflicts,u,(y,E)=>this.extUri.isEqual(y.previewResource,E.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:y})=>({created:u,uri:this.toRemoteBackupResource(y)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:y})=>({created:u,uri:this.toLocalBackupResource(y)}))}toRemoteBackupResource(o){return k.URI.from({scheme:A.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${o}`})}toLocalBackupResource(o){return k.URI.from({scheme:A.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${o}`})}async getMachineId({uri:o}){const u=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(u))){const{content:y}=await this.getUserData(u);if(y)return this.parseSyncData(y)?.machineId}}async resolveContent(o){const u=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(u))){const{content:y}=await this.getUserData(u);return y}return this.extUri.isEqual(o,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(o){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const y of u.resourcePreviews){if(this.extUri.isEqual(y.acceptedResource,o))return y.acceptResult?y.acceptResult.content:null;if(this.extUri.isEqual(y.remoteResource,o))return y.remoteContent;if(this.extUri.isEqual(y.localResource,o))return y.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(o){}}async doGenerateSyncResourcePreview(o,u,y,E){const f=await this.isRemoteDataFromCurrentMachine(o),T=await this.generateSyncPreview(o,u,f,E),O=[];for(const x of T){const j=x.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(x.localChange===0&&x.remoteChange===0)O.push({...x,acceptedResource:j,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const H=y?await this.getMergeResult(x,E):void 0;if(E.isCancellationRequested)break;await this.fileService.writeFile(x.previewResource,R.VSBuffer.fromString(H?.content||""));const V=H&&!H.hasConflicts?await this.getAcceptResult(x,x.previewResource,void 0,E):void 0;O.push({...x,acceptResult:V,mergeState:H?.hasConflicts?"conflict":V?"accepted":"preview",localChange:V?V.localChange:H?H.localChange:x.localChange,remoteChange:V?V.remoteChange:H?H.remoteChange:x.remoteChange})}}return{remoteUserData:o,lastSyncUserData:u,resourcePreviews:O,isLastSyncFromCurrentMachine:f}}async getLastSyncUserData(){try{const o=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(o.value.toString()),y=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&y&&u.version!==y,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${y}.`),await this.resetLocal(),null;const E=u;if(E.content===null)return{ref:u.ref,syncData:null};const f=JSON.parse(E.content);if(c(f))return{...u,syncData:f,content:void 0}}catch(o){o instanceof L.FileOperationError&&o.fileOperationResult===1||this.logService.error(o)}return null}async updateLastSyncUserData(o,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const y=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),E={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,version:y,...u};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(E)))}async getRemoteUserData(o){const{ref:u,content:y}=await this.getUserData(o);let E=null;return y!==null&&(E=this.parseSyncData(y)),{ref:u,syncData:E}}parseSyncData(o){try{const u=JSON.parse(o);if(c(u))return u}catch(u){this.logService.error(u)}throw new A.UserDataSyncError((0,d.localize)(1,null),A.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(o){if((0,C.isString)(o)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,o);return{ref:o,content:u}}else{const u=o?{ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(o,u){const y=await this.currentMachineIdPromise,E={version:this.version,machineId:y,content:o};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(E),u,this.syncHeaders),{ref:u,syncData:E}}async backupLocal(o){const u={version:this.version,content:o};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=de([J(1,L.IFileService),J(2,P.IEnvironmentService),J(3,g.IStorageService),J(4,A.IUserDataSyncStoreService),J(5,A.IUserDataSyncBackupStoreService),J(6,A.IUserDataSyncResourceEnablementService),J(7,p.ITelemetryService),J(8,A.IUserDataSyncLogService),J(9,h.IConfigurationService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(o,u,y,E,f,T,O,x,j,H,V){super(u,y,E,f,T,O,x,j,H,V);this.file=o,this._register(this.fileService.watch(this.extUri.dirname(o))),this._register(this.fileService.onDidFilesChange(N=>this.onFileChanges(N)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(o){return null}}async updateLocalFileContent(o,u,y){try{u?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(o),y?void 0:u):await this.fileService.createFile(this.file,R.VSBuffer.fromString(o),{overwrite:y})}catch(E){throw E instanceof L.FileOperationError&&E.fileOperationResult===1||E instanceof L.FileOperationError&&E.fileOperationResult===3?new A.UserDataSyncError(E.message,A.UserDataSyncErrorCode.LocalPreconditionFailed):E}}onFileChanges(o){!o.contains(this.file)||this.triggerLocalChange()}};r=de([J(2,L.IFileService),J(3,P.IEnvironmentService),J(4,g.IStorageService),J(5,A.IUserDataSyncStoreService),J(6,A.IUserDataSyncBackupStoreService),J(7,A.IUserDataSyncResourceEnablementService),J(8,p.ITelemetryService),J(9,A.IUserDataSyncLogService),J(10,h.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let i=class extends r{constructor(o,u,y,E,f,T,O,x,j,H,V,N){super(o,u,y,E,f,T,O,x,j,H,N);this.userDataSyncUtilService=V,this._formattingOptions=void 0}hasErrors(o){const u=[];return(0,m.parse)(o,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};i=de([J(2,L.IFileService),J(3,P.IEnvironmentService),J(4,g.IStorageService),J(5,A.IUserDataSyncStoreService),J(6,A.IUserDataSyncBackupStoreService),J(7,A.IUserDataSyncResourceEnablementService),J(8,p.ITelemetryService),J(9,A.IUserDataSyncLogService),J(10,A.IUserDataSyncUtilService),J(11,h.IConfigurationService)],i),e.AbstractJsonFileSynchroniser=i;let a=class{constructor(o,u,y,E){this.resource=o,this.environmentService=u,this.logService=y,this.fileService=E,this.extUri=this.fileService.hasCapability(u.userDataSyncHome,1024)?v.extUri:v.extUriIgnorePathCase,this.lastSyncResource=(0,A.getLastSyncResourceUri)(this.resource,u,v.extUri)}async initialize({ref:o,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const y=this.parseSyncData(u);if(!y)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:o,syncData:y})}catch(f){this.logService.error(f)}}parseSyncData(o){try{const u=JSON.parse(o);if(c(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(o,u={}){const y={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(y)))}};a=de([J(1,P.IEnvironmentService),J(2,A.IUserDataSyncLogService),J(3,L.IFileService)],a),e.AbstractInitializer=a}),define(te[188],ne([0,1,21,3,10,28,33,11,23,185,45,24,5,46,40,19,20,85,9,84,6]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d,h,C,D,b,I,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function c(l,o){const u=JSON.parse(l.content);if(l.version===1||l.version===2){const y=(await o.getInstalled(0)).filter(E=>E.isBuiltin);for(const E of u)l.version===1&&(E.enabled===!1&&(E.disabled=!0),delete E.enabled),l.version===2&&y.every(f=>!(0,A.areSameExtensions)(f.identifier,E.identifier))&&(E.installed=!0)}return u}function t(l,o,u){const y=u.get((0,A.getExtensionId)(l,o),0)||"{}";return JSON.parse(y)}e.getExtensionStorageState=t;function r(l,o,u,y){y.store((0,A.getExtensionId)(l,o),JSON.stringify(u),0,1)}e.storeExtensionStorageState=r;let i=class at extends n.AbstractSynchroniser{constructor(o,u,y,E,f,T,O,x,j,H,V,N,_,M){super("extensions",u,o,y,E,f,N,_,j,V);this.storageService=y,this.extensionManagementService=T,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=x,this.extensionGalleryService=H,this.extensionsStorageSyncService=M,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.debounce(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,B=>B.some(({local:F})=>!!F)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,B=>!B.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(o,u){const y=o.syncData?await c(o.syncData,this.extensionManagementService):null,E=u?.skippedExtensions||[],f=u?.syncData?await c(u.syncData,this.extensionManagementService):null,T=await this.extensionManagementService.getInstalled(),O=this.getLocalExtensions(T),x=this.ignoredExtensionsManagementService.getIgnoredExtensions(T);y?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:j,remote:H}=(0,w.merge)(O,y,f,E,x),V={local:j,remote:H,content:this.getPreviewContent(O,j.added,j.updated,j.removed),localChange:j.added.length>0||j.removed.length>0||j.updated.length>0?2:0,remoteChange:H!==null?2:0};return[{skippedExtensions:E,localResource:this.localResource,localContent:this.format(O),localExtensions:O,remoteResource:this.remoteResource,remoteContent:y?this.format(y):null,previewResource:this.previewResource,previewResult:V,localChange:V.localChange,remoteChange:V.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(o,u,y,E){const f=[...u,...y],T=new Set,O=x=>{T.add(x.id.toLowerCase()),x.uuid&&T.add(x.uuid)};f.forEach(({identifier:x})=>O(x)),E.forEach(O);for(const x of o)T.has(x.identifier.id.toLowerCase())||x.identifier.uuid&&T.has(x.identifier.uuid)||f.push(x);return this.format(f)}async getMergeResult(o,u){return{...o.previewResult,hasConflicts:!1}}async getAcceptResult(o,u,y,E){if(this.extUri.isEqual(u,this.localResource))return this.acceptLocal(o);if(this.extUri.isEqual(u,this.remoteResource))return this.acceptRemote(o);if(this.extUri.isEqual(u,this.previewResource))return o.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async acceptLocal(o){const u=await this.extensionManagementService.getInstalled(),y=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),E=(0,w.merge)(o.localExtensions,null,null,o.skippedExtensions,y),{local:f,remote:T}=E;return{content:o.localContent,local:f,remote:T,localChange:f.added.length>0||f.removed.length>0||f.updated.length>0?2:0,remoteChange:T!==null?2:0}}async acceptRemote(o){const u=await this.extensionManagementService.getInstalled(),y=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),E=o.remoteContent?JSON.parse(o.remoteContent):null;if(E!==null){const f=(0,w.merge)(o.localExtensions,E,o.localExtensions,[],y),{local:T,remote:O}=f;return{content:o.remoteContent,local:T,remote:O,localChange:T.added.length>0||T.removed.length>0||T.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:o.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(o,u,y,E){let{skippedExtensions:f,localExtensions:T}=y[0][0],{local:O,remote:x,localChange:j,remoteChange:H}=y[0][1];if(j===0&&H===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),j!==0&&(await this.backupLocal(JSON.stringify(T)),f=await this.updateLocalExtensions(O.added,O.removed,O.updated,f)),x){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const V=JSON.stringify(x.all);o=await this.updateRemoteUserData(V,E?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${x.added.length?` Added: ${JSON.stringify(x.added.map(N=>N.identifier.id))}.`:""}${x.updated.length?` Updated: ${JSON.stringify(x.updated.map(N=>N.identifier.id))}.`:""}${x.removed.length?` Removed: ${JSON.stringify(x.removed.map(N=>N.identifier.id))}.`:""}`)}u?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(o,{skippedExtensions:f}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${f.length?` Skipped: ${JSON.stringify(f.map(V=>V.identifier.id))}.`:""}`))}async getAssociatedResources({uri:o}){return[{resource:this.extUri.joinPath(o,"extensions.json"),comparableResource:at.EXTENSIONS_DATA_URI}]}async resolveContent(o){if(this.extUri.isEqual(o,at.EXTENSIONS_DATA_URI)){const y=await this.extensionManagementService.getInstalled(),E=this.ignoredExtensionsManagementService.getIgnoredExtensions(y),f=this.getLocalExtensions(y).filter(T=>!E.some(O=>(0,A.areSameExtensions)({id:O},T.identifier)));return this.format(f)}if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o))return this.resolvePreviewContent(o);let u=await super.resolveContent(o);if(u)return u;if(u=await super.resolveContent(this.extUri.dirname(o)),u){const y=this.parseSyncData(u);if(y)switch(this.extUri.basename(o)){case"extensions.json":return this.format(this.parseExtensions(y))}}return null}format(o){o.sort((E,f)=>!E.identifier.uuid&&f.identifier.uuid?-1:E.identifier.uuid&&!f.identifier.uuid?1:(0,C.compare)(E.identifier.id,f.identifier.id));const u=JSON.stringify(o),y=(0,d.format)(u,void 0,{});return(0,h.applyEdits)(u,y)}async hasLocalData(){try{const o=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(o).some(y=>y.installed||y.disabled))return!0}catch(o){}return!1}async updateLocalExtensions(o,u,y,E){const f=[],T=[],O=await this.extensionManagementService.getInstalled();if(u.length){const j=O.filter(({identifier:H,isBuiltin:V})=>!V&&u.some(N=>(0,A.areSameExtensions)(H,N)));await s.Promises.settled(j.map(async H=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,H.identifier.id),await this.extensionManagementService.uninstall(H,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,H.identifier.id),f.push(H.identifier)}))}(o.length||y.length)&&await s.Promises.settled([...o,...y].map(async j=>{const H=O.find(N=>(0,A.areSameExtensions)(N.identifier,j.identifier));if(H&&H.isBuiltin){j.state&&H.manifest.version===j.version&&this.updateExtensionState(j.state,H.manifest.publisher,H.manifest.name,H.manifest.version),j.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,j.identifier.id),await this.extensionEnablementService.disableExtension(j.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,j.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,j.identifier.id),await this.extensionEnablementService.enableExtension(j.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,j.identifier.id)),f.push(j.identifier);return}const V=await this.extensionGalleryService.getCompatibleExtension(j.identifier);if(j.state&&(H?H.manifest.version===j.version:!!V)){const N=H?H.manifest.publisher:V.publisher,_=H?H.manifest.name:V.name;this.updateExtensionState(j.state,N,_,H?.manifest.version)}if(V)try{j.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,j.identifier.id,V.version),await this.extensionEnablementService.disableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,j.identifier.id,V.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,j.identifier.id,V.version),await this.extensionEnablementService.enableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,j.identifier.id,V.version)),H||(await this.extensionManagementService.canInstall(V)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,j.identifier.id,V.version),await this.extensionManagementService.installFromGallery(V,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,j.identifier.id,V.version),f.push(V.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,V.displayName||V.identifier.id),T.push(j)))}catch(N){T.push(j),this.logService.error(N),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,V.displayName||V.identifier.id)}else this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,j.identifier.id),T.push(j)}));const x=[];for(const j of E)f.some(H=>(0,A.areSameExtensions)(H,j.identifier))||x.push(j);for(const j of T)x.some(H=>(0,A.areSameExtensions)(H.identifier,j.identifier))||x.push(j);return x}updateExtensionState(o,u,y,E){const f=t(u,y,this.storageService),T=E?this.extensionsStorageSyncService.getKeysForSync({id:(0,A.getGalleryExtensionId)(u,y),version:E}):void 0;T?T.forEach(O=>{f[O]=o[O]}):Object.keys(o).forEach(O=>f[O]=o[O]),r(u,y,f,this.storageService)}parseExtensions(o){return JSON.parse(o.content)}getLocalExtensions(o){const u=this.extensionEnablementService.getDisabledExtensions();return o.map(({identifier:y,isBuiltin:E,manifest:f})=>{const T={identifier:y,version:f.version};u.some(O=>(0,A.areSameExtensions)(O,y))&&(T.disabled=!0),E||(T.installed=!0);try{const O=this.extensionsStorageSyncService.getKeysForSync({id:y.id,version:f.version});if(O){const x=t(f.publisher,f.name,this.storageService);T.state=Object.keys(x).reduce((j,H)=>(O.includes(H)&&(j[H]=x[H]),j),{})}}catch(O){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,I.getErrorMessage)(O))}return T})}};i.EXTENSIONS_DATA_URI=m.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([J(0,R.IEnvironmentService),J(1,P.IFileService),J(2,D.IStorageService),J(3,S.IUserDataSyncStoreService),J(4,S.IUserDataSyncBackupStoreService),J(5,k.IExtensionManagementService),J(6,k.IGlobalExtensionEnablementService),J(7,b.IIgnoredExtensionsManagementService),J(8,S.IUserDataSyncLogService),J(9,k.IExtensionGalleryService),J(10,v.IConfigurationService),J(11,S.IUserDataSyncResourceEnablementService),J(12,p.ITelemetryService),J(13,g.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let a=class extends n.AbstractInitializer{constructor(o,u,y,E,f){super("extensions",E,f,y);this.extensionManagementService=o,this.ignoredExtensionsManagementService=u}async parseExtensions(o){return o.syncData?await c(o.syncData,this.extensionManagementService):null}generatePreview(o,u){const y=[],E=[],f=[];for(const T of o){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(T.identifier.id))continue;const O=u.find(x=>(0,A.areSameExtensions)(x.identifier,T.identifier));O?(y.push(O),T.disabled&&f.push(T.identifier)):T.installed&&(E.push(T.identifier),T.disabled&&f.push(T.identifier))}return{installedExtensions:y,newExtensions:E,disabledExtensions:f,remoteExtensions:o}}};a=de([J(0,k.IExtensionManagementService),J(1,b.IIgnoredExtensionsManagementService),J(2,P.IFileService),J(3,R.IEnvironmentService),J(4,S.IUserDataSyncLogService)],a),e.AbstractExtensionsInitializer=a}),define(te[189],ne([0,1,26,21]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(P,v,w,n,p){if(!v)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const m=k(P,v);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const d=w?k(w,v):{added:Object.keys(v).reduce((I,g)=>(I.add(g),I),new Set),removed:new Set,updated:new Set},h=w?k(w,P):{added:Object.keys(P).reduce((I,g)=>(I.add(g),I),new Set),removed:new Set,updated:new Set},C={added:{},removed:[],updated:{}},D=S.deepClone(v),b=!w;for(const I of h.added.values())I!==L.SYNC_SERVICE_URL_TYPE&&b&&d.added.has(I)||(D[I]=P[I]);for(const I of h.updated.values())D[I]=P[I];for(const I of h.removed.values())n.unregistered.includes(I)||delete D[I];for(const I of d.added.values()){const g=v[I];if(n.machine.includes(I)){p.info(`GlobalState: Skipped adding ${I} in local storage because it is declared as machine scoped.`);continue}if(w&&h.added.has(I))continue;const s=P[I];s&&s.value===g.value||I===L.SYNC_SERVICE_URL_TYPE&&b&&h.added.has(I)||(s?C.updated[I]=g:C.added[I]=g)}for(const I of d.updated.values()){const g=v[I];if(n.machine.includes(I)){p.info(`GlobalState: Skipped updating ${I} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(I)||h.removed.has(I))continue;const s=P[I];s&&s.value===g.value||(C.updated[I]=g)}for(const I of d.removed.values()){if(n.machine.includes(I)){p.trace(`GlobalState: Skipped removing ${I} in local storage because it is declared as machine scoped.`);continue}h.updated.has(I)||h.removed.has(I)||C.removed.push(I)}return{local:C,remote:A(D,v)?null:D}}e.merge=R;function k(P,v){const w=Object.keys(P),n=Object.keys(v),p=n.filter(h=>w.indexOf(h)===-1).reduce((h,C)=>(h.add(C),h),new Set),m=w.filter(h=>n.indexOf(h)===-1).reduce((h,C)=>(h.add(C),h),new Set),d=new Set;for(const h of w){if(m.has(h))continue;const C=P[h],D=v[h];S.equals(C,D)||d.add(h)}return{added:p,removed:m,updated:d}}function A(P,v){const{added:w,removed:n,updated:p}=k(P,v);return w.size===0&&n.size===0&&p.size===0}}),define(te[190],ne([0,1,21,25,3,10,11,52,189,32,45,24,23,5,46,40,20,7,44,30,16]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d,h,C,D,b,I,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const c="globalState.argv.",t=["locale"];function r(u){const y=u.storage?Object.keys(u.storage).sort():[],E={};y.forEach(O=>E[O]=u.storage[O]),u.storage=E;const f=JSON.stringify(u),T=(0,h.format)(f,void 0,{});return(0,C.applyEdits)(f,T)}const i=1;let a=class ot extends n.AbstractSynchroniser{constructor(y,E,f,T,O,x,j,H,V){super("globalState",y,O,V,E,f,x,j,T,H);this.storageService=V,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(y.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(R.Event.any(R.Event.filter(y.onDidFilesChange,N=>N.contains(this.environmentService.argvResource)),R.Event.filter(V.onDidChangeValue,N=>N.scope===0&&N.target!==void 0?N.target===0:V.keys(0,0).includes(N.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(y,E,f,T){const O=y.syncData?JSON.parse(y.syncData.content):null;E=E===null&&f?y:E;const x=E&&E.syncData?JSON.parse(E.syncData.content):null,j=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const H=this.getStorageKeys(x),{local:V,remote:N}=(0,v.merge)(j.storage,O?O.storage:null,x?x.storage:null,H,this.logService),_={content:null,local:V,remote:N,localChange:Object.keys(V.added).length>0||Object.keys(V.updated).length>0||V.removed.length>0?2:0,remoteChange:N!==null?2:0};return[{localResource:this.localResource,localContent:r(j),localUserData:j,remoteResource:this.remoteResource,remoteContent:O?r(O):null,previewResource:this.previewResource,previewResult:_,localChange:_.localChange,remoteChange:_.remoteChange,acceptedResource:this.acceptedResource,storageKeys:H}]}async getMergeResult(y,E){return{...y.previewResult,hasConflicts:!1}}async getAcceptResult(y,E,f,T){if(this.extUri.isEqual(E,this.localResource))return this.acceptLocal(y);if(this.extUri.isEqual(E,this.remoteResource))return this.acceptRemote(y);if(this.extUri.isEqual(E,this.previewResource))return y.previewResult;throw new Error(`Invalid Resource: ${E.toString()}`)}async acceptLocal(y){return{content:y.localContent,local:{added:{},removed:[],updated:{}},remote:y.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(y){if(y.remoteContent!==null){const E=JSON.parse(y.remoteContent),{local:f,remote:T}=(0,v.merge)(y.localUserData.storage,E.storage,null,y.storageKeys,this.logService);return{content:y.remoteContent,local:f,remote:T,localChange:Object.keys(f.added).length>0||Object.keys(f.updated).length>0||f.removed.length>0?2:0,remoteChange:T!==null?2:0}}else return{content:y.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(y,E,f,T){let{localUserData:O}=f[0][0],{local:x,remote:j,localChange:H,remoteChange:V}=f[0][1];if(H===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),H!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(O)),await this.writeLocalGlobalState(x),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),V!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const N=JSON.stringify({storage:j});y=await this.updateRemoteUserData(N,T?null:y.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}E?.ref!==y.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(y),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:y}){return[{resource:this.extUri.joinPath(y,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(y){if(this.extUri.isEqual(y,ot.GLOBAL_STATE_DATA_URI)){const f=await this.getLocalGlobalState();return r(f)}if(this.extUri.isEqual(this.remoteResource,y)||this.extUri.isEqual(this.localResource,y)||this.extUri.isEqual(this.acceptedResource,y))return this.resolvePreviewContent(y);let E=await super.resolveContent(y);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(y)),E){const f=this.parseSyncData(E);if(f)switch(this.extUri.basename(y)){case"globalState.json":return r(JSON.parse(f.content))}}return null}async hasLocalData(){try{const{storage:y}=await this.getLocalGlobalState();if(Object.keys(y).length>1||y[`${c}.locale`]?.value!=="en")return!0}catch(y){}return!1}async getLocalGlobalState(){const y={},E=await this.getLocalArgvContent(),f=(0,w.parse)(E);for(const T of t)f[T]!==void 0&&(y[`${c}${T}`]={version:1,value:f[T]});for(const T of this.storageService.keys(0,0)){const O=this.storageService.get(T,0);O&&(y[T]={version:1,value:O})}return{storage:y}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(y){}return"{}"}async writeLocalGlobalState({added:y,removed:E,updated:f}){const T={},O={},x=(H,V)=>{for(const N of H){if(N.startsWith(c)){T[N.substring(c.length)]=V?V[N].value:void 0;continue}if(V){const _=V[N];_.value!==String(this.storageService.get(N,0))&&(O[N]=_.value)}else this.storageService.get(N,0)!==void 0&&(O[N]=void 0)}};if(x(Object.keys(y),y),x(Object.keys(f),f),x(E),Object.keys(T).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(T),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(O).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const H of Object.keys(O))this.storageService.store(H,O[H],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(O))}}async updateArgv(y){const E=await this.getLocalArgvContent();let f=E;for(const T of Object.keys(y))f=(0,P.edit)(f,[T],y[T],{});E!==f&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(f)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(y){const E=this.storageService.keys(0,0),f=this.storageService.keys(0,1),T=[...E,...f],O=y?.storage?Object.keys(y.storage).filter(x=>!x.startsWith(c)&&!T.includes(x)&&this.storageService.get(x,0)!==void 0):[];if(!b.isWeb){const x=[...S.ALL_SYNC_RESOURCES.map(j=>(0,S.getEnablementKey)(j)),S.SYNC_SERVICE_URL_TYPE];O.push(...x),f.push(...x)}return{user:E,machine:f,unregistered:O}}};a.GLOBAL_STATE_DATA_URI=d.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),a=de([J(0,A.IFileService),J(1,S.IUserDataSyncStoreService),J(2,S.IUserDataSyncBackupStoreService),J(3,S.IUserDataSyncLogService),J(4,k.IEnvironmentService),J(5,S.IUserDataSyncResourceEnablementService),J(6,p.ITelemetryService),J(7,m.IConfigurationService),J(8,D.IStorageService)],a),e.GlobalStateSynchroniser=a;let l=class extends n.AbstractInitializer{constructor(y,E,f,T){super("globalState",f,T,E);this.storageService=y}async doInitialize(y){const E=y.syncData?JSON.parse(y.syncData.content):null;if(!E){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const f={},T={};for(const O of Object.keys(E.storage))O.startsWith(c)?f[O.substring(c.length)]=E.storage[O].value:this.storageService.get(O,0)===void 0&&(T[O]=E.storage[O].value);if(Object.keys(f).length){let O="{}";try{O=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(x){}for(const x of Object.keys(f))O=(0,P.edit)(O,[x],f[x],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(O))}if(Object.keys(T).length)for(const O of Object.keys(T))this.storageService.store(O,T[O],0,0)}};l=de([J(0,D.IStorageService),J(1,A.IFileService),J(2,k.IEnvironmentService),J(3,S.IUserDataSyncLogService)],l),e.GlobalStateInitializer=l;let o=class{constructor(y,E,f,T,O){this.userDataSyncStoreClient=y,this.storageService=E,this.environmentService=f,this.fileService=T,this.logService=O}getSyncStoreType(y){return this.parseGlobalState(y)?.storage[S.SYNC_SERVICE_URL_TYPE]?.value}async sync(y){const E=(0,S.createSyncHeaders)((0,g.generateUuid)());try{return await this.doSync(y,E)}catch(f){if(f instanceof S.UserDataSyncError)switch(f.code){case S.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(y,E)}throw f}}async doSync(y,E){const f=await this.userDataSyncStoreClient.read("globalState",null,E),T=this.parseGlobalState(f)||{storage:{}};T.storage[S.SYNC_SERVICE_URL_TYPE]={value:y,version:i};const O=await(0,I.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),x={version:i,machineId:O,content:r(T)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(x),f.ref,E)}parseGlobalState({content:y}){if(!y)return null;const E=JSON.parse(y);if((0,n.isSyncData)(E))return E?JSON.parse(E.content):null;throw new Error("Invalid remote data")}};o=de([J(1,D.IStorageService),J(2,k.IEnvironmentService),J(3,A.IFileService),J(4,s.ILogService)],o),e.UserDataSyncStoreTypeSynchronizer=o}),define(te[191],ne([0,1,11,21,186,32,124,10,23,7,14,22,45,24,20,25,3]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d,h,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function b(s,c){const t=JSON.parse(s);if(!c)return(0,n.isUndefined)(t.all)?null:t.all;switch(w.OS){case 2:return(0,n.isUndefined)(t.mac)?null:t.mac;case 3:return(0,n.isUndefined)(t.linux)?null:t.linux;case 1:return(0,n.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=b;let I=class extends m.AbstractJsonFileSynchroniser{constructor(c,t,r,i,a,l,o,u,y,E){super(o.keybindingsResource,"keybindings",l,o,u,c,t,a,E,r,y,i);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(i.onDidChangeConfiguration,f=>f.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(c,t,r,i){const a=c.syncData?this.getKeybindingsContentFromSyncContent(c.syncData.content):null;t=t===null&&r?c:t;const l=t?this.getKeybindingsContentFromLastSyncUserData(t):null,o=await this.getLocalFileContent(),u=await this.getFormattingOptions();let y=null,E=!1,f=!1,T=!1;if(a){let x=o?o.value.toString():"[]";if(x=x||"[]",this.hasErrors(x))throw new L.UserDataSyncError((0,A.localize)(0,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!l||l!==x||l!==a){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const j=await(0,R.merge)(x,a,l,u,this.userDataSyncUtilService);j.hasChanges&&(y=j.mergeContent,T=j.hasConflicts,E=T||j.mergeContent!==x,f=T||j.mergeContent!==a)}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),y=o.value.toString(),f=!0);const O={content:y,localChange:E?o?2:1:0,remoteChange:f?2:0,hasConflicts:T};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:O.localChange,remoteResource:this.remoteResource,remoteContent:a,remoteChange:O.remoteChange,previewResource:this.previewResource,previewResult:O,acceptedResource:this.acceptedResource}]}async getMergeResult(c,t){return c.previewResult}async getAcceptResult(c,t,r,i){if(this.extUri.isEqual(t,this.localResource))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(c,t,r,i){const{fileContent:a}=r[0][0];let{content:l,localChange:o,remoteChange:u}=r[0][1];if(o===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.hasErrors(l)))throw new L.UserDataSyncError((0,A.localize)(1,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),a&&await this.backupLocal(this.toSyncContent(a.value.toString())),await this.updateLocalFileContent(l||"[]",a,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const y=this.toSyncContent(l||"[]",c.syncData?.content);c=await this.updateRemoteUserData(y,i?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(y){}t?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(c,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const c=await this.getLocalFileContent();if(c){const t=(0,k.parse)(c.value.toString());if((0,p.isNonEmptyArray)(t))return!0}}catch(c){if(c.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:c}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(c,"keybindings.json"),comparableResource:t}]}async resolveContent(c){if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let t=await super.resolveContent(c);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(c)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(c)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(c){return!c.syncData||c.platformSpecific!==void 0&&c.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(c.syncData.content)}getKeybindingsContentFromSyncContent(c){try{return b(c,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(c,t){let r={};try{r=JSON.parse(t||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=c,w.OS){case 2:r.mac=c;break;case 3:r.linux=c;break;case 1:r.windows=c;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){let c=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return c!==void 0||(c=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,c!==void 0)?c:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};I=de([J(0,L.IUserDataSyncStoreService),J(1,L.IUserDataSyncBackupStoreService),J(2,L.IUserDataSyncLogService),J(3,v.IConfigurationService),J(4,L.IUserDataSyncResourceEnablementService),J(5,S.IFileService),J(6,P.IEnvironmentService),J(7,h.IStorageService),J(8,L.IUserDataSyncUtilService),J(9,d.ITelemetryService)],I),e.KeybindingsSynchroniser=I;let g=class extends m.AbstractInitializer{constructor(c,t,r){super("keybindings",t,r,c)}async doInitialize(c){const t=c.syncData?this.getKeybindingsContentFromSyncContent(c.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,C.VSBuffer.fromString(t)),await this.updateLastSyncUserData(c)}async isEmpty(){try{const c=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,k.parse)(c.value.toString());return!(0,p.isNonEmptyArray)(t)}catch(c){return c.fileOperationResult===1}}getKeybindingsContentFromSyncContent(c){try{return b(c,!0)}catch(t){return this.logService.error(t),null}}};g=de([J(0,S.IFileService),J(1,P.IEnvironmentService),J(2,L.IUserDataSyncLogService)],g),e.KeybindingsInitializer=g}),define(te[192],ne([0,1,26,32,40,46,52,21,22]),function(Y,e,S,L,R,k,A,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function w(o,u,y){let E=[];y?E=p(y):E=n(u);const f=[],T=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(E))for(const O of E)O.startsWith("-")?T.push(O.substring(1)):f.push(O);return(0,v.distinct)([...o,...f].filter(O=>T.indexOf(O)===-1))}e.getIgnoredSettings=w;function n(o){let u=o.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=o.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:o.getValue("settingsSync.ignoredSettings")||[]}function p(o){const u=(0,L.parse)(o);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function m(o,u,y,E){if(y.length){const f=l(u),T=(0,L.parse)(u),O=(0,L.parse)(o),x=[];for(const j of y){const H=T[j],V=O[j];H===void 0?o=A.edit(o,[j],void 0,E):V!==void 0?o=A.edit(o,[j],H,E):x.push(c(j,f))}x.sort((j,H)=>j.startOffset-H.startOffset),x.forEach(j=>o=b(j.setting.key,u,o,E))}return o}e.updateIgnoredSettings=m;function d(o,u,y,E,f,T){const O=m(o,u,E,T),x=y!==O,j=y!==u;if(!x&&!j)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(x&&!j)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(j&&!x)return{conflictsSettings:[],localContent:m(u,o,E,T),remoteContent:null,hasConflicts:!1};if(y===null&&C(o)){const ee=h(o,u,E)?null:m(u,o,E,T);return{conflictsSettings:[],localContent:ee,remoteContent:null,hasConflicts:!1}}let H=o,V=u;const N=(0,L.parse)(o),_=(0,L.parse)(u),M=y?(0,L.parse)(y):null,B=E.reduce((ee,se)=>(ee.add(se),ee),new Set),F=D(N,_,B),U=D(M,N,B),z=D(M,_,B),W=new Map,K=new Set,$=ee=>{K.add(ee);const se=f.filter(({key:ue})=>ue===ee)[0];se?(H=A.edit(H,[ee],se.value,T),V=A.edit(V,[ee],se.value,T)):W.set(ee,{key:ee,localValue:N[ee],remoteValue:_[ee]})};for(const ee of U.removed.values())z.updated.has(ee)?$(ee):V=A.edit(V,[ee],void 0,T);for(const ee of z.removed.values())K.has(ee)||(U.updated.has(ee)?$(ee):H=A.edit(H,[ee],void 0,T));for(const ee of U.updated.values())K.has(ee)||(z.updated.has(ee)?F.updated.has(ee)&&$(ee):V=A.edit(V,[ee],N[ee],T));for(const ee of z.updated.values())K.has(ee)||(U.updated.has(ee)?F.updated.has(ee)&&$(ee):H=A.edit(H,[ee],_[ee],T));for(const ee of U.added.values())K.has(ee)||(z.added.has(ee)?F.updated.has(ee)&&$(ee):V=b(ee,H,V,T));for(const ee of z.added.values())K.has(ee)||(U.added.has(ee)?F.updated.has(ee)&&$(ee):H=b(ee,V,H,T));const G=W.size>0||!h(H,V,E),X=G||!h(H,o,[]),Z=G||!h(V,u,[]);return{localContent:X?H:null,remoteContent:Z?V:null,conflictsSettings:[...W.values()],hasConflicts:G}}e.merge=d;function h(o,u,y){if(o===u)return!0;const E=(0,L.parse)(o),f=(0,L.parse)(u),T=y.reduce((j,H)=>(j.add(H),j),new Set),O=l(o).filter(j=>!(j.setting&&T.has(j.setting.key))),x=l(u).filter(j=>!(j.setting&&T.has(j.setting.key)));if(O.length!==x.length)return!1;for(let j=0;j<O.length;j++){const H=O[j],V=x[j];if(H.setting&&V.setting){if(H.setting.key!==V.setting.key||!S.equals(E[H.setting.key],f[H.setting.key]))return!1}else if(!H.setting&&!V.setting){if(H.value!==V.value)return!1}else return!1}return!0}e.areSame=h;function C(o){return o?l(o).length===0:!0}e.isEmpty=C;function D(o,u,y){const E=o?Object.keys(o).filter(j=>!y.has(j)):[],f=Object.keys(u).filter(j=>!y.has(j)),T=f.filter(j=>E.indexOf(j)===-1).reduce((j,H)=>(j.add(H),j),new Set),O=E.filter(j=>f.indexOf(j)===-1).reduce((j,H)=>(j.add(H),j),new Set),x=new Set;if(o)for(const j of E){if(O.has(j))continue;const H=o[j],V=u[j];S.equals(H,V)||x.add(j)}return{added:T,removed:O,updated:x}}function b(o,u,y,E){const f=(0,L.parse)(u),T=l(u),O=l(y),x=I(o,T,O);return g(y,o,f[o],x,O,E)}e.addSetting=b;function I(o,u,y){const E=u.findIndex(T=>T.setting?.key===o),f=u[E-1];if(f){if(f.setting){const O=c(f.setting.key,y);if(O)return{index:y.indexOf(O),insertAfter:!0}}else{const O=t(E,u);if(O){const x=c(O.setting.key,y);if(x){const j=r(y.indexOf(x),y),H=i(u,O,u[E]);if(j){const V=i(y,x,j),N=a(H,V);return N?{index:y.indexOf(N),insertAfter:!0}:{index:y.indexOf(j),insertAfter:!1}}else{const V=i(y,x,y[y.length-1]),N=a(H,V);return N?{index:y.indexOf(N),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const T=u[E+1];if(T)if(T.setting){const O=c(T.setting.key,y);if(O)return{index:y.indexOf(O),insertAfter:!1}}else{const O=r(E,u);if(O){const x=c(O.setting.key,y);if(x){const j=t(y.indexOf(x),y),H=i(u,u[E],O);if(j){const V=i(y,j,x),N=a(H.reverse(),V.reverse());return N?{index:y.indexOf(N),insertAfter:!1}:{index:y.indexOf(j),insertAfter:!0}}else{const V=i(y,y[0],x),N=a(H.reverse(),V.reverse());return N?{index:y.indexOf(N),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function g(o,u,y,E,f,T){let O;return E.index===-1?O=(0,R.setProperty)(o,[u],y,T):O=s(o,u,y,E,f,T).map(x=>(0,R.withFormatting)(o,x,T)[0]),(0,R.applyEdits)(o,O)}function s(o,u,y,E,f,T){const O=`${JSON.stringify(u)}: ${JSON.stringify(y)}`,x=(0,k.getEOL)(T,o),j=f[E.index];if(E.insertAfter){const H=[];if(j.setting)H.push({offset:j.endOffset,length:0,content:","+O});else{const V=r(E.index,f),N=t(E.index,f),_=N?.setting?.commaOffset;N&&_===void 0&&H.push({offset:N.endOffset,length:0,content:","});const M=_!==void 0&&_>j.endOffset;H.push({offset:M?_+1:j.endOffset,length:0,content:V?x+O+",":x+O})}return H}else{if(j.setting)return[{offset:j.startOffset,length:0,content:O+","}];const H=(f[E.index-1]&&!f[E.index-1].setting?x:"")+O+(r(E.index,f)?",":"")+x;return[{offset:j.startOffset,length:0,content:H}]}}function c(o,u){return u.filter(y=>y.setting?.key===o)[0]}function t(o,u){for(let y=o-1;y>=0;y--)if(u[y].setting)return u[y]}function r(o,u){for(let y=o+1;y<u.length;y++)if(u[y].setting)return u[y]}function i(o,u,y){const E=o.indexOf(u),f=o.indexOf(y);return o.filter((T,O)=>E<O&&O<f)}function a(o,u){if(o.length&&u.length){let y=0;for(;y<u.length&&y<o.length;y++)if(o[y].value!==u[y].value)return u[y-1];return u[y-1]}}function l(o){const u=[];let y=-1,E,f;const T={onObjectBegin:O=>{y++},onObjectProperty:(O,x,j)=>{y===0&&(E=x,f=O)},onObjectEnd:(O,x)=>{y--,y===0&&u.push({startOffset:E,endOffset:O+x,value:o.substring(E,O+x),setting:{key:f,commaOffset:void 0}})},onArrayBegin:(O,x)=>{y++},onArrayEnd:(O,x)=>{y--,y===0&&u.push({startOffset:E,endOffset:O+x,value:o.substring(E,O+x),setting:{key:f,commaOffset:void 0}})},onLiteralValue:(O,x,j)=>{y===0&&u.push({startOffset:E,endOffset:x+j,value:o.substring(E,x+j),setting:{key:f,commaOffset:void 0}})},onSeparator:(O,x,j)=>{if(y===0&&O===","){let H=u.length-1;for(;H>=0&&!u[H].setting;H--);const V=u[H];V&&u.splice(H,1,{startOffset:V.startOffset,endOffset:V.endOffset,value:V.value,setting:{key:V.setting.key,commaOffset:x}})}},onComment:(O,x)=>{y===0&&u.push({startOffset:O,endOffset:O+x,value:o.substring(O,O+x)})}};return(0,L.visit)(o,T),u}}),define(te[193],ne([0,1,11,21,25,125,3,10,23,192,52,45,24,28,20,40]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function D(c){return c&&c.settings&&typeof c.settings=="string"&&Object.keys(c).length===1}function b(c){const t=JSON.parse(c);return D(t)?t:{settings:c}}e.parseSettingsSyncContent=b;let I=class extends p.AbstractJsonFileSynchroniser{constructor(t,r,i,a,l,o,u,y,E,f,T){super(r.settingsResource,"settings",t,r,i,a,l,E,f,o,u,y);this.extensionManagementService=T,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,i,a){const l=await this.getLocalFileContent(),o=await this.getFormattingOptions(),u=this.getSettingsSyncContent(t);r=r===null&&i?t:r;const y=r?this.getSettingsSyncContent(r):null,E=await this.getIgnoredSettings();let f=null,T=!1,O=!1,x=!1;if(u){let H=l?l.value.toString().trim():"{}";H=H||"{}",this.validateContent(H),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const V=(0,w.merge)(H,u.settings,y?y.settings:null,E,[],o);f=V.localContent||V.remoteContent,T=V.localContent!==null,O=V.remoteContent!==null,x=V.hasConflicts}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),f=l.value.toString(),O=!0);const j={content:f,localChange:T?2:0,remoteChange:O?2:0,hasConflicts:x};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:j.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:j.remoteChange,previewResource:this.previewResource,previewResult:j,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,w.updateIgnoredSettings)(t.previewResult.content,"{}",a,i):null}}async getAcceptResult(t,r,i,a){const l=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,w.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",o,l):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,w.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",o,l):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i!==null?(0,w.updateIgnoredSettings)(i,t.fileContent?t.fileContent.value.toString():"{}",o,l):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,i,a){const{fileContent:l}=i[0][0];let{content:o,localChange:u,remoteChange:y}=i[0][1];if(u===0&&y===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),l&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(l.value.toString()))),await this.updateLocalFileContent(o,l,a),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),y!==0){const E=await this.getFormattingOptions(),f=this.getSettingsSyncContent(t),T=await this.getIgnoredSettings(o);o=(0,w.updateIgnoredSettings)(o,f?f.settings:"{}",T,E),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),a?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(E){}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),i=(0,n.edit)(t.value.toString(),[L.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,w.isEmpty)(i)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i){const a=this.parseSettingsSyncContent(i.content);if(a)switch(this.extUri.basename(t)){case"settings.json":return a.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();r=(0,w.updateIgnoredSettings)(r,"{}",a,i)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,a=>a.some(({local:l})=>!!l)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,a=>!a.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,w.getIgnoredSettings)(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new L.UserDataSyncError((0,k.localize)(0,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!s(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let a=i.settings;const l=await this.getFormattingOptions();for(const o in r)if(["version","content","machineId"].indexOf(o)===-1&&r[o]!==void 0){const u=(0,C.setProperty)(a,[o],r[o],l);u.length&&(a=(0,C.applyEdits)(a,u))}await this.fileService.writeFile(this.file,R.VSBuffer.fromString(a))}catch(t){}}};I=de([J(0,S.IFileService),J(1,P.IEnvironmentService),J(2,h.IStorageService),J(3,L.IUserDataSyncStoreService),J(4,L.IUserDataSyncBackupStoreService),J(5,L.IUserDataSyncLogService),J(6,L.IUserDataSyncUtilService),J(7,v.IConfigurationService),J(8,L.IUserDataSyncResourceEnablementService),J(9,m.ITelemetryService),J(10,d.IExtensionManagementService)],I),e.SettingsSynchroniser=I;let g=class extends p.AbstractInitializer{constructor(t,r,i){super("settings",r,i,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,R.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,w.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}};g=de([J(0,S.IFileService),J(1,P.IEnvironmentService),J(2,L.IUserDataSyncLogService)],g),e.SettingsInitializer=g;function s(c){return!!(c&&c.version!==void 0&&typeof c.version=="number"&&c.content!==void 0&&typeof c.content=="string"&&c.machineId!==void 0&&typeof c.machineId=="string")}}),define(te[194],ne([0,1,21,10,11,23,45,24,25,187,20,26,3]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let d=class extends A.AbstractSynchroniser{constructor(D,b,I,g,s,c,t,r,i){super("snippets",b,D,I,g,s,r,i,c,t);this.version=1,this.snippetsFolder=D.snippetsHome,this._register(this.fileService.watch(D.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(m.Event.filter(this.fileService.onDidFilesChange,a=>a.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(D,b,I,g){const s=await this.getSnippetsFileContents(),c=this.toSnippetsContents(s),t=D.syncData?this.parseSnippets(D.syncData):null;b=b===null&&I?D:b;const r=b&&b.syncData?this.parseSnippets(b.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,w.merge)(c,t,r);return this.getResourcePreviews(i,s,t||{})}async getMergeResult(D,b){return D.previewResult}async getAcceptResult(D,b,I,g){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:D.fileContent?D.fileContent.value.toString():null,localChange:0,remoteChange:D.fileContent?D.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:D.remoteContent,localChange:D.remoteContent!==null?D.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder))return I===void 0?{content:D.previewResult.content,localChange:D.previewResult.localChange,remoteChange:D.previewResult.remoteChange}:{content:I,localChange:I===null?D.fileContent!==null?3:0:2,remoteChange:I===null?D.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async applyResult(D,b,I,g){const s=I.map(([c,t])=>({...c,acceptResult:t}));s.every(({localChange:c,remoteChange:t})=>c===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),s.some(({localChange:c})=>c!==0)&&(await this.updateLocalBackup(s),await this.updateLocalSnippets(s,g)),s.some(({remoteChange:c})=>c!==0)&&(D=await this.updateRemoteSnippets(s,D,g)),b?.ref!==D.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(D),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:c}of s)try{await this.fileService.del(c)}catch(t){}}getResourcePreviews(D,b,I){const g=new Map;for(const s of Object.keys(D.local.added)){const c={content:D.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};g.set(s,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(D.local.updated)){const c={content:D.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0};g.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of D.local.removed){const c={content:null,hasConflicts:!1,localChange:3,remoteChange:0};g.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(D.remote.added)){const c={content:D.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1};g.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(D.remote.updated)){const c={content:D.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2};g.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of D.remote.removed){const c={content:null,hasConflicts:!1,localChange:0,remoteChange:3};g.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of D.conflicts){const c={content:b[s]?b[s].value.toString():null,hasConflicts:!0,localChange:b[s]?2:1,remoteChange:I[s]?2:1};g.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s]||null,localContent:b[s]?b[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(b))if(!g.has(s)){const c={content:b[s]?b[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};g.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s]||null,localContent:b[s]?b[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...g.values()]}async getAssociatedResources({uri:D}){let b=await super.resolveContent(D);if(b){const I=this.parseSyncData(b);if(I){const g=this.parseSnippets(I),s=[];for(const c of Object.keys(g)){const t=this.extUri.joinPath(D,c),r=this.extUri.joinPath(this.snippetsFolder,c),i=await this.fileService.exists(r);s.push({resource:t,comparableResource:i?r:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})})}return s}}return[]}async resolveContent(D){if(this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(D);let b=await super.resolveContent(D);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(D)),b){const I=this.parseSyncData(b);if(I)return this.parseSnippets(I)[this.extUri.basename(D)]||null}return null}async hasLocalData(){try{const D=await this.getSnippetsFileContents();if(Object.keys(D).length)return!0}catch(D){}return!1}async updateLocalBackup(D){const b={};for(const I of D)I.fileContent&&(b[this.extUri.basename(I.localResource)]=I.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(b)))}async updateLocalSnippets(D,b){for(const{fileContent:I,acceptResult:g,localResource:s,remoteResource:c,localChange:t}of D)if(t!==0){const r=c?this.extUri.basename(c):this.extUri.basename(s),i=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(i)),await this.fileService.del(i),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(i))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(i)),await this.fileService.createFile(i,v.VSBuffer.fromString(g.content),{overwrite:b}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(i))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(i)),await this.fileService.writeFile(i,v.VSBuffer.fromString(g.content),b?void 0:I),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(i)))}}async updateRemoteSnippets(D,b,I){const g=b.syncData?this.parseSnippets(b.syncData):{},s=(0,p.deepClone)(g);for(const{acceptResult:c,localResource:t,remoteResource:r,remoteChange:i}of D)if(i!==0){const a=t?this.extUri.basename(t):this.extUri.basename(r);i===3?delete s[a]:s[a]=c.content}return(0,w.areSame)(g,s)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),b=await this.updateRemoteUserData(JSON.stringify(s),I?null:b.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),b}parseSnippets(D){return JSON.parse(D.content)}toSnippetsContents(D){const b={};for(const I of Object.keys(D))b[I]=D[I].value.toString();return b}async getSnippetsFileContents(){const D={};let b;try{b=await this.fileService.resolve(this.snippetsFolder)}catch(I){if(I instanceof R.FileOperationError&&I.fileOperationResult===1)return D;throw I}for(const I of b.children||[]){const g=I.resource,s=this.extUri.extname(g);if(s===".json"||s===".code-snippets"){const c=this.extUri.relativePath(this.snippetsFolder,g),t=await this.fileService.readFile(g);D[c]=t}}return D}};d=de([J(0,L.IEnvironmentService),J(1,R.IFileService),J(2,n.IStorageService),J(3,S.IUserDataSyncStoreService),J(4,S.IUserDataSyncBackupStoreService),J(5,S.IUserDataSyncLogService),J(6,k.IConfigurationService),J(7,S.IUserDataSyncResourceEnablementService),J(8,P.ITelemetryService)],d),e.SnippetsSynchroniser=d;let h=class extends A.AbstractInitializer{constructor(D,b,I){super("snippets",b,I,D)}async doInitialize(D){const b=D.syncData?JSON.parse(D.syncData.content):null;if(!b){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const g of Object.keys(b)){const s=b[g];if(s){const c=this.extUri.joinPath(this.environmentService.snippetsHome,g);await this.fileService.createFile(c,v.VSBuffer.fromString(s)),this.logService.info("Created snippet",this.extUri.basename(c))}}await this.updateLastSyncUserData(D)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(D){return D.fileOperationResult===1}}};h=de([J(0,R.IFileService),J(1,L.IEnvironmentService),J(2,S.IUserDataSyncLogService)],h),e.SnippetsInitializer=h}),define(te[60],ne([0,1,4,3,2,21]),function(Y,e,S,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,S.createDecorator)("IUserDataSyncAccountService");let A=class extends R.Disposable{constructor(v){super();this.userDataSyncStoreService=v,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(v.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(v.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(v){(v&&this._account?v.token!==this._account.token||v.authenticationProviderId!==this._account.authenticationProviderId:v!==this._account)&&(this._account=v,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(v))}};A=de([J(0,k.IUserDataSyncStoreService)],A),e.UserDataSyncAccountService=A}),define(te[195],ne([0,1,2,21,15,23,11,10,55,25,6]),function(Y,e,S,L,R,k,A,P,v,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let p=class extends S.Disposable{constructor(d,h,C,D){super();this.environmentService=d,this.fileService=h,this.configurationService=C,this.logService=D,L.ALL_SYNC_RESOURCES.forEach(b=>this.cleanUpBackup(b))}async getAllRefs(d){const h=(0,R.joinPath)(this.environmentService.userDataSyncHome,d),C=await this.fileService.resolve(h);return C.children?C.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort().reverse().map(b=>({ref:b.name,created:this.getCreationTime(b)})):[]}async resolveContent(d,h){if(!h){const C=await this.getAllRefs(d);C.length&&(h=C[C.length-1].ref)}if(h){const C=(0,R.joinPath)(this.environmentService.userDataSyncHome,d,h);return(await this.fileService.readFile(C)).value.toString()}return null}async backup(d,h){const C=(0,R.joinPath)(this.environmentService.userDataSyncHome,d),D=(0,R.joinPath)(C,`${(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(D,w.VSBuffer.fromString(h))}catch(b){this.logService.error(b)}try{this.cleanUpBackup(d)}catch(b){}}async cleanUpBackup(d){const h=(0,R.joinPath)(this.environmentService.userDataSyncHome,d);try{try{if(!await this.fileService.exists(h))return}catch(D){return}const C=await this.fileService.resolve(h);if(C.children){const D=C.children.filter(s=>s.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(s.name)).sort(),b=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let I=D.filter(s=>Date.now()-this.getCreationTime(s)>b);const g=D.length-I.length;g<10&&(I=I.slice(10-g)),await n.Promises.settled(I.map(async s=>{this.logService.info("Deleting from backup",s.resource.path),await this.fileService.del(s.resource)}))}}catch(C){this.logService.error(C)}}getCreationTime(d){return d.ctime||new Date(parseInt(d.name.substring(0,4)),parseInt(d.name.substring(4,6))-1,parseInt(d.name.substring(6,8)),parseInt(d.name.substring(9,11)),parseInt(d.name.substring(11,13)),parseInt(d.name.substring(13,15))).getTime()}};p=de([J(0,P.IEnvironmentService),J(1,A.IFileService),J(2,k.IConfigurationService),J(3,L.IUserDataSyncLogService)],p),e.UserDataSyncBackupStoreService=p}),define(te[196],ne([0,1,5,2]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(m){this.service=m}listen(m,d){switch(d){case"onError":return this.service.onError}throw new Error(`Event not found: ${d}`)}call(m,d,h){switch(d){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class k{constructor(m){this.service=m}listen(m,d){throw new Error(`Event not found: ${d}`)}call(m,d,h){switch(d){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(S.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class A{constructor(m){this.channel=m}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.channel.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.channel.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=A;class P{constructor(m){this.service=m}listen(m,d){switch(d){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${d}`)}async call(m,d,h){switch(d){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class v{constructor(m){this.service=m}listen(m,d){switch(d){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${d}`)}call(m,d,h){switch(d){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=v;class w{constructor(m){this.service=m}listen(m,d){switch(d){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${d}`)}call(m,d,h){switch(d){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=w;class n extends L.Disposable{constructor(m){super();this.channel=m,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.channel.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(m)}revive(m){return{url:S.URI.revive(m.url),type:m.type,defaultUrl:S.URI.revive(m.defaultUrl),insidersUrl:S.URI.revive(m.insidersUrl),stableUrl:S.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(te[197],ne([0,1,16,10]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends S.AbstractLogger{constructor(A,P){super();this.logger=this._register(A.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...P){this.logger.trace(A,...P)}debug(A,...P){this.logger.debug(A,...P)}info(A,...P){this.logger.info(A,...P)}warn(A,...P){this.logger.warn(A,...P)}error(A,...P){this.logger.error(A,...P)}critical(A,...P){this.logger.critical(A,...P)}flush(){this.logger.flush()}};R=de([J(0,S.ILoggerService),J(1,L.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(te[61],ne([0,1,4,2,44,10,11,20,21,128,27,7,19,3]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let C=class Ge extends L.Disposable{constructor(b,I,g,s,c,t){super();this.storageService=g,this.userDataSyncStoreService=s,this.logService=c,this.productService=t,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,R.getServiceMachineId)(b,I,g)}async getMachines(b){const I=await this.currentMachineIdPromise;return(await this.readMachinesData(b)).machines.map(s=>({...s,isCurrent:s.id===I}))}async addCurrentMachine(b){const I=await this.currentMachineIdPromise,g=await this.readMachinesData(b);g.machines.some(({id:s})=>s===I)||(g.machines.push({id:I,name:this.computeCurrentMachineName(g.machines)}),await this.writeMachinesData(g))}async removeCurrentMachine(b){const I=await this.currentMachineIdPromise,g=await this.readMachinesData(b),s=g.machines.filter(({id:c})=>c!==I);s.length!==g.machines.length&&(g.machines=s,await this.writeMachinesData(g))}async renameMachine(b,I,g){const s=await this.currentMachineIdPromise,c=await this.readMachinesData(g),t=c.machines.find(({id:r})=>r===b);t&&(t.name=I,await this.writeMachinesData(c),c.machines.some(({id:r})=>r===s)&&this.storageService.store(h,I,0,1))}async setEnablement(b,I){const g=await this.readMachinesData(),s=g.machines.find(({id:c})=>c===b);s&&(s.disabled=I?void 0:!0,await this.writeMachinesData(g))}computeCurrentMachineName(b){const I=this.storageService.get(h,0);if(I)return I;const g=`${this.productService.nameLong} (${(0,p.PlatformToString)(p.isWeb?0:p.platform)})`,s=new RegExp(`${(0,m.escapeRegExpCharacters)(g)}\\s#(\\d+)`);let c=0;for(const t of b){const r=s.exec(t.name),i=r?parseInt(r[1]):0;c=i>c?i:c}return`${g} #${c+1}`}async readMachinesData(b){this.userData=await this.readUserData(b);const I=this.parse(this.userData);if(I.version!==Ge.VERSION)throw new Error((0,w.localize)(0,null,this.productService.nameLong));return I}async writeMachinesData(b){const I=JSON.stringify(b),g=await this.userDataSyncStoreService.write(Ge.RESOURCE,I,this.userData?.ref||null);this.userData={ref:g,content:I},this._onDidChange.fire()}async readUserData(b){if(this.userData){const I=b&&b.latest?b.latest[Ge.RESOURCE]:void 0;if(this.userData.ref===I)return this.userData;if(I===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ge.RESOURCE,this.userData)}parse(b){if(b.content!==null)try{return JSON.parse(b.content)}catch(I){this.logService.error(I)}return{version:Ge.VERSION,machines:[]}}};C.VERSION=1,C.RESOURCE="machines",C=de([J(0,k.IEnvironmentService),J(1,A.IFileService),J(2,P.IStorageService),J(3,v.IUserDataSyncStoreService),J(4,v.IUserDataSyncLogService),J(5,n.IProductService)],C),e.UserDataSyncMachinesService=C}),define(te[86],ne([0,1,6,3,2,21,60,24,9,20,10,61,126,55,5,15,7,27]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d,h,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const I="sync.enable",g="sync.disableMachineEventually",s="sync.sessionId",c="sync.storeUrl",t="sync.productQuality";let r=class extends R.Disposable{constructor(o,u,y){super();this.storageService=o,this.environmentService=u,this.userDataSyncStoreManagementService=y,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(o.onDidChangeValue(E=>this.onDidStorageChange(E)))}isEnabled(o){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(I,0,!!o)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(o){o&&!this.canToggleEnablement()||this.storageService.store(I,o,0,1)}onDidStorageChange(o){if(o.scope===0&&I===o.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};r=de([J(0,w.IStorageService),J(1,n.IEnvironmentService),J(2,k.IUserDataSyncStoreManagementService)],r),e.UserDataAutoSyncEnablementService=r;let i=class extends R.Disposable{constructor(o,u,y,E,f,T,O,x,j,H,V){super();this.userDataSyncStoreManagementService=u,this.userDataSyncStoreService=y,this.userDataSyncResourceEnablementService=E,this.userDataSyncService=f,this.logService=T,this.userDataSyncAccountService=O,this.telemetryService=x,this.userDataSyncMachinesService=j,this.storageService=H,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=V,this.syncTriggerDelayer=this._register(new S.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=u.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=o.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(u.onDidChangeUserDataSyncStore(()=>{(0,C.isEqual)(this.syncUrl,u.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=u.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(O.onDidChangeAccount(()=>this.updateAutoSync())),this._register(y.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(L.Event.debounce(f.onDidChangeLocal,(N,_)=>N?[...N,_]:[_],1e3)(N=>this.triggerSync(N,!1,!1))),this._register(L.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,N])=>N)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const o=this.storageService.get(c,0);return o?h.URI.parse(o):void 0}set syncUrl(o){o?this.storageService.store(c,o.toString(),0,1):this.storageService.remove(c,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(o){o?this.storageService.store(t,o,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:o,message:u}=this.isAutoSyncEnabled();o?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(y=>this.onDidFinishSync(y))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(u&&this.logService.info(u),this.autoSync.clear()):u&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(u))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,d.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(o,u,y){try{this.userDataSyncAccountService.account&&!y&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(s,0),o?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(E){if(u)this.logService.error(E),this.updateEnablement(!1);else throw E}}updateEnablement(o){this.userDataAutoSyncEnablementService.isEnabled()!==o&&(this.telemetryService.publicLog2(I,{enabled:o}),this.userDataAutoSyncEnablementService.setEnablement(o),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(o){if(!o){this.successiveFailures=0;return}const u=k.UserDataSyncError.toUserDataSyncError(o);u instanceof k.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:u.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),u.code===k.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):u.code===k.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):u.code===k.UserDataSyncErrorCode.LocalTooManyRequests||u.code===k.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):u.code===k.UserDataSyncErrorCode.UpgradeRequired||u.code===k.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):u.code===k.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${u.resource} content with newer version than of client. Requires client upgrade.`)):u.code===k.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${u.resource} content with older version than of client. Requires server reset.`)):u.code===k.UserDataSyncErrorCode.ServiceChanged||u.code===k.UserDataSyncErrorCode.DefaultServiceChanged?D.isWeb&&u.code===k.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(u),this.successiveFailures++),this._onError.fire(u)}async disableMachineEventually(){this.storageService.store(g,!0,0,1),await(0,S.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(g,0,!1)}stopDisableMachineEventually(){this.storageService.remove(g,0)}async triggerSync(o,u,y){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(u&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...o),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",y)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};i=de([J(0,b.IProductService),J(1,k.IUserDataSyncStoreManagementService),J(2,k.IUserDataSyncStoreService),J(3,k.IUserDataSyncResourceEnablementService),J(4,k.IUserDataSyncService),J(5,k.IUserDataSyncLogService),J(6,A.IUserDataSyncAccountService),J(7,P.ITelemetryService),J(8,p.IUserDataSyncMachinesService),J(9,w.IStorageService),J(10,k.IUserDataAutoSyncEnablementService)],i),e.UserDataAutoSyncService=i;class a extends R.Disposable{constructor(o,u,y,E,f,T,O,x){super();this.lastSyncUrl=o,this.interval=u,this.userDataSyncStoreManagementService=y,this.userDataSyncStoreService=E,this.userDataSyncService=f,this.userDataSyncMachinesService=T,this.logService=O,this.storageService=x,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new L.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new L.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,S.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(o,u){const y=(0,S.createCancelablePromise)(async E=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(f){if((0,v.isPromiseCanceledError)(f))return}return this.doSync(o,u,E)});return this.syncPromise=y,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const o=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),u=this.userDataSyncStoreManagementService.userDataSyncStore;return!!u&&!!o&&(!(0,C.isEqual)(u.defaultUrl,o.defaultUrl)||!(0,C.isEqual)(u.insidersUrl,o.insidersUrl)||!(0,C.isEqual)(u.stableUrl,o.stableUrl))}async doSync(o,u,y){this.logService.info(`Auto Sync: Triggered by ${o}`),this._onDidStartSync.fire();let E;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(u),y.isCancellationRequested)return;let f=this.syncTask.manifest;if(f===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new k.UserDataAutoSyncError((0,m.localize)(0,null),k.UserDataSyncErrorCode.DefaultServiceChanged):new k.UserDataAutoSyncError((0,m.localize)(1,null),k.UserDataSyncErrorCode.ServiceChanged):new k.UserDataAutoSyncError((0,m.localize)(2,null),k.UserDataSyncErrorCode.TurnedOff);const T=this.storageService.get(s,0);if(T&&f&&T!==f.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new k.UserDataAutoSyncError((0,m.localize)(3,null),k.UserDataSyncErrorCode.DefaultServiceChanged):new k.UserDataAutoSyncError((0,m.localize)(4,null),k.UserDataSyncErrorCode.ServiceChanged):new k.UserDataAutoSyncError((0,m.localize)(5,null),k.UserDataSyncErrorCode.SessionExpired);const O=await this.userDataSyncMachinesService.getMachines(f||void 0);if(y.isCancellationRequested)return;const x=O.find(j=>j.isCurrent);if(x?.disabled)throw new k.UserDataAutoSyncError((0,m.localize)(6,null),k.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),f===null&&(f=await this.userDataSyncStoreService.manifest()),f&&f.session!==T&&this.storageService.store(s,f.session,0,1),y.isCancellationRequested)return;x||await this.userDataSyncMachinesService.addCurrentMachine(f||void 0)}catch(f){this.logService.error(f),E=f}this._onDidFinishSync.fire(E)}register(o){return super._register(o)}}a.INTERVAL_SYNCING="Interval"}),define(te[198],ne([0,1,21,2,3,20,24,7]),function(Y,e,S,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let v=class extends L.Disposable{constructor(n,p){super();this.storageService=n,this.telemetryService=p,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(m=>this.onDidStorageChange(m)))}isResourceEnabled(n){return this.storageService.getBoolean((0,S.getEnablementKey)(n),0,!0)}setResourceEnablement(n,p){if(this.isResourceEnabled(n)!==p){const m=(0,S.getEnablementKey)(n);this.telemetryService.publicLog2(m,{enabled:p}),this.storeResourceEnablement(m,p)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,p){this.storageService.store(n,p,0,P.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const p=S.ALL_SYNC_RESOURCES.filter(m=>(0,S.getEnablementKey)(m)===n.key)[0];if(p){this._onDidChangeResourceEnablement.fire([p,this.isResourceEnabled(p)]);return}}}};v=de([J(0,k.IStorageService),J(1,A.ITelemetryService)],v),e.UserDataSyncResourceEnablementService=v}),define(te[199],ne([0,1,21,2,4,3,188,191,190,43,24,22,20,193,15,194,30,6,9]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d,h,C,D,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const g="sync.lastSyncTime";let s=class extends L.Disposable{constructor(i,a,l,o,u,y){super();this.userDataSyncStoreService=i,this.userDataSyncStoreManagementService=a,this.instantiationService=l,this.logService=o,this.telemetryService=u,this.storageService=y,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(d.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(P.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(C.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(v.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(A.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(k.Event.any(...this.synchronisers.map(E=>k.Event.map(E.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(k.Event.any(...this.synchronisers.map(E=>k.Event.map(E.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(g,0,void 0),this.onDidChangeLocal=k.Event.any(...this.synchronisers.map(E=>k.Event.map(E.onDidChangeLocal,()=>E.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(i){await this.checkEnablement();const a=(0,D.generateUuid)();let l;try{const E=(0,S.createSyncHeaders)(a);i&&(E["Cache-Control"]="no-cache"),l=await this.userDataSyncStoreService.manifest(E)}catch(E){const f=S.UserDataSyncError.toUserDataSyncError(E);throw this.reportUserDataSyncError(f,a),f}let o=!1;const u=this;let y;return{manifest:l,run(){if(o)throw new Error("Can run a task only once");return y=(0,b.createCancelablePromise)(E=>u.sync(l,a,E)),y.finally(()=>y=void 0)},async stop(){if(y&&y.cancel(),u.status!=="idle")return u.stop()}}}async createManualSyncTask(){await this.checkEnablement();const i=(0,D.generateUuid)(),a=(0,S.createSyncHeaders)(i);let l;try{l=await this.userDataSyncStoreService.manifest(a)}catch(o){const u=S.UserDataSyncError.toUserDataSyncError(o);throw this.reportUserDataSyncError(u,i),u}return new c(i,l,a,this.synchronisers,this.logService)}async sync(i,a,l){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),l.isCancellationRequested)return;const o=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const u=(0,S.createSyncHeaders)(a);for(const y of this.synchronisers){if(l.isCancellationRequested)return;try{await y.sync(i,u)}catch(E){if(E instanceof S.UserDataSyncError)switch(E.code){case S.UserDataSyncErrorCode.TooLarge:throw new S.UserDataSyncError(E.message,E.code,y.resource);case S.UserDataSyncErrorCode.TooManyRequests:case S.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case S.UserDataSyncErrorCode.LocalTooManyRequests:case S.UserDataSyncErrorCode.Gone:case S.UserDataSyncErrorCode.UpgradeRequired:case S.UserDataSyncErrorCode.IncompatibleRemoteContent:case S.UserDataSyncErrorCode.IncompatibleLocalContent:throw E}const f=S.UserDataSyncError.toUserDataSyncError(E);this.reportUserDataSyncError(f,a),this.logService.error(E),this.logService.error(`${y.resource}: ${(0,w.toErrorMessage)(E)}`),this._syncErrors.push([y.resource,f])}}this.logService.info(`Sync done. Took ${new Date().getTime()-o}ms`),this.updateLastSyncTime()}catch(u){const y=S.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(y,a),y}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const i of this.synchronisers)try{i.status!=="idle"&&await i.stop()}catch(a){this.logService.error(a)}}async replace(i){await this.checkEnablement();for(const a of this.synchronisers)if(await a.replace(i))return}async accept(i,a,l,o){await this.checkEnablement();const u=this.getSynchroniser(i);await u.accept(a,l),o&&await u.apply(!1,(0,S.createSyncHeaders)((0,D.generateUuid)()))}async resolveContent(i){for(const a of this.synchronisers){const l=await a.resolveContent(i);if(l)return l}return null}getRemoteSyncResourceHandles(i){return this.getSynchroniser(i).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(i){return this.getSynchroniser(i).getLocalSyncResourceHandles()}getAssociatedResources(i,a){return this.getSynchroniser(i).getAssociatedResources(a)}getMachineId(i,a){return this.getSynchroniser(i).getMachineId(a)}async hasLocalData(){const i=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const a of i)if(await a.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(i){this.logService.error(i)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(g,0);for(const i of this.synchronisers)try{await i.resetLocal()}catch(a){this.logService.error(`${i.resource}: ${(0,w.toErrorMessage)(a)}`),this.logService.error(a)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const i of this.synchronisers)if(await i.hasPreviouslySynced())return!0;return!1}setStatus(i){const a=this._status;this._status!==i&&(this._status=i,this._onDidChangeStatus.fire(i),a==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const i=this.computeStatus();this.setStatus(i)}updateConflicts(){const i=this.computeConflicts();(0,p.equals)(this._conflicts,i,([a,l],[o,u])=>a===a&&(0,p.equals)(l,u,(y,E)=>(0,h.isEqual)(y.previewResource,E.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(i))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(g,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(i,a){this.telemetryService.publicLog2("sync/error",{code:i.code,url:i instanceof S.UserDataSyncStoreError?i.url:void 0,resource:i.resource,executionId:a,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(i=>i.status==="hasConflicts").map(i=>[i.resource,i.conflicts.map(t)])}getSynchroniser(i){return this.synchronisers.find(a=>a.resource===i)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};s=de([J(0,S.IUserDataSyncStoreService),J(1,S.IUserDataSyncStoreManagementService),J(2,R.IInstantiationService),J(3,S.IUserDataSyncLogService),J(4,n.ITelemetryService),J(5,m.IStorageService)],s),e.UserDataSyncService=s;class c extends L.Disposable{constructor(i,a,l,o,u){super();this.id=i,this.manifest=a,this.syncHeaders=l,this.synchronisers=o,this.logService=u,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new k.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,b.createCancelablePromise)(i=>this.getPreviews(i))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(i){throw this.logService.error(i),i}}async accept(i,a){try{return await this.performAction(i,l=>l.accept(i,a))}catch(l){throw this.logService.error(l),l}}async merge(i){try{return i?await this.performAction(i,a=>a.merge(i)):await this.mergeAll()}catch(a){throw this.logService.error(a),a}}async discard(i){try{return await this.performAction(i,a=>a.discard(i))}catch(a){throw this.logService.error(a),a}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const i=[];for(const[,a]of this.previews)for(const l of a.resourcePreviews)l.mergeState==="conflict"&&i.push(l.previewResource);for(const a of i)await this.discard(a);return this.previews}catch(i){throw this.logService.error(i),i}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const i=[];for(const[a,l]of this.previews){this.synchronizingResources.push([a,l.resourcePreviews.map(y=>y.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(y=>y.resource===a);for(const y of l.resourcePreviews)(y.localChange!==0||y.remoteChange!==0)&&y.mergeState==="preview"&&await o.merge(y.previewResource);const u=await o.apply(!1,this.syncHeaders);u&&i.push(this.toSyncResourcePreview(o.resource,u)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(y=>y[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}catch(i){throw this.logService.error(i),i}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,a]of this.previews){this.synchronizingResources.push([i,a.resourcePreviews.map(o=>o.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(o=>o.resource===i);for(const o of a.resourcePreviews)await l.accept(o.remoteResource);await l.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(o=>o[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,a]of this.previews){this.synchronizingResources.push([i,a.resourcePreviews.map(o=>o.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(o=>o.resource===i);for(const o of a.resourcePreviews)await l.accept(o.localResource);await l.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(o=>o[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async stop(){for(const i of this.synchronisers)try{await i.stop()}catch(a){(0,I.isPromiseCanceledError)(a)||this.logService.error(a)}this.reset()}async performAction(i,a){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const l=this.previews.findIndex(([,x])=>x.resourcePreviews.some(({localResource:j,previewResource:H,remoteResource:V})=>(0,h.isEqual)(i,j)||(0,h.isEqual)(i,H)||(0,h.isEqual)(i,V)));if(l===-1)return this.previews;const[o,u]=this.previews[l],y=u.resourcePreviews.find(({localResource:x,remoteResource:j,previewResource:H})=>(0,h.isEqual)(x,i)||(0,h.isEqual)(j,i)||(0,h.isEqual)(H,i));if(!y)return this.previews;let E=this.synchronizingResources.find(x=>x[0]===o);E||(E=[o,[]],this.synchronizingResources.push(E)),E[1].some(x=>(0,h.isEqual)(x,y.localResource))||(E[1].push(y.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const f=this.synchronisers.find(x=>x.resource===this.previews[l][0]),T=await a(f);T?this.previews.splice(l,1,this.toSyncResourcePreview(f.resource,T)):this.previews.splice(l,1);const O=this.synchronizingResources.findIndex(x=>x[0]===o);return this.synchronizingResources[O][1].splice(E[1].findIndex(x=>(0,h.isEqual)(x,y.localResource)),1),E[1].length||(this.synchronizingResources.splice(O,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const i=[];for(const[a,l]of this.previews){this.synchronizingResources.push([a,l.resourcePreviews.map(y=>y.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(y=>y.resource===a);let u=l;for(const y of l.resourcePreviews)(y.localChange!==0||y.remoteChange!==0)&&y.mergeState==="preview"&&(u=await o.merge(y.previewResource));u&&i.push(this.toSyncResourcePreview(o.resource,u)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(y=>y[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}async getPreviews(i){const a=[];for(const l of this.synchronisers){if(i.isCancellationRequested)return[];const o=await l.preview(this.manifest,this.syncHeaders);o&&a.push(this.toSyncResourcePreview(l.resource,o))}return a}toSyncResourcePreview(i,a){return[i,{isLastSyncFromCurrentMachine:a.isLastSyncFromCurrentMachine,resourcePreviews:a.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(te[200],ne([0,1,3,21,5,2,14]),function(Y,e,S,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(p,m){this.service=p,this.logService=m,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new S.Emitter}listen(p,m){switch(m){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${m}`)}async call(p,m,d){try{return await this._call(p,m,d)}catch(h){throw this.logService.error(h),h}}async _call(p,m,d){switch(m){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(R.URI.revive(d[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(d[0],R.URI.revive(d[1]),d[2],d[3]);case"resolveContent":return this.service.resolveContent(R.URI.revive(d[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(d[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(d[0]);case"getAssociatedResources":return this.service.getAssociatedResources(d[0],{created:d[1].created,uri:R.URI.revive(d[1].uri)});case"getMachineId":return this.service.getMachineId(d[0],{created:d[1].created,uri:R.URI.revive(d[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(m.startsWith("manualSync/")){const h=m.substring("manualSync/".length),C=d[0],D=this.getManualSyncTask(C);switch(d=d.slice(1),h){case"preview":return D.preview();case"accept":return D.accept(R.URI.revive(d[0]),d[1]);case"merge":return D.merge(R.URI.revive(d[0]));case"discard":return D.discard(R.URI.revive(d[0]));case"discardConflicts":return D.discardConflicts();case"apply":return D.apply();case"pull":return D.pull();case"push":return D.push();case"stop":return D.stop();case"_getStatus":return D.status;case"dispose":return this.disposeManualSyncTask(D)}}throw new Error("Invalid call")}getManualSyncTask(p){const m=this.manualSyncTasks.get(this.createKey(p));if(!m)throw new Error(`Manual sync taks not found: ${p}`);return m.manualSyncTask}async createManualSyncTask(){const p=new k.DisposableStore,m=p.add(await this.service.createManualSyncTask());return p.add(m.onSynchronizeResources(d=>this.onManualSynchronizeResources.fire({manualSyncTaskId:m.id,data:d}))),this.manualSyncTasks.set(this.createKey(m.id),{manualSyncTask:m,disposables:p}),{id:m.id,manifest:m.manifest,status:m.status}}disposeManualSyncTask(p){p.dispose();const m=this.createKey(p.id);this.manualSyncTasks.get(m)?.disposables.dispose(),this.manualSyncTasks.delete(m)}createKey(p){return`manualSyncTask-${p}`}}e.UserDataSyncChannel=P;class v extends k.Disposable{constructor(p){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new S.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new S.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new S.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new S.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(m,d,h){return p.call(m,d,h).then(null,C=>{throw L.UserDataSyncError.toUserDataSyncError(C)})},listen(m,d){return p.listen(m,d)}},this.channel.call("_getInitialData").then(([m,d,h])=>{this.updateStatus(m),this.updateConflicts(d),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(C=>this.updateStatus(C))),this._register(this.channel.listen("onDidChangeLastSyncTime")(C=>this.updateLastSyncTime(C)))}),this._register(this.channel.listen("onDidChangeConflicts")(m=>this.updateConflicts(m))),this._register(this.channel.listen("onSyncErrors")(m=>this._onSyncErrors.fire(m.map(([d,h])=>[d,L.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:p,manifest:m,status:d}=await this.channel.call("createManualSyncTask"),h=this,C=new w(p,m,d,{async call(D,b,I){return h.channel.call(`manualSync/${D}`,[p,...(0,A.isArray)(b)?b:[b]],I)},listen(D,b){return S.Event.map(S.Event.filter(h.channel.listen(`manualSync/${D}`,b),I=>!C.isDiposed()&&I.manualSyncTaskId===p),I=>I.data)}});return C}replace(p){return this.channel.call("replace",[p])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(p,m,d,h){return this.channel.call("accept",[p,m,d,h])}resolveContent(p){return this.channel.call("resolveContent",[p])}async getLocalSyncResourceHandles(p){return(await this.channel.call("getLocalSyncResourceHandles",[p])).map(({created:d,uri:h})=>({created:d,uri:R.URI.revive(h)}))}async getRemoteSyncResourceHandles(p){return(await this.channel.call("getRemoteSyncResourceHandles",[p])).map(({created:d,uri:h})=>({created:d,uri:R.URI.revive(h)}))}async getAssociatedResources(p,m){return(await this.channel.call("getAssociatedResources",[p,m])).map(({resource:h,comparableResource:C})=>({resource:R.URI.revive(h),comparableResource:R.URI.revive(C)}))}async getMachineId(p,m){return this.channel.call("getMachineId",[p,m])}async updateStatus(p){this._status=p,this._onDidChangeStatus.fire(p)}async updateConflicts(p){this._conflicts=p.map(([m,d])=>[m,d.map(h=>({...h,localResource:R.URI.revive(h.localResource),remoteResource:R.URI.revive(h.remoteResource),previewResource:R.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(p){this._lastSyncTime!==p&&(this._lastSyncTime=p,this._onDidChangeLastSyncTime.fire(p))}}e.UserDataSyncChannelClient=v;class w extends k.Disposable{constructor(p,m,d,h){super();this.id=p,this.manifest=m,this._disposed=!1,this._status=d;const C=this;this.channel={async call(D,b,I){try{const g=await h.call(D,b,I);return C.isDiposed()||(C._status=await h.call("_getStatus")),g}catch(g){throw L.UserDataSyncError.toUserDataSyncError(g)}},listen(D,b){return h.listen(D,b)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const p=await this.channel.call("preview");return this.deserializePreviews(p)}async accept(p,m){const d=await this.channel.call("accept",[p,m]);return this.deserializePreviews(d)}async merge(p){const m=await this.channel.call("merge",[p]);return this.deserializePreviews(m)}async discard(p){const m=await this.channel.call("discard",[p]);return this.deserializePreviews(m)}async discardConflicts(){const p=await this.channel.call("discardConflicts");return this.deserializePreviews(p)}async apply(){const p=await this.channel.call("apply");return this.deserializePreviews(p)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(p){return p.map(([m,d])=>[m,{isLastSyncFromCurrentMachine:d.isLastSyncFromCurrentMachine,resourcePreviews:d.resourcePreviews.map(h=>({...h,localResource:R.URI.revive(h.localResource),remoteResource:R.URI.revive(h.remoteResource),previewResource:R.URI.revive(h.previewResource),acceptedResource:R.URI.revive(h.acceptedResource)}))}])}}}),define(te[201],ne([0,1,2,21,39,15,29,23,27,44,10,11,20,30,7,3,6,14,5,9,92]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d,h,C,D,b,I,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const c="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",a=100,l=1e3*60*5;let o=class extends S.Disposable{constructor(O,x,j){super();this.productService=O,this.configurationService=x,this.storageService=j,this._onDidChangeUserDataSyncStore=this._register(new C.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(C.Event.filter(j.onDidChangeValue,H=>H.key===L.SYNC_SERVICE_URL_TYPE&&H.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(L.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(L.SYNC_SERVICE_URL_TYPE,O,0,h.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[L.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(L.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,x){O=h.isWeb&&O?.web?{...O,...O.web}:O;const j={...O||{},...x||{}};if(j&&(0,b.isString)(j.url)&&(0,b.isObject)(j.authenticationProviders)&&Object.keys(j.authenticationProviders).every(H=>(0,b.isArray)(j.authenticationProviders[H].scopes))){const H=j,V=!!H.canSwitch&&!x?.url,N=H.url===H.insidersUrl?"insiders":"stable",_=(V?this.userDataSyncStoreType:void 0)||N,M=x?.url||(_==="insiders"?H.insidersUrl:_==="stable"?H.stableUrl:H.url);return{url:I.URI.parse(M),type:_,defaultType:N,defaultUrl:I.URI.parse(H.url),stableUrl:I.URI.parse(H.stableUrl),insidersUrl:I.URI.parse(H.insidersUrl),canSwitch:V,authenticationProviders:Object.keys(H.authenticationProviders).reduce((B,F)=>(B.push({id:F,scopes:H.authenticationProviders[F].scopes}),B),[])}}}};o=de([J(0,v.IProductService),J(1,P.IConfigurationService),J(2,m.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let u=class extends o{constructor(O,x,j){super(O,x,j);const H=this.storageService.get(c,0);H&&(this.previousConfigurationSyncStore=JSON.parse(H));const V=this.productService[L.CONFIGURATION_SYNC_STORE_KEY];V?this.storageService.store(c,JSON.stringify(V),0,1):this.storageService.remove(c,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=de([J(0,v.IProductService),J(1,P.IConfigurationService),J(2,m.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let y=class extends S.Disposable{constructor(O,x,j,H,V,N,_){super();this.requestService=j,this.logService=H,this.storageService=_,this._onTokenFailed=this._register(new C.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new C.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new C.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,w.getServiceMachineId)(V,N,_).then(M=>{const B={"X-Client-Name":`${x.applicationName}${h.isWeb?"-web":""}`,"X-Client-Version":x.version,"X-Machine-Id":M};return x.commit&&(B["X-Client-Commit"]=x.commit),B}),this.session=new f(a,l,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,S.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,x){this.authToken={token:O,type:x}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,k.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(t,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(x=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),x).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,x=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O),j={},H=await this.request(x.toString(),{type:"GET",headers:j},[],A.CancellationToken.None);return(await(0,R.asJson)(H)||[]).map(({url:N,created:_})=>({ref:(0,k.relativePath)(x,x.with({path:N})),created:_*1e3}))}async resolveContent(O,x){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O,x).toString(),H={};H["Cache-Control"]="no-cache";const V=await this.request(j,{type:"GET",headers:H},[],A.CancellationToken.None);return await(0,R.asText)(V)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),j={};await this.request(x,{type:"DELETE",headers:j},[],A.CancellationToken.None)}async read(O,x,j={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const H=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();j={...j},j["Cache-Control"]="no-cache",x&&(j["If-None-Match"]=x.ref);const V=await this.request(H,{type:"GET",headers:j},[304],A.CancellationToken.None);if(V.res.statusCode===304)return x;const N=V.res.headers.etag;if(!N)throw new L.UserDataSyncStoreError("Server did not return the ref",H,L.UserDataSyncErrorCode.NoRef,V.res.headers[L.HEADER_OPERATION_ID]);const _=await(0,R.asText)(V);return{ref:N,content:_}}async write(O,x,j,H={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();H={...H},H["Content-Type"]=s.Mimes.text,j&&(H["If-Match"]=j);const N=await this.request(V,{type:"POST",data:x,headers:H},[],A.CancellationToken.None),_=N.res.headers.etag;if(!_)throw new L.UserDataSyncStoreError("Server did not return the ref",V,L.UserDataSyncErrorCode.NoRef,N.res.headers[L.HEADER_OPERATION_ID]);return _}async manifest(O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,k.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();O={...O},O["Content-Type"]="application/json";const j=await this.request(x,{type:"GET",headers:O},[],A.CancellationToken.None),H=await(0,R.asJson)(j),V=this.storageService.get(r,0);return V&&H&&V!==H.session&&this.clearSession(),H===null&&V&&this.clearSession(),H&&this.storageService.store(r,H.session,0,1),H}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),x={"Content-Type":s.Mimes.text};await this.request(O,{type:"DELETE",headers:x},[],A.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(i,0)}async request(O,x,j,H){if(!this.authToken)throw new L.UserDataSyncStoreError("No Auth Token Available",O,L.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new L.UserDataSyncStoreError(`${x.type} request '${O}' failed because of too many requests (429).`,O,L.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const V=await this.commonHeadersPromise;x.headers={...x.headers||{},...V,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(x.headers),this.logService.trace("Sending request to server",{url:O,type:x.type,headers:{...x.headers,authorization:void 0}});let N;try{N=await this.session.request(O,x,H)}catch(F){if(!(F instanceof L.UserDataSyncStoreError)){const U=(0,g.isPromiseCanceledError)(F)?L.UserDataSyncErrorCode.RequestCanceled:(0,g.getErrorMessage)(F).startsWith("XHR timeout")?L.UserDataSyncErrorCode.RequestTimeout:L.UserDataSyncErrorCode.RequestFailed;F=new L.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,U,void 0)}throw this.logService.info("Request failed",O),F}const _=N.res.headers[L.HEADER_OPERATION_ID],M={url:O,status:N.res.statusCode,"execution-id":x.headers[L.HEADER_EXECUTION_ID],"operation-id":_},B=(0,R.isSuccess)(N)||N.res.statusCode&&j.indexOf(N.res.statusCode)!==-1;if(B?this.logService.trace("Request succeeded",M):this.logService.info("Request failed",M),N.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new L.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,L.UserDataSyncErrorCode.Unauthorized,_);if(this._onTokenSucceed.fire(),N.res.statusCode===409)throw new L.UserDataSyncStoreError(`${x.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,L.UserDataSyncErrorCode.Conflict,_);if(N.res.statusCode===410)throw new L.UserDataSyncStoreError(`${x.type} request '${O}' failed because the requested resource is not longer available (410).`,O,L.UserDataSyncErrorCode.Gone,_);if(N.res.statusCode===412)throw new L.UserDataSyncStoreError(`${x.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,L.UserDataSyncErrorCode.PreconditionFailed,_);if(N.res.statusCode===413)throw new L.UserDataSyncStoreError(`${x.type} request '${O}' failed because of too large payload (413).`,O,L.UserDataSyncErrorCode.TooLarge,_);if(N.res.statusCode===426)throw new L.UserDataSyncStoreError(`${x.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,L.UserDataSyncErrorCode.UpgradeRequired,_);if(N.res.statusCode===429){const F=N.res.headers["retry-after"];throw F?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(F)*1e3)),new L.UserDataSyncStoreError(`${x.type} request '${O}' failed because of too many requests (429).`,O,L.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,_)):new L.UserDataSyncStoreError(`${x.type} request '${O}' failed because of too many requests (429).`,O,L.UserDataSyncErrorCode.TooManyRequests,_)}if(!B)throw new L.UserDataSyncStoreError("Server returned "+N.res.statusCode,O,L.UserDataSyncErrorCode.Unknown,_);return N}addSessionHeaders(O){let x=this.storageService.get(i,0);x===void 0&&(x=(0,d.generateUuid)(),this.storageService.store(i,x,0,1)),O["X-Machine-Session-Id"]=x;const j=this.storageService.get(r,0);j!==void 0&&(O["X-User-Session-Id"]=j)}};y=de([J(1,v.IProductService),J(2,R.IRequestService),J(3,L.IUserDataSyncLogService),J(4,n.IEnvironmentService),J(5,p.IFileService),J(6,m.IStorageService)],y),e.UserDataSyncStoreClient=y;let E=class extends y{constructor(O,x,j,H,V,N,_){super(O.userDataSyncStore?.url,x,j,H,V,N,_);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};E=de([J(0,L.IUserDataSyncStoreManagementService),J(1,v.IProductService),J(2,R.IRequestService),J(3,L.IUserDataSyncLogService),J(4,n.IEnvironmentService),J(5,p.IFileService),J(6,m.IStorageService)],E),e.UserDataSyncStoreService=E;class f{constructor(O,x,j,H){this.limit=O,this.interval=x,this.requestService=j,this.logService=H,this.requests=[],this.startTime=void 0}request(O,x,j){if(this.isExpired()&&this.reset(),x.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new L.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,L.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(x,j)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=f}),define(te[202],ne([0,1,21,3,58,86,60,24,20,61,27]),function(Y,e,S,L,R,k,A,P,v,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let p=class extends k.UserDataAutoSyncService{constructor(d,h,C,D,b,I,g,s,c,t,r,i){super(d,h,C,D,b,g,s,c,t,r,i);this._register(L.Event.debounce(L.Event.any(L.Event.map(I.onDidFocusWindow,()=>"windowFocus"),L.Event.map(I.onDidOpenWindow,()=>"windowOpen")),(a,l)=>a?[...a,l]:[l],1e3)(a=>this.triggerSync(a,!0,!1)))}};p=de([J(0,n.IProductService),J(1,S.IUserDataSyncStoreManagementService),J(2,S.IUserDataSyncStoreService),J(3,S.IUserDataSyncResourceEnablementService),J(4,S.IUserDataSyncService),J(5,R.INativeHostService),J(6,S.IUserDataSyncLogService),J(7,A.IUserDataSyncAccountService),J(8,P.ITelemetryService),J(9,w.IUserDataSyncMachinesService),J(10,v.IStorageService),J(11,S.IUserDataAutoSyncEnablementService)],p),e.UserDataAutoSyncService=p}),define(te[203],ne([0,1,3,2,6]),function(Y,e,S,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends L.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:v,getActiveWindowId:w}){super();this.disposables=this._register(new L.DisposableStore),S.Event.latch(S.Event.any(P,v))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>w()),(async()=>{try{const p=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:p}catch(p){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(te[62],ne([0,1,108,8,48,6,18,210,211,14]),function(Y,e,S,L,R,k,A,P,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=n;function p(c){const t=c.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function m(c){if(c instanceof n)return c;let t;return/end of central directory record signature not found/.test(c.message)&&(t="CorruptZip"),new n(t,c)}function d(c,t,r,i,a,l){const o=L.dirname(t),u=L.join(i,o);if(!u.startsWith(i))return Promise.reject(new Error(S.localize(0,null,t)));const y=L.join(i,t);let E;return l.onCancellationRequested(()=>{E&&E.destroy()}),Promise.resolve(A.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((f,T)=>{if(!l.isCancellationRequested)try{E=(0,R.createWriteStream)(y,{mode:r}),E.once("close",()=>f()),E.once("error",T),c.once("error",T),c.pipe(E)}catch(O){T(O)}}))}function h(c,t,r,i){let a=(0,k.createCancelablePromise)(()=>Promise.resolve()),l=0;return i.onCancellationRequested(()=>{a.cancel(),c.close()}),new Promise((o,u)=>{const y=new k.Sequencer,E=f=>{f.isCancellationRequested||(l++,c.readEntry())};c.once("error",u),c.once("close",()=>a.then(()=>{i.isCancellationRequested||c.entryCount===l?o():u(new n("Incomplete",new Error(S.localize(1,null,l,c.entryCount))))},u)),c.readEntry(),c.on("entry",f=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(f.fileName)){E(i);return}const T=f.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(T)){const j=L.join(t,T);a=(0,k.createCancelablePromise)(H=>A.Promises.mkdir(j,{recursive:!0}).then(()=>E(H)).then(void 0,u));return}const O=D(c,f),x=p(f);a=(0,k.createCancelablePromise)(j=>y.queue(()=>O.then(H=>d(H,T,x,t,r,j).then(()=>E(j)))).then(null,u))})})}function C(c,t=!1){return new Promise((r,i)=>{(0,P.open)(c,t?{lazyEntries:!0}:void 0,(a,l)=>{a?i(m(a)):r((0,w.assertIsDefined)(l))})})}function D(c,t){return new Promise((r,i)=>{c.openReadStream(t,(a,l)=>{a?i(m(a)):r((0,w.assertIsDefined)(l))})})}function b(c,t){return new Promise((r,i)=>{const a=new v.ZipFile;t.forEach(o=>{o.contents?a.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&a.addFile(o.localPath,o.path)}),a.end();const l=(0,R.createWriteStream)(c);a.outputStream.pipe(l),a.outputStream.once("error",i),l.once("error",i),l.once("finish",()=>r(c))})}e.zip=b;function I(c,t,r={},i){const a=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let l=C(c,!0);return r.overwrite&&(l=l.then(o=>A.Promises.rm(t).then(()=>o))),l.then(o=>h(o,t,{sourcePathRegex:a},i))}e.extract=I;function g(c,t){return C(c).then(r=>new Promise((i,a)=>{r.on("entry",l=>{l.fileName===t&&D(r,l).then(o=>i(o),o=>a(o))}),r.once("close",()=>a(new Error(S.localize(2,null,t))))}))}function s(c,t){return g(c,t).then(r=>new Promise((i,a)=>{const l=[];r.once("error",a),r.on("data",o=>l.push(o)),r.on("end",()=>i(Buffer.concat(l)))}))}e.buffer=s}),define(te[204],ne([0,1,62,113]),function(Y,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(k){return(0,S.buffer)(k,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch(P){throw new Error((0,L.localize)(0,null))}})}e.getManifest=R}),define(te[205],ne([0,1,57,2,18,8,16,28,33,6,5,10,134,114,27,62,7,22,17,11,15,30,9]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d,h,C,D,b,I,g,s,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",i="scanningUser",a="extracting",l="deleting",o="renaming";let u=class extends L.Disposable{constructor(E,f,T,O,x){super();this.beforeRemovingExtension=E,this.fileService=f,this.logService=T,this.environmentService=O,this.productService=x,this._devSystemExtensionsPath=null,this.systemExtensionsPath=O.builtinExtensionsPath,this.extensionsPath=O.extensionsPath,this.uninstalledPath=k.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new w.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(E){const f=[];(E===null||E===0)&&f.push(this.scanSystemExtensions().then(null,T=>Promise.reject(new P.ExtensionManagementError(this.joinErrors(T).message,r)))),(E===null||E===1)&&f.push(this.scanUserExtensions(!0).then(null,T=>Promise.reject(new P.ExtensionManagementError(this.joinErrors(T).message,i))));try{const T=await Promise.all(f);return(0,b.flatten)(T)}catch(T){throw this.joinErrors(T)}}async scanUserExtensions(E){this.logService.trace("Started scanning user extensions");let[f,T]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return T=T.filter(O=>!f[new v.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),E&&(T=(0,v.groupByExtension)(T,x=>x.identifier).map(x=>x.sort((j,H)=>S.rcompare(j.manifest.version,H.manifest.version))[0])),this.logService.trace("Scanned user extensions:",T.length),T}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(E,f,T){const O=E.key(),x=k.join(this.extensionsPath,`.${(0,c.generateUuid)()}`),j=k.join(this.extensionsPath,O);try{await R.Promises.rm(j)}catch(V){try{await R.Promises.rm(j)}catch(N){}throw new P.ExtensionManagementError((0,d.localize)(0,null,j,E.id),l)}await this.extractAtLocation(E,f,x,T);let H=await this.scanExtension(n.URI.file(x),1);if(!H)throw new Error((0,d.localize)(1,null,x));await this.storeMetadata(H,{installedTimestamp:Date.now()});try{await this.rename(E,x,j,Date.now()+2*60*1e3),this.logService.info("Renamed to",j)}catch(V){try{await R.Promises.rm(x)}catch(N){}if(V.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",E.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(V)}. Deleted from extracted location`,x),V}try{H=await this.scanExtension(n.URI.file(j),1)}catch(V){}if(H)return H;throw new Error((0,d.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(E,f){return this.setMetadata(E,f),await this.storeMetadata(E,{...f,installedTimestamp:E.installedTimestamp}),E}async storeMetadata(E,f){f.isMachineScoped=f.isMachineScoped||void 0,f.isBuiltin=f.isBuiltin||void 0,f.installedTimestamp=f.installedTimestamp||void 0;const T=k.join(E.location.fsPath,"package.json"),O=await R.Promises.readFile(T,"utf8"),{manifest:x}=await this.parseManifest(O);return x.__metadata=f,await R.Promises.writeFile(T,JSON.stringify(x,null,"	")),E}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...E){const f=E.map(T=>new v.ExtensionIdentifierWithVersion(T.identifier,T.manifest.version));await this.withUninstalledExtensions(T=>{f.forEach(O=>T[O.key()]=!0)})}async setInstalled(E){await this.withUninstalledExtensions(O=>delete O[E.key()]);const T=(await this.scanExtensions(1)).find(O=>new v.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).equals(E))||null;return T?(await this.storeMetadata(T,{installedTimestamp:Date.now()}),this.scanExtension(T.location,1)):null}async withUninstalledExtensions(E){return this.uninstalledFileLimiter.queue(async()=>{let f;try{f=await R.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let T={};if(f)try{T=JSON.parse(f)}catch(O){}return E&&(E(T),Object.keys(T).length?await R.Promises.writeFile(this.uninstalledPath,JSON.stringify(T)):await R.Promises.rm(this.uninstalledPath)),T})}async removeExtension(E,f){this.logService.trace(`Deleting ${f} extension from disk`,E.identifier.id,E.location.fsPath),await R.Promises.rm(E.location.fsPath),this.logService.info("Deleted from disk",E.identifier.id,E.location.fsPath)}async removeUninstalledExtension(E){await this.removeExtension(E,"uninstalled"),await this.withUninstalledExtensions(f=>delete f[new v.ExtensionIdentifierWithVersion(E.identifier,E.manifest.version).key()])}async extractAtLocation(E,f,T,O){this.logService.trace(`Started extracting the extension from ${f} to ${T}`);try{await R.Promises.rm(T)}catch(x){throw new P.ExtensionManagementError(this.joinErrors(x).message,l)}try{await(0,C.extract)(f,T,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${T}:`,E.id)}catch(x){try{await R.Promises.rm(T)}catch(j){}throw new P.ExtensionManagementError(x.message,x instanceof C.ExtractError&&x.type?x.type:a)}}async rename(E,f,T,O){try{await R.Promises.rename(f,T)}catch(x){if(D.isWindows&&x&&x.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${f} to ${T} with 'EPERM' error. Trying again...`,E.id),this.rename(E,f,T,O);throw new P.ExtensionManagementError(x.message||(0,d.localize)(3,null,f,T),x.code||o)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const E=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return E;const f=this.scanDevSystemExtensions(),[T,O]=await Promise.all([E,f]);return[...T,...O]}async scanExtensionsInDir(E,f){const T=new w.Limiter(10),O=await this.fileService.resolve(n.URI.file(E));return O.children?(await Promise.all(O.children.filter(j=>j.isDirectory).map(j=>T.queue(async()=>f===1&&(0,s.basename)(j.resource).indexOf(".")===0?null:this.scanExtension(j.resource,f))))).filter(j=>j&&j.identifier):[]}async scanExtension(E,f){try{const T=await this.fileService.resolve(E);if(T.children){const{manifest:O,metadata:x}=await this.readManifest(E.fsPath),j=T.children.find(({name:_})=>/^readme(\.txt|\.md|)$/i.test(_))?.resource,H=T.children.find(({name:_})=>/^changelog(\.txt|\.md|)$/i.test(_))?.resource,V={id:(0,v.getGalleryExtensionId)(O.publisher,O.name)},N={type:f,identifier:V,manifest:O,location:E,readmeUrl:j,changelogUrl:H,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:f===0};return x&&(this.setMetadata(N,x),N.installedTimestamp=x.installedTimestamp),N}}catch(T){f!==0&&this.logService.trace(T)}return null}async scanDefaultSystemExtensions(){const E=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",E.length),E}async scanDevSystemExtensions(){const E=this.getDevSystemExtensionsList();if(E.length){const f=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",f.length),f.filter(T=>E.some(O=>(0,v.areSameExtensions)(T.identifier,{id:O})))}else return[]}setMetadata(E,f){E.publisherDisplayName=f.publisherDisplayName||null,E.publisherId=f.publisherId||null,E.identifier.uuid=f.id,E.isMachineScoped=!!f.isMachineScoped,E.isBuiltin=E.type===0||!!f.isBuiltin}async removeUninstalledExtensions(){const E=await this.getUninstalledExtensions(),f=await this.scanAllUserExtensions(),T=new Set;for(const j of f)E[new v.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).key()]||T.add(j.identifier.id.toLowerCase());const O=(0,v.groupByExtension)(f,j=>j.identifier);await w.Promises.settled(O.map(async j=>{const H=j.sort((V,N)=>S.rcompare(V.manifest.version,N.manifest.version))[0];T.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(H)}));const x=f.filter(j=>E[new v.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).key()]);await w.Promises.settled(x.map(j=>this.removeUninstalledExtension(j)))}async removeOutdatedExtensions(){const E=await this.scanAllUserExtensions(),f=[],T=(0,v.groupByExtension)(E,O=>O.identifier);f.push(...(0,b.flatten)(T.map(O=>O.sort((x,j)=>S.rcompare(x.manifest.version,j.manifest.version)).slice(1)))),await w.Promises.settled(f.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(E=>E.name)}joinErrors(E){const f=Array.isArray(E)?E:[E];return f.length===1?f[0]instanceof Error?f[0]:new Error(f[0]):f.reduce((T,O)=>new Error(`${T.message}${T.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=k.normalize(k.join(I.FileAccess.asFileUri("",Y).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(E){const f=[R.Promises.readFile(k.join(E,"package.json"),"utf8").then(j=>this.parseManifest(j)),R.Promises.readFile(k.join(E,"package.nls.json"),"utf8").then(void 0,j=>j.code!=="ENOENT"?Promise.reject(j):"{}").then(j=>JSON.parse(j))],[{manifest:T,metadata:O},x]=await Promise.all(f);return{manifest:(0,m.localizeManifest)(T,x),metadata:O}}parseManifest(E){return new Promise((f,T)=>{try{const O=JSON.parse(E),x=O.__metadata||null;f({manifest:O,metadata:x})}catch(O){T(new Error((0,d.localize)(4,null)))}})}};u=de([J(1,g.IFileService),J(2,A.ILogService),J(3,p.INativeEnvironmentService),J(4,h.IProductService)],u),e.ExtensionsScanner=u}),define(te[206],ne([0,1,112,8,18,2,62,28,33,10,6,3,57,5,51,7,16,145,43,24,70,15,30,72,4,17,29,204,155,205,156,157,11,9,14]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d,h,C,D,b,I,g,s,c,t,r,i,a,l,o,u,y,E,f,T,O,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const j="unsetUninstalled",H="downloading",V="validating",N="local",_="unknown";let M=class extends k.Disposable{constructor($,G,X,Z,ee,se,ue){super();this.environmentService=$,this.galleryService=G,this.logService=X,this.downloadService=Z,this.telemetryService=ee,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new p.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new p.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new p.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new p.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const ge=this._register(se.createInstance(E.ExtensionsLifecycle));this.extensionsScanner=this._register(se.createInstance(y.ExtensionsScanner,Se=>ge.postUninstall(Se))),this.manifestCache=this._register(new b.ExtensionsManifestCache($,this)),this.extensionsDownloader=this._register(se.createInstance(u.ExtensionsDownloader));const me=this._register(new f.ExtensionsWatcher(this,ue,$,X));this._register(me.onDidChangeExtensionsByAnotherSource(({added:Se,removed:be})=>{Se.length&&this._onDidInstallExtensions.fire(Se.map(Ce=>({identifier:Ce.identifier,operation:0,local:Ce}))),be.forEach(Ce=>this._onDidUninstallExtension.fire({identifier:Ce}))})),this._register((0,k.toDisposable)(()=>{this.installingExtensions.forEach(Se=>Se.cancel()),this.uninstallingExtensions.forEach(Se=>Se.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip($){this.logService.trace("ExtensionManagementService#zip",$.identifier.id);const G=await this.collectFiles($),X=await(0,A.zip)((0,c.joinPath)(this.environmentService.tmpDir,(0,t.generateUuid)()).fsPath,G);return d.URI.file(X)}async unzip($){return this.logService.trace("ExtensionManagementService#unzip",$.toString()),(await this.install($)).identifier}async getManifest($){const G=await this.downloadVsix($),X=L.resolve(G.fsPath);return(0,o.getManifest)(X)}async collectFiles($){const G=async Z=>{let ee=await R.Promises.readdir(Z);ee=ee.map(ge=>L.join(Z,ge));const se=await Promise.all(ee.map(ge=>R.Promises.stat(ge)));let ue=Promise.resolve([]);return se.forEach((ge,me)=>{const Se=ee[me];ge.isFile()&&(ue=ue.then(be=>[...be,Se])),ge.isDirectory()&&(ue=ue.then(be=>G(Se).then(Ce=>[...be,...Ce])))}),ue};return(await G($.location.fsPath)).map(Z=>({path:`extension/${L.relative($.location.fsPath,Z)}`,localPath:Z}))}async canInstall($){return!0}async install($,G={}){this.logService.trace("ExtensionManagementService#install",$.toString());const X=await this.downloadVsix($),Z=L.resolve(X.fsPath),ee=await(0,o.getManifest)(Z);if(ee.engines&&ee.engines.vscode&&!(0,s.isEngineValid)(ee.engines.vscode,h.default.version,h.default.date))throw new Error(S.localize(0,null,(0,v.getGalleryExtensionId)(ee.publisher,ee.name),h.default.version));return this.installExtension(ee,Z,G)}async installFromGallery($,G={}){if(!this.galleryService.isEnabled())throw new Error(S.localize(1,null));try{$=await this.checkAndGetCompatibleVersion($)}catch(Z){throw this.logService.error((0,O.getErrorMessage)(Z)),F(this.telemetryService,"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)($),void 0,Z),Z}const X=await this.galleryService.getManifest($,l.CancellationToken.None);if(X===null){const Z=new P.ExtensionManagementError(`Missing manifest for extension ${$.identifier.id}`,V);throw this.logService.error("Failed to install extension:",$.identifier.id,Z.message),F(this.telemetryService,"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)($),void 0,Z),Z}return this.installExtension(X,$,G)}async downloadVsix($){if($.scheme===a.Schemas.file)return $;if(!this.downloadService)throw new Error("Download service is not available");const G=(0,c.joinPath)(this.environmentService.tmpDir,(0,t.generateUuid)());return await this.downloadService.download($,G),G}createInstallVSIXExtensionTask($,G,X){return new W($,G,X,this.galleryService,this.extensionsScanner,this.logService)}createInstallFromGalleryExtensionTask($,G){return new z($,G,this.extensionsDownloader,this.telemetryService,this.extensionsScanner,this.logService)}createInstallExtensionTask($,G,X){return(0,x.isString)(G)?this.createInstallVSIXExtensionTask($,G,X):this.createInstallFromGalleryExtensionTask(G,X)}async installExtension($,G,X){if(!(0,x.isString)(G)){let ge=this.installingExtensions.get(new v.ExtensionIdentifierWithVersion(G.identifier,G.version).key());if(ge)return this.logService.info("Extensions is already requested to install",G.identifier.id),ge.waitUntilTaskIsFinished();X={...X,installOnlyNewlyAddedFromExtensionPack:!0}}const Z=[],ee=[],se=this.createInstallExtensionTask($,G,X);(0,x.isString)(G)||this.installingExtensions.set(new v.ExtensionIdentifierWithVersion(se.identifier,$.version).key(),se),this._onInstallExtension.fire({identifier:se.identifier,source:G}),this.logService.info("Installing extension:",se.identifier.id),Z.push({task:se,manifest:$});let ue=!1;try{if(X.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",se.identifier.id);else try{const me=await this.getAllDepsAndPackExtensionsToInstall(se.identifier,$,!!X.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:Se,manifest:be}of me)if(ue=ue||!!be.extensionDependencies?.some(Ce=>(0,v.areSameExtensions)({id:Ce},se.identifier)),this.installingExtensions.has(new v.ExtensionIdentifierWithVersion(Se.identifier,Se.version).key()))this.logService.info("Extension is already requested to install",Se.identifier.id);else{const Ce=this.createInstallExtensionTask(be,Se,{...X,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new v.ExtensionIdentifierWithVersion(Ce.identifier,be.version).key(),Ce),this._onInstallExtension.fire({identifier:Ce.identifier,source:Se}),this.logService.info("Installing extension:",Ce.identifier.id),Z.push({task:Ce,manifest:be})}}catch(me){throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",se.identifier.id),this.logService.error(me),me}const ge=Z.reduce((me,{task:Se,manifest:be})=>(me.set(Se.identifier.id.toLowerCase(),{task:Se,manifest:be}),me),new Map);for(;ge.size;){let me;const Se=[...ge.values()].filter(({manifest:Ee})=>!Ee.extensionDependencies?.some(De=>ge.has(De.toLowerCase())));Se.length?me=ge.size===1?Se:Se.filter(({task:Ee})=>!(Ee===se&&!ue)):(this.logService.info("Found extensions with circular dependencies",Se.map(({task:Ee})=>Ee.identifier.id)),me=[...ge.values()]);const Ce=(await Promise.allSettled(me.map(async({task:Ee})=>{try{const De=await Ee.run();ee.push({local:De,identifier:Ee.identifier,operation:Ee.operation,source:Ee.source})}catch(De){throw this.logService.error("Error while installing the extension:",Ee.identifier.id),this.logService.error(De),De}finally{ge.delete(Ee.identifier.id.toLowerCase())}}))).reduce((Ee,De)=>(De.status==="rejected"&&Ee.push(De.reason),Ee),[]);if(Ce.length)throw B(Ce)}return ee.forEach(({identifier:me})=>this.logService.info("Extensions installed successfully:",me.id)),this._onDidInstallExtensions.fire(ee),ee.filter(({identifier:me})=>(0,v.areSameExtensions)(me,se.identifier))[0].local}catch(ge){if(Z.forEach(({task:me})=>me.cancel()),ee.length)try{await this.extensionsScanner.setUninstalled(...ee.map(({local:me})=>me)),this.logService.info("Rollback: Uninstalled extensions",...ee.map(({identifier:me})=>me.id))}catch(me){this.logService.warn("Error while rolling back extensions",(0,O.getErrorMessage)(me))}throw this.logService.error("Failed to install extension:",se.identifier.id,(0,O.getErrorMessage)(ge)),this._onDidInstallExtensions.fire(Z.map(({task:me})=>({identifier:me.identifier,operation:1,source:me.source}))),ge instanceof Error&&(ge.name=ge&&ge.code?ge.code:_),ge}finally{for(const{task:ge,manifest:me}of Z)if(!(0,x.isString)(ge.source)){const Se=new v.ExtensionIdentifierWithVersion(ge.identifier,me.version).key();this.installingExtensions.delete(Se)||this.logService.warn("Installation task is not found in the cache",Se)}}}async getAllDepsAndPackExtensionsToInstall($,G,X){if(!this.galleryService.isEnabled())return[];let Z=await this.getInstalled();const ee=[$,...Z.map(ge=>ge.identifier)],se=[],ue=async(ge,me)=>{const Se=me.extensionDependencies||[];if(me.extensionPack){const be=X?Z.find(Ce=>(0,v.areSameExtensions)(Ce.identifier,ge)):void 0;for(const Ce of me.extensionPack)be&&be.manifest.extensionPack&&be.manifest.extensionPack.some(Ee=>(0,v.areSameExtensions)({id:Ee},{id:Ce}))||Se.every(Ee=>!(0,v.areSameExtensions)({id:Ee},{id:Ce}))&&Se.push(Ce)}if(Se.length){const be=[...ee,...se.map(Ee=>Ee.gallery.identifier)],Ce=Se.filter(Ee=>be.every(De=>!(0,v.areSameExtensions)(De,{id:Ee})));if(Ce.length){const Ee=await this.galleryService.query({names:Ce,pageSize:Se.length},l.CancellationToken.None);for(const De of Ee.firstPage){if(be.find(Te=>(0,v.areSameExtensions)(Te,De.identifier)))continue;const Fe=await this.checkAndGetCompatibleVersion(De);if(!await this.canInstall(Fe)){this.logService.info("Skipping the extension as it cannot be installed",Fe.identifier.id);continue}const Re=await this.galleryService.getManifest(Fe,l.CancellationToken.None);if(Re===null)throw new P.ExtensionManagementError(`Missing manifest for extension ${Fe.identifier.id}`,V);se.push({gallery:Fe,manifest:Re}),await ue(Fe.identifier,Re)}}}};return await ue($,G),Z=await this.getInstalled(),se.filter(ge=>!Z.some(me=>(0,v.areSameExtensions)(me.identifier,ge.gallery.identifier)))}async checkAndGetCompatibleVersion($){if(await this.isMalicious($))throw new P.ExtensionManagementError(S.localize(2,null,$.identifier.id),P.INSTALL_ERROR_MALICIOUS);const G=await this.galleryService.getCompatibleExtension($);if(!G)throw new P.ExtensionManagementError(S.localize(3,null,$.identifier.id,h.default.version),P.INSTALL_ERROR_INCOMPATIBLE);return G}async reinstallFromGallery($){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",$.identifier.id),!this.galleryService.isEnabled())throw new Error(S.localize(4,null));const G=await this.findGalleryExtension($);if(!G)throw new Error(S.localize(5,null));await this.extensionsScanner.setUninstalled($);try{await this.extensionsScanner.removeUninstalledExtension($)}catch(X){throw new Error(S.localize(6,null,(0,I.toErrorMessage)(X)))}await this.installFromGallery(G)}async isMalicious($){const G=await this.getExtensionsReport();return(0,v.getMaliciousExtensionsSet)(G).has($.identifier.id)}async uninstall($,G={}){this.logService.trace("ExtensionManagementService#uninstall",$.identifier.id);const X=await this.getInstalled(1),Z=X.find(ee=>(0,v.areSameExtensions)(ee.identifier,$.identifier));if(!Z)throw new Error(S.localize(7,null,$.manifest.displayName||$.manifest.name));try{await this.checkForDependenciesAndUninstall(Z,X,G)}catch(ee){throw B(ee)}}async updateMetadata($,G){return this.logService.trace("ExtensionManagementService#updateMetadata",$.identifier.id),$=await this.extensionsScanner.saveMetadataForLocalExtension($,{...$.manifest.__metadata||{},...G}),this.manifestCache.invalidate(),$}async updateExtensionScope($,G){return this.logService.trace("ExtensionManagementService#updateExtensionScope",$.identifier.id),$=await this.extensionsScanner.saveMetadataForLocalExtension($,{...$.manifest.__metadata||{},isMachineScoped:G}),this.manifestCache.invalidate(),$}async findGalleryExtension($){if($.identifier.uuid){const G=await this.findGalleryExtensionById($.identifier.uuid);return G||this.findGalleryExtensionByName($.identifier.id)}return this.findGalleryExtensionByName($.identifier.id)}async findGalleryExtensionById($){return(await this.galleryService.query({ids:[$],pageSize:1},l.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName($){return(await this.galleryService.query({names:[$],pageSize:1},l.CancellationToken.None)).firstPage[0]}async checkForDependenciesAndUninstall($,G,X){try{await this.preUninstallExtension($);const Z=X.donotIncludePack?[]:this.getAllPackExtensionsToUninstall($,G);await this.uninstallExtensions($,Z,G,X)}catch(Z){throw await this.postUninstallExtension($,new P.ExtensionManagementError(Z instanceof Error?Z.message:Z,N)),Z}await this.postUninstallExtension($)}async uninstallExtensions($,G,X,Z){const ee=[$,...G];if(!Z.donotCheckDependents)for(const se of ee)this.checkForDependents(se,ee,X,$);await n.Promises.settled([this.uninstallExtension($),...G.map(se=>this.doUninstall(se))])}checkForDependents($,G,X,Z){const ee=this.getDependents($,X);if(ee.length){const se=ee.filter(ue=>G.indexOf(ue)===-1);if(se.length)throw new Error(this.getDependentsErrorMessage($,se,Z))}}getDependentsErrorMessage($,G,X){return X===$?G.length===1?S.localize(8,null,X.manifest.displayName||X.manifest.name,G[0].manifest.displayName||G[0].manifest.name):G.length===2?S.localize(9,null,X.manifest.displayName||X.manifest.name,G[0].manifest.displayName||G[0].manifest.name,G[1].manifest.displayName||G[1].manifest.name):S.localize(10,null,X.manifest.displayName||X.manifest.name,G[0].manifest.displayName||G[0].manifest.name,G[1].manifest.displayName||G[1].manifest.name):G.length===1?S.localize(11,null,X.manifest.displayName||X.manifest.name,$.manifest.displayName||$.manifest.name,G[0].manifest.displayName||G[0].manifest.name):G.length===2?S.localize(12,null,X.manifest.displayName||X.manifest.name,$.manifest.displayName||$.manifest.name,G[0].manifest.displayName||G[0].manifest.name,G[1].manifest.displayName||G[1].manifest.name):S.localize(13,null,X.manifest.displayName||X.manifest.name,$.manifest.displayName||$.manifest.name,G[0].manifest.displayName||G[0].manifest.name,G[1].manifest.displayName||G[1].manifest.name)}getAllPackExtensionsToUninstall($,G,X=[]){if(X.indexOf($)!==-1)return[];X.push($);const Z=$.manifest.extensionPack?$.manifest.extensionPack:[];if(Z.length){const ee=G.filter(ue=>!ue.isBuiltin&&Z.some(ge=>(0,v.areSameExtensions)({id:ge},ue.identifier))),se=[];for(const ue of ee)se.push(...this.getAllPackExtensionsToUninstall(ue,G,X));return[...ee,...se]}return[]}getDependents($,G){return G.filter(X=>X.manifest.extensionDependencies&&X.manifest.extensionDependencies.some(Z=>(0,v.areSameExtensions)({id:Z},$.identifier)))}async doUninstall($){try{await this.preUninstallExtension($),await this.uninstallExtension($)}catch(G){throw await this.postUninstallExtension($,new P.ExtensionManagementError(G instanceof Error?G.message:G,N)),G}await this.postUninstallExtension($)}async preUninstallExtension($){if(!await R.Promises.exists($.location.fsPath))throw new Error(S.localize(14,null));this.logService.info("Uninstalling extension:",$.identifier.id),this._onUninstallExtension.fire($.identifier)}async uninstallExtension($){let G=this.uninstallingExtensions.get($.identifier.id);return G||(G=(0,n.createCancelablePromise)(async()=>{const X=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...X.filter(Z=>(0,v.areSameExtensions)(Z.identifier,$.identifier)))}),this.uninstallingExtensions.set($.identifier.id,G),G.finally(()=>this.uninstallingExtensions.delete($.identifier.id))),G}async postUninstallExtension($,G){if(G)this.logService.error("Failed to uninstall extension:",$.identifier.id,G.message);else if(this.logService.info("Successfully uninstalled extension:",$.identifier.id),$.identifier.uuid)try{await this.galleryService.reportStatistic($.manifest.publisher,$.manifest.name,$.manifest.version,"uninstall")}catch(Z){}F(this.telemetryService,"extensionGallery:uninstall",(0,v.getLocalExtensionTelemetryData)($),void 0,G);const X=G?G instanceof P.ExtensionManagementError?G.code:_:void 0;this._onDidUninstallExtension.fire({identifier:$.identifier,error:X})}getInstalled($=null){return this.extensionsScanner.scanExtensions($)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}getExtensionsReport(){const $=new Date().getTime();return(!this.reportedExtensions||$-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=$),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const $=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${$.length} reported extensions from service`),$}catch($){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};M=de([J(0,w.INativeEnvironmentService),J(1,P.IExtensionGalleryService),J(2,D.ILogService),J(3,(0,i.optional)(r.IDownloadService)),J(4,g.ITelemetryService),J(5,i.IInstantiationService),J(6,T.IFileService)],M),e.ExtensionManagementService=M;function B(K){const $=Array.isArray(K)?K:[K];return $.length===1?$[0]instanceof Error?$[0]:new Error($[0]):$.reduce((G,X)=>new Error(`${G.message}${G.message?",":""}${X instanceof Error?X.message:X}`),new Error(""))}function F(K,$,G,X,Z){const ee=Z?Z instanceof P.ExtensionManagementError?Z.code:_:void 0;K.publicLogError($,{...G,success:!Z,duration:X,errorcode:ee})}class U{constructor($,G,X,Z){this.identifier=$,this.source=G,this.extensionsScanner=X,this.logService=Z,this.barrier=new n.Barrier,this._operation=1}get operation(){return this._operation}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)($=>this.install($))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)($=>new Promise((G,X)=>{const Z=$.onCancellationRequested(()=>{Z.dispose(),X((0,O.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}async installExtension($,G){try{const X=await this.unsetUninstalledAndGetLocal($.identifierWithVersion);if(X)return $.metadata?this.extensionsScanner.saveMetadataForLocalExtension(X,$.metadata):X}catch(X){throw C.isMacintosh?new P.ExtensionManagementError(S.localize(15,null),j):new P.ExtensionManagementError(S.localize(16,null),j)}return this.extract($,G)}async unsetUninstalledAndGetLocal($){if(!await this.isUninstalled($))return null;this.logService.trace("Removing the extension from uninstalled list:",$.id);const X=await this.extensionsScanner.setInstalled($);return this.logService.info("Removed the extension from uninstalled list:",$.id),X}async isUninstalled($){return!!(await this.extensionsScanner.getUninstalledExtensions())[$.key()]}async extract({zipPath:$,identifierWithVersion:G,metadata:X},Z){let ee=await this.extensionsScanner.extractUserExtension(G,$,Z);return this.logService.info("Extracting completed.",G.id),X&&(ee=await this.extensionsScanner.saveMetadataForLocalExtension(ee,X)),ee}}class z extends U{constructor($,G,X,Z,ee,se){super($.identifier,$,ee,se);this.gallery=$,this.options=G,this.extensionsDownloader=X,this.telemetryService=Z}install($){return this.installGalleryExtension(this.gallery,this.options,$)}async installGalleryExtension($,G,X){const Z=new Date().getTime();try{const se=(await this.extensionsScanner.scanExtensions(null)).find(me=>(0,v.areSameExtensions)(me.identifier,$.identifier));se&&(this._operation=2);const ue=await this.downloadInstallableExtension($,this._operation);ue.metadata.isMachineScoped=G.isMachineScoped||se?.isMachineScoped,ue.metadata.isBuiltin=G.isBuiltin||se?.isBuiltin;const ge=await this.installExtension(ue,X);se&&m.neq(se.manifest.version,$.version)&&await this.extensionsScanner.setUninstalled(se);try{await this.extensionsDownloader.delete(d.URI.file(ue.zipPath))}catch(me){}return F(this.telemetryService,this.getTelemetryEvent(this._operation),(0,v.getGalleryExtensionTelemetryData)($),new Date().getTime()-Z,void 0),ge}catch(ee){throw F(this.telemetryService,this.getTelemetryEvent(this._operation),(0,v.getGalleryExtensionTelemetryData)($),new Date().getTime()-Z,ee),ee}}getTelemetryEvent($){return $===2?"extensionGallery:update":"extensionGallery:install"}async downloadInstallableExtension($,G){const X={id:$.identifier.uuid,publisherId:$.publisherId,publisherDisplayName:$.publisherDisplayName};let Z;try{this.logService.trace("Started downloading extension:",$.identifier.id),Z=(await this.extensionsDownloader.downloadExtension($,G)).fsPath,this.logService.info("Downloaded extension:",$.identifier.id,Z)}catch(ee){throw new P.ExtensionManagementError(B(ee).message,H)}try{const ee=await(0,o.getManifest)(Z);return{zipPath:Z,identifierWithVersion:new v.ExtensionIdentifierWithVersion($.identifier,ee.version),metadata:X}}catch(ee){throw new P.ExtensionManagementError(B(ee).message,V)}}}class W extends U{constructor($,G,X,Z,ee,se){super({id:(0,v.getGalleryExtensionId)($.publisher,$.name)},G,ee,se);this.manifest=$,this.zipPath=G,this.options=X,this.galleryService=Z}async install($){const G=new v.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),Z=(await this.extensionsScanner.scanExtensions(1)).find(se=>(0,v.areSameExtensions)(this.identifier,se.identifier)),ee=await this.getMetadata(this.identifier.id,$);if(Z)if(ee.isMachineScoped=this.options.isMachineScoped||Z.isMachineScoped,ee.isBuiltin=this.options.isBuiltin||Z.isBuiltin,this._operation=2,G.equals(new v.ExtensionIdentifierWithVersion(Z.identifier,Z.manifest.version)))try{await this.extensionsScanner.removeExtension(Z,"existing")}catch(se){throw new Error(S.localize(17,null,this.manifest.displayName||this.manifest.name))}else m.gt(Z.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(Z);else{const se=await this.unsetUninstalledAndGetLocal(G);if(se)try{await this.extensionsScanner.removeExtension(se,"existing")}catch(ue){throw new Error(S.localize(18,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:this.zipPath,identifierWithVersion:G,metadata:ee},$)}async getMetadata($,G){try{const X=(await this.galleryService.query({names:[$],pageSize:1},G)).firstPage[0];if(X)return{id:X.identifier.uuid,publisherDisplayName:X.publisherDisplayName,publisherId:X.publisherId}}catch(X){}return{}}}}),define(te[212],ne([0,1,48,35,213,102,51,101,36,76,50,149,10,131,133,28,206,174,23,165,39,166,24,59,172,80,81,177,16,77,158,56,2,167,72,162,163,154,153,151,150,173,71,159,11,161,17,27,21,199,201,196,58,197,202,171,20,169,198,60,195,175,61,73,135,203,176,86,85,84,4,152,144,9,43,82,184,179,200,142,146,178,5,15]),function(Y,e,S,L,R,k,A,P,v,w,n,p,m,d,h,C,D,b,I,g,s,c,t,r,i,a,l,o,u,y,E,f,T,O,x,j,H,V,N,_,M,B,F,U,z,W,K,$,G,X,Z,ee,se,ue,ge,me,Se,be,Ce,Ee,De,Fe,Re,Te,Ke,Ye,$e,je,Q,re,ae,ye,pe,Ae,Ie,Ue,Le,Oe,Me,q,ie,oe,le,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class fe extends T.Disposable{constructor(he){super();this.configuration=he,this.server=this._register(new P.Server),(0,R.gracefulify)(S),this.registerListeners()}registerListeners(){const he=()=>this.dispose();process.once("exit",he),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",he)}async open(){const he=await this.initServices();(0,G.registerConfiguration)(),he.invokeFunction(Pe=>{const ke=Pe.get(u.ILogService);ke.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Pe),this.registerErrorHandler(ke)}),this._register((0,T.combinedDisposable)(he.createInstance(j.CodeCacheCleaner,this.configuration.codeCachePath),he.createInstance(H.LanguagePackCachedDataCleaner),he.createInstance(V.StorageDataCleaner,this.configuration.backupWorkspacesPath),he.createInstance(N.LogsDataCleaner),he.createInstance(ye.LocalizationsUpdater),he.createInstance(pe.DeprecatedExtensionsCleaner)))}async initServices(){const he=new w.ServiceCollection,Pe={_serviceBrand:void 0,...A.default};he.set($.IProductService,Pe);const ke=new v.StaticRouter(We=>We==="main"),Ne=new M.MessagePortMainProcessService(this.server,ke);he.set(_.IMainProcessService,Ne);const _e=new d.NativeEnvironmentService(this.configuration.args,Pe);he.set(m.INativeEnvironmentService,_e);const et=new y.LogLevelChannelClient(this.server.getChannel("logLevel",ke)),Je=new y.LoggerChannelClient(this.configuration.logLevel,et.onDidChangeLogLevel,Ne.getChannel("logger"));he.set(u.ILoggerService,Je);const nt=this._register(new u.MultiplexLogService([this._register(new u.ConsoleLogger(this.configuration.logLevel)),this._register(Je.createLogger((0,ce.joinPath)(le.URI.file(_e.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Be=this._register(new y.FollowerLogService(et,nt));he.set(u.ILogService,Be);const Ve=this._register(new U.FileService(Be));he.set(z.IFileService,Ve);const it=this._register(new W.DiskFileSystemProvider(Be));Ve.registerProvider(K.Schemas.file,it);const qe=this._register(new g.ConfigurationService(_e.settingsResource,Ve));he.set(I.IConfigurationService,qe),await qe.initialize();const Xe=new me.NativeStorageService(void 0,Ne,_e);he.set(Se.IStorageService,Xe),await Xe.initialize(),this._register((0,T.toDisposable)(()=>Xe.flush())),he.set(s.IRequestService,new n.SyncDescriptor(c.RequestService)),he.set(q.IChecksumService,new n.SyncDescriptor(ie.ChecksumService));const tt=v.ProxyChannel.toService(Ne.getChannel("nativeHost"),{context:this.configuration.windowId});he.set(se.INativeHostService,tt),he.set(x.IDownloadService,new n.SyncDescriptor(O.DownloadService));const rt=this._register(new Ye.ActiveWindowManager(tt)),ht=new v.StaticRouter(We=>rt.getActiveClientId().then(st=>We===st));he.set(Te.IExtensionRecommendationNotificationService,new Ke.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ht)));let Qe,He;if(!_e.isExtensionDevelopment&&!_e.disableTelemetry&&Pe.enableTelemetry){He=new $e.TelemetryLogAppender(Je,_e);const{appRoot:We,extensionsPath:st,isBuilt:dt,installSourcePath:gt}=_e;if(Pe.aiConfig&&Pe.aiConfig.asimovKey&&dt){const ct=new o.AppInsightsAppender("monacoworkbench",null,Pe.aiConfig.asimovKey);this._register((0,T.toDisposable)(()=>ct.flush())),He=(0,r.combinedAppender)(ct,He)}Qe=new l.TelemetryService({appender:He,commonProperties:(0,i.resolveCommonProperties)(Ve,(0,L.release)(),(0,L.hostname)(),process.arch,Pe.commit,Pe.version,this.configuration.machineId,Pe.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:[We,st]},qe)}else Qe=r.NullTelemetryService,He=r.NullAppender;this.server.registerChannel("telemetryAppender",new a.TelemetryAppenderChannel(He)),he.set(t.ITelemetryService,Qe);const ft=new oe.CustomEndpointTelemetryService(qe,Qe);return he.set(t.ICustomEndpointTelemetryService,ft),he.set(C.IExtensionManagementService,new n.SyncDescriptor(D.ExtensionManagementService)),he.set(C.IExtensionGalleryService,new n.SyncDescriptor(b.ExtensionGalleryService)),he.set(C.IExtensionTipsService,new n.SyncDescriptor(Fe.ExtensionTipsService)),he.set(f.ILocalizationsService,new n.SyncDescriptor(E.LocalizationsService)),he.set(F.IDiagnosticsService,new n.SyncDescriptor(B.DiagnosticsService)),he.set(Ee.IUserDataSyncAccountService,new n.SyncDescriptor(Ee.UserDataSyncAccountService)),he.set(G.IUserDataSyncLogService,new n.SyncDescriptor(ue.UserDataSyncLogService)),he.set(G.IUserDataSyncUtilService,new ee.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),he.set(C.IGlobalExtensionEnablementService,new n.SyncDescriptor(be.GlobalExtensionEnablementService)),he.set(Q.IIgnoredExtensionsManagementService,new n.SyncDescriptor(Q.IgnoredExtensionsManagementService)),he.set(re.IExtensionsStorageSyncService,new n.SyncDescriptor(re.ExtensionsStorageSyncService)),he.set(G.IUserDataSyncStoreManagementService,new n.SyncDescriptor(Z.UserDataSyncStoreManagementService)),he.set(G.IUserDataSyncStoreService,new n.SyncDescriptor(Z.UserDataSyncStoreService)),he.set(Re.IUserDataSyncMachinesService,new n.SyncDescriptor(Re.UserDataSyncMachinesService)),he.set(G.IUserDataSyncBackupStoreService,new n.SyncDescriptor(De.UserDataSyncBackupStoreService)),he.set(G.IUserDataAutoSyncEnablementService,new n.SyncDescriptor(je.UserDataAutoSyncEnablementService)),he.set(G.IUserDataSyncResourceEnablementService,new n.SyncDescriptor(Ce.UserDataSyncResourceEnablementService)),he.set(G.IUserDataSyncService,new n.SyncDescriptor(X.UserDataSyncService)),he.set(Oe.ILocalPtyService,this._register(new Le.PtyHostService({GraceTime:6e4,ShortGraceTime:6e3},qe,Be,Qe))),new p.InstantiationService(he)}initChannels(he){const Pe=new h.ExtensionManagementChannel(he.get(C.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Pe);const ke=v.ProxyChannel.fromService(he.get(f.ILocalizationsService));this.server.registerChannel("localizations",ke);const Ne=v.ProxyChannel.fromService(he.get(F.IDiagnosticsService));this.server.registerChannel("diagnostics",Ne);const _e=new h.ExtensionTipsChannel(he.get(C.IExtensionTipsService));this.server.registerChannel("extensionTipsService",_e);const et=v.ProxyChannel.fromService(he.get(q.IChecksumService));this.server.registerChannel("checksum",et);const Je=new ee.UserDataSyncMachinesServiceChannel(he.get(Re.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Je);const nt=v.ProxyChannel.fromService(he.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",nt);const Be=new ee.UserDataSyncAccountServiceChannel(he.get(Ee.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Be);const Ve=new ee.UserDataSyncStoreManagementServiceChannel(he.get(G.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ve);const it=new Me.UserDataSyncChannel(he.get(G.IUserDataSyncService),he.get(u.ILogService));this.server.registerChannel("userDataSync",it);const qe=this._register(he.get(ae.IInstantiationService).createInstance(ge.UserDataAutoSyncService)),Xe=new ee.UserDataAutoSyncChannel(qe);this.server.registerChannel("userDataAutoSync",Xe);const tt=he.get(Oe.ILocalPtyService),rt=v.ProxyChannel.fromService(tt);this.server.registerChannel(Ue.TerminalIpcChannels.LocalPty,rt)}registerErrorHandler(he){window.addEventListener("unhandledrejection",Pe=>{(0,Ae.onUnexpectedError)(Pe.reason),Pe.preventDefault()}),(0,Ae.setUnexpectedErrorHandler)(Pe=>{const ke=(0,Ie.toErrorMessage)(Pe,!0);!ke||he.error(`[uncaught exception in sharedProcess]: ${ke}`)})}}async function ve(we){const he=new fe(we);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await he.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=ve})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/87d692b7bf1eb5a663b3e62620a6e7e436e1838c/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
