/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/errors","vs/base/common/types","vs/base/common/uri","vs/base/common/network","vs/base/node/pfs","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/base/common/process","vs/base/common/stream","vs/base/common/extpath","fs","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/performance","vs/base/common/iterator","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],te=function(q){for(var t=[],h=0,O=q.length;h<O;h++)t[h]=ee[q[h]];return t};define(ee[57],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function h(O,S){if(!O)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}t.ok=h}),define(ee[44],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function h(T){return(D,l,f)=>{let y=null,v=null;if(typeof f.value=="function"?(y="value",v=f.value):typeof f.get=="function"&&(y="get",v=f.get),!v)throw new Error("not supported");f[y]=T(v,l)}}t.createDecorator=h;function O(T,D,l){let f=null,y=null;if(typeof l.value=="function"?(f="value",y=l.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(f="get",y=l.get),!y)throw new Error("not supported");const v=`$memoize$${D}`;l[f]=function(...E){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,E)}),this[v]}}t.memoize=O;function S(T,D,l){return h((f,y)=>{const v=`$debounce$${y}`,E=`$debounce$result$${y}`;return function(...A){this[E]||(this[E]=l?l():void 0),clearTimeout(this[v]),D&&(this[E]=D(this[E],...A),A=[this[E]]),this[v]=setTimeout(()=>{f.apply(this,A),this[E]=l?l():void 0},T)}})}t.debounce=S;function R(T,D,l){return h((f,y)=>{const v=`$throttle$timer$${y}`,E=`$throttle$result$${y}`,A=`$throttle$lastRun$${y}`,a=`$throttle$pending$${y}`;return function(...u){if(this[E]||(this[E]=l?l():void 0),(this[A]===null||this[A]===void 0)&&(this[A]=-Number.MAX_VALUE),D&&(this[E]=D(this[E],...u)),this[a])return;const I=this[A]+T;I<=Date.now()?(this[A]=Date.now(),f.apply(this,[this[E]]),this[E]=l?l():void 0):(this[a]=!0,this[v]=setTimeout(()=>{this[a]=!1,this[A]=Date.now(),f.apply(this,[this[E]]),this[E]=l?l():void 0},I-Date.now()))}})}t.throttle=R}),define(ee[22],te([0,1,7]),function(q,t,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayQueue=t.maxIndex=t.minIndex=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function O(P,g=0){return P[P.length-(1+g)]}t.tail=O;function S(P){if(P.length===0)throw new Error("Invalid tail call");return[P.slice(0,P.length-1),P[P.length-1]]}t.tail2=S;function R(P,g,L=(k,M)=>k===M){if(P===g)return!0;if(!P||!g||P.length!==g.length)return!1;for(let k=0,M=P.length;k<M;k++)if(!L(P[k],g[k]))return!1;return!0}t.equals=R;function T(P,g,L){let k=0,M=P.length-1;for(;k<=M;){const m=(k+M)/2|0,N=L(P[m],g);if(N<0)k=m+1;else if(N>0)M=m-1;else return m}return-(k+1)}t.binarySearch=T;function D(P,g){let L=0,k=P.length;if(k===0)return 0;for(;L<k;){const M=Math.floor((L+k)/2);g(P[M])?k=M:L=M+1}return L}t.findFirstInSorted=D;function l(P,g,L){if(P=P|0,P>=g.length)throw new TypeError("invalid index");let k=g[Math.floor(g.length*Math.random())],M=[],m=[],N=[];for(let z of g){const V=L(z,k);V<0?M.push(z):V>0?m.push(z):N.push(z)}return P<M.length?l(P,M,L):P<M.length+N.length?N[0]:l(P-(M.length+N.length),m,L)}t.quickSelect=l;function f(P,g){const L=[];let k;for(const M of P.slice(0).sort(g))!k||g(k[0],M)!==0?(k=[M],L.push(k)):k.push(M);return L}t.groupBy=f;function y(P,g,L){const k=[];function M(z,V,$){if(V===0&&$.length===0)return;const K=k[k.length-1];K&&K.start+K.deleteCount===z?(K.deleteCount+=V,K.toInsert.push(...$)):k.push({start:z,deleteCount:V,toInsert:$})}let m=0,N=0;for(;;){if(m===P.length){M(m,0,g.slice(N));break}if(N===g.length){M(m,P.length-m,[]);break}const z=P[m],V=g[N],$=L(z,V);$===0?(m+=1,N+=1):$<0?(M(m,1,[]),m+=1):$>0&&(M(m,0,[V]),N+=1)}return k}t.sortedDiff=y;function v(P,g,L){const k=y(P,g,L),M=[],m=[];for(const N of k)M.push(...P.slice(N.start,N.start+N.deleteCount)),m.push(...N.toInsert);return{removed:M,added:m}}t.delta=v;function E(P,g,L){if(L===0)return[];const k=P.slice(0,L).sort(g);return a(P,g,k,L,P.length),k}t.top=E;function A(P,g,L,k,M){return L===0?Promise.resolve([]):new Promise((m,N)=>{(async()=>{const z=P.length,V=P.slice(0,L).sort(g);for(let $=L,K=Math.min(L+k,z);$<z;$=K,K=Math.min(K+k,z)){if($>L&&await new Promise(Y=>setTimeout(Y)),M&&M.isCancellationRequested)throw(0,h.canceled)();a(P,g,V,$,K)}return V})().then(m,N)})}t.topAsync=A;function a(P,g,L,k,M){for(const m=L.length;k<M;k++){const N=P[k];if(g(N,L[m-1])<0){L.pop();const z=D(L,V=>g(N,V)<0);L.splice(z,0,N)}}}function u(P){return P.filter(g=>!!g)}t.coalesce=u;function I(P){let g=0;for(let L=0;L<P.length;L++)P[L]&&(P[g]=P[L],g+=1);P.length=g}t.coalesceInPlace=I;function C(P,g,L){P.splice(L,0,P.splice(g,1)[0])}t.move=C;function b(P){return!Array.isArray(P)||P.length===0}t.isFalsyOrEmpty=b;function d(P){return Array.isArray(P)&&P.length>0}t.isNonEmptyArray=d;function r(P,g){if(!g)return P.filter((k,M)=>P.indexOf(k)===M);const L=Object.create(null);return P.filter(k=>{const M=g(k);return L[M]?!1:(L[M]=!0,!0)})}t.distinct=r;function o(P){const g=new Set;return P.filter(L=>g.has(L)?!1:(g.add(L),!0))}t.distinctES6=o;function e(P){const g=Object.create(null);return L=>{const k=P(L);return g[k]?!1:(g[k]=!0,!0)}}t.uniqueFilter=e;function i(P,g){for(let L=P.length-1;L>=0;L--){const k=P[L];if(g(k))return L}return-1}t.lastIndex=i;function n(P,g){return P.length>0?P[0]:g}t.firstOrDefault=n;function s(P,g,L=(k,M)=>k===M){let k=0;for(let M=0,m=Math.min(P.length,g.length);M<m&&L(P[M],g[M]);M++)k++;return k}t.commonPrefixLength=s;function c(P){return[].concat(...P)}t.flatten=c;function p(P,g){let L=typeof g=="number"?P:0;typeof g=="number"?L=P:(L=0,g=P);const k=[];if(L<=g)for(let M=L;M<g;M++)k.push(M);else for(let M=L;M>g;M--)k.push(M);return k}t.range=p;function w(P,g,L){return P.reduce((k,M)=>(k[g(M)]=L?L(M):M,k),Object.create(null))}t.index=w;function x(P,g){return P.push(g),()=>F(P,g)}t.insert=x;function F(P,g){const L=P.indexOf(g);if(L>-1)return P.splice(L,1),g}t.remove=F;function U(P,g,L){const k=P.slice(0,g),M=P.slice(g);return k.concat(L,M)}t.arrayInsert=U;function B(P,g){let L;if(typeof g=="number"){let k=g;L=()=>{const M=Math.sin(k++)*179426549;return M-Math.floor(M)}}else L=Math.random;for(let k=P.length-1;k>0;k-=1){const M=Math.floor(L()*(k+1)),m=P[k];P[k]=P[M],P[M]=m}}t.shuffle=B;function _(P,g){const L=P.indexOf(g);L>-1&&(P.splice(L,1),P.unshift(g))}t.pushToStart=_;function Q(P,g){const L=P.indexOf(g);L>-1&&(P.splice(L,1),P.push(g))}t.pushToEnd=Q;function ne(P,g){return Array.isArray(P)?P.map(g):g(P)}t.mapArrayOrNot=ne;function se(P){return Array.isArray(P)?P:[P]}t.asArray=se;function Z(P){return P[Math.floor(Math.random()*P.length)]}t.getRandomElement=Z;function ce(P,g){for(const L of P){const k=g(L);if(k!==void 0)return k}}t.mapFind=ce;function H(P,g){let L=Number.MAX_SAFE_INTEGER,k=0;return P.forEach((M,m)=>{const N=g(M);N<L&&(L=N,k=m)}),k}t.minIndex=H;function W(P,g){let L=Number.MIN_SAFE_INTEGER,k=0;return P.forEach((M,m)=>{const N=g(M);N>L&&(L=N,k=m)}),k}t.maxIndex=W;class J{constructor(g){this.items=g,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(g){let L=this.firstIdx;for(;L<this.items.length&&g(this.items[L]);)L++;const k=L===this.firstIdx?null:this.items.slice(this.firstIdx,L);return this.firstIdx=L,k}takeFromEndWhile(g){let L=this.lastIdx;for(;L>=0&&g(this.items[L]);)L--;const k=L===this.lastIdx?null:this.items.slice(L+1,this.lastIdx+1);return this.lastIdx=L,k}}t.ArrayQueue=J}),define(ee[58],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var h;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(h=t.ScanError||(t.ScanError={}));var O;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(O=t.SyntaxKind||(t.SyntaxKind={}));var S;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(S=t.ParseErrorCode||(t.ParseErrorCode={}));var R;(function(e){e.DEFAULT={allowTrailingComma:!0}})(R=t.ParseOptions||(t.ParseOptions={}));function T(e,i=!1){let n=0,s=e.length,c="",p=0,w=16,x=0;function F(Z){let ce=0,H=0;for(;ce<Z;){const W=e.charCodeAt(n);if(W>=48&&W<=57)H=H*16+W-48;else if(W>=65&&W<=70)H=H*16+W-65+10;else if(W>=97&&W<=102)H=H*16+W-97+10;else break;n++,ce++}return ce<Z&&(H=-1),H}function U(Z){n=Z,c="",p=0,w=16,x=0}function B(){const Z=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&f(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&f(e.charCodeAt(n)))for(n++;n<e.length&&f(e.charCodeAt(n));)n++;else return x=3,e.substring(Z,n);let ce=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&f(e.charCodeAt(n))){for(n++;n<e.length&&f(e.charCodeAt(n));)n++;ce=n}else x=3;return e.substring(Z,ce)}function _(){let Z="",ce=n;for(;;){if(n>=s){Z+=e.substring(ce,n),x=2;break}const H=e.charCodeAt(n);if(H===34){Z+=e.substring(ce,n),n++;break}if(H===92){if(Z+=e.substring(ce,n),n++,n>=s){x=2;break}switch(e.charCodeAt(n++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:const J=F(4);J>=0?Z+=String.fromCharCode(J):x=4;break;default:x=5}ce=n;continue}if(H>=0&&H<=31)if(l(H)){Z+=e.substring(ce,n),x=2;break}else x=6;n++}return Z}function Q(){if(c="",x=0,p=n,n>=s)return p=s,w=17;let Z=e.charCodeAt(n);if(D(Z)){do n++,c+=String.fromCharCode(Z),Z=e.charCodeAt(n);while(D(Z));return w=15}if(l(Z))return n++,c+=String.fromCharCode(Z),Z===13&&e.charCodeAt(n)===10&&(n++,c+=`
`),w=14;switch(Z){case 123:return n++,w=1;case 125:return n++,w=2;case 91:return n++,w=3;case 93:return n++,w=4;case 58:return n++,w=6;case 44:return n++,w=5;case 34:return n++,c=_(),w=10;case 47:const ce=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<s&&!l(e.charCodeAt(n));)n++;return c=e.substring(ce,n),w=12}if(e.charCodeAt(n+1)===42){n+=2;const H=s-1;let W=!1;for(;n<H;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,W=!0;break}n++}return W||(n++,x=1),c=e.substring(ce,n),w=13}return c+=String.fromCharCode(Z),n++,w=16;case 45:if(c+=String.fromCharCode(Z),n++,n===s||!f(e.charCodeAt(n)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=B(),w=11;default:for(;n<s&&ne(Z);)n++,Z=e.charCodeAt(n);if(p!==n){switch(c=e.substring(p,n),c){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return c+=String.fromCharCode(Z),n++,w=16}}function ne(Z){if(D(Z)||l(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let Z;do Z=Q();while(Z>=12&&Z<=15);return Z}return{setPosition:U,getPosition:()=>n,scan:i?se:Q,getToken:()=>w,getTokenValue:()=>c,getTokenOffset:()=>p,getTokenLength:()=>n-p,getTokenError:()=>x}}t.createScanner=T;function D(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function l(e){return e===10||e===13||e===8232||e===8233}function f(e){return e>=48&&e<=57}var y;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(y||(y={}));function v(e,i){const n=[],s=new Object;let c;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function x(F,U,B,_){p.value=F,p.offset=U,p.length=B,p.type=_,p.colonOffset=void 0,c=p}try{d(e,{onObjectBegin:(F,U)=>{if(i<=F)throw s;c=void 0,w=i>F,n.push("")},onObjectProperty:(F,U,B)=>{if(i<U||(x(F,U,B,"property"),n[n.length-1]=F,i<=U+B))throw s},onObjectEnd:(F,U)=>{if(i<=F)throw s;c=void 0,n.pop()},onArrayBegin:(F,U)=>{if(i<=F)throw s;c=void 0,n.push(0)},onArrayEnd:(F,U)=>{if(i<=F)throw s;c=void 0,n.pop()},onLiteralValue:(F,U,B)=>{if(i<U||(x(F,U,B,o(F)),i<=U+B))throw s},onSeparator:(F,U,B)=>{if(i<=U)throw s;if(F===":"&&c&&c.type==="property")c.colonOffset=U,w=!1,c=void 0;else if(F===","){const _=n[n.length-1];typeof _=="number"?n[n.length-1]=_+1:(w=!0,n[n.length-1]=""),c=void 0}}})}catch(F){if(F!==s)throw F}return{path:n,previousNode:c,isAtPropertyKey:w,matches:F=>{let U=0;for(let B=0;U<F.length&&B<n.length;B++)if(F[U]===n[B]||F[U]==="*")U++;else if(F[U]!=="**")return!1;return U===F.length}}}t.getLocation=v;function E(e,i=[],n=R.DEFAULT){let s=null,c=[];const p=[];function w(F){Array.isArray(c)?c.push(F):s!==null&&(c[s]=F)}return d(e,{onObjectBegin:()=>{const F={};w(F),p.push(c),c=F,s=null},onObjectProperty:F=>{s=F},onObjectEnd:()=>{c=p.pop()},onArrayBegin:()=>{const F=[];w(F),p.push(c),c=F,s=null},onArrayEnd:()=>{c=p.pop()},onLiteralValue:w,onError:(F,U,B)=>{i.push({error:F,offset:U,length:B})}},n),c[0]}t.parse=E;function A(e,i=[],n=R.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(F){s.type==="property"&&(s.length=F-s.offset,s=s.parent)}function p(F){return s.children.push(F),F}d(e,{onObjectBegin:F=>{s=p({type:"object",offset:F,length:-1,parent:s,children:[]})},onObjectProperty:(F,U,B)=>{s=p({type:"property",offset:U,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:F,offset:U,length:B,parent:s})},onObjectEnd:(F,U)=>{s.length=F+U-s.offset,s=s.parent,c(F+U)},onArrayBegin:(F,U)=>{s=p({type:"array",offset:F,length:-1,parent:s,children:[]})},onArrayEnd:(F,U)=>{s.length=F+U-s.offset,s=s.parent,c(F+U)},onLiteralValue:(F,U,B)=>{p({type:o(F),offset:U,length:B,parent:s,value:F}),c(U+B)},onSeparator:(F,U,B)=>{s.type==="property"&&(F===":"?s.colonOffset=U:F===","&&c(U))},onError:(F,U,B)=>{i.push({error:F,offset:U,length:B})}},n);const x=s.children[0];return x&&delete x.parent,x}t.parseTree=A;function a(e,i){if(!e)return;let n=e;for(let s of i)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let c=!1;for(const p of n.children)if(Array.isArray(p.children)&&p.children[0].value===s){n=p.children[1],c=!0;break}if(!c)return}else{const c=s;if(n.type!=="array"||c<0||!Array.isArray(n.children)||c>=n.children.length)return;n=n.children[c]}return n}t.findNodeAtLocation=a;function u(e){if(!e.parent||!e.parent.children)return[];const i=u(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=u;function I(e){switch(e.type){case"array":return e.children.map(I);case"object":const i=Object.create(null);for(let n of e.children){const s=n.children[1];s&&(i[n.children[0].value]=I(s))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=I;function C(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=C;function b(e,i,n=!1){if(C(e,i,n)){const s=e.children;if(Array.isArray(s))for(let c=0;c<s.length&&s[c].offset<=i;c++){const p=b(s[c],i,n);if(p)return p}return e}}t.findNodeAtOffset=b;function d(e,i,n=R.DEFAULT){const s=T(e,!1);function c(m){return m?()=>m(s.getTokenOffset(),s.getTokenLength()):()=>!0}function p(m){return m?N=>m(N,s.getTokenOffset(),s.getTokenLength()):()=>!0}const w=c(i.onObjectBegin),x=p(i.onObjectProperty),F=c(i.onObjectEnd),U=c(i.onArrayBegin),B=c(i.onArrayEnd),_=p(i.onLiteralValue),Q=p(i.onSeparator),ne=c(i.onComment),se=p(i.onError),Z=n&&n.disallowComments,ce=n&&n.allowTrailingComma;function H(){for(;;){const m=s.scan();switch(s.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:Z||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(m){case 12:case 13:Z?W(10):ne();break;case 16:W(1);break;case 15:case 14:break;default:return m}}}function W(m,N=[],z=[]){if(se(m),N.length+z.length>0){let V=s.getToken();for(;V!==17;){if(N.indexOf(V)!==-1){H();break}else if(z.indexOf(V)!==-1)break;V=H()}}}function J(m){const N=s.getTokenValue();return m?_(N):x(N),H(),!0}function P(){switch(s.getToken()){case 11:let m=0;try{m=JSON.parse(s.getTokenValue()),typeof m!="number"&&(W(2),m=0)}catch(N){W(2)}_(m);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return H(),!0}function g(){return s.getToken()!==10?(W(3,[],[2,5]),!1):(J(!1),s.getToken()===6?(Q(":"),H(),M()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function L(){w(),H();let m=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(m||W(4,[],[]),Q(","),H(),s.getToken()===2&&ce)break}else m&&W(6,[],[]);g()||W(4,[],[2,5]),m=!0}return F(),s.getToken()!==2?W(7,[2],[]):H(),!0}function k(){U(),H();let m=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(m||W(4,[],[]),Q(","),H(),s.getToken()===4&&ce)break}else m&&W(6,[],[]);M()||W(4,[],[4,5]),m=!0}return B(),s.getToken()!==4?W(8,[4],[]):H(),!0}function M(){switch(s.getToken()){case 3:return k();case 1:return L();case 10:return J(!0);default:return P()}}return H(),s.getToken()===17?n.allowEmptyContent?!0:(W(4,[],[]),!1):M()?(s.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}t.visit=d;function r(e,i){let n=T(e),s=[],c,p=0,w;do switch(w=n.getPosition(),c=n.scan(),c){case 12:case 13:case 17:p!==w&&s.push(e.substring(p,w)),i!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,i)),p=n.getPosition();break}while(c!==17);return s.join("")}t.stripComments=r;function o(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=o}),function(){function q(S){const R=[];typeof S=="number"&&R.push("code/timeOrigin",S);function T(l){R.push(l,Date.now())}function D(){const l=[];for(let f=0;f<R.length;f+=2)l.push({name:R[f],startTime:R[f+1]});return l}return{mark:T,getMarks:D}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const T of performance.getEntriesByType("mark"))R.push({name:T.name,startTime:Math.round(S+T.startTime)});return R}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function h(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=t()),S.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return h(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=h(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=h(O))}(),function(q,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var h=t();for(var O in h)(typeof exports=="object"?exports:q)[O]=h[O]}}(typeof self!="undefined"?self:this,function(){return function(q){var t={};function h(O){if(t[O])return t[O].exports;var S=t[O]={i:O,l:!1,exports:{}};return q[O].call(S.exports,S,S.exports,h),S.l=!0,S.exports}return h.m=q,h.c=t,h.d=function(O,S,R){h.o(O,S)||Object.defineProperty(O,S,{enumerable:!0,get:R})},h.r=function(O){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},h.t=function(O,S){if(1&S&&(O=h(O)),8&S||4&S&&typeof O=="object"&&O&&O.__esModule)return O;var R=Object.create(null);if(h.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:O}),2&S&&typeof O!="string")for(var T in O)h.d(R,T,function(D){return O[D]}.bind(null,T));return R},h.n=function(O){var S=O&&O.__esModule?function(){return O.default}:function(){return O};return h.d(S,"a",S),S},h.o=function(O,S){return Object.prototype.hasOwnProperty.call(O,S)},h.p="",h(h.s=0)}([function(q,t,h){(function(O){var S;t=q.exports=z,S=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var R=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,D=t.re=[],l=t.src=[],f=0,y=f++;l[y]="0|[1-9]\\d*";var v=f++;l[v]="[0-9]+";var E=f++;l[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var A=f++;l[A]="("+l[y]+")\\.("+l[y]+")\\.("+l[y]+")";var a=f++;l[a]="("+l[v]+")\\.("+l[v]+")\\.("+l[v]+")";var u=f++;l[u]="(?:"+l[y]+"|"+l[E]+")";var I=f++;l[I]="(?:"+l[v]+"|"+l[E]+")";var C=f++;l[C]="(?:-("+l[u]+"(?:\\."+l[u]+")*))";var b=f++;l[b]="(?:-?("+l[I]+"(?:\\."+l[I]+")*))";var d=f++;l[d]="[0-9A-Za-z-]+";var r=f++;l[r]="(?:\\+("+l[d]+"(?:\\."+l[d]+")*))";var o=f++,e="v?"+l[A]+l[C]+"?"+l[r]+"?";l[o]="^"+e+"$";var i="[v=\\s]*"+l[a]+l[b]+"?"+l[r]+"?",n=f++;l[n]="^"+i+"$";var s=f++;l[s]="((?:<|>)?=?)";var c=f++;l[c]=l[v]+"|x|X|\\*";var p=f++;l[p]=l[y]+"|x|X|\\*";var w=f++;l[w]="[v=\\s]*("+l[p]+")(?:\\.("+l[p]+")(?:\\.("+l[p]+")(?:"+l[C]+")?"+l[r]+"?)?)?";var x=f++;l[x]="[v=\\s]*("+l[c]+")(?:\\.("+l[c]+")(?:\\.("+l[c]+")(?:"+l[b]+")?"+l[r]+"?)?)?";var F=f++;l[F]="^"+l[s]+"\\s*"+l[w]+"$";var U=f++;l[U]="^"+l[s]+"\\s*"+l[x]+"$";var B=f++;l[B]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=f++;l[_]="(?:~>?)";var Q=f++;l[Q]="(\\s*)"+l[_]+"\\s+",D[Q]=new RegExp(l[Q],"g");var ne=f++;l[ne]="^"+l[_]+l[w]+"$";var se=f++;l[se]="^"+l[_]+l[x]+"$";var Z=f++;l[Z]="(?:\\^)";var ce=f++;l[ce]="(\\s*)"+l[Z]+"\\s+",D[ce]=new RegExp(l[ce],"g");var H=f++;l[H]="^"+l[Z]+l[w]+"$";var W=f++;l[W]="^"+l[Z]+l[x]+"$";var J=f++;l[J]="^"+l[s]+"\\s*("+i+")$|^$";var P=f++;l[P]="^"+l[s]+"\\s*("+e+")$|^$";var g=f++;l[g]="(\\s*)"+l[s]+"\\s*("+i+"|"+l[w]+")",D[g]=new RegExp(l[g],"g");var L=f++;l[L]="^\\s*("+l[w]+")\\s+-\\s+("+l[w]+")\\s*$";var k=f++;l[k]="^\\s*("+l[x]+")\\s+-\\s+("+l[x]+")\\s*$";var M=f++;l[M]="(<|>)?=?\\s*\\*";for(var m=0;m<35;m++)S(m,l[m]),D[m]||(D[m]=new RegExp(l[m]));function N(j,G){if(j instanceof z)return j;if(typeof j!="string"||j.length>R||!(G?D[n]:D[o]).test(j))return null;try{return new z(j,G)}catch(X){return null}}function z(j,G){if(j instanceof z){if(j.loose===G)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof z))return new z(j,G);S("SemVer",j,G),this.loose=G;var X=j.trim().match(G?D[n]:D[o]);if(!X)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(oe){if(/^[0-9]+$/.test(oe)){var le=+oe;if(le>=0&&le<T)return le}return oe}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}t.parse=N,t.valid=function(j,G){var X=N(j,G);return X?X.version:null},t.clean=function(j,G){var X=N(j.trim().replace(/^[=v]+/,""),G);return X?X.version:null},t.SemVer=z,z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},z.prototype.toString=function(){return this.version},z.prototype.compare=function(j){return S("SemVer.compare",this.version,this.loose,j),j instanceof z||(j=new z(j,this.loose)),this.compareMain(j)||this.comparePre(j)},z.prototype.compareMain=function(j){return j instanceof z||(j=new z(j,this.loose)),$(this.major,j.major)||$(this.minor,j.minor)||$(this.patch,j.patch)},z.prototype.comparePre=function(j){if(j instanceof z||(j=new z(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var G=0;do{var X=this.prerelease[G],oe=j.prerelease[G];if(S("prerelease compare",G,X,oe),X===void 0&&oe===void 0)return 0;if(oe===void 0)return 1;if(X===void 0)return-1;if(X!==oe)return $(X,oe)}while(++G)},z.prototype.inc=function(j,G){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},t.inc=function(j,G,X,oe){typeof X=="string"&&(oe=X,X=void 0);try{return new z(j,X).inc(G,oe).version}catch(le){return null}},t.diff=function(j,G){if(re(j,G))return null;var X=N(j),oe=N(G);if(X.prerelease.length||oe.prerelease.length){for(var le in X)if((le==="major"||le==="minor"||le==="patch")&&X[le]!==oe[le])return"pre"+le;return"prerelease"}for(var le in X)if((le==="major"||le==="minor"||le==="patch")&&X[le]!==oe[le])return le},t.compareIdentifiers=$;var V=/^[0-9]+$/;function $(j,G){var X=V.test(j),oe=V.test(G);return X&&oe&&(j=+j,G=+G),X&&!oe?-1:oe&&!X?1:j<G?-1:j>G?1:0}function K(j,G,X){return new z(j,X).compare(new z(G,X))}function Y(j,G,X){return K(j,G,X)>0}function ie(j,G,X){return K(j,G,X)<0}function re(j,G,X){return K(j,G,X)===0}function ae(j,G,X){return K(j,G,X)!==0}function me(j,G,X){return K(j,G,X)>=0}function pe(j,G,X){return K(j,G,X)<=0}function de(j,G,X,oe){var le;switch(G){case"===":typeof j=="object"&&(j=j.version),typeof X=="object"&&(X=X.version),le=j===X;break;case"!==":typeof j=="object"&&(j=j.version),typeof X=="object"&&(X=X.version),le=j!==X;break;case"":case"=":case"==":le=re(j,X,oe);break;case"!=":le=ae(j,X,oe);break;case">":le=Y(j,X,oe);break;case">=":le=me(j,X,oe);break;case"<":le=ie(j,X,oe);break;case"<=":le=pe(j,X,oe);break;default:throw new TypeError("Invalid operator: "+G)}return le}function ve(j,G){if(j instanceof ve){if(j.loose===G)return j;j=j.value}if(!(this instanceof ve))return new ve(j,G);S("comparator",j,G),this.loose=G,this.parse(j),this.semver===De?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}t.rcompareIdentifiers=function(j,G){return $(G,j)},t.major=function(j,G){return new z(j,G).major},t.minor=function(j,G){return new z(j,G).minor},t.patch=function(j,G){return new z(j,G).patch},t.compare=K,t.compareLoose=function(j,G){return K(j,G,!0)},t.rcompare=function(j,G,X){return K(G,j,X)},t.sort=function(j,G){return j.sort(function(X,oe){return t.compare(X,oe,G)})},t.rsort=function(j,G){return j.sort(function(X,oe){return t.rcompare(X,oe,G)})},t.gt=Y,t.lt=ie,t.eq=re,t.neq=ae,t.gte=me,t.lte=pe,t.cmp=de,t.Comparator=ve;var De={};function we(j,G){if(j instanceof we)return j.loose===G?j:new we(j.raw,G);if(j instanceof ve)return new we(j.value,G);if(!(this instanceof we))return new we(j,G);if(this.loose=G,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function Le(j){return!j||j.toLowerCase()==="x"||j==="*"}function je(j,G,X,oe,le,Ie,ye,Oe,be,Te,ke,Pe,Re){return((G=Le(X)?"":Le(oe)?">="+X+".0.0":Le(le)?">="+X+"."+oe+".0":">="+G)+" "+(Oe=Le(be)?"":Le(Te)?"<"+(+be+1)+".0.0":Le(ke)?"<"+be+"."+(+Te+1)+".0":Pe?"<="+be+"."+Te+"."+ke+"-"+Pe:"<="+Oe)).trim()}function Be(j,G){for(var X=0;X<j.length;X++)if(!j[X].test(G))return!1;if(G.prerelease.length){for(X=0;X<j.length;X++)if(S(j[X].semver),j[X].semver!==De&&j[X].semver.prerelease.length>0){var oe=j[X].semver;if(oe.major===G.major&&oe.minor===G.minor&&oe.patch===G.patch)return!0}return!1}return!0}function ze(j,G,X){try{G=new we(G,X)}catch(oe){return!1}return G.test(j)}function xe(j,G,X,oe){var le,Ie,ye,Oe,be;switch(j=new z(j,oe),G=new we(G,oe),X){case">":le=Y,Ie=pe,ye=ie,Oe=">",be=">=";break;case"<":le=ie,Ie=me,ye=Y,Oe="<",be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(j,G,oe))return!1;for(var Te=0;Te<G.set.length;++Te){var ke=G.set[Te],Pe=null,Re=null;if(ke.forEach(function(Fe){Fe.semver===De&&(Fe=new ve(">=0.0.0")),Pe=Pe||Fe,Re=Re||Fe,le(Fe.semver,Pe.semver,oe)?Pe=Fe:ye(Fe.semver,Re.semver,oe)&&(Re=Fe)}),Pe.operator===Oe||Pe.operator===be||(!Re.operator||Re.operator===Oe)&&Ie(j,Re.semver)||Re.operator===be&&ye(j,Re.semver))return!1}return!0}ve.prototype.parse=function(j){var G=this.loose?D[J]:D[P],X=j.match(G);if(!X)throw new TypeError("Invalid comparator: "+j);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new z(X[2],this.loose):this.semver=De},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(j){return S("Comparator.test",j,this.loose),this.semver===De||(typeof j=="string"&&(j=new z(j,this.loose)),de(j,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(j,G){if(!(j instanceof ve))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new we(j.value,G),ze(this.value,X,G);if(j.operator==="")return X=new we(this.value,G),ze(j.semver,X,G);var oe=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),le=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Ie=this.semver.version===j.semver.version,ye=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Oe=de(this.semver,"<",j.semver,G)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),be=de(this.semver,">",j.semver,G)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return oe||le||Ie&&ye||Oe||be},t.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(j){var G=this.loose;j=j.trim(),S("range",j,G);var X=G?D[k]:D[L];j=j.replace(X,je),S("hyphen replace",j),j=j.replace(D[g],"$1$2$3"),S("comparator trim",j,D[g]),j=(j=(j=j.replace(D[Q],"$1~")).replace(D[ce],"$1^")).split(/\s+/).join(" ");var oe=G?D[J]:D[P],le=j.split(" ").map(function(Ie){return function(ye,Oe){return S("comp",ye),ye=function(be,Te){return be.trim().split(/\s+/).map(function(ke){return function(Pe,Re){S("caret",Pe,Re);var Fe=Re?D[W]:D[H];return Pe.replace(Fe,function(Ae,ue,ge,Ee,Se){var Ce;return S("caret",Pe,Ae,ue,ge,Ee,Se),Le(ue)?Ce="":Le(ge)?Ce=">="+ue+".0.0 <"+(+ue+1)+".0.0":Le(Ee)?Ce=ue==="0"?">="+ue+"."+ge+".0 <"+ue+"."+(+ge+1)+".0":">="+ue+"."+ge+".0 <"+(+ue+1)+".0.0":Se?(S("replaceCaret pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),Ce=ue==="0"?ge==="0"?">="+ue+"."+ge+"."+Ee+Se+" <"+ue+"."+ge+"."+(+Ee+1):">="+ue+"."+ge+"."+Ee+Se+" <"+ue+"."+(+ge+1)+".0":">="+ue+"."+ge+"."+Ee+Se+" <"+(+ue+1)+".0.0"):(S("no pr"),Ce=ue==="0"?ge==="0"?">="+ue+"."+ge+"."+Ee+" <"+ue+"."+ge+"."+(+Ee+1):">="+ue+"."+ge+"."+Ee+" <"+ue+"."+(+ge+1)+".0":">="+ue+"."+ge+"."+Ee+" <"+(+ue+1)+".0.0"),S("caret return",Ce),Ce})}(ke,Te)}).join(" ")}(ye,Oe),S("caret",ye),ye=function(be,Te){return be.trim().split(/\s+/).map(function(ke){return function(Pe,Re){var Fe=Re?D[se]:D[ne];return Pe.replace(Fe,function(Ae,ue,ge,Ee,Se){var Ce;return S("tilde",Pe,Ae,ue,ge,Ee,Se),Le(ue)?Ce="":Le(ge)?Ce=">="+ue+".0.0 <"+(+ue+1)+".0.0":Le(Ee)?Ce=">="+ue+"."+ge+".0 <"+ue+"."+(+ge+1)+".0":Se?(S("replaceTilde pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),Ce=">="+ue+"."+ge+"."+Ee+Se+" <"+ue+"."+(+ge+1)+".0"):Ce=">="+ue+"."+ge+"."+Ee+" <"+ue+"."+(+ge+1)+".0",S("tilde return",Ce),Ce})}(ke,Te)}).join(" ")}(ye,Oe),S("tildes",ye),ye=function(be,Te){return S("replaceXRanges",be,Te),be.split(/\s+/).map(function(ke){return function(Pe,Re){Pe=Pe.trim();var Fe=Re?D[U]:D[F];return Pe.replace(Fe,function(Ae,ue,ge,Ee,Se,Ce){S("xRange",Pe,Ae,ue,ge,Ee,Se,Ce);var Ve=Le(ge),Me=Ve||Le(Ee),Ue=Me||Le(Se);return ue==="="&&Ue&&(ue=""),Ve?Ae=ue===">"||ue==="<"?"<0.0.0":"*":ue&&Ue?(Me&&(Ee=0),Ue&&(Se=0),ue===">"?(ue=">=",Me?(ge=+ge+1,Ee=0,Se=0):Ue&&(Ee=+Ee+1,Se=0)):ue==="<="&&(ue="<",Me?ge=+ge+1:Ee=+Ee+1),Ae=ue+ge+"."+Ee+"."+Se):Me?Ae=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ue&&(Ae=">="+ge+"."+Ee+".0 <"+ge+"."+(+Ee+1)+".0"),S("xRange return",Ae),Ae})}(ke,Te)}).join(" ")}(ye,Oe),S("xrange",ye),ye=function(be,Te){return S("replaceStars",be,Te),be.trim().replace(D[M],"")}(ye,Oe),S("stars",ye),ye}(Ie,G)}).join(" ").split(/\s+/);return this.loose&&(le=le.filter(function(Ie){return!!Ie.match(oe)})),le=le.map(function(Ie){return new ve(Ie,G)})},we.prototype.intersects=function(j,G){if(!(j instanceof we))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(oe){return j.set.some(function(le){return le.every(function(Ie){return oe.intersects(Ie,G)})})})})},t.toComparators=function(j,G){return new we(j,G).set.map(function(X){return X.map(function(oe){return oe.value}).join(" ").trim().split(" ")})},we.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new z(j,this.loose));for(var G=0;G<this.set.length;G++)if(Be(this.set[G],j))return!0;return!1},t.satisfies=ze,t.maxSatisfying=function(j,G,X){var oe=null,le=null;try{var Ie=new we(G,X)}catch(ye){return null}return j.forEach(function(ye){Ie.test(ye)&&(oe&&le.compare(ye)!==-1||(le=new z(oe=ye,X)))}),oe},t.minSatisfying=function(j,G,X){var oe=null,le=null;try{var Ie=new we(G,X)}catch(ye){return null}return j.forEach(function(ye){Ie.test(ye)&&(oe&&le.compare(ye)!==1||(le=new z(oe=ye,X)))}),oe},t.validRange=function(j,G){try{return new we(j,G).range||"*"}catch(X){return null}},t.ltr=function(j,G,X){return xe(j,G,"<",X)},t.gtr=function(j,G,X){return xe(j,G,">",X)},t.outside=xe,t.prerelease=function(j,G){var X=N(j,G);return X&&X.prerelease.length?X.prerelease:null},t.intersects=function(j,G,X){return j=new we(j,X),G=new we(G,X),j.intersects(G)},t.coerce=function(j){if(j instanceof z)return j;if(typeof j!="string")return null;var G=j.match(D[B]);return G==null?null:N((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,h(1))},function(q,t){var h,O,S=q.exports={};function R(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function D(I){if(h===setTimeout)return setTimeout(I,0);if((h===R||!h)&&setTimeout)return h=setTimeout,setTimeout(I,0);try{return h(I,0)}catch(C){try{return h.call(null,I,0)}catch(b){return h.call(this,I,0)}}}(function(){try{h=typeof setTimeout=="function"?setTimeout:R}catch(I){h=R}try{O=typeof clearTimeout=="function"?clearTimeout:T}catch(I){O=T}})();var l,f=[],y=!1,v=-1;function E(){y&&l&&(y=!1,l.length?f=l.concat(f):v=-1,f.length&&A())}function A(){if(!y){var I=D(E);y=!0;for(var C=f.length;C;){for(l=f,f=[];++v<C;)l&&l[v].run();v=-1,C=f.length}l=null,y=!1,function(b){if(O===clearTimeout)return clearTimeout(b);if((O===T||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(b);try{O(b)}catch(d){try{return O.call(null,b)}catch(r){return O.call(this,b)}}}(I)}}function a(I,C){this.fun=I,this.array=C}function u(){}S.nextTick=function(I){var C=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)C[b-1]=arguments[b];f.push(new a(I,C)),f.length!==1||y||D(A)},a.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=u,S.addListener=u,S.once=u,S.off=u,S.removeListener=u,S.removeAllListeners=u,S.emit=u,S.prependListener=u,S.prependOnceListener=u,S.listeners=function(I){return[]},S.binding=function(I){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(I){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(ee[34],te([0,1,7,2]),function(q,t,h,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function S(d){const r=d;return r?[r.on,r.pause,r.resume,r.destroy].every(o=>typeof o=="function"):!1}t.isReadableStream=S;function R(d){const r=d;return r?S(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}t.isReadableBufferedStream=R;function T(d,r){return new D(d,r)}t.newWriteableStream=T;class D{constructor(r,o){this.reducer=r,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(o=>o(r))}emitError(r){this.listeners.error.length===0?(0,h.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(o=>o(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,o){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(r,o){if(this.state.destroyed)return;let e;switch(r){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(o);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(d,r){const o=[];let e;for(;(e=d.read())!==null;)o.push(e);return r(o)}t.consumeReadable=l;function f(d,r,o){const e=[];let i;for(;(i=d.read())!==null&&e.length<o;)e.push(i);return i===null&&e.length>0?r(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return d.read()}}}t.peekReadable=f;function y(d,r){return new Promise((o,e)=>{const i=[];v(d,{onData:n=>{r&&i.push(n)},onError:n=>{r?e(n):o(void 0)},onEnd:()=>{o(r?r(i):void 0)}})})}t.consumeStream=y;function v(d,r){d.on("error",o=>r.onError(o)),d.on("end",()=>r.onEnd()),d.on("data",o=>r.onData(o))}t.listenStream=v;function E(d,r){return new Promise((o,e)=>{const i=new O.DisposableStore,n=[],s=w=>{if(n.push(w),n.length>r)return i.dispose(),d.pause(),o({stream:d,buffer:n,ended:!1})},c=w=>e(w),p=()=>o({stream:d,buffer:n,ended:!0});i.add((0,O.toDisposable)(()=>d.removeListener("error",c))),d.on("error",c),i.add((0,O.toDisposable)(()=>d.removeListener("end",p))),d.on("end",p),i.add((0,O.toDisposable)(()=>d.removeListener("data",s))),d.on("data",s)})}t.peekStream=E;function A(d,r){const o=T(r);return o.end(d),o}t.toStream=A;function a(){const d=T(()=>{throw new Error("not supported")});return d.end(),d}t.emptyStream=a;function u(d){let r=!1;return{read:()=>r?null:(r=!0,d)}}t.toReadable=u;function I(d,r,o){const e=T(o);return v(d,{onData:i=>e.write(r.data(i)),onError:i=>e.error(r.error?r.error(i):i),onEnd:()=>e.end()}),e}t.transform=I;function C(d,r,o){let e=!1;return{read:()=>{const i=r.read();return e?i:(e=!0,i!==null?o([d,i]):d)}}}t.prefixedReadable=C;function b(d,r,o){let e=!1;const i=T(o);return v(r,{onData:n=>e?i.write(n):(e=!0,i.write(o([d,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(d)),i.end()}}),i}t.prefixedStream=b}),define(ee[16],te([0,1,18,34]),function(q,t,h,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const S=typeof Buffer!="undefined",R=typeof TextEncoder!="undefined",T=typeof TextDecoder!="undefined";let D,l;class f{constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}static alloc(w){return S?new f(Buffer.allocUnsafe(w)):new f(new Uint8Array(w))}static wrap(w){return S&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new f(w)}static fromString(w,x){return!(x?.dontUseNodeBuffer||!1)&&S?new f(Buffer.from(w)):R?(D||(D=new TextEncoder),new f(D.encode(w))):new f(h.encodeUTF8(w))}static concat(w,x){if(typeof x=="undefined"){x=0;for(let B=0,_=w.length;B<_;B++)x+=w[B].byteLength}const F=f.alloc(x);let U=0;for(let B=0,_=w.length;B<_;B++){const Q=w[B];F.set(Q,U),U+=Q.byteLength}return F}toString(){return S?this.buffer.toString():T?(l||(l=new TextDecoder),l.decode(this.buffer)):h.decodeUTF8(this.buffer)}slice(w,x){return new f(this.buffer.subarray(w,x))}set(w,x){w instanceof f?this.buffer.set(w.buffer,x):this.buffer.set(w,x)}readUInt32BE(w){return E(this.buffer,w)}writeUInt32BE(w,x){A(this.buffer,w,x)}readUInt32LE(w){return a(this.buffer,w)}writeUInt32LE(w,x){u(this.buffer,w,x)}readUInt8(w){return I(this.buffer,w)}writeUInt8(w,x){C(this.buffer,w,x)}}t.VSBuffer=f;function y(p,w){return p[w+0]<<0>>>0|p[w+1]<<8>>>0}t.readUInt16LE=y;function v(p,w,x){p[x+0]=w&255,w=w>>>8,p[x+1]=w&255}t.writeUInt16LE=v;function E(p,w){return p[w]*2**24+p[w+1]*2**16+p[w+2]*2**8+p[w+3]}t.readUInt32BE=E;function A(p,w,x){p[x+3]=w,w=w>>>8,p[x+2]=w,w=w>>>8,p[x+1]=w,w=w>>>8,p[x]=w}t.writeUInt32BE=A;function a(p,w){return p[w+0]<<0>>>0|p[w+1]<<8>>>0|p[w+2]<<16>>>0|p[w+3]<<24>>>0}t.readUInt32LE=a;function u(p,w,x){p[x+0]=w&255,w=w>>>8,p[x+1]=w&255,w=w>>>8,p[x+2]=w&255,w=w>>>8,p[x+3]=w&255}t.writeUInt32LE=u;function I(p,w){return p[w]}t.readUInt8=I;function C(p,w,x){p[x]=w}t.writeUInt8=C;function b(p){return O.consumeReadable(p,w=>f.concat(w))}t.readableToBuffer=b;function d(p){return O.toReadable(p)}t.bufferToReadable=d;function r(p){return O.consumeStream(p,w=>f.concat(w))}t.streamToBuffer=r;async function o(p){return p.ended?f.concat(p.buffer):f.concat([...p.buffer,await r(p.stream)])}t.bufferedStreamToBuffer=o;function e(p){return O.toStream(p,w=>f.concat(w))}t.bufferToStream=e;function i(p){return O.transform(p,{data:w=>typeof w=="string"?f.fromString(w):f.wrap(w)},w=>f.concat(w))}t.streamToBufferReadableStream=i;function n(p){return O.newWriteableStream(w=>f.concat(w),p)}t.newWriteableBufferStream=n;function s(p,w){return O.prefixedReadable(p,w,x=>f.concat(x))}t.prefixedBufferReadable=s;function c(p,w){return O.prefixedStream(p,w,x=>f.concat(x))}t.prefixedBufferStream=c}),define(ee[19],te([0,1,8]),function(q,t,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function O(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const I=Array.isArray(u)?[]:{};return Object.keys(u).forEach(C=>{u[C]&&typeof u[C]=="object"?I[C]=O(u[C]):I[C]=u[C]}),I}t.deepClone=O;function S(u){if(!u||typeof u!="object")return u;const I=[u];for(;I.length>0;){const C=I.shift();Object.freeze(C);for(const b in C)if(R.call(C,b)){const d=C[b];typeof d=="object"&&!Object.isFrozen(d)&&I.push(d)}}return u}t.deepFreeze=S;const R=Object.prototype.hasOwnProperty;function T(u,I){return D(u,I,new Set)}t.cloneAndChange=T;function D(u,I,C){if((0,h.isUndefinedOrNull)(u))return u;const b=I(u);if(typeof b!="undefined")return b;if((0,h.isArray)(u)){const d=[];for(const r of u)d.push(D(r,I,C));return d}if((0,h.isObject)(u)){if(C.has(u))throw new Error("Cannot clone recursive data-structure");C.add(u);const d={};for(let r in u)R.call(u,r)&&(d[r]=D(u[r],I,C));return C.delete(u),d}return u}function l(u,I,C=!0){return(0,h.isObject)(u)?((0,h.isObject)(I)&&Object.keys(I).forEach(b=>{b in u?C&&((0,h.isObject)(u[b])&&(0,h.isObject)(I[b])?l(u[b],I[b],C):u[b]=I[b]):u[b]=I[b]}),u):I}t.mixin=l;function f(u,I){if(u===I)return!0;if(u==null||I===null||I===void 0||typeof u!=typeof I||typeof u!="object"||Array.isArray(u)!==Array.isArray(I))return!1;let C,b;if(Array.isArray(u)){if(u.length!==I.length)return!1;for(C=0;C<u.length;C++)if(!f(u[C],I[C]))return!1}else{const d=[];for(b in u)d.push(b);d.sort();const r=[];for(b in I)r.push(b);if(r.sort(),!f(d,r))return!1;for(C=0;C<d.length;C++)if(!f(u[d[C]],I[d[C]]))return!1}return!0}t.equals=f;function y(u){const I=new Set;return JSON.stringify(u,(C,b)=>{if((0,h.isObject)(b)||Array.isArray(b)){if(I.has(b))return"[Circular]";I.add(b)}return b})}t.safeStringify=y;function v(u,I,C){const b=I(u);return typeof b=="undefined"?C:b}t.getOrDefault=v;function E(u,I){const C=Object.create(null);return!u||!I||Object.keys(I).forEach(d=>{const r=u[d],o=I[d];f(r,o)||(C[d]=o)}),C}t.distinct=E;function A(u,I){const C=I.toLowerCase(),b=Object.keys(u).find(d=>d.toLowerCase()===C);return b?u[b]:u[I]}t.getCaseInsensitive=A;function a(u,I){const C=Object.create(null);for(const b of Object.keys(u))I(b,u[b])&&(C[b]=u[b]);return C}t.filter=a}),define(ee[59],te([0,1,9]),function(q,t,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function O(f){const y=f;return y&&typeof y.type=="string"&&typeof y.severity=="string"}t.isRemoteConsoleLog=O;function S(f){const y=[];let v;try{const E=JSON.parse(f.arguments),A=E[E.length-1];A&&A.__$stack&&(E.pop(),v=A.__$stack),y.push(...E)}catch(E){y.push("Unable to log remote console arguments",f.arguments)}return{args:y,stack:v}}t.parse=S;function R(f){if(typeof f!="string")return R(S(f).stack);const y=f;if(y){const v=T(y),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(E&&E.length===4)return{uri:h.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}t.getFirstFrame=R;function T(f){if(!f)return f;const y=f.indexOf(`
`);return y===-1?f:f.substring(0,y)}function D(f,y){const{args:v,stack:E}=S(f),A=typeof v[0]=="string"&&v.length===1;let a=T(E);a&&(a=`(${a.trim()})`);let u=[];if(typeof v[0]=="string"?a&&A?u=[`%c[${y}] %c${v[0]} %c${a}`,l("blue"),l(""),l("grey")]:u=[`%c[${y}] %c${v[0]}`,l("blue"),l(""),...v.slice(1)]:u=[`%c[${y}]%`,l("blue"),...v],a&&!A&&u.push(a),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,u)}t.log=D;function l(f){return`color: ${f}`}}),define(ee[60],te([0,1,16,18,9]),function(q,t,h,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function R(y){return JSON.stringify(y,l)}t.stringify=R;function T(y){let v=JSON.parse(y);return v=f(v),v}t.parse=T;var D;(function(y){y[y.Uri=1]="Uri",y[y.Regexp=2]="Regexp",y[y.ScmResource=3]="ScmResource",y[y.ScmResourceGroup=4]="ScmResourceGroup",y[y.ScmProvider=5]="ScmProvider",y[y.CommentController=6]="CommentController",y[y.CommentThread=7]="CommentThread",y[y.CommentThreadReply=8]="CommentThreadReply",y[y.CommentNode=9]="CommentNode",y[y.CommentThreadNode=10]="CommentThreadNode",y[y.TimelineActionContext=11]="TimelineActionContext",y[y.NotebookCellActionContext=12]="NotebookCellActionContext",y[y.TestItemContext=13]="TestItemContext"})(D=t.MarshalledId||(t.MarshalledId={}));function l(y,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:(0,O.regExpFlags)(v)}:v}function f(y,v=0){if(!y||v>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return S.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof h.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let E=0;E<y.length;++E)y[E]=f(y[E],v+1);else for(const E in y)Object.hasOwnProperty.call(y,E)&&(y[E]=f(y[E],v+1))}return y}t.revive=f}),define(ee[61],te([0,1,18,35,3,45,4]),function(q,t,h,O,S,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function D(){return Object.create(null)}t.getEmptyExpression=D;const l="**",f="/",y="[/\\\\]",v="[^/\\\\]",E=/\//g;function A(g){switch(g){case 0:return"";case 1:return`${v}*?`;default:return`(?:${y}|${v}+${y}|${y}${v}+)*?`}}function a(g,L){if(!g)return[];const k=[];let M=!1,m=!1,N="";for(const z of g){switch(z){case L:if(!M&&!m){k.push(N),N="";continue}break;case"{":M=!0;break;case"}":M=!1;break;case"[":m=!0;break;case"]":m=!1;break}N+=z}return N&&k.push(N),k}t.splitGlobAware=a;function u(g){if(!g)return"";let L="";const k=a(g,f);if(k.every(M=>M===l))L=".*";else{let M=!1;k.forEach((m,N)=>{if(m===l){M||(L+=A(2),M=!0);return}let z=!1,V="",$=!1,K="";for(const Y of m){if(Y!=="}"&&z){V+=Y;continue}if($&&(Y!=="]"||!K)){let ie;Y==="-"?ie=Y:(Y==="^"||Y==="!")&&!K?ie="^":Y===f?ie="":ie=h.escapeRegExpCharacters(Y),K+=ie;continue}switch(Y){case"{":z=!0;continue;case"[":$=!0;continue;case"}":L+=`(?:${a(V,",").map(ae=>u(ae)).join("|")})`,z=!1,V="";break;case"]":L+="["+K+"]",$=!1,K="";break;case"?":L+=v;continue;case"*":L+=A(1);continue;default:L+=h.escapeRegExpCharacters(Y)}}N<k.length-1&&(k[N+1]!==l||N+2<k.length)&&(L+=y),M=!1})}return L}const I=/^\*\*\/\*\.[\w\.-]+$/,C=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new R.LRUCache(1e4),i=function(){return!1},n=function(){return null};function s(g,L){if(!g)return n;let k;typeof g!="string"?k=g.pattern:k=g,k=k.trim();const M=`${k}_${!!L.trimForExclusions}`;let m=e.get(M);if(m)return c(m,g);let N;if(I.test(k)){const z=k.substr(4);m=function(V,$){return typeof V=="string"&&V.endsWith(z)?k:null}}else(N=C.exec(p(k,L)))?m=w(N[1],k):(L.trimForExclusions?d:b).test(k)?m=x(k,L):(N=r.exec(p(k,L)))?m=F(N[1].substr(1),k,!0):(N=o.exec(p(k,L)))?m=F(N[1],k,!1):m=U(k);return e.set(M,m),c(m,g)}function c(g,L){return typeof L=="string"?g:function(k,M){return O.isEqualOrParent(k,L.base)?g(S.relative(L.base,k),M):null}}function p(g,L){return L.trimForExclusions&&g.endsWith("/**")?g.substr(0,g.length-2):g}function w(g,L){const k=`/${g}`,M=`\\${g}`,m=function(z,V){return typeof z!="string"?null:V?V===g?L:null:z===g||z.endsWith(k)||z.endsWith(M)?L:null},N=[g];return m.basenames=N,m.patterns=[L],m.allBasenames=N,m}function x(g,L){const k=P(g.slice(1,-1).split(",").map(V=>s(V,L)).filter(V=>V!==n),g),M=k.length;if(!M)return n;if(M===1)return k[0];const m=function(V,$){for(let K=0,Y=k.length;K<Y;K++)if(k[K](V,$))return g;return null},N=k.find(V=>!!V.allBasenames);N&&(m.allBasenames=N.allBasenames);const z=k.reduce((V,$)=>$.allPaths?V.concat($.allPaths):V,[]);return z.length&&(m.allPaths=z),m}function F(g,L,k){const M=S.sep===S.posix.sep,m=M?g:g.replace(E,S.sep),N=S.sep+m,z=S.posix.sep+g,V=k?function($,K){return typeof $=="string"&&($===m||$.endsWith(N)||!M&&($===g||$.endsWith(z)))?L:null}:function($,K){return typeof $=="string"&&($===m||!M&&$===g)?L:null};return V.allPaths=[(k?"*/":"./")+g],V}function U(g){try{const L=new RegExp(`^${u(g)}$`);return function(k){return L.lastIndex=0,typeof k=="string"&&L.test(k)?g:null}}catch(L){return n}}function B(g,L,k){return!g||typeof L!="string"?!1:_(g)(L,void 0,k)}t.match=B;function _(g,L={}){if(!g)return i;if(typeof g=="string"||Z(g)){const k=s(g,L);if(k===n)return i;const M=function(m,N){return!!k(m,N)};return k.allBasenames&&(M.allBasenames=k.allBasenames),k.allPaths&&(M.allPaths=k.allPaths),M}return W(g,L)}t.parse=_;function Q(g){if(!g)return;let L;return k=>(L||(L=(g()||Promise.resolve([])).then(M=>M?se(M):{})),L.then(M=>!!M[k]))}t.hasSiblingPromiseFn=Q;function ne(g){if(!g)return;let L;return k=>{if(!L){const M=g();L=M?se(M):{}}return!!L[k]}}t.hasSiblingFn=ne;function se(g){const L={};for(const k of g)L[k]=!0;return L}function Z(g){const L=g;return L&&typeof L.base=="string"&&typeof L.pattern=="string"}t.isRelativePattern=Z;function ce(g){return g.allBasenames||[]}t.getBasenameTerms=ce;function H(g){return g.allPaths||[]}t.getPathTerms=H;function W(g,L){const k=P(Object.getOwnPropertyNames(g).map(V=>J(V,g[V],L)).filter(V=>V!==n)),M=k.length;if(!M)return n;if(!k.some(V=>!!V.requiresSiblings)){if(M===1)return k[0];const V=function(Y,ie){for(let re=0,ae=k.length;re<ae;re++){const me=k[re](Y,ie);if(me)return me}return null},$=k.find(Y=>!!Y.allBasenames);$&&(V.allBasenames=$.allBasenames);const K=k.reduce((Y,ie)=>ie.allPaths?Y.concat(ie.allPaths):Y,[]);return K.length&&(V.allPaths=K),V}const m=function(V,$,K){let Y;for(let ie=0,re=k.length;ie<re;ie++){const ae=k[ie];ae.requiresSiblings&&K&&($||($=S.basename(V)),Y||(Y=$.substr(0,$.length-S.extname(V).length)));const me=ae(V,$,Y,K);if(me)return me}return null},N=k.find(V=>!!V.allBasenames);N&&(m.allBasenames=N.allBasenames);const z=k.reduce((V,$)=>$.allPaths?V.concat($.allPaths):V,[]);return z.length&&(m.allPaths=z),m}function J(g,L,k){if(L===!1)return n;const M=s(g,k);if(M===n)return n;if(typeof L=="boolean")return M;if(L){const m=L.when;if(typeof m=="string"){const N=(z,V,$,K)=>{if(!K||!M(z,V))return null;const Y=m.replace("$(basename)",$),ie=K(Y);return(0,T.isThenable)(ie)?ie.then(re=>re?g:null):ie?g:null};return N.requiresSiblings=!0,N}}return M}function P(g,L){const k=g.filter(V=>!!V.basenames);if(k.length<2)return g;const M=k.reduce((V,$)=>{const K=$.basenames;return K?V.concat(K):V},[]);let m;if(L){m=[];for(let V=0,$=M.length;V<$;V++)m.push(L)}else m=k.reduce((V,$)=>{const K=$.patterns;return K?V.concat(K):V},[]);const N=function(V,$){if(typeof V!="string")return null;if(!$){let Y;for(Y=V.length;Y>0;Y--){const ie=V.charCodeAt(Y-1);if(ie===47||ie===92)break}$=V.substr(Y)}const K=M.indexOf($);return K!==-1?m[K]:null};N.basenames=M,N.patterns=m,N.allBasenames=M;const z=g.filter(V=>!V.basenames);return z.push(N),z}}),define(ee[62],te([0,1,9,3,18,10,14,20,35]),function(q,t,h,O,S,R,T,D,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function f(s,c,p){if(typeof s=="string"&&(s=h.URI.file(s)),p){const x=p.getWorkspaceFolder(s);if(x){const F=p.getWorkspace().folders.length>1;let U;if((0,D.isEqual)(x.uri,s)?U="":U=(0,D.relativePath)(x.uri,s),F){const B=x.name?x.name:(0,D.basename)(x.uri);U=U?B+" \u2022 "+U:B}return U}}if(s.scheme!==R.Schemas.file&&s.scheme!==R.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,l.hasDriveLetter)(s.fsPath))return(0,O.normalize)(v(s.fsPath));let w=(0,O.normalize)(s.fsPath);return!T.isWindows&&c?.userHome&&(w=A(w,c.userHome.fsPath)),w}t.getPathLabel=f;function y(s){if(!s)return;typeof s=="string"&&(s=h.URI.file(s));const c=(0,D.basename)(s)||(s.scheme===R.Schemas.file?s.fsPath:s.path);return T.isWindows&&(0,l.isRootOrDriveLetter)(c)?v(c):c}t.getBaseLabel=y;function v(s){return(0,l.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}t.normalizeDriveLetter=v;let E=Object.create(null);function A(s,c){if(T.isWindows||!s||!c)return s;let p=E.original===c?E.normalized:void 0;return p||(p=`${(0,S.rtrim)(c,O.posix.sep)}${O.posix.sep}`,E={original:c,normalized:p}),(T.isLinux?s.startsWith(p):(0,S.startsWithIgnoreCase)(s,p))&&(s=`~/${s.substr(p.length)}`),s}t.tildify=A;function a(s,c){return s.replace(/^~($|\/|\\)/,`${c}$1`)}t.untildify=a;const u="\u2026",I="\\\\",C="~";function b(s,c=O.sep){const p=new Array(s.length);let w=!1;for(let x=0;x<s.length;x++){let F=s[x];if(F===""){p[x]=`.${c}`;continue}if(!F){p[x]=F;continue}w=!0;let U="";F.indexOf(I)===0?(U=F.substr(0,F.indexOf(I)+I.length),F=F.substr(F.indexOf(I)+I.length)):F.indexOf(c)===0?(U=F.substr(0,F.indexOf(c)+c.length),F=F.substr(F.indexOf(c)+c.length)):F.indexOf(C)===0&&(U=F.substr(0,F.indexOf(C)+C.length),F=F.substr(F.indexOf(C)+C.length));const B=F.split(c);for(let _=1;w&&_<=B.length;_++)for(let Q=B.length-_;w&&Q>=0;Q--){w=!1;let ne=B.slice(Q,Q+_).join(c);for(let se=0;!w&&se<s.length;se++)if(se!==x&&s[se]&&s[se].indexOf(ne)>-1){const Z=Q+_===B.length,ce=Q>0&&s[se].indexOf(c)>-1?c+ne:ne,H=s[se].endsWith(ce);w=!Z||H}if(!w){let se="";(B[0].endsWith(":")||U!=="")&&(Q===1&&(Q=0,_++,ne=B[0]+c+ne),Q>0&&(se=B[0]+c),se=U+se),Q>0&&(se=se+u+c),se=se+ne,Q+_<B.length&&(se=se+c+u),p[x]=se}}w&&(p[x]=F)}return p}t.shorten=b;var d;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function r(s,c=Object.create(null)){const p=[];let w=!1,x="";for(const F of s)if(F==="$"||w&&F==="{")x&&p.push({value:x,type:d.TEXT}),x="",w=!0;else if(F==="}"&&w){const U=c[x];if(typeof U=="string")U.length&&p.push({value:U,type:d.VARIABLE});else if(U){const B=p[p.length-1];(!B||B.type!==d.SEPARATOR)&&p.push({value:U.label,type:d.SEPARATOR})}x="",w=!1}else x+=F;return x&&!w&&p.push({value:x,type:d.TEXT}),p.filter((F,U)=>{if(F.type===d.SEPARATOR){const B=p[U-1],_=p[U+1];return[B,_].every(Q=>Q&&(Q.type===d.VARIABLE||Q.type===d.TEXT)&&Q.value.length>0)}return!0}).map(F=>F.value).join("")}t.template=r;function o(s,c){return T.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):s.replace(/&&|&/g,p=>p==="&"?"&&":"&")}t.mnemonicMenuLabel=o;function e(s,c){return T.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,""):T.isWindows?s.replace(/&&|&/g,p=>p==="&"?"&&":"&"):s.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(s){return s.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(s){const c=s.indexOf("/")!==-1?O.posix:O.win32,p=c.basename(s),w=c.dirname(s);return p.length?{name:p,parentPath:w}:{name:w,parentPath:""}}t.splitName=n}),define(ee[46],te([0,1,124]),function(q,t,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class O{constructor(R="utf8"){this.stringDecoder=new h.StringDecoder(R),this.remaining=null}write(R){const T=[],D=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(D.length<1)return T;let l=0,f,y=l;for(;y<D.length;)if(f=D.charCodeAt(y),f===13||f===10){if(T.push(D.substring(l,y)),y++,y<D.length){const v=f;f=D.charCodeAt(y),(v===13&&f===10||v===10&&f===13)&&y++}l=y}else y++;return this.remaining=l<D.length?D.substr(l):null,T}end(){return this.remaining}}t.LineDecoder=O}),define(ee[63],te([0,1,36,18,3,11]),function(q,t,h,O,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function T(y){const v=(0,S.dirname)(y);if(y===v)return y;const E=((0,S.basename)(y)||y).toLowerCase();try{const a=(0,R.readdirSync)(v).filter(u=>u.toLowerCase()===E);if(a.length===1){const u=T(v);if(u)return(0,S.join)(u,a[0])}else if(a.length>1){const u=a.indexOf(E);if(u>=0){const I=T(v);if(I)return(0,S.join)(I,a[u])}}}catch(A){}return null}t.realcaseSync=T;async function D(y){try{return await R.Promises.realpath(y)}catch(v){const E=f(y);return await R.Promises.access(E,h.constants.R_OK),E}}t.realpath=D;function l(y){try{return h.realpathSync(y)}catch(v){const E=f(y);return h.accessSync(E,h.constants.R_OK),E}}t.realpathSync=l;function f(y){return(0,O.rtrim)((0,S.normalize)(y),S.sep)}}),define(ee[64],te([0,1,11,31,3]),function(q,t,h,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,T=/^Microsoft.PowerShell_.*/,D=/^Microsoft.PowerShellPreview_.*/;var l;(function(r){r[r.x64=0]="x64",r[r.x86=1]="x86",r[r.ARM=2]="ARM"})(l||(l={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class v{constructor(o,e,i){this.exePath=o,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await h.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:r=!1}={}){return r?f===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function A({useAlternateBitness:r=!1,findPreview:o=!1}={}){const e=E({useAlternateBitness:r});if(!e)return null;const i=S.join(e,"PowerShell");if(!await h.SymlinkSupport.existsDirectory(i))return null;let n=-1,s=null;for(const w of await h.Promises.readdir(i)){let x=-1;if(o){const U=w.indexOf("-");if(U<0)continue;const B=w.substring(0,U);if(!R.test(B)||w.substring(U+1)!=="preview")continue;x=parseInt(B,10)}else{if(!R.test(w))continue;x=parseInt(w,10)}if(x<=n)continue;const F=S.join(i,w,"pwsh.exe");!await h.SymlinkSupport.existsFile(F)||(s=F,n=x)}if(!s)return null;const c=e.includes("x86")?" (x86)":"",p=o?" Preview":"";return new v(s,`PowerShell${p}${c}`,!0)}async function a({findPreview:r}={}){if(!process.env.LOCALAPPDATA)return null;const o=S.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await h.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=r?{pwshMsixDirRegex:D,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const n of await h.Promises.readdir(o))if(e.test(n)){const s=S.join(o,n,"pwsh.exe");return new v(s,i)}return null}function u(){const r=S.join(O.homedir(),".dotnet","tools","pwsh.exe");return new v(r,".NET Core PowerShell Global Tool")}function I(){const r=S.join(process.env.windir,f===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(r,"Windows PowerShell",!0)}async function*C(){let r=await A();r&&(yield r),r=await A({useAlternateBitness:!0}),r&&(yield r),r=await a(),r&&(yield r),r=u(),r&&(yield r),r=await A({findPreview:!0}),r&&(yield r),r=await a({findPreview:!0}),r&&(yield r),r=await A({useAlternateBitness:!0,findPreview:!0}),r&&(yield r),r=I(),r&&(yield r)}async function*b(){for await(const r of C())await r.exists()&&(yield r)}t.enumeratePowerShellInstallations=b;async function d(){for await(const r of b())return r;return null}t.getFirstAvailablePowerShellInstallation=d}),define(ee[65],te([0,1,3,36,14,125,2,11]),function(q,t,h,O,S,R,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function l(v,E,A){return y({path:v,isDirectory:!1},E,A)}t.watchFile=l;function f(v,E,A){return y({path:v,isDirectory:!0},E,A)}t.watchFolder=f,t.CHANGE_BUFFER_DELAY=100;function y(v,E,A){const a=(0,h.basename)(v.path),u=new Map;let I=!1,C=[(0,T.toDisposable)(()=>{u.forEach(b=>(0,T.dispose)(b)),u.clear()})];try{const b=(0,O.watch)(v.path);C.push((0,T.toDisposable)(()=>{b.removeAllListeners(),b.close()}));const d=new Set;v.isDirectory&&D.Promises.readdir(v.path).then(r=>r.forEach(o=>d.add(o))),b.on("error",(r,o)=>{I||A(`Failed to watch ${v.path} for changes using fs.watch() (${r}, ${o})`)}),b.on("change",(r,o)=>{if(I)return;let e="";if(o&&(e=o.toString(),S.isMacintosh&&(e=(0,R.normalizeNFC)(e))),!e||r!=="change"&&r!=="rename")return;const i=v.isDirectory?(0,h.join)(v.path,e):v.path;if(v.isDirectory)if(r==="rename"){const n=u.get(i);n&&(0,T.dispose)(n);const s=setTimeout(async()=>{u.delete(i);const c=await D.Promises.exists(i);if(I)return;let p;c?d.has(e)?p="changed":(p="added",d.add(e)):(d.delete(e),p="deleted"),E(p,i)},t.CHANGE_BUFFER_DELAY);u.set(i,(0,T.toDisposable)(()=>clearTimeout(s)))}else{let n;d.has(e)?n="changed":(n="added",d.add(e)),E(n,i)}else if(r==="rename"||e!==a){const n=setTimeout(async()=>{const s=await D.Promises.exists(i);I||(s?(E("changed",i),C=[y(v,E,A)]):E("deleted",i))},t.CHANGE_BUFFER_DELAY);(0,T.dispose)(C),C=[(0,T.toDisposable)(()=>clearTimeout(n))]}else E("changed",i)})}catch(b){D.Promises.exists(v.path).then(d=>{d&&!I&&A(`Failed to watch ${v.path} for changes using fs.watch() (${b.toString()})`)})}return(0,T.toDisposable)(()=>{I=!0,C=(0,T.dispose)(C)})}});var fe=this&&this.__decorate||function(q,t,h,O){var S=arguments.length,R=S<3?t:O===null?O=Object.getOwnPropertyDescriptor(t,h):O,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(q,t,h,O);else for(var D=q.length-1;D>=0;D--)(T=q[D])&&(R=(S<3?T(R):S>3?T(t,h,R):T(t,h))||R);return S>3&&R&&Object.defineProperty(t,h,R),R};define(ee[37],te([0,1,12,2,4,26,7,16,22,8,60,18,44]),function(q,t,h,O,S,R,T,D,l,f,y,v,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var A;(function(P){P[P.Promise=100]="Promise",P[P.PromiseCancel=101]="PromiseCancel",P[P.EventListen=102]="EventListen",P[P.EventDispose=103]="EventDispose"})(A=t.RequestType||(t.RequestType={}));function a(P){switch(P){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(P){P[P.Initialize=200]="Initialize",P[P.PromiseSuccess=201]="PromiseSuccess",P[P.PromiseError=202]="PromiseError",P[P.PromiseErrorObj=203]="PromiseErrorObj",P[P.EventFire=204]="EventFire"})(u=t.ResponseType||(t.ResponseType={}));function I(P){switch(P){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var C;(function(P){P[P.Uninitialized=0]="Uninitialized",P[P.Idle=1]="Idle"})(C||(C={}));class b{constructor(g){this.buffer=g,this.pos=0}read(g){const L=this.buffer.slice(this.pos,this.pos+g);return this.pos+=L.byteLength,L}}class d{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(g){this.buffers.push(g)}}var r;(function(P){P[P.Undefined=0]="Undefined",P[P.String=1]="String",P[P.Buffer=2]="Buffer",P[P.VSBuffer=3]="VSBuffer",P[P.Array=4]="Array",P[P.Object=5]="Object"})(r||(r={}));function o(P){const g=D.VSBuffer.alloc(4);return g.writeUInt32BE(P,0),g}function e(P){return P.read(4).readUInt32BE(0)}function i(P){const g=D.VSBuffer.alloc(1);return g.writeUInt8(P,0),g}const n={Undefined:i(r.Undefined),String:i(r.String),Buffer:i(r.Buffer),VSBuffer:i(r.VSBuffer),Array:i(r.Array),Object:i(r.Object)},s=typeof Buffer!="undefined";function c(P,g){if(typeof g=="undefined")P.write(n.Undefined);else if(typeof g=="string"){const L=D.VSBuffer.fromString(g);P.write(n.String),P.write(o(L.byteLength)),P.write(L)}else if(s&&Buffer.isBuffer(g)){const L=D.VSBuffer.wrap(g);P.write(n.Buffer),P.write(o(L.byteLength)),P.write(L)}else if(g instanceof D.VSBuffer)P.write(n.VSBuffer),P.write(o(g.byteLength)),P.write(g);else if(Array.isArray(g)){P.write(n.Array),P.write(o(g.length));for(const L of g)c(P,L)}else{const L=D.VSBuffer.fromString(JSON.stringify(g));P.write(n.Object),P.write(o(L.byteLength)),P.write(L)}}function p(P){switch(P.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return P.read(e(P)).toString();case r.Buffer:return P.read(e(P)).buffer;case r.VSBuffer:return P.read(e(P));case r.Array:{const L=e(P),k=[];for(let M=0;M<L;M++)k.push(p(P));return k}case r.Object:return JSON.parse(P.read(e(P)).toString())}}class w{constructor(g,L,k=null,M=1e3){this.protocol=g,this.ctx=L,this.logger=k,this.timeoutDelay=M,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(m=>this.onRawMessage(m)),this.sendResponse({type:200})}registerChannel(g,L){this.channels.set(g,L),setTimeout(()=>this.flushPendingRequests(g),0)}sendResponse(g){switch(g.type){case 200:{const L=this.send([g.type]);this.logger&&this.logger.logOutgoing(L,0,1,I(g.type));return}case 201:case 202:case 204:case 203:{const L=this.send([g.type,g.id],g.data);this.logger&&this.logger.logOutgoing(L,g.id,1,I(g.type),g.data);return}}}send(g,L=void 0){const k=new d;return c(k,g),c(k,L),this.sendBuffer(k.buffer)}sendBuffer(g){try{return this.protocol.send(g),g.byteLength}catch(L){return 0}}onRawMessage(g){const L=new b(g),k=p(L),M=p(L),m=k[0];switch(m){case 100:return this.logger&&this.logger.logIncoming(g.byteLength,k[1],1,`${a(m)}: ${k[2]}.${k[3]}`,M),this.onPromise({type:m,id:k[1],channelName:k[2],name:k[3],arg:M});case 102:return this.logger&&this.logger.logIncoming(g.byteLength,k[1],1,`${a(m)}: ${k[2]}.${k[3]}`,M),this.onEventListen({type:m,id:k[1],channelName:k[2],name:k[3],arg:M});case 101:return this.logger&&this.logger.logIncoming(g.byteLength,k[1],1,`${a(m)}`),this.disposeActiveRequest({type:m,id:k[1]});case 103:return this.logger&&this.logger.logIncoming(g.byteLength,k[1],1,`${a(m)}`),this.disposeActiveRequest({type:m,id:k[1]})}}onPromise(g){const L=this.channels.get(g.channelName);if(!L){this.collectPendingRequest(g);return}const k=new R.CancellationTokenSource;let M;try{M=L.call(this.ctx,g.name,g.arg,k.token)}catch(z){M=Promise.reject(z)}const m=g.id;M.then(z=>{this.sendResponse({id:m,data:z,type:201}),this.activeRequests.delete(g.id)},z=>{z instanceof Error?this.sendResponse({id:m,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.sendResponse({id:m,data:z,type:203}),this.activeRequests.delete(g.id)});const N=(0,O.toDisposable)(()=>k.cancel());this.activeRequests.set(g.id,N)}onEventListen(g){const L=this.channels.get(g.channelName);if(!L){this.collectPendingRequest(g);return}const k=g.id,m=L.listen(this.ctx,g.name,g.arg)(N=>this.sendResponse({id:k,data:N,type:204}));this.activeRequests.set(g.id,m)}disposeActiveRequest(g){const L=this.activeRequests.get(g.id);L&&(L.dispose(),this.activeRequests.delete(g.id))}collectPendingRequest(g){let L=this.pendingRequests.get(g.channelName);L||(L=[],this.pendingRequests.set(g.channelName,L));const k=setTimeout(()=>{console.error(`Unknown channel: ${g.channelName}`),g.type===100&&this.sendResponse({id:g.id,data:{name:"Unknown channel",message:`Channel name '${g.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);L.push({request:g,timeoutTimer:k})}flushPendingRequests(g){const L=this.pendingRequests.get(g);if(L){for(const k of L)switch(clearTimeout(k.timeoutTimer),k.request.type){case 100:this.onPromise(k.request);break;case 102:this.onEventListen(k.request);break}this.pendingRequests.delete(g)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(g=>g.dispose()),this.activeRequests.clear()}}t.ChannelServer=w;var x;(function(P){P[P.LocalSide=0]="LocalSide",P[P.OtherSide=1]="OtherSide"})(x=t.RequestInitiator||(t.RequestInitiator={}));class F{constructor(g,L=null){this.protocol=g,this.isDisposed=!1,this.state=C.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(k=>this.onBuffer(k)),this.logger=L}getChannel(g){const L=this;return{call(k,M,m){return L.isDisposed?Promise.reject(T.canceled()):L.requestPromise(g,k,M,m)},listen(k,M){return L.isDisposed?Promise.reject(T.canceled()):L.requestEvent(g,k,M)}}}requestPromise(g,L,k,M=R.CancellationToken.None){const m=this.lastRequestId++,z={id:m,type:100,channelName:g,name:L,arg:k};if(M.isCancellationRequested)return Promise.reject(T.canceled());let V;return new Promise((K,Y)=>{if(M.isCancellationRequested)return Y(T.canceled());const ie=()=>{const pe=de=>{switch(de.type){case 201:this.handlers.delete(m),K(de.data);break;case 202:this.handlers.delete(m);const ve=new Error(de.data.message);ve.stack=de.data.stack,ve.name=de.data.name,Y(ve);break;case 203:this.handlers.delete(m),Y(de.data);break}};this.handlers.set(m,pe),this.sendRequest(z)};let re=null;this.state===C.Idle?ie():(re=(0,S.createCancelablePromise)(pe=>this.whenInitialized()),re.then(()=>{re=null,ie()}));const ae=()=>{re?(re.cancel(),re=null):this.sendRequest({id:m,type:101}),Y(T.canceled())},me=M.onCancellationRequested(ae);V=(0,O.combinedDisposable)((0,O.toDisposable)(ae),me),this.activeRequests.add(V)}).finally(()=>{this.activeRequests.delete(V)})}requestEvent(g,L,k){const M=this.lastRequestId++,N={id:M,type:102,channelName:g,name:L,arg:k};let z=null;const V=new h.Emitter({onFirstListenerAdd:()=>{z=(0,S.createCancelablePromise)(K=>this.whenInitialized()),z.then(()=>{z=null,this.activeRequests.add(V),this.sendRequest(N)})},onLastListenerRemove:()=>{z?(z.cancel(),z=null):(this.activeRequests.delete(V),this.sendRequest({id:M,type:103}))}}),$=K=>V.fire(K.data);return this.handlers.set(M,$),V.event}sendRequest(g){switch(g.type){case 100:case 102:{const L=this.send([g.type,g.id,g.channelName,g.name],g.arg);this.logger&&this.logger.logOutgoing(L,g.id,0,`${a(g.type)}: ${g.channelName}.${g.name}`,g.arg);return}case 101:case 103:{const L=this.send([g.type,g.id]);this.logger&&this.logger.logOutgoing(L,g.id,0,a(g.type));return}}}send(g,L=void 0){const k=new d;return c(k,g),c(k,L),this.sendBuffer(k.buffer)}sendBuffer(g){try{return this.protocol.send(g),g.byteLength}catch(L){return 0}}onBuffer(g){const L=new b(g),k=p(L),M=p(L),m=k[0];switch(m){case 200:return this.logger&&this.logger.logIncoming(g.byteLength,0,0,I(m)),this.onResponse({type:k[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(g.byteLength,k[1],0,I(m),M),this.onResponse({type:k[0],id:k[1],data:M})}}onResponse(g){if(g.type===200){this.state=C.Idle,this._onDidInitialize.fire();return}const L=this.handlers.get(g.id);L&&L(g)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===C.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(g=>g.dispose()),this.activeRequests.clear()}}fe([E.memoize],F.prototype,"onDidInitializePromise",null),t.ChannelClient=F;class U{constructor(g){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,g(({protocol:L,onDidClientDisconnect:k})=>{h.Event.once(L.onMessage)(m=>{const N=new b(m),z=p(N),V=new w(L,z),$=new F(L);this.channels.forEach((Y,ie)=>V.registerChannel(ie,Y));const K={channelServer:V,channelClient:$,ctx:z};this._connections.add(K),this._onDidAddConnection.fire(K),k(()=>{V.dispose(),$.dispose(),this._connections.delete(K),this._onDidRemoveConnection.fire(K)})})})}get connections(){const g=[];return this._connections.forEach(L=>g.push(L)),g}getChannel(g,L){const k=this;return{call(M,m,N){let z;if((0,f.isFunction)(L)){let $=(0,l.getRandomElement)(k.connections.filter(L));z=$?Promise.resolve($):h.Event.toPromise(h.Event.filter(k.onDidAddConnection,L))}else z=L.routeCall(k,M,m);const V=z.then($=>$.channelClient.getChannel(g));return _(V).call(M,m,N)},listen(M,m){if((0,f.isFunction)(L))return k.getMulticastEvent(g,L,M,m);const N=L.routeEvent(k,M,m).then(z=>z.channelClient.getChannel(g));return _(N).listen(M,m)}}}getMulticastEvent(g,L,k,M){const m=this;let N=new O.DisposableStore;const z=new h.Emitter({onFirstListenerAdd:()=>{N=new O.DisposableStore;const V=new h.EventMultiplexer,$=new Map,K=ie=>{const ae=ie.channelClient.getChannel(g).listen(k,M),me=V.add(ae);$.set(ie,me)},Y=ie=>{const re=$.get(ie);!re||(re.dispose(),$.delete(ie))};m.connections.filter(L).forEach(K),h.Event.filter(m.onDidAddConnection,L)(K,void 0,N),m.onDidRemoveConnection(Y,void 0,N),V.event(z.fire,z,N),N.add(V)},onLastListenerRemove:()=>{N.dispose()}});return z.event}registerChannel(g,L){this.channels.set(g,L),this._connections.forEach(k=>{k.channelServer.registerChannel(g,L)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=U;class B{constructor(g,L,k=null){const M=new d;c(M,L),g.send(M.buffer),this.channelClient=new F(g,k),this.channelServer=new w(g,L,k)}getChannel(g){return this.channelClient.getChannel(g)}registerChannel(g,L){this.channelServer.registerChannel(g,L)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=B;function _(P){return{call(g,L,k){return P.then(M=>M.call(g,L,k))},listen(g,L){const k=new h.Relay;return P.then(M=>k.input=M.listen(g,L)),k.event}}}t.getDelayedChannel=_;function Q(P){let g=!1;return{call(L,k,M){return g?P.call(L,k,M):(0,S.timeout)(0).then(()=>g=!0).then(()=>P.call(L,k,M))},listen(L,k){if(g)return P.listen(L,k);const M=new h.Relay;return(0,S.timeout)(0).then(()=>g=!0).then(()=>M.input=P.listen(L,k)),M.event}}}t.getNextTickChannel=Q;class ne{constructor(g){this.fn=g}routeCall(g){return this.route(g)}routeEvent(g){return this.route(g)}async route(g){for(const L of g.connections)if(await Promise.resolve(this.fn(L.ctx)))return Promise.resolve(L);return await h.Event.toPromise(g.onDidAddConnection),await this.route(g)}}t.StaticRouter=ne;var se;(function(P){function g(M,m){const N=M,z=m&&m.disableMarshalling,V=new Map;for(const $ in N)k($)&&V.set($,h.Event.buffer(N[$],!0));return new class{listen($,K){const Y=V.get(K);if(Y)return Y;throw new Error(`Event not found: ${K}`)}call($,K,Y){const ie=N[K];if(typeof ie=="function"){if(!z&&Array.isArray(Y))for(let re=0;re<Y.length;re++)Y[re]=(0,y.revive)(Y[re]);return ie.apply(N,Y)}throw new Error(`Method not found: ${K}`)}}}P.fromService=g;function L(M,m){const N=m&&m.disableMarshalling;return new Proxy({},{get(z,V){if(typeof V=="string")return m?.properties?.has(V)?m.properties.get(V):k(V)?M.listen(V):async function(...$){let K;m&&!(0,f.isUndefinedOrNull)(m.context)?K=[m.context,...$]:K=$;const Y=await M.call(V,K);return N?Y:(0,y.revive)(Y)};throw new Error(`Property not found: ${String(V)}`)}})}P.toService=L;function k(M){return M[0]==="o"&&M[1]==="n"&&v.isUpperAsciiLetter(M.charCodeAt(2))}})(se=t.ProxyChannel||(t.ProxyChannel={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(P){if(Array.isArray(P))return P;if(P&&typeof P=="object"&&typeof P.toString=="function"){let g=P.toString();if(g!=="[object Object]")return g}return P}function H(P){return Array.isArray(P)?P.map(ce):ce(P)}function W(P,g,L,k,M,m,N){N=H(N);const z=Z[M],V=z[k%z.length];let $=[`%c[${P}]%c[${String(g).padStart(7," ")}]%c[len: ${String(L).padStart(5," ")}]%c${String(k).padStart(5," ")} - ${m}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(m)?($=$.concat(N),$.push(")")):$.push(N),console.log.apply(console,$)}t.logWithColors=W;class J{constructor(g,L){this._outgoingPrefix=g,this._incomingPrefix=L,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(g,L,k,M,m){this._totalOutgoing+=g,W(this._outgoingPrefix,this._totalOutgoing,g,L,k,M,m)}logIncoming(g,L,k,M,m){this._totalIncoming+=g,W(this._incomingPrefix,this._totalIncoming,g,L,k,M,m)}}t.IPCLogger=J}),define(ee[66],te([0,1,2,12,4,8]),function(q,t,h,O,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var T;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=t.StorageHint||(t.StorageHint={}));var D;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(D||(D={}));class l extends h.Disposable{constructor(v,E=Object.create(null)){super();this.database=v,this.options=E,this._onDidChangeStorage=this._register(new O.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=D.None,this.cache=new Map,this.flushDelayer=new S.ThrottledDelayer(l.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){v.changed?.forEach((E,A)=>this.accept(A,E)),v.deleted?.forEach(E=>this.accept(E,void 0))}accept(v,E){if(this.state===D.Closed)return;let A=!1;(0,R.isUndefinedOrNull)(E)?A=this.cache.delete(v):this.cache.get(v)!==E&&(this.cache.set(v,E),A=!0),A&&this._onDidChangeStorage.fire(v)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===D.None&&(this.state=D.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,E){const A=this.cache.get(v);return(0,R.isUndefinedOrNull)(A)?E:A}getBoolean(v,E){const A=this.get(v);return(0,R.isUndefinedOrNull)(A)?E:A==="true"}getNumber(v,E){const A=this.get(v);return(0,R.isUndefinedOrNull)(A)?E:parseInt(A,10)}async set(v,E){if(this.state===D.Closed)return;if((0,R.isUndefinedOrNull)(E))return this.delete(v);const A=String(E);if(this.cache.get(v)!==A)return this.cache.set(v,A),this.pendingInserts.set(v,A),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire(v),this.flushDelayer.trigger(()=>this.flushPending())}async delete(v){if(!(this.state===D.Closed||!this.cache.delete(v)))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire(v),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=D.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(v){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=l,l.DEFAULT_FLUSH_DELAY=100;class f{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert&&v.insert.forEach((E,A)=>this.items.set(A,E)),v.delete&&v.delete.forEach(E=>this.items.delete(E))}async close(){}}t.InMemoryStorageDatabase=f}),define(ee[67],te([5,6]),function(q,t){return q.create("vs/base/common/date",t)}),define(ee[68],te([0,1,67]),function(q,t,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const O=60,S=O*60,R=S*24,T=R*7,D=R*30,l=R*365;function f(v,E){typeof v!="number"&&(v=v.getTime());const A=Math.round((new Date().getTime()-v)/1e3);if(A<-30)return(0,h.localize)(0,null,f(new Date().getTime()+A*1e3,!1));if(A<30)return(0,h.localize)(1,null);let a;return A<O?(a=A,E?a===1?(0,h.localize)(2,null,a):(0,h.localize)(3,null,a):a===1?(0,h.localize)(4,null,a):(0,h.localize)(5,null,a)):A<S?(a=Math.floor(A/O),E?a===1?(0,h.localize)(6,null,a):(0,h.localize)(7,null,a):a===1?(0,h.localize)(8,null,a):(0,h.localize)(9,null,a)):A<R?(a=Math.floor(A/S),E?a===1?(0,h.localize)(10,null,a):(0,h.localize)(11,null,a):a===1?(0,h.localize)(12,null,a):(0,h.localize)(13,null,a)):A<T?(a=Math.floor(A/R),E?a===1?(0,h.localize)(14,null,a):(0,h.localize)(15,null,a):a===1?(0,h.localize)(16,null,a):(0,h.localize)(17,null,a)):A<D?(a=Math.floor(A/T),E?a===1?(0,h.localize)(18,null,a):(0,h.localize)(19,null,a):a===1?(0,h.localize)(20,null,a):(0,h.localize)(21,null,a)):A<l?(a=Math.floor(A/D),E?a===1?(0,h.localize)(22,null,a):(0,h.localize)(23,null,a):a===1?(0,h.localize)(24,null,a):(0,h.localize)(25,null,a)):(a=Math.floor(A/l),E?a===1?(0,h.localize)(26,null,a):(0,h.localize)(27,null,a):a===1?(0,h.localize)(28,null,a):(0,h.localize)(29,null,a))}t.fromNow=f;function y(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=y}),define(ee[69],te([5,6]),function(q,t){return q.create("vs/base/common/errorMessage",t)}),define(ee[28],te([0,1,69,8,22]),function(q,t,h,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function R(f,y){return y&&(f.stack||f.stacktrace)?h.localize(0,null,D(f),T(f.stack)||T(f.stacktrace)):D(f)}function T(f){return Array.isArray(f)?f.join(`
`):f}function D(f){return typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?h.localize(1,null,f.message):f.message||h.localize(2,null)}function l(f=null,y=!1){if(!f)return h.localize(3,null);if(Array.isArray(f)){const v=S.coalesce(f),E=l(v[0],y);return v.length>1?h.localize(4,null,E,v.length):E}if(O.isString(f))return f;if(f.detail){const v=f.detail;if(v.error)return R(v.error,y);if(v.exception)return R(v.exception,y)}return f.stack?R(f,y):f.message?f.message:h.localize(5,null)}t.toErrorMessage=l}),define(ee[70],te([5,6]),function(q,t){return q.create("vs/base/node/processes",t)}),define(ee[47],te([0,1,3,11,32,70,33,8,19,35,14,46,10]),function(q,t,h,O,S,R,T,D,l,f,y,v,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function A(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function a(r,o){if(y.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};o&&(e.cwd=o);const i=S.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],e);return new Promise(n=>{i.once("error",s=>{n({success:!1,error:s})}),i.once("exit",(s,c)=>{n(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?A(e.status):1})}else if(y.isLinux||y.isMacintosh)try{const e=E.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",q).fsPath;return new Promise(i=>{S.execFile(e,[r.pid.toString()],{encoding:"utf8",shell:!0},(n,s,c)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function u(r=T.env){return r.comspec||"cmd.exe"}t.getWindowsShell=u;class I{constructor(o,e,i,n){if(e!==void 0&&i!==void 0&&n!==void 0)this.cmd=o,this.args=e,this.shell=i,this.options=n;else{const s=o;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(T.env).forEach(c=>{s[c]=T.env[c]}),Object.keys(this.options.env).forEach(c=>{s[c]=this.options.env[c]}),this.options.env=s}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const e=o.lastIndexOf(h.sep);return e!==-1&&(o=o.substring(e+1)),I.WellKnowCommands[o]?o:"other"}start(o){return y.isWindows&&(this.options&&this.options.cwd&&f.isUNC(this.options.cwd)||!this.options&&f.isUNC(T.cwd()))?Promise.reject(new Error(R.localize(0,null))):this.useExec().then(e=>{let i,n;const s=new Promise((c,p)=>{i=c,n=p});if(e){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=S.exec(c,this.options,(p,w,x)=>{this.childProcess=null;const F=p;F&&F.killed?n({killed:this.terminateRequested,stdout:w.toString(),stderr:x.toString()}):this.handleExec(i,o,p,w,x)})}else{let c=null;const p=w=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(w,i,o,n);const x={terminated:this.terminateRequested};D.isNumber(w)&&(x.cmdCode=w),i(x)};if(this.shell&&y.isWindows){const w=l.deepClone(this.options);w.windowsVerbatimArguments=!0,w.detached=!1;let x=!1,F=!1;const U=[];let B=this.ensureQuotes(this.cmd);U.push(B.value),x=B.quoted,this.args&&this.args.forEach(Q=>{B=this.ensureQuotes(Q),U.push(B.value),F=F&&B.quoted});const _=["/s","/c"];x?F?_.push('"'+U.join(" ")+'"'):U.length>1?_.push('"'+U[0]+'" '+U.slice(1).join(" ")):_.push('"'+U[0]+'"'):_.push(U.join(" ")),c=S.spawn(u(),_,w)}else this.cmd&&(c=S.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(D.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",w=>{this.childProcess=null,n({terminated:this.terminateRequested,error:w})}),c.pid&&(this.childProcess.on("close",p),this.handleSpawn(c,i,o,n,!0)))}return s})}handleClose(o,e,i,n){}ensureQuotes(o){return I.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,a(o,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!y.isWindows)return o(!1);const e=S.spawn(u(),["/s","/c"]);e.on("error",i=>o(!0)),e.on("exit",i=>o(!1))})}}t.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class C extends I{constructor(o,e,i,n){super(o,e,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,e,i,n,s){[n,s].forEach((c,p)=>{const w=new v.LineDecoder;w.write(c).forEach(U=>{e({line:U,source:p===0?0:1})});const F=w.end();F&&e({line:F,source:p===0?0:1})}),o({terminated:this.terminateRequested,error:i})}handleSpawn(o,e,i,n,s){const c=new v.LineDecoder,p=new v.LineDecoder;o.stdout.on("data",w=>{c.write(w).forEach(F=>i({line:F,source:0}))}),o.stderr.on("data",w=>{p.write(w).forEach(F=>i({line:F,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=p}handleClose(o,e,i,n){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&i({line:s,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&i({line:c,source:1})}}t.LineProcess=C;function b(r){let o=[],e=!1;const i=function(n){if(e){o.push(n);return}(!r.send(n,c=>{if(c&&console.error(c),e=!1,o.length>0){const p=o.slice(0);o=[],p.forEach(w=>i(w))}})||y.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=b;var d;(function(r){async function o(e,i,n){if(h.isAbsolute(e))return e;if(i===void 0&&(i=T.cwd()),h.dirname(e)!=="."||(n===void 0&&D.isString(T.env.PATH)&&(n=T.env.PATH.split(h.delimiter)),n===void 0||n.length===0))return h.join(i,e);async function c(p){return await O.Promises.exists(p)?!(await O.Promises.stat(p)).isDirectory():!1}for(let p of n){let w;if(h.isAbsolute(p)?w=h.join(p,e):w=h.join(i,p,e),await c(w))return w;let x=w+".com";if(await c(x)||(x=w+".exe",await c(x)))return x}return h.join(i,e)}r.findExecutable=o})(d=t.win32||(t.win32={}))}),define(ee[71],te([0,1,31,14,64,47]),function(q,t,h,O,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function T(A,a){return A===1?O.isWindows?v():R.getWindowsShell(a):f(A,a)}t.getSystemShell=T;function D(A,a){return A===1?O.isWindows?E(a):R.getWindowsShell(a):f(A,a)}t.getSystemShellSync=D;let l=null;function f(A,a){if(O.isLinux&&A===2||O.isMacintosh&&A===3)return"/bin/bash";if(!l){let u;if(O.isWindows)u="/bin/bash";else{if(u=a.SHELL,!u)try{u=(0,h.userInfo)().shell}catch(I){}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}l=u}return l}let y=null;async function v(){return y||(y=(await(0,S.getFirstAvailablePowerShellInstallation)()).exePath),y}function E(A){if(y)return y;const a=O.isWindows&&parseFloat((0,h.release)())>=10,u=A.hasOwnProperty("PROCESSOR_ARCHITEW6432"),I=`${A.windir}\\${u?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?I:R.getWindowsShell(A)}}),define(ee[48],te([0,1,32,2,4,19,12,47,37,59,26,7,16,14]),function(q,t,h,O,S,R,T,D,l,f,y,v,E,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class a extends l.ChannelServer{constructor(C){super({send:b=>{try{process.send&&process.send(b.buffer.toString("base64"))}catch(d){}},onMessage:T.Event.fromNodeEventEmitter(process,"message",b=>E.VSBuffer.wrap(Buffer.from(b,"base64")))},C);process.once("disconnect",()=>this.dispose())}}t.Server=a;class u{constructor(C,b){this.modulePath=C,this.options=b,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new T.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const d=b&&b.timeout?b.timeout:6e4;this.disposeDelayer=new S.Delayer(d),this.child=null,this._client=null}getChannel(C){const b=this;return{call(d,r,o){return b.requestPromise(C,d,r,o)},listen(d,r){return b.requestEvent(C,d,r)}}}requestPromise(C,b,d,r=y.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(v.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(C),e=(0,S.createCancelablePromise)(s=>o.call(b,d,s)),i=r.onCancellationRequested(()=>e.cancel()),n=(0,O.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(C,b,d){if(!this.disposeDelayer)return T.Event.None;this.disposeDelayer.cancel();let r;const o=new T.Emitter({onFirstListenerAdd:()=>{r=this.getCachedChannel(C).listen(b,d)(o.fire,o),this.activeRequests.add(r)},onLastListenerRemove:()=>{this.activeRequests.delete(r),r.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const C=this.options&&this.options.args?this.options.args:[],b=Object.create(null);b.env={...(0,R.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(b.env={...b.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(b.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(b.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(b.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),b.execArgv===void 0&&(b.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),A.isMacintosh&&b.env&&delete b.env.DYLD_LIBRARY_PATH,this.child=(0,h.fork)(this.modulePath,C,b);const d=new T.Emitter;T.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,f.isRemoteConsoleLog)(c)){(0,f.log)(c,`IPC Library: ${this.options.serverName}`);return}d.fire(E.VSBuffer.wrap(Buffer.from(c,"base64")))});const o=this.options.useQueue?(0,D.createQueuedSender)(this.child):this.child,e=c=>this.child&&this.child.connected&&o.send(c.buffer.toString("base64")),i=d.event,n={send:e,onMessage:i};this._client=new l.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,p)=>{process.removeListener("exit",s),this.activeRequests.forEach(w=>(0,O.dispose)(w)),this.activeRequests.clear(),c!==0&&p!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+p),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:p})})}return this._client}getCachedChannel(C){let b=this.channels.get(C);return b||(b=this.client.getChannel(C),this.channels.set(C,b)),b}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=u}),define(ee[72],te([5,6]),function(q,t){return q.create("vs/base/node/zip",t)}),define(ee[73],te([5,6]),function(q,t){return q.create("vs/platform/configuration/common/configurationRegistry",t)}),define(ee[74],te([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(ee[75],te([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(ee[76],te([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(ee[77],te([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(ee[78],te([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(ee[79],te([5,6]),function(q,t){return q.create("vs/platform/extensions/common/extensionValidator",t)}),define(ee[80],te([5,6]),function(q,t){return q.create("vs/platform/files/common/fileService",t)}),define(ee[81],te([5,6]),function(q,t){return q.create("vs/platform/files/common/io",t)}),define(ee[82],te([5,6]),function(q,t){return q.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(ee[83],te([5,6]),function(q,t){return q.create("vs/platform/request/common/request",t)}),define(ee[84],te([5,6]),function(q,t){return q.create("vs/platform/telemetry/common/telemetryService",t)}),define(ee[85],te([0,1,3,20,44,68,10,9,33]),function(q,t,h,O,S,R,T,D,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class f{constructor(a,u,I){this._args=a,this.paths=u,this.productService=I}get appRoot(){return(0,h.dirname)(T.FileAccess.asFileUri("",q).fsPath)}get userHome(){return D.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return D.URI.file((0,h.join)(this.userDataPath,"User"))}get tmpDir(){return D.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,O.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,O.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const a=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,h.join)(this.userDataPath,"logs",a)}return this.args.logsPath}get userDataSyncLogResource(){return D.URI.file((0,h.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,O.joinPath)(D.URI.file((0,h.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return D.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return D.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,O.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,O.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const a=l.env.VSCODE_PORTABLE;return a?D.URI.file((0,h.join)(a,"argv.json")):(0,O.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,O.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return D.URI.file((0,h.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,h.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const a=this.args["builtin-extensions-dir"];return a?(0,h.resolve)(a):(0,h.normalize)((0,h.join)(T.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const a=this.args["extensions-download-dir"];return a?(0,h.resolve)(a):(0,h.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const a=this.args["extensions-dir"];if(a)return(0,h.resolve)(a);const u=l.env.VSCODE_EXTENSIONS;if(u)return u;const I=l.env.VSCODE_PORTABLE;return I?(0,h.join)(I,"extensions"):(0,O.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const a=this.args.extensionDevelopmentPath;if(Array.isArray(a))return a.map(u=>/^[^:/?#]+?:\/\//.test(u)?D.URI.parse(u):D.URI.file((0,h.normalize)(u)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(a=>a==="ui"||a==="workspace"||a==="web"?a:"workspace")}get extensionTestsLocationURI(){const a=this.args.extensionTestsPath;if(a)return/^[^:/?#]+?:\/\//.test(a)?D.URI.parse(a):D.URI.file((0,h.normalize)(a))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const a=this.args["disable-extension"];if(a){if(typeof a=="string")return[a];if(Array.isArray(a)&&a.length>0)return a}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!l.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,O.joinPath)(D.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return D.URI.file((0,h.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([S.memoize],f.prototype,"appRoot",null),fe([S.memoize],f.prototype,"userHome",null),fe([S.memoize],f.prototype,"userDataPath",null),fe([S.memoize],f.prototype,"appSettingsHome",null),fe([S.memoize],f.prototype,"tmpDir",null),fe([S.memoize],f.prototype,"userRoamingDataHome",null),fe([S.memoize],f.prototype,"settingsResource",null),fe([S.memoize],f.prototype,"userDataSyncHome",null),fe([S.memoize],f.prototype,"userDataSyncLogResource",null),fe([S.memoize],f.prototype,"sync",null),fe([S.memoize],f.prototype,"machineSettingsResource",null),fe([S.memoize],f.prototype,"globalStorageHome",null),fe([S.memoize],f.prototype,"workspaceStorageHome",null),fe([S.memoize],f.prototype,"keybindingsResource",null),fe([S.memoize],f.prototype,"keyboardLayoutResource",null),fe([S.memoize],f.prototype,"argvResource",null),fe([S.memoize],f.prototype,"snippetsHome",null),fe([S.memoize],f.prototype,"isExtensionDevelopment",null),fe([S.memoize],f.prototype,"untitledWorkspacesHome",null),fe([S.memoize],f.prototype,"installSourcePath",null),fe([S.memoize],f.prototype,"builtinExtensionsPath",null),fe([S.memoize],f.prototype,"extensionsPath",null),fe([S.memoize],f.prototype,"extensionDevelopmentLocationURI",null),fe([S.memoize],f.prototype,"extensionDevelopmentKind",null),fe([S.memoize],f.prototype,"extensionTestsLocationURI",null),fe([S.memoize],f.prototype,"debugExtensionHost",null),fe([S.memoize],f.prototype,"serviceMachineIdResource",null),fe([S.memoize],f.prototype,"telemetryLogResource",null),fe([S.memoize],f.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=f;function y(A,a){return E(A["inspect-extensions"],A["inspect-brk-extensions"],5870,a,A.debugId)}t.parseExtensionHostPort=y;function v(A,a){return E(A["inspect-search"],A["inspect-brk-search"],5876,a)}t.parseSearchPort=v;function E(A,a,u,I,C){const d=Number(a||A)||(I?null:u),r=d?Boolean(!!a):!1;return{port:d,break:r,debugId:C}}}),function(){"use strict";function q(t,h,O,S){function R(D){const l=T(D),f=[l];return t.isAbsolute(l)||f.unshift(S),t.resolve(...f)}function T(D){const l=process.env.VSCODE_PORTABLE;if(l)return t.join(l,"user-data");const f=D["user-data-dir"];if(f)return f;let y=process.env.VSCODE_APPDATA;if(!y)switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=t.join(v,"AppData","Roaming")}break;case"darwin":y=t.join(h.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||t.join(h.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(y,O)}return{getUserDataPath:R}}if(typeof define=="function")define(ee[86],te([0,87,31,10,20,33]),function(t,h,O,S,R,T){const D=R.dirname(S.FileAccess.asFileUri("",t)),l=t.__$__nodeRequire(R.joinPath(D,"package.json").fsPath);return q(h,O,l.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),h=require("path"),O=require("os");module.exports=q(h,O,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[88],te([0,1,31,86,85]),function(q,t,h,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class R extends S.AbstractNativeEnvironmentService{constructor(D,l){super(D,{homeDir:(0,h.homedir)(),tmpDir:(0,h.tmpdir)(),userDataDir:(0,O.getUserDataPath)(D)},l)}}t.NativeEnvironmentService=R}),define(ee[89],te([0,1,19]),function(q,t,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const O=/^%([\w\d.-]+)%$/i;function S(R,T){const D=l=>{if(typeof l!="string")return;const f=O.exec(l);if(!f)return;const y=T[f[1]]??l;return typeof y=="string"?y:typeof y.message=="string"?y.message:l};return(0,h.cloneAndChange)(R,D)}t.localizeManifest=S}),define(ee[49],te([0,1,79]),function(q,t,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function R(E){return E=E.trim(),E==="*"||O.test(E)}t.isValidVersionStr=R;function T(E){if(!R(E))return null;if(E=E.trim(),E==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let A=E.match(O);return A?{hasCaret:A[1]==="^",hasGreaterEquals:A[1]===">=",majorBase:A[2]==="x"?0:parseInt(A[2],10),majorMustEqual:A[2]!=="x",minorBase:A[4]==="x"?0:parseInt(A[4],10),minorMustEqual:A[4]!=="x",patchBase:A[6]==="x"?0:parseInt(A[6],10),patchMustEqual:A[6]!=="x",preRelease:A[8]||null}:null}t.parseVersion=T;function D(E){if(!E)return null;let A=E.majorBase,a=E.majorMustEqual,u=E.minorBase,I=E.minorMustEqual,C=E.patchBase,b=E.patchMustEqual;E.hasCaret&&(A===0||(I=!1),b=!1);let d=0;if(E.preRelease){const r=S.exec(E.preRelease);if(r){const[,o,e,i]=r;d=Date.UTC(Number(o),Number(e)-1,Number(i))}}return{majorBase:A,majorMustEqual:a,minorBase:u,minorMustEqual:I,patchBase:C,patchMustEqual:b,isMinimum:E.hasGreaterEquals,notBefore:d}}t.normalizeVersion=D;function l(E,A,a){let u;typeof E=="string"?u=D(T(E)):u=E;let I;A instanceof Date?I=A.getTime():typeof A=="string"&&(I=new Date(A).getTime());let C;if(typeof a=="string"?C=D(T(a)):C=a,!u||!C)return!1;let b=u.majorBase,d=u.minorBase,r=u.patchBase,o=C.majorBase,e=C.minorBase,i=C.patchBase,n=C.notBefore,s=C.majorMustEqual,c=C.minorMustEqual,p=C.patchMustEqual;return C.isMinimum?b>o?!0:b<o?!1:d>e?!0:d<e||I&&I<n?!1:r>=i:(b===1&&o===0&&(!s||!c||!p)&&(o=1,e=0,i=0,s=!0,c=!1,p=!1),b<o?!1:b>o?!s:d<e?!1:d>e?!c:r<i?!1:r>i?!p:!(I&&I<n))}t.isValidVersion=l;function f(E,A,a,u){return a.isBuiltin||typeof a.main=="undefined"?!0:v(E,A,a.engines.vscode,u)}t.isValidExtensionVersion=f;function y(E,A,a){return E==="*"||v(A,a,E)}t.isEngineValid=y;function v(E,A,a,u=[]){let I=D(T(a));if(!I)return u.push(h.localize(0,null,a)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return u.push(h.localize(1,null,a)),!1}else if(!I.majorMustEqual)return u.push(h.localize(2,null,a)),!1;return l(E,A,I)?!0:(u.push(h.localize(3,null,E,a)),!1)}}),define(ee[90],te([0,1,37,48,2,10]),function(q,t,h,O,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends S.Disposable{constructor(l,f,y,v){super();this.folders=l,this.onDidFilesChange=f,this.onLogMessage=y,this.verboseLogging=v,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const l=this._register(new O.Client(R.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(l.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=h.ProxyChannel.toService((0,h.getNextTickChannel)(l.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f))),this.setFolders(this.folders)}setVerboseLogging(l){this.verboseLogging=l,!this.isDisposed&&this.service&&this.service.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${l}`})}setFolders(l){this.folders=l,this.service&&this.service.setRoots(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(ee[91],te([0,1,37,48,2,10]),function(q,t,h,O,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends S.Disposable{constructor(l,f,y,v,E={}){super();this.folders=l,this.onDidFilesChange=f,this.onLogMessage=y,this.verboseLogging=v,this.watcherOptions=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const l=this._register(new O.Client(R.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(l.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=h.ProxyChannel.toService((0,h.getNextTickChannel)(l.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f))),this.service.setRoots(this.folders)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${l}`})}setVerboseLogging(l){this.verboseLogging=l,this.service&&this.service.setVerboseLogging(l)}setFolders(l){this.folders=l,this.service&&this.service.setRoots(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(ee[92],te([0,1,32,46,61,10]),function(q,t,h,O,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class T{constructor(l,f,y,v,E){this.watchedFolder=l,this.eventCallback=y,this.logCallback=v,this.verboseLogging=E,this.restartCounter=0,Array.isArray(f)?this.ignored=f.map(A=>(0,S.parse)(A)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${l}, excludes: ${f.join(",")}`),this.startWatcher()}startWatcher(){const l=[this.watchedFolder];this.verboseLogging&&l.push("-verbose"),this.handle=(0,h.spawn)(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",q).fsPath,l);const f=new O.LineDecoder;this.handle.stdout.on("data",y=>{const v=[];for(const E of f.write(y)){const A=E.split("|");if(A.length===2){const a=Number(A[0]),u=A[1];if(a>=0&&a<3){if(this.ignored&&this.ignored.some(I=>I(u))){this.verboseLogging&&this.log(u);continue}v.push({type:T.changeTypeMap[a],path:u})}else this.log(A[1])}}v.length>0&&this.eventCallback(v)}),this.handle.on("error",y=>this.onError(y)),this.handle.stderr.on("data",y=>this.onError(y)),this.handle.on("exit",(y,v)=>this.onExit(y,v))}onError(l){this.error("process error: "+l.toString())}onExit(l,f){this.handle&&(this.error(`terminated unexpectedly (code: ${l}, signal: ${f})`),this.restartCounter<=T.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(l){this.logCallback({type:"error",message:`[File Watcher (C#)] ${l}`})}log(l){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${l}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=T,T.MAX_RESTARTS=5,T.changeTypeMap=[0,1,2]}),define(ee[93],te([0,1,92,3,18]),function(q,t,h,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class R{constructor(D,l,f,y){this.onDidFilesChange=l,this.onLogMessage=f,this.verboseLogging=y,this.service=void 0,this.folder=D[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(O.posix.sep)&&(this.folder.path=(0,S.rtrim)(this.folder.path,O.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new h.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,D=>this.onFileEvents(D),D=>this.onLogMessage(D),this.verboseLogging)}setVerboseLogging(D){this.verboseLogging=D,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(D){this.isDisposed||D.length>0&&this.onDidFilesChange(D)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=R}),define(ee[50],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class h{constructor(S,R=[],T=!1){this.ctor=S,this.staticArguments=R,this.supportsDelayedInstantiation=T}}t.SyncDescriptor=h}),define(ee[94],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class h{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}t.Node=h;class O{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let T of this._nodes.values())T.outgoing.size===0&&R.push(T);return R}insertEdge(R,T){const D=this.lookupOrInsertNode(R),l=this.lookupOrInsertNode(T);D.outgoing.set(this._hashFn(T),l),l.incoming.set(this._hashFn(R),D)}removeNode(R){const T=this._hashFn(R);this._nodes.delete(T);for(let D of this._nodes.values())D.outgoing.delete(T),D.incoming.delete(T)}lookupOrInsertNode(R){const T=this._hashFn(R);let D=this._nodes.get(T);return D||(D=new h(R),this._nodes.set(T,D)),D}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[T,D]of this._nodes)R.push(`${T}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,T]of this._nodes){const D=new Set([R]),l=this._findCycle(T,D);if(l)return l}}_findCycle(R,T){for(let[D,l]of R.outgoing){if(T.has(D))return[...T,D].join(" -> ");T.add(D);const f=this._findCycle(l,T);if(f)return f;T.delete(D)}}}t.Graph=O}),define(ee[95],te([0,1,13]),function(q,t,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,h.createDecorator)("downloadService")}),define(ee[21],te([0,1,13]),function(q,t,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,h.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,h.refineServiceDecorator)(t.IEnvironmentService)}),define(ee[23],te([0,1,74,13,10]),function(q,t,h,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";function R(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}t.isIExtensionIdentifier=R;var T;(function(v){v[v.NoneOrRelevance=0]="NoneOrRelevance",v[v.LastUpdatedDate=1]="LastUpdatedDate",v[v.Title=2]="Title",v[v.PublisherName=3]="PublisherName",v[v.InstallCount=4]="InstallCount",v[v.PublishedDate=5]="PublishedDate",v[v.AverageRating=6]="AverageRating",v[v.WeightedRating=12]="WeightedRating"})(T=t.SortBy||(t.SortBy={}));var D;(function(v){v[v.Default=0]="Default",v[v.Ascending=1]="Ascending",v[v.Descending=2]="Descending"})(D=t.SortOrder||(t.SortOrder={}));var l;(function(v){v.Uninstall="uninstall"})(l=t.StatisticType||(t.StatisticType={}));var f;(function(v){v[v.None=0]="None",v[v.Install=1]="Install",v[v.Update=2]="Update"})(f=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class y extends Error{constructor(E,A){super(E);this.code=A,this.name=A}}t.ExtensionManagementError=y,t.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=S.FileAccess.asBrowserUri("./media/defaultIcon.png",q).toString(!0),t.ExtensionsLabel=(0,h.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,h.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,O.createDecorator)("IExtensionManagementCLIService")}),define(ee[38],te([0,1,18,13]),function(q,t,h,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function S(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}t.getWorkspaceSupportTypeMessage=S;function R(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}t.isIExtensionIdentifier=R,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(T=t.ExtensionType||(t.ExtensionType={}));class D{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,E){if(typeof v=="undefined"||v===null)return typeof E=="undefined"||E===null;if(typeof E=="undefined"||E===null)return!1;if(typeof v=="string"||typeof E=="string"){let A=typeof v=="string"?v:v.value,a=typeof E=="string"?E:E.value;return h.equalsIgnoreCase(A,a)}return v._lower===E._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}t.ExtensionIdentifier=D;function l(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}t.isLanguagePackExtension=l;function f(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=f,t.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[24],te([0,1,18,38]),function(q,t,h,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function S(a,u){return a.uuid&&u.uuid?a.uuid===u.uuid:a.id===u.id?!0:(0,h.compareIgnoreCase)(a.id,u.id)===0}t.areSameExtensions=S;class R{constructor(u,I){this.version=I,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof R?S(this,u)&&this.version===u.version:!1}}t.ExtensionIdentifierWithVersion=R;function T(a,u){return`${a}.${u}`}t.getExtensionId=T;function D(a){return a.toLocaleLowerCase()}t.adoptToGalleryExtensionId=D;function l(a,u){return D(T(a,u))}t.getGalleryExtensionId=l;function f(a,u){const I=[],C=b=>{for(const d of I)if(d.some(r=>S(u(r),u(b))))return d;return null};for(const b of a){const d=C(b);d?d.push(b):I.push([b])}return I}t.groupByExtension=f;function y(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=y;function v(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}t.getGalleryExtensionTelemetryData=v,t.BetterMergeId=new O.ExtensionIdentifier("pprice.better-merge");function E(a){const u=new Set;for(const I of a)I.malicious&&u.add(I.id.id);return u}t.getMaliciousExtensionsSet=E;function A(a,u){const I=[],C=u.manifest.extensionDependencies?.slice(0)??[];for(;C.length;){const b=C.shift();if(b&&I.every(d=>!S(d.identifier,{id:b}))){const d=a.filter(r=>S(r.identifier,{id:b}));d.length===1&&(I.push(d[0]),C.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return I}t.getExtensionDependencies=A});var he=this&&this.__param||function(q,t){return function(h,O){t(h,O,q)}};define(ee[96],te([0,1,75,7,9,39,23,24,38,62,26,10]),function(q,t,h,O,S,R,T,D,l,f,y,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const E=b=>(0,h.localize)(0,null,b),A=(0,h.localize)(1,null,"ms-dotnettools.csharp");function a(b,d){return d?`${b.publisher}.${b.name}@${b.version}`:`${b.publisher}.${b.name}`}const u=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function I(b){const d=u.exec(b);return d&&d[1]?[(0,D.adoptToGalleryExtensionId)(d[1]),d[2]]:[(0,D.adoptToGalleryExtensionId)(b),void 0]}t.getIdAndVersion=I;let C=class{constructor(d,r){this.extensionManagementService=d,this.extensionGalleryService=r}get location(){}async listExtensions(d,r,o=console){let e=await this.extensionManagementService.getInstalled(1);const i=l.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(r&&r!==""){if(i.indexOf(r.toLowerCase())<0){o.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(s=>s.manifest.categories?s.manifest.categories.map(p=>p.toLowerCase()).indexOf(r.toLowerCase())>-1:!1)}else if(r===""){o.log("Possible Categories: "),i.forEach(s=>{o.log(s)});return}this.location&&o.log((0,h.localize)(2,null,this.location)),e=e.sort((s,c)=>s.identifier.id.localeCompare(c.identifier.id));let n;for(let s of e)n!==s.identifier.id&&(n=s.identifier.id,o.log(a(s.manifest,d)))}async installExtensions(d,r,o,e,i=console){const n=[],s=[];d.length&&i.log(this.location?(0,h.localize)(3,null,this.location):(0,h.localize)(4,null));const c=await this.extensionManagementService.getInstalled(1),p=(F,U)=>{const B=c.find(_=>(0,D.areSameExtensions)(_.identifier,{id:F}));if(B){if(!U&&!e)return i.log((0,h.localize)(5,null,F,B.manifest.version,F)),!1;if(U&&B.manifest.version===U)return i.log((0,h.localize)(6,null,`${F}@${U}`)),!1}return!0},w=[],x=[];for(const F of d)if(F instanceof S.URI)w.push(F);else{const[U,B]=I(F);p(U,B)&&x.push({id:U,version:B,installOptions:{isBuiltin:!1,isMachineScoped:o}})}for(const F of r){const[U,B]=I(F);p(U,B)&&x.push({id:U,version:B,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(w.length&&await Promise.all(w.map(async F=>{try{const U=await this.installVSIX(F,{isBuiltin:!1,isMachineScoped:o},e,i);U&&s.push(U)}catch(U){i.error(U.message||U.stack||U),n.push(F.toString())}})),x.length){const F=await this.getGalleryExtensions(x);await Promise.all(x.map(async U=>{const B=F.get(U.id.toLowerCase());if(B)try{const _=await this.installFromGallery(U,B,c,e,i);_&&s.push(_)}catch(_){i.error(_.message||_.stack||_),n.push(U.id)}else i.error(`${E(U.version?`${U.id}@${U.version}`:U.id)}
${A}`),n.push(U.id)}))}if(n.length)throw new Error((0,h.localize)(7,null,n.join(", ")))}async installVSIX(d,r,o,e){const i=await this.extensionManagementService.getManifest(d);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,o,e))try{return await this.extensionManagementService.install(d,r),e.log((0,h.localize)(8,null,(0,f.getBaseLabel)(d))),i}catch(s){if((0,O.isPromiseCanceledError)(s))return e.log((0,h.localize)(9,null,(0,f.getBaseLabel)(d))),null;throw s}return null}async getGalleryExtensions(d){const r=d.filter(({version:i})=>i===void 0).map(({id:i})=>i),o=d.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(r,y.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(o.map(async({id:i,version:n})=>{const s=await this.extensionGalleryService.getCompatibleExtension({id:i},n);s&&e.set(s.identifier.id.toLowerCase(),s)}))]),e}async installFromGallery({id:d,version:r,installOptions:o},e,i,n,s){const c=await this.extensionGalleryService.getManifest(e,y.CancellationToken.None);if(c&&!this.validateExtensionKind(c,s))return null;const p=i.find(w=>(0,D.areSameExtensions)(w.identifier,e.identifier));if(p){if(e.version===p.manifest.version)return s.log((0,h.localize)(10,null,r?`${d}@${r}`:d)),null;s.log((0,h.localize)(11,null,d,e.version))}try{return o.isBuiltin?s.log(r?(0,h.localize)(12,null,d,r):(0,h.localize)(13,null,d)):s.log(r?(0,h.localize)(14,null,d,r):(0,h.localize)(15,null,d)),await this.extensionManagementService.installFromGallery(e,o),s.log((0,h.localize)(16,null,d,e.version)),c}catch(w){if((0,O.isPromiseCanceledError)(w))return s.log((0,h.localize)(17,null,d)),null;throw w}}validateExtensionKind(d,r){return!0}async validateVSIX(d,r,o){const e={id:(0,D.getGalleryExtensionId)(d.publisher,d.name)},n=(await this.extensionManagementService.getInstalled(1)).find(s=>(0,D.areSameExtensions)(e,s.identifier)&&(0,R.gt)(s.manifest.version,d.version));return n&&!r?(o.log((0,h.localize)(18,null,n.identifier.id,n.manifest.version,d.version)),!1):this.validateExtensionKind(d,o)}async uninstallExtensions(d,r,o=console){const e=async n=>{if(n instanceof S.URI){const s=await this.extensionManagementService.getManifest(n);return a(s)}return n},i=[];for(const n of d){const s=await e(n),p=(await this.extensionManagementService.getInstalled()).filter(w=>(0,D.areSameExtensions)(w.identifier,{id:s}));if(!p.length)throw new Error(`${this.notInstalled(s)}
${A}`);if(p.some(w=>w.type===0)){o.log((0,h.localize)(19,null,s));return}if(!r&&p.some(w=>w.isBuiltin)){o.log((0,h.localize)(20,null,s));return}o.log((0,h.localize)(21,null,s));for(const w of p)await this.extensionManagementService.uninstall(w),i.push(w);this.location?o.log((0,h.localize)(22,null,s,this.location)):o.log((0,h.localize)(23,null,s))}}async locateExtension(d,r=console){const o=await this.extensionManagementService.getInstalled();d.forEach(e=>{o.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===v.Schemas.file){r.log(i.location.fsPath);return}})})}notInstalled(d){return this.location?(0,h.localize)(24,null,d,this.location):(0,h.localize)(25,null,d)}};C=fe([he(0,T.IExtensionManagementService),he(1,T.IExtensionGalleryService)],C),t.ExtensionManagementCLIService=C}),define(ee[97],te([0,1,2,3,38,11]),function(q,t,h,O,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class T extends h.Disposable{constructor(l,f){super();this.environmentService=l,this.extensionsManifestCache=(0,O.join)(this.environmentService.userDataPath,S.MANIFEST_CACHE_FOLDER,S.USER_MANIFEST_CACHE_FILE),this._register(f.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(f.onDidUninstallExtension(y=>this.onDidUnInstallExtension(y)))}onDidInstallExtensions(l){l.some(f=>!!f.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=T}),define(ee[98],te([0,1,87,32,29,14,126,28,71,26,7]),function(q,t,h,O,S,R,T,D,l,f,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function v(a,u,I){return u["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):R.isWindows?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,T.isLaunchedFromCli)(I)&&!u["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,T.isLaunchedFromCli)(I)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=new Promise(async C=>{const b=new f.CancellationTokenSource,d=setTimeout(()=>{a.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),b.dispose(!0),C({})},1e4);try{const r=await A(a,b.token);C(r)}catch(r){(0,y.isPromiseCanceledError)(r)||a.error(`[resolve shell env] Unable to resolve shell environment (${r}). Proceeding without shell environment...`),C({})}finally{clearTimeout(d),b.dispose()}})),E)}t.resolveShellEnv=v;let E;async function A(a,u){const I=new Promise(async(C,b)=>{const d=process.env.ELECTRON_RUN_AS_NODE;a.trace("getUnixShellEnvironment#runAsNode",d);const r=process.env.ELECTRON_NO_ATTACH_CONSOLE;a.trace("getUnixShellEnvironment#noAttach",r);const o=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(o+"(.*)"+o),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};a.trace("getUnixShellEnvironment#env",i);const n=await(0,l.getSystemShell)(R.OS,i);if(a.trace("getUnixShellEnvironment#shell",n),u.isCancellationRequested)return b(y.canceled);const s=h.basename(n);let c,p;/^pwsh(-preview)?$/.test(s)?(c=`& '${process.execPath}' -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,p=["-Login","-Command"]):(c=`'${process.execPath}' -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,p=["-ilc"]),a.trace("getUnixShellEnvironment#spawn",JSON.stringify(p),c);const w=(0,O.spawn)(n,[...p,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});u.onCancellationRequested(()=>(w.kill(),b(y.canceled))),w.on("error",U=>{a.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(U)),C({})});const x=[];w.stdout.on("data",U=>x.push(U));const F=[];w.stderr.on("data",U=>F.push(U)),w.on("close",(U,B)=>{const _=Buffer.concat(x).toString("utf8");a.trace("getUnixShellEnvironment#raw",_);const Q=Buffer.concat(F).toString("utf8");if(Q.trim()&&a.trace("getUnixShellEnvironment#stderr",Q),U||B)return b(new Error(`Failed to get environment (code ${U}, signal ${B})`));const ne=e.exec(_),se=ne?ne[1]:"{}";try{const Z=JSON.parse(se);d?Z.ELECTRON_RUN_AS_NODE=d:delete Z.ELECTRON_RUN_AS_NODE,r?Z.ELECTRON_NO_ATTACH_CONSOLE=r:delete Z.ELECTRON_NO_ATTACH_CONSOLE,delete Z.XDG_RUNTIME_DIR,a.trace("getUnixShellEnvironment#result",Z),C(Z)}catch(Z){a.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(Z)),b(Z)}})});try{return await I}catch(C){return a.error("getUnixShellEnvironment#error",(0,D.toErrorMessage)(C)),{}}}}),define(ee[51],te([0,1,9,17,14]),function(q,t,h,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function R(l){return l.map(f=>({type:f.type,resource:h.URI.file(f.path)}))}t.toFileChanges=R;function T(l){const f=new D;for(const y of l)f.processEvent(y);return f.normalize()}t.normalizeFileChanges=T;class D{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(f){const y=this.mapPathToChange.get(f.path);if(y){const v=y.type,E=f.type;v===1&&E===2?(this.mapPathToChange.delete(f.path),this.normalized.splice(this.normalized.indexOf(y),1)):v===2&&E===1?y.type=0:v===1&&E===0||(y.type=E)}else this.normalized.push(f),this.mapPathToChange.set(f.path,f)}normalize(){const f=[],y=[];return this.normalized.filter(v=>v.type!==2?(f.push(v),!1):!0).sort((v,E)=>v.path.length-E.path.length).filter(v=>y.some(E=>(0,O.isParent)(v.path,E,!S.isLinux))?!1:(y.push(v.path),!0)).concat(f)}}}),define(ee[99],te([0,1,51,2,11,63,65,4,3]),function(q,t,h,O,S,R,T,D,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class f extends O.Disposable{constructor(v,E,A,a){super();this.path=v,this.onDidFilesChange=E,this.onLogMessage=A,this.verboseLogging=a,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(v){this.verboseLogging=v}async startWatching(){try{const{stat:v,symbolicLink:E}=await S.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let A=this.path;if(E)try{A=await(0,R.realpath)(A)}catch(a){if(this.onError(a),E.dangling)return}v.isDirectory()?this._register((0,T.watchFolder)(A,(a,u)=>{this.onFileChange({type:a==="changed"?0:a==="added"?1:2,path:(0,l.join)(this.path,(0,l.basename)(u))})},a=>this.onError(a))):this._register((0,T.watchFile)(A,a=>{this.onFileChange({type:a==="changed"?0:2,path:this.path})},a=>this.onError(a)))}catch(v){v.code!=="ENOENT"&&this.onError(v)}}onFileChange(v){this.fileChangesBuffer.push(v),this.verboseLogging&&this.onVerbose(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),this.fileChangesDelayer.trigger(async()=>{const E=this.fileChangesBuffer;this.fileChangesBuffer=[];const A=(0,h.normalizeFileChanges)(E);if(this.verboseLogging)for(const a of A)this.onVerbose(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`);A.length>0&&this.onDidFilesChange(A)})}onError(v){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${v}`})}onVerbose(v){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=f}),define(ee[52],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class h{constructor(...S){this._entries=new Map;for(let[R,T]of S)this.set(R,T)}set(S,R){const T=this._entries.get(S);return this._entries.set(S,R),T}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}t.ServiceCollection=h}),define(ee[100],te([0,1,7,94,50,13,52,4]),function(q,t,h,O,S,R,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const l=!1;class f extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class y{constructor(a=new T.ServiceCollection,u=!1,I){this._activeInstantiations=new Set,this._services=a,this._strict=u,this._parent=I,this._services.set(R.IInstantiationService,this)}createChild(a){return new y(a,this._strict,this)}invokeFunction(a,...u){let I=E.traceInvocation(a),C=!1;try{return a({get:(d,r)=>{if(C)throw(0,h.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(d,I);if(!o&&r!==R.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return o}},...u)}finally{C=!0,I.stop()}}createInstance(a,...u){let I,C;return a instanceof S.SyncDescriptor?(I=E.traceCreation(a.ctor),C=this._createInstance(a.ctor,a.staticArguments.concat(u),I)):(I=E.traceCreation(a),C=this._createInstance(a,u,I)),I.stop(),C}_createInstance(a,u=[],I){let C=R._util.getServiceDependencies(a).sort((r,o)=>r.index-o.index),b=[];for(const r of C){let o=this._getOrCreateServiceInstance(r.id,I);if(!o&&this._strict&&!r.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${r.id}.`);b.push(o)}let d=C.length>0?C[0].index:u.length;if(u.length!==d){console.warn(`[createInstance] First service dependency of ${a.name} at position ${d+1} conflicts with ${u.length} static arguments`);let r=d-u.length;r>0?u=u.concat(new Array(r)):u=u.slice(0,d)}return new a(...[...u,...b])}_setServiceInstance(a,u){if(this._services.get(a)instanceof S.SyncDescriptor)this._services.set(a,u);else if(this._parent)this._parent._setServiceInstance(a,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let u=this._services.get(a);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):u}_getOrCreateServiceInstance(a,u){let I=this._getServiceInstanceOrDescriptor(a);return I instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,I,u.branch(a,!0)):(u.branch(a,!1),I)}_safeCreateAndCacheServiceInstance(a,u,I){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,u,I)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,u,I){const C=new O.Graph(r=>r.id.toString());let b=0;const d=[{id:a,desc:u,_trace:I}];for(;d.length;){const r=d.pop();if(C.lookupOrInsertNode(r),b++>1e3)throw new f(C);for(let o of R._util.getServiceDependencies(r.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(o.id);if(!e&&!o.optional&&console.warn(`[createInstance] ${a} depends on ${o.id} which is NOT registered.`),e instanceof S.SyncDescriptor){const i={id:o.id,desc:e,_trace:r._trace.branch(o.id,!0)};C.insertEdge(r,i),d.push(i)}}}for(;;){const r=C.roots();if(r.length===0){if(!C.isEmpty())throw new f(C);break}for(const{data:o}of r){if(this._getServiceInstanceOrDescriptor(o.id)instanceof S.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}C.removeNode(o)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,u,I=[],C,b){if(this._services.get(a)instanceof S.SyncDescriptor)return this._createServiceInstance(u,I,C,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,u,I,C,b);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(a,u=[],I,C){if(I){const b=new D.IdleValue(()=>this._createInstance(a,u,C));return new Proxy(Object.create(null),{get(d,r){if(r in d)return d[r];let o=b.value,e=o[r];return typeof e!="function"||(e=e.bind(o),d[r]=e),e},set(d,r,o){return b.value[r]=o,!0}})}else return this._createInstance(a,u,C)}}t.InstantiationService=y;var v;(function(A){A[A.Creation=0]="Creation",A[A.Invocation=1]="Invocation",A[A.Branch=2]="Branch"})(v||(v={}));class E{constructor(a,u){this.type=a,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return l?new E(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(a){return l?new E(0,a.name):E._None}branch(a,u){let I=new E(2,a.toString());return this._dep.push([a,u,I]),I}stop(){let a=Date.now()-this._start;E._totals+=a;let u=!1;function I(b,d){let r=[],o=new Array(b+1).join("	");for(const[e,i,n]of d._dep)if(i&&n){u=!0,r.push(`${o}CREATES -> ${e}`);let s=I(b+1,n);s&&r.push(s)}else r.push(`${o}uses -> ${e}`);return r.join(`
`)}let C=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${I(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(a>2||u)&&console.log(C.join(`
`))}}E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(ee[53],te([0,1,13]),function(q,t,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,h.createDecorator)("localizationsService");function O(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const R of S.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}t.isValidLocalization=O}),define(ee[15],te([0,1,13,2,14,12,28]),function(q,t,h,O,S,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,h.createDecorator)("logService"),t.ILoggerService=(0,h.createDecorator)("loggerService");function D(){return new Date().toISOString()}var l;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(l=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=l.Info;class f extends O.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=f;class y extends f{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(l.Trace)&&this.log(l.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(l.Debug)&&this.log(l.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(l.Info)&&this.log(l.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(l.Warning)&&this.log(l.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(l.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(l.Error,this.format(n))}else this.log(l.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(l.Critical)&&this.log(l.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let s=e[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(c){}i+=(n>0?" ":"")+s}return i}}t.AbstractMessageLogger=y;class v extends f{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!S.isWindows}trace(e,...i){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,e,...i):console.log(`[main ${D()}]`,e,...i))}debug(e,...i){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,e,...i):console.log(`[main ${D()}]`,e,...i))}info(e,...i){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,e,...i):console.log(`[main ${D()}]`,e,...i))}warn(e,...i){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,e,...i):console.warn(`[main ${D()}]`,e,...i))}error(e,...i){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,e,...i):console.error(`[main ${D()}]`,e,...i))}critical(e,...i){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,e,...i):console.error(`[main ${D()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=v;class E extends f{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=E;class A extends f{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}t.AdapterLogger=A;class a extends f{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=a;class u extends O.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=u;class I extends O.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(n))}))}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?l.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=I;class C{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=C;function b(o){if(o.verbose)return l.Trace;if(typeof o.logLevel=="string"){const e=d(o.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=b;function d(o){switch(o){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}t.parseLogLevel=d;function r(o){switch(o){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}t.LogLevelToString=r}),define(ee[101],te([0,1,11,2,17,23,21,9,20,24,15,29,39,14,4,7]),function(q,t,h,O,S,R,T,D,l,f,y,v,E,A,a,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let C=class extends O.Disposable{constructor(d,r,o,e){super();this.fileService=r,this.extensionGalleryService=o,this.logService=e,this.extensionsDownloadDir=D.URI.file(d.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(d,r){await this.cleanUpPromise;const o=this.getName(d),e=(0,l.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(e)){const i=(0,l.joinPath)(this.extensionsDownloadDir,`.${(0,v.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(d,i,r);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(s){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",d.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,u.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(d){}async rename(d,r,o){try{await h.Promises.rename(d.fsPath,r.fsPath)}catch(e){if(A.isWindows&&e&&e.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${d} to ${r} with 'EPERM' error. Trying again...`),this.rename(d,r,o);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const d=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(d.children){const r=[],o=[];for(const n of d.children){const s=this.parse(n.name);s&&o.push([s,n])}const e=(0,f.groupByExtension)(o,([n])=>n),i=[];for(const n of e)n.sort((s,c)=>E.rcompare(s[0].version,c[0].version)),r.push(...n.slice(1).map(s=>s[1].resource)),i.push(n[0][1]);i.sort((n,s)=>n.mtime-s.mtime),r.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await a.Promises.settled(r.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(d){this.logService.error(d)}}getName(d){return this.cache?new f.ExtensionIdentifierWithVersion(d.identifier,d.version).key().toLowerCase():(0,v.generateUuid)()}parse(d){const r=I.exec(d);return r&&r[1]&&r[2]?new f.ExtensionIdentifierWithVersion({id:r[1]},r[2]):null}};C=fe([he(0,T.INativeEnvironmentService),he(1,S.IFileService),he(2,R.IExtensionGalleryService),he(3,y.ILogService)],C),t.ExtensionsDownloader=C}),define(ee[102],te([0,1,2,15,32,28,3,4,12,10,11,21]),function(q,t,h,O,S,R,T,D,l,f,y,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let E=class extends h.Disposable{constructor(a,u){super();this.environmentService=a,this.logService=u,this.processesLimiter=new D.Limiter(5)}async postUninstall(a){const u=this.parseScript(a,"uninstall");return u&&(this.logService.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(u.script,"uninstall",u.args,!0,a).then(()=>this.logService.info(a.identifier.id,a.manifest.version,"Finished running post uninstall script"),I=>this.logService.error(a.identifier.id,a.manifest.version,`Failed to run post uninstall script: ${I}`)))),y.Promises.rm(this.getExtensionStoragePath(a)).then(void 0,I=>this.logService.error("Error while removing extension storage path",I))}parseScript(a,u){const I=`vscode:${u}`;if(a.location.scheme===f.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[I]=="string"){const C=a.manifest.scripts[I].split(" ");return C.length<2||C[0]!=="node"||!C[1]?(this.logService.warn(a.identifier.id,a.manifest.version,`${I} should be a node script`),null):{script:(0,T.join)(a.location.fsPath,C[1]),args:C.slice(2)||[]}}return null}runLifecycleHook(a,u,I,C,b){return new Promise((d,r)=>{const o=this.start(a,u,I,b);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?r(n):d(void 0)};o.on("error",n=>{i((0,R.toErrorMessage)(n)||"Unknown")}),o.on("exit",(n,s)=>{i(n?`post-${u} process exited with code ${n}`:void 0)}),C&&(e=setTimeout(()=>{e=null,o.kill(),r("timed out")},5e3))})}start(a,u,I,C){const b={silent:!0,execArgv:void 0},d=(0,S.fork)(a,[`--type=extension-post-${u}`,...I],b);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const r=l.Event.fromNodeEventEmitter(d.stdout,"data"),o=l.Event.fromNodeEventEmitter(d.stderr,"data");r(n=>this.logService.info(C.identifier.id,C.manifest.version,`post-${u}`,n)),o(n=>this.logService.error(C.identifier.id,C.manifest.version,`post-${u}`,n));const e=l.Event.any(l.Event.map(r,n=>({data:`%c${n}`,format:[""]})),l.Event.map(o,n=>({data:`%c${n}`,format:["color: red"]})));return l.Event.debounce(e,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(C.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),d}getExtensionStoragePath(a){return(0,T.join)(this.environmentService.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};E=fe([he(0,v.IEnvironmentService),he(1,O.ILogService)],E),t.ExtensionsLifecycle=E}),define(ee[103],te([0,1,2,21,12,17,9,24,20,15]),function(q,t,h,O,S,R,T,D,l,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let y=class extends h.Disposable{constructor(E,A,a,u){super();this.extensionsManagementService=E,this.logService=u,this._onDidChangeExtensionsByAnotherSource=this._register(new S.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(b=>{this.installedExtensions=b.map(d=>d.identifier),this.startTimestamp=Date.now()}),this._register(E.onInstallExtension(b=>this.onInstallExtension(b))),this._register(E.onDidInstallExtensions(b=>this.onDidInstallExtensions(b))),this._register(E.onDidUninstallExtension(b=>this.onDidUninstallExtension(b)));const I=T.URI.file(a.extensionsPath),C=new l.ExtUri(b=>!A.hasCapability(b,1024));this._register(A.watch(I)),this._register(S.Event.filter(A.onDidChangeFilesRaw,b=>b.changes.some(d=>this.doesChangeAffects(d,I,C)))(()=>this.onDidChange()))}doesChangeAffects(E,A,a){return a.isEqual(a.dirname(E.resource),A)?a.isEqual(E.resource,a.joinPath(A,".obsolete"))?!0:!(E.type!==1&&E.type!==2||a.basename(E.resource).startsWith(".")):!1}onInstallExtension(E){this.addInstallingExtension(E.identifier)}onDidInstallExtensions(E){for(const A of E)this.removeInstallingExtension(A.identifier),A.local&&this.addInstalledExtension(A.identifier)}onDidUninstallExtension(E){E.error||this.removeInstalledExtension(E.identifier)}addInstallingExtension(E){this.removeInstallingExtension(E),this.installingExtensions.push(E)}removeInstallingExtension(E){this.installingExtensions=this.installingExtensions.filter(A=>!(0,D.areSameExtensions)(A,E))}addInstalledExtension(E){this.installedExtensions&&(this.removeInstalledExtension(E),this.installedExtensions.push(E))}removeInstalledExtension(E){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(A=>!(0,D.areSameExtensions)(A,E)))}async onDidChange(){if(this.installedExtensions){const E=await this.extensionsManagementService.getInstalled(1),A=E.filter(u=>[...this.installingExtensions,...this.installedExtensions].some(I=>(0,D.areSameExtensions)(I,u.identifier))?!1:u.installedTimestamp&&u.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",u.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",u.identifier.id),!1)),a=this.installedExtensions.filter(u=>this.installingExtensions.some(I=>(0,D.areSameExtensions)(I,u))?!1:E.every(I=>!(0,D.areSameExtensions)(I.identifier,u))?(this.logService.info("Detected extension removed from another source",u.id),!0):!1);this.installedExtensions=E.map(u=>u.identifier),(A.length||a.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:A,removed:a})}}};y=fe([he(1,R.IFileService),he(2,O.INativeEnvironmentService),he(3,f.ILogService)],y),t.ExtensionsWatcher=y}),define(ee[104],te([0,1,11,127,23,2,21,4,24,15,53,22,12,10,3]),function(q,t,h,O,S,R,T,D,l,f,y,v,E,A,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let u=class extends R.Disposable{constructor(b,d,r){super();this.extensionManagementService=b,this.logService=r,this._onDidLanguagesChange=this._register(new E.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new I(d,r)),this._register(b.onDidInstallExtensions(o=>this.onDidInstallExtensions(o))),this._register(b.onDidUninstallExtension(({identifier:o})=>this.onDidUninstallExtension(o)))}getLanguageIds(){return this.cache.getLanguagePacks().then(b=>{const d=["en",...Object.keys(b)];return(0,v.distinct)(d)})}onDidInstallExtensions(b){for(const{local:d}of b)d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",d.identifier.id),this.update().then(r=>{r&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(b){this.cache.getLanguagePacks().then(d=>{Object.keys(d).some(r=>d[r]&&d[r].extensions.some(o=>(0,l.areSameExtensions)(o.extensionIdentifier,b)))&&(this.logService.debug("Removing language packs from the extension",b.id),this.update().then(r=>{r&&this._onDidLanguagesChange.fire()}))})}async update(){const[b,d]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),r=await this.cache.update(d);return!(0,v.equals)(Object.keys(b),Object.keys(r))}};u=fe([he(0,S.IExtensionManagementService),he(1,T.INativeEnvironmentService),he(2,f.ILogService)],u),t.LocalizationsService=u;let I=class extends R.Disposable{constructor(b,d){super();this.logService=d,this.languagePacks={},this.languagePacksFilePath=(0,a.join)(b.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(b){return this.withLanguagePacks(d=>{Object.keys(d).forEach(r=>delete d[r]),this.createLanguagePacksFromExtensions(d,...b)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(b,...d){for(const r of d)r&&r.manifest&&r.manifest.contributes&&r.manifest.contributes.localizations&&r.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(b,r);Object.keys(b).forEach(r=>this.updateHash(b[r]))}createLanguagePacksFromExtension(b,d){const r=d.identifier,o=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const e of o)if(d.location.scheme===A.Schemas.file&&(0,y.isValidLocalization)(e)){let i=b[e.languageId];i||(i={hash:"",extensions:[],translations:{}},b[e.languageId]=i);let n=i.extensions.filter(s=>(0,l.areSameExtensions)(s.extensionIdentifier,r))[0];n?n.version=d.manifest.version:i.extensions.push({extensionIdentifier:r,version:d.manifest.version});for(const s of e.translations)i.translations[s.id]=(0,a.join)(d.location.fsPath,s.path)}}updateHash(b){if(b){const d=(0,O.createHash)("md5");for(const r of b.extensions)d.update(r.extensionIdentifier.uuid||r.extensionIdentifier.id).update(r.version);b.hash=d.digest("hex")}}withLanguagePacks(b=()=>null){return this.languagePacksFileLimiter.queue(()=>{let d=null;return h.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,r=>r.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(r)).then(r=>{try{return JSON.parse(r)}catch(o){return{}}}).then(r=>(d=b(r),r)).then(r=>{for(const e of Object.keys(r))r[e]||delete r[e];this.languagePacks=r,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),h.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>d,r=>this.logService.error(r))})}};I=fe([he(0,T.INativeEnvironmentService),he(1,f.ILogService)],I)}),define(ee[105],te([0,1,15,17]),function(q,t,h,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function S(l,f,y,v){try{const E=await new Promise((A,a)=>{q(["spdlog"],A,a)});return E.setFlushOn(h.LogLevel.Trace),E.createAsyncRotatingLogger(l,f,y,v)}catch(E){console.error(E)}return null}function R(l,f,y,v){const E=q.__$__nodeRequire("spdlog");return E.setFlushOn(h.LogLevel.Trace),E.createRotatingLogger(l,f,y,v)}t.createRotatingLogger=R;function T(l,f,y){switch(f){case h.LogLevel.Trace:l.trace(y);break;case h.LogLevel.Debug:l.debug(y);break;case h.LogLevel.Info:l.info(y);break;case h.LogLevel.Warning:l.warn(y);break;case h.LogLevel.Error:l.error(y);break;case h.LogLevel.Critical:l.critical(y);break;default:throw new Error("Invalid log level")}}class D extends h.AbstractMessageLogger{constructor(f,y,v,E){super();this.name=f,this.filepath=y,this.rotating=v,this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(A=>{this._logger&&this._logger.setLevel(A)}))}_createSpdLogLogger(){const f=this.rotating?6:1,y=30/f*O.ByteSize.MB;return S(this.name,this.filepath,y,f).then(v=>{if(v){this._logger=v,this._logger.setLevel(this.getLevel());for(const{level:E,message:A}of this.buffer)T(this._logger,E,A);this.buffer=[]}})}log(f,y){this._logger?T(this._logger,f,y):this.getLevel()<=f&&this.buffer.push({level:f,message:y})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=D}),define(ee[54],te([0,1,81,16,17,7,40]),function(q,t,h,O,S,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function D(v,E,A,a,u,I){let C;try{await l(v,E,A,a,u,I)}catch(b){C=b}finally{C&&u.errorTransformer&&(C=u.errorTransformer(C)),typeof C!="undefined"&&A.error(C),A.end()}}t.readFileIntoStream=D;async function l(v,E,A,a,u,I){f(I);const C=await v.open(E,{create:!1});try{f(I);let b=0,d=0,r=u&&typeof u.length=="number"?u.length:void 0,o=O.VSBuffer.alloc(Math.min(u.bufferSize,typeof r=="number"?r:u.bufferSize)),e=u&&typeof u.position=="number"?u.position:0,i=0;do d=await v.read(C,e,o.buffer,i,o.byteLength-i),e+=d,i+=d,b+=d,typeof r=="number"&&(r-=d),i===o.byteLength&&(await A.write(a(o)),o=O.VSBuffer.alloc(Math.min(u.bufferSize,typeof r=="number"?r:u.bufferSize)),i=0);while(d>0&&(typeof r!="number"||r>0)&&f(I)&&y(b,u));if(i>0){let n=i;typeof r=="number"&&(n=Math.min(i,r)),A.write(a(o.slice(0,n)))}}catch(b){throw(0,S.ensureFileSystemProviderError)(b)}finally{await v.close(C)}}function f(v){if(v.isCancellationRequested)throw(0,R.canceled)();return!0}function y(v,E){if(E?.limits){if(typeof E.limits.memory=="number"&&v>E.limits.memory)throw(0,S.createFileSystemProviderError)((0,h.localize)(0,null,T.default.nameShort),S.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&v>E.limits.size)throw(0,S.createFileSystemProviderError)((0,h.localize)(1,null),S.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[106],te([0,1,80,128,2,17,12,20,45,22,15,16,34,4,26,10,54,129]),function(q,t,h,O,S,R,T,D,l,f,y,v,E,A,a,u,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let b=class Ne extends S.Disposable{constructor(r){super();this.logService=r,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new T.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new A.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new R.FileChangesEvent(o,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new A.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new R.FileChangesEvent(o,!0)))),this.watchedResources=l.TernarySearchTree.forUris(o=>{const e=this.getProvider(o.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new A.ResourceQueue)}registerProvider(r,o){if(this.provider.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,O.mark)(`code/registerFilesystem/${r}`),this.provider.set(r,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:r,provider:o});const e=new S.DisposableStore;return e.add(o.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(o)))),e.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:r}))),typeof o.onDidErrorOccur=="function"&&e.add(o.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:r,provider:o}),this.provider.delete(r),(0,S.dispose)(e)})}getProvider(r){return this.provider.get(r)}async activateProvider(r){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:r,join(e){o.push(e)}}),!this.provider.has(r)&&await A.Promises.settled(o)}canHandleResource(r){return this.provider.has(r.scheme)}hasCapability(r,o){const e=this.provider.get(r.scheme);return!!(e&&e.capabilities&o)}listCapabilities(){return C.Iterable.map(this.provider,([r,o])=>({scheme:r,capabilities:o.capabilities}))}async withProvider(r){if(!(0,D.isAbsolutePath)(r))throw new R.FileOperationError((0,h.localize)(0,null,this.resourceForError(r)),8);await this.activateProvider(r.scheme);const o=this.provider.get(r.scheme);if(!o){const e=new Error;throw e.name="ENOPRO",e.message=(0,h.localize)(1,null,r.toString()),e}return o}async withReadProvider(r){const o=await this.withProvider(r);if((0,R.hasOpenReadWriteCloseCapability)(o)||(0,R.hasReadWriteCapability)(o)||(0,R.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(r){const o=await this.withProvider(r);if((0,R.hasOpenReadWriteCloseCapability)(o)||(0,R.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,o){try{return await this.doResolveFile(r,o)}catch(e){throw(0,R.toFileSystemProviderErrorCode)(e)===R.FileSystemProviderErrorCode.FileNotFound?new R.FileOperationError((0,h.localize)(2,null,this.resourceForError(r)),1):(0,R.ensureFileSystemProviderError)(e)}}async doResolveFile(r,o){const e=await this.withProvider(r),i=this.isPathCaseSensitive(e),n=o?.resolveTo,s=o?.resolveSingleChildDescendants,c=o?.resolveMetadata,p=await e.stat(r);let w;return this.toFileStat(e,r,p,void 0,!!c,(x,F)=>(w||(w=l.TernarySearchTree.forUris(()=>!i),w.set(r,!0),(0,f.isNonEmptyArray)(n)&&n.forEach(U=>w.set(U,!0))),Boolean(w.findSuperstr(x.resource)||w.get(x.resource))?!0:x.isDirectory&&s?F===1:!1))}async toFileStat(r,o,e,i,n,s){const{providerExtUri:c}=this.getExtUri(r),p={resource:o,name:c.basename(o),isFile:(e.type&R.FileType.File)!=0,isDirectory:(e.type&R.FileType.Directory)!=0,isSymbolicLink:(e.type&R.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&R.FilePermission.Readonly)||Boolean(r.capabilities&2048),etag:(0,R.etag)({mtime:e.mtime,size:e.size})};if(p.isDirectory&&s(p,i)){try{const w=await r.readdir(o),x=await A.Promises.settled(w.map(async([F,U])=>{try{const B=c.joinPath(o,F),_=n?await r.stat(B):{type:U};return await this.toFileStat(r,B,_,w.length,n,s)}catch(B){return this.logService.trace(B),null}}));p.children=(0,f.coalesce)(x)}catch(w){this.logService.trace(w),p.children=[]}return p}return p}async resolveAll(r){return A.Promises.settled(r.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(r){const o=await this.withProvider(r);try{return!!await o.stat(r)}catch(e){return!1}}async canCreateFile(r,o){try{await this.doValidateCreateFile(r,o)}catch(e){return e}return!0}async doValidateCreateFile(r,o){if(!o?.overwrite&&await this.exists(r))throw new R.FileOperationError((0,h.localize)(3,null,this.resourceForError(r)),3,o)}async createFile(r,o=v.VSBuffer.fromString(""),e){await this.doValidateCreateFile(r,e);const i=await this.writeFile(r,o);return this._onDidRunOperation.fire(new R.FileOperationEvent(r,0,i)),i}async writeFile(r,o,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,r,e)||await this.mkdirp(i,n.dirname(r));let c;if((0,R.hasReadWriteCapability)(i)&&!(o instanceof v.VSBuffer))if((0,E.isReadableStream)(o)){const p=await(0,E.peekStream)(o,3);p.ended?c=v.VSBuffer.concat(p.buffer):c=p}else c=(0,E.peekReadable)(o,p=>v.VSBuffer.concat(p),3);else c=o;!(0,R.hasOpenReadWriteCloseCapability)(i)||(0,R.hasReadWriteCapability)(i)&&c instanceof v.VSBuffer?await this.doWriteUnbuffered(i,r,e,c):await this.doWriteBuffered(i,r,e,c instanceof v.VSBuffer?(0,v.bufferToReadable)(c):c)}catch(s){throw new R.FileOperationError((0,h.localize)(4,null,this.resourceForError(r),(0,R.ensureFileSystemProviderError)(s).toString()),(0,R.toFileOperationResult)(s),e)}return this.resolve(r,{resolveMetadata:!0})}async validateWriteFile(r,o,e){if(!!e?.unlock&&!(r.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(o)));let n;try{n=await r.stat(o)}catch(s){return}if((n.type&R.FileType.Directory)!=0)throw new R.FileOperationError((0,h.localize)(6,null,this.resourceForError(o)),0,e);if(this.throwIfFileIsReadonly(o,n),e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==R.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,R.etag)({mtime:e.mtime,size:n.size}))throw new R.FileOperationError((0,h.localize)(7,null),3,e);return n}async readFile(r,o){const e=await this.withReadProvider(r);return o?.atomic?this.doReadFileAtomic(e,r,o):this.doReadFile(e,r,o)}async doReadFileAtomic(r,o,e){return new Promise((i,n)=>{this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(r,o,e);i(s)}catch(s){n(s)}})})}async doReadFile(r,o,e){const i=await this.doReadFileStream(r,o,{...e,preferUnbuffered:!0});return{...i,value:await(0,v.streamToBuffer)(i.value)}}async readFileStream(r,o){const e=await this.withReadProvider(r);return this.doReadFileStream(e,r,o)}async doReadFileStream(r,o,e){const i=new a.CancellationTokenSource,n=this.validateReadFile(o,e).then(c=>c,c=>{throw i.cancel(),c});let s;try{return e&&typeof e.etag=="string"&&e.etag!==R.ETAG_DISABLED&&await n,!((0,R.hasOpenReadWriteCloseCapability)(r)||(0,R.hasFileReadStreamCapability)(r))||(0,R.hasReadWriteCapability)(r)&&e?.preferUnbuffered?s=this.readFileUnbuffered(r,o,e):(0,R.hasFileReadStreamCapability)(r)?s=this.readFileStreamed(r,o,i.token,e):s=this.readFileBuffered(r,o,i.token,e),{...await n,value:s}}catch(c){s&&await(0,E.consumeStream)(s);const p=(0,h.localize)(8,null,this.resourceForError(o),(0,R.ensureFileSystemProviderError)(c).toString());throw c instanceof R.NotModifiedSinceFileOperationError?new R.NotModifiedSinceFileOperationError(p,c.stat,e):new R.FileOperationError(p,(0,R.toFileOperationResult)(c),e)}}readFileStreamed(r,o,e,i=Object.create(null)){const n=r.readFileStream(o,i,e);return(0,E.transform)(n,{data:s=>s instanceof v.VSBuffer?s:v.VSBuffer.wrap(s),error:s=>new R.FileOperationError((0,h.localize)(9,null,this.resourceForError(o),(0,R.ensureFileSystemProviderError)(s).toString()),(0,R.toFileOperationResult)(s),i)},s=>v.VSBuffer.concat(s))}readFileBuffered(r,o,e,i=Object.create(null)){const n=(0,v.newWriteableBufferStream)();return(0,I.readFileIntoStream)(r,o,n,s=>s,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new R.FileOperationError((0,h.localize)(10,null,this.resourceForError(o),(0,R.ensureFileSystemProviderError)(s).toString()),(0,R.toFileOperationResult)(s),i)},e),n}readFileUnbuffered(r,o,e){const i=(0,E.newWriteableStream)(n=>v.VSBuffer.concat(n));return(async()=>{try{let n=await r.readFile(o);e&&typeof e.position=="number"&&(n=n.slice(e.position)),e&&typeof e.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(o,n.byteLength,e),i.end(v.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(r,o){const e=await this.resolve(r,{resolveMetadata:!0});if(e.isDirectory)throw new R.FileOperationError((0,h.localize)(11,null,this.resourceForError(r)),0,o);if(o&&typeof o.etag=="string"&&o.etag!==R.ETAG_DISABLED&&o.etag===e.etag)throw new R.NotModifiedSinceFileOperationError((0,h.localize)(12,null),e,o);return this.validateReadFileLimits(r,e.size,o),e}validateReadFileLimits(r,o,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&o>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&o>e.limits.size&&(i=7),typeof i=="number")throw new R.FileOperationError((0,h.localize)(13,null,this.resourceForError(r)),i)}}async canMove(r,o,e){return this.doCanMoveCopy(r,o,"move",e)}async canCopy(r,o,e){return this.doCanMoveCopy(r,o,"copy",e)}async doCanMoveCopy(r,o,e,i){if(r.toString()!==o.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r):await this.withReadProvider(r),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(n,r,s,o,e,i)}catch(n){return n}return!0}async move(r,o,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(i,r,n,o,"move",!!e),c=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(r,s==="move"?2:3,c)),c}async copy(r,o,e){const i=await this.withReadProvider(r),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(i,r,n,o,"copy",!!e),c=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(r,s==="copy"?3:2,c)),c}async doMoveCopy(r,o,e,i,n,s){if(o.toString()===i.toString())return n;const{exists:c,isSameResourceWithDifferentPathCase:p}=await this.doValidateMoveCopy(r,o,e,i,n,s);if(c&&!p&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(r===e&&(0,R.hasFileFolderCopyCapability)(r))await r.copy(o,i,{overwrite:s});else{const w=await this.resolve(o);w.isDirectory?await this.doCopyFolder(r,w,e,i):await this.doCopyFile(r,o,e,i)}return n}else return r===e?(await r.rename(o,i,{overwrite:s}),n):(await this.doMoveCopy(r,o,e,i,"copy",s),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(r,o,e,i){if((0,R.hasOpenReadWriteCloseCapability)(r)&&(0,R.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(r,o,e,i);if((0,R.hasOpenReadWriteCloseCapability)(r)&&(0,R.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(r,o,e,i);if((0,R.hasReadWriteCapability)(r)&&(0,R.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(r,o,e,i);if((0,R.hasReadWriteCapability)(r)&&(0,R.hasReadWriteCapability)(e))return this.doPipeUnbuffered(r,o,e,i)}async doCopyFolder(r,o,e,i){await e.mkdir(i),Array.isArray(o.children)&&await A.Promises.settled(o.children.map(async n=>{const s=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(r,await this.resolve(n.resource),e,s):this.doCopyFile(r,n.resource,e,s)}))}async doValidateMoveCopy(r,o,e,i,n,s){let c=!1;if(r===e){const{providerExtUri:w,isPathCaseSensitive:x}=this.getExtUri(r);if(x||(c=w.isEqual(o,i)),c&&n==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(o),this.resourceForError(i)));if(!c&&w.isEqualOrParent(i,o))throw new Error((0,h.localize)(15,null,this.resourceForError(o),this.resourceForError(i)))}const p=await this.exists(i);if(p&&!c){if(!s)throw new R.FileOperationError((0,h.localize)(16,null,this.resourceForError(o),this.resourceForError(i)),4);if(r===e){const{providerExtUri:w}=this.getExtUri(r);if(w.isEqualOrParent(o,i))throw new Error((0,h.localize)(17,null,this.resourceForError(o),this.resourceForError(i)))}}return{exists:p,isSameResourceWithDifferentPathCase:c}}getExtUri(r){const o=this.isPathCaseSensitive(r);return{providerExtUri:o?D.extUri:D.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(r){return!!(r.capabilities&1024)}async createFolder(r){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);await this.mkdirp(o,r);const e=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(r,0,e)),e}async mkdirp(r,o){const e=[],{providerExtUri:i}=this.getExtUri(r);for(;!i.isEqual(o,i.dirname(o));)try{if(((await r.stat(o)).type&R.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(o)));break}catch(n){if((0,R.toFileSystemProviderErrorCode)(n)!==R.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(o)),o=i.dirname(o)}for(let n=e.length-1;n>=0;n--){o=i.joinPath(o,e[n]);try{await r.mkdir(o)}catch(s){if((0,R.toFileSystemProviderErrorCode)(s)!==R.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(r,o){try{await this.doValidateDelete(r,o)}catch(e){return e}return!0}async doValidateDelete(r,o){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);if(!!o?.useTrash&&!(e.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(r)));let n;try{n=await e.stat(r)}catch(c){}if(n)this.throwIfFileIsReadonly(r,n);else throw new R.FileOperationError((0,h.localize)(20,null,this.resourceForError(r)),1);if(!!!o?.recursive){const c=await this.resolve(r);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(r)))}return e}async del(r,o){const e=await this.doValidateDelete(r,o),i=!!o?.useTrash,n=!!o?.recursive;await e.delete(r,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new R.FileOperationEvent(r,1))}onDidChangeFile(r,o){this._onDidChangeFilesRaw.fire({changes:r});let e,i;{for(const n of r)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new R.FileChangesEvent(e,!o))}if(i){const n=o?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&Ne.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(r,o={recursive:!1,excludes:[]}){const e=new S.DisposableStore;{let i=!1,n=()=>{i=!0};e.add((0,S.toDisposable)(()=>n())),this.doWatch(r,o).then(s=>{i?(0,S.dispose)(s):n=()=>(0,S.dispose)(s)},s=>this.logService.error(s))}return o.recursive||(this.watchedResources.set(r,(this.watchedResources.get(r)??0)+1),e.add((0,S.toDisposable)(()=>{const i=this.watchedResources.get(r);typeof i=="number"&&(i<=1?this.watchedResources.delete(r):this.watchedResources.set(r,i-1))}))),e}async doWatch(r,o){const e=await this.withProvider(r),i=this.toWatchKey(e,r,o),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(r,o)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,S.toDisposable)(()=>{n.count--,n.count===0&&((0,S.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(r,o,e){const{providerExtUri:i}=this.getExtUri(r);return[i.getComparisonKey(o),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(r=>(0,S.dispose)(r.disposable)),this.activeWatchers.clear()}async doWriteBuffered(r,o,e,i){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(async()=>{const n=await r.open(o,{create:!0,unlock:e?.unlock??!1});try{(0,E.isReadableStream)(i)||(0,E.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(r,n,i):await this.doWriteReadableBufferedQueued(r,n,i)}catch(s){throw(0,R.ensureFileSystemProviderError)(s)}finally{await r.close(n)}})}async doWriteStreamBufferedQueued(r,o,e){let i=0,n;if((0,E.isReadableBufferedStream)(e)){if(e.buffer.length>0){const s=v.VSBuffer.concat(e.buffer);await this.doWriteBuffer(r,o,s,s.byteLength,i,0),i+=s.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(s,c)=>{(0,E.listenStream)(n,{onData:async p=>{n.pause();try{await this.doWriteBuffer(r,o,p,p.byteLength,i,0)}catch(w){return c(w)}i+=p.byteLength,setTimeout(()=>n.resume())},onError:p=>c(p),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(r,o,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(r,o,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(r,o,e,i,n,s){let c=0;for(;c<i;)c+=await r.write(o,n+c,e.buffer,s+c,i-c)}async doWriteUnbuffered(r,o,e,i){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(r,o,e,i))}async doWriteUnbufferedQueued(r,o,e,i){let n;i instanceof v.VSBuffer?n=i:(0,E.isReadableStream)(i)?n=await(0,v.streamToBuffer)(i):(0,E.isReadableBufferedStream)(i)?n=await(0,v.bufferedStreamToBuffer)(i):n=(0,v.readableToBuffer)(i),await r.writeFile(o,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(r,o,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(r,o,e,i))}async doPipeBufferedQueued(r,o,e,i){let n,s;try{n=await r.open(o,{create:!1}),s=await e.open(i,{create:!0,unlock:!1});const c=v.VSBuffer.alloc(this.BUFFER_SIZE);let p=0,w=0,x=0;do x=await r.read(n,p,c.buffer,w,c.byteLength-w),await this.doWriteBuffer(e,s,c,x,p,w),p+=x,w+=x,w===c.byteLength&&(w=0);while(x>0)}catch(c){throw(0,R.ensureFileSystemProviderError)(c)}finally{await A.Promises.settled([typeof n=="number"?r.close(n):Promise.resolve(),typeof s=="number"?e.close(s):Promise.resolve()])}}async doPipeUnbuffered(r,o,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(r,o,e,i))}async doPipeUnbufferedQueued(r,o,e,i){return e.writeFile(i,await r.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(r,o,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(r,o,e,i))}async doPipeUnbufferedToBufferedQueued(r,o,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const s=await r.readFile(o);await this.doWriteBuffer(e,n,v.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,R.ensureFileSystemProviderError)(s)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(r,o,e,i){const n=await(0,v.streamToBuffer)(this.readFileBuffered(r,o,a.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(r,o){if(r.capabilities&2048)throw new R.FileOperationError((0,h.localize)(22,null,this.resourceForError(o)),6);return r}throwIfFileIsReadonly(r,o){if((o.permissions??0)&R.FilePermission.Readonly)throw new R.FileOperationError((0,h.localize)(23,null,this.resourceForError(r)),6)}resourceForError(r){return r.scheme===u.Schemas.file?r.fsPath:r.toString(!0)}};b.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},b=fe([he(0,y.ILogService)],b),t.FileService=b}),define(ee[107],te([0,1,2,17,12,14,11,3,20,35,4,15,82,51,91,93,90,99,34,54,22,16]),function(q,t,h,O,S,R,T,D,l,f,y,v,E,A,a,u,I,C,b,d,r,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends h.Disposable{constructor(n,s){super();this.logService=n,this.options=s,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=S.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new S.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new S.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new y.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:c}=await T.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,c),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(n){try{const s=await T.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),c=[];return await Promise.all(s.map(async p=>{try{let w;p.isSymbolicLink()?w=(await this.stat((0,l.joinPath)(n,p.name))).type:w=this.toType(p),c.push([p.name,w])}catch(w){this.logService.trace(w)}})),c}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let c;return s?.dangling?c=O.FileType.Unknown:n.isFile()?c=O.FileType.File:n.isDirectory()?c=O.FileType.Directory:c=O.FileType.Unknown,s&&(c|=O.FileType.SymbolicLink),c}async readFile(n){try{const s=this.toFilePath(n);return await T.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(n,s,c){const p=(0,b.newWriteableStream)(w=>o.VSBuffer.concat(w.map(x=>o.VSBuffer.wrap(x))).buffer);return(0,d.readFileIntoStream)(this,n,p,w=>w.buffer,{...s,bufferSize:this.BUFFER_SIZE},c),p}async writeFile(n,s,c){let p;try{const w=this.toFilePath(n);if(!c.create||!c.overwrite){if(await T.Promises.exists(w)){if(!c.overwrite)throw(0,O.createFileSystemProviderError)((0,E.localize)(0,null),O.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,O.createFileSystemProviderError)((0,E.localize)(1,null),O.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(n,{create:!0,unlock:c.unlock}),await this.write(p,0,s,0,s.byteLength)}catch(w){throw await this.toFileSystemProviderWriteError(n,w)}finally{typeof p=="number"&&await this.close(p)}}async open(n,s){try{const c=this.toFilePath(n);if((0,O.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:x}=await T.SymlinkSupport.stat(c);x.mode&128||await T.Promises.chmod(c,x.mode|128)}catch(x){this.logService.trace(x)}let p;if((0,O.isFileOpenForWriteOptions)(s)){if(R.isWindows)try{await T.Promises.truncate(c,0),p="r+"}catch(x){x.code!=="ENOENT"&&this.logService.trace(x)}p||(p="w")}else p="r";const w=await T.Promises.open(c,p);return this.mapHandleToPos.set(w,0),(0,O.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(w,n),w}catch(c){throw(0,O.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(n,c):this.toFileSystemProviderError(c)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await T.Promises.fdatasync(n)}catch(s){this.canFlush=!1,this.logService.error(s)}return await T.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}}async read(n,s,c,p,w){const x=this.normalizePos(n,s);let F=null;try{const U=await T.Promises.read(n,c,p,w,x);return typeof U=="number"?F=U:F=U.bytesRead,F}catch(U){throw this.toFileSystemProviderError(U)}finally{this.updatePos(n,x,F)}}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,c){const p=this.mapHandleToPos.get(n);typeof p=="number"&&(typeof s=="number"||(typeof c=="number"?this.mapHandleToPos.set(n,p+c):this.mapHandleToPos.delete(n)))}async write(n,s,c,p,w){return(0,y.retry)(()=>this.doWrite(n,s,c,p,w),100,3)}async doWrite(n,s,c,p,w){const x=this.normalizePos(n,s);let F=null;try{const U=await T.Promises.write(n,c,p,w,x);return typeof U=="number"?F=U:F=U.bytesWritten,F}catch(U){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),U)}finally{this.updatePos(n,x,F)}}async mkdir(n){try{await T.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const c=this.toFilePath(n);await this.doDelete(c,s)}catch(c){throw this.toFileSystemProviderError(c)}}async doDelete(n,s){s.recursive?await T.Promises.rm(n,T.RimRafMode.MOVE):await T.Promises.unlink(n)}async rename(n,s,c){const p=this.toFilePath(n),w=this.toFilePath(s);if(p!==w)try{await this.validateTargetDeleted(n,s,"move",c.overwrite),await T.Promises.move(p,w)}catch(x){throw(x.code==="EINVAL"||x.code==="EBUSY"||x.code==="ENAMETOOLONG")&&(x=new Error((0,E.localize)(2,null,(0,D.basename)(p),(0,D.basename)((0,D.dirname)(w)),x.toString()))),this.toFileSystemProviderError(x)}}async copy(n,s,c){const p=this.toFilePath(n),w=this.toFilePath(s);if(p!==w)try{await this.validateTargetDeleted(n,s,"copy",c.overwrite),await T.Promises.copy(p,w,{preserveSymlinks:!0})}catch(x){throw(x.code==="EINVAL"||x.code==="EBUSY"||x.code==="ENAMETOOLONG")&&(x=new Error((0,E.localize)(3,null,(0,D.basename)(p),(0,D.basename)((0,D.dirname)(w)),x.toString()))),this.toFileSystemProviderError(x)}}async validateTargetDeleted(n,s,c,p){const w=this.toFilePath(n),x=this.toFilePath(s);let F=!1;if(!!(this.capabilities&1024)||(F=(0,f.isEqual)(w,x,!0)),F&&c==="copy")throw(0,O.createFileSystemProviderError)((0,E.localize)(4,null),O.FileSystemProviderErrorCode.FileExists);if(!F&&await T.Promises.exists(x)){if(!p)throw(0,O.createFileSystemProviderError)((0,E.localize)(5,null),O.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(n,s){return s.recursive?this.watchRecursive(n,s.excludes):this.watchNonRecursive(n)}watchRecursive(n,s){const c={path:this.toFilePath(n),excludes:s},p=(0,r.insert)(this.recursiveFoldersToWatch,c);return this.refreshRecursiveWatchers(),(0,h.toDisposable)(()=>{p(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof I.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,h.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,s;this.options?.watcher?.usePolling?(n=a.FileWatcher,s=this.options?.watcher):this.recursiveFoldersToWatch.length===1?R.isWindows?n=u.FileWatcher:n=a.FileWatcher:n=I.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,c=>this._onDidChangeFile.fire((0,A.toFileChanges)(c)),c=>{c.type==="error"&&this._onDidWatchErrorOccur.fire(c.message),this.logService[c.type](c.message)},this.logService.getLevel()===v.LogLevel.Trace,s),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))}}watchNonRecursive(n){const s=new C.FileWatcher(this.toFilePath(n),p=>this._onDidChangeFile.fire((0,A.toFileChanges)(p)),p=>{p.type==="error"&&this._onDidWatchErrorOccur.fire(p.message),this.logService[p.type](p.message)},this.logService.getLevel()===v.LogLevel.Trace),c=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)});return(0,h.combinedDisposable)(s,c)}toFilePath(n){return(0,D.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof O.FileSystemProviderError)return n;let s;switch(n.code){case"ENOENT":s=O.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=O.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=O.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=O.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=O.FileSystemProviderErrorCode.NoPermissions;break;default:s=O.FileSystemProviderErrorCode.Unknown}return(0,O.createFileSystemProviderError)(n,s)}async toFileSystemProviderWriteError(n,s){let c=this.toFileSystemProviderError(s);if(n&&c.code===O.FileSystemProviderErrorCode.NoPermissions)try{const{stat:p}=await T.SymlinkSupport.stat(this.toFilePath(n));p.mode&128||(c=(0,O.createFileSystemProviderError)(s,O.FileSystemProviderErrorCode.FileWriteLocked))}catch(p){this.logService.trace(p)}return c}dispose(){super.dispose(),(0,h.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,h.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(ee[41],te([0,1,13]),function(q,t,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,h.createDecorator)("productService")}),define(ee[25],te([0,1,8,57]),function(q,t,h,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class S{constructor(){this.data=new Map}add(T,D){O.ok(h.isString(T)),O.ok(h.isObject(D)),O.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,D)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}t.Registry=new S}),define(ee[108],te([0,1,25,12]),function(q,t,h,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function S(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class R{constructor(){this._onDidChangeSchema=new O.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,f){this.schemasById[S(l)]=f,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new R;h.Registry.add(t.Extensions.JSONContribution,T)}),define(ee[30],te([0,1,73,12,25,8,108]),function(q,t,h,O,S,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var D;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(D=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var l;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(l=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const f=S.Registry.as(T.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:h.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},f.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,d=!0){this.registerConfigurations([b],d)}registerConfigurations(b,d=!0){const r=[];b.forEach(o=>{r.push(...this.validateAndRegisterProperties(o,d,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),f.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}deregisterConfigurations(b){const d=[],r=o=>{if(o.properties)for(const e in o.properties)d.push(e),delete this.configurationProperties[e],this.removeFromSchema(e,o.properties[e]);o.allOf&&o.allOf.forEach(e=>r(e))};for(const o of b){r(o);const e=this.configurationContributors.indexOf(o);e!==-1&&this.configurationContributors.splice(e,1)}f.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}registerDefaultConfigurations(b){const d=[],r=[];for(const o of b)for(const e in o)if(d.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]={...this.defaultValues[e]||{},...o[e]};const i={type:"object",default:this.defaultValues[e],description:h.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};r.push(E(e)),this.configurationProperties[e]=i,this.defaultLanguageConfigurationOverridesNode.properties[e]=i}else{this.defaultValues[e]=o[e];const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterDefaultConfigurations(b){const d=[];for(const r of b)for(const o in r)if(d.push(o),delete this.defaultValues[o],t.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const e=this.configurationProperties[o];e&&(this.updatePropertyDefaultValue(o,e),this.updateSchema(o,e))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const d of b)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,d=!0,r,o=3){o=R.isUndefinedOrNull(b.scope)?o:b.scope;let e=[],i=b.properties;if(i)for(let s in i){if(d&&u(s)){delete i[s];continue}const c=i[s];if(this.updatePropertyDefaultValue(s,c),t.OVERRIDE_PROPERTY_PATTERN.test(s)?c.scope=void 0:(c.scope=R.isUndefinedOrNull(c.scope)?o:c.scope,c.restricted=R.isUndefinedOrNull(c.restricted)?!!r?.restrictedConfigurations?.includes(s):c.restricted),i[s].hasOwnProperty("included")&&!i[s].included){this.excludedConfigurationProperties[s]=i[s],delete i[s];continue}else this.configurationProperties[s]=i[s];!i[s].deprecationMessage&&i[s].markdownDeprecationMessage&&(i[s].deprecationMessage=i[s].markdownDeprecationMessage),e.push(s)}let n=b.allOf;if(n)for(let s of n)e.push(...this.validateAndRegisterProperties(s,d,r,o));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const d=r=>{let o=r.properties;if(o)for(const i in o)this.updateSchema(i,o[i]);let e=r.allOf;e&&e.forEach(d)};d(b)}updateSchema(b,d){switch(t.allSettings.properties[b]=d,d.scope){case 1:t.applicationSettings.properties[b]=d;break;case 2:t.machineSettings.properties[b]=d;break;case 6:t.machineOverridableSettings.properties[b]=d;break;case 3:t.windowSettings.properties[b]=d;break;case 4:t.resourceSettings.properties[b]=d;break;case 5:t.resourceSettings.properties[b]=d,this.resourceLanguageSettingsSchema.properties[b]=d;break}}removeFromSchema(b,d){switch(delete t.allSettings.properties[b],d.scope){case 1:delete t.applicationSettings.properties[b];break;case 2:delete t.machineSettings.properties[b];break;case 6:delete t.machineOverridableSettings.properties[b];break;case 3:delete t.windowSettings.properties[b];break;case 4:case 5:delete t.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const d=`[${b}]`,r={type:"object",description:h.localize(2,null),errorMessage:h.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,r),t.allSettings.properties[d]=r,t.applicationSettings.properties[d]=r,t.machineSettings.properties[d]=r,t.machineOverridableSettings.properties[d]=r,t.windowSettings.properties[d]=r,t.resourceSettings.properties[d]=r}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,d){let r=this.defaultValues[b];R.isUndefined(r)&&(r=d.default),R.isUndefined(r)&&(r=A(d.type)),d.default=r}}const v="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(v);function E(C){return C.substring(1,C.length-1)}t.overrideIdentifierFromKey=E;function A(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=A;const a=new y;S.Registry.add(t.Extensions.Configuration,a);function u(C){return C.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(C)?h.localize(5,null,C):a.getConfigurationProperties()[C]!==void 0?h.localize(6,null,C):null:h.localize(4,null)}t.validateProperty=u;function I(){const C=[],b=a.getConfigurationProperties();for(const d of Object.keys(b))C.push([d,b[d].scope]);return C.push(["launch",4]),C.push(["task",4]),C}t.getScopes=I}),define(ee[27],te([0,1,19,8,9,25,13,30]),function(q,t,h,O,S,R,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,T.createDecorator)("configurationService");function l(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof S.URI)}t.isConfigurationOverrides=l;var f;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(f=t.ConfigurationTarget||(t.ConfigurationTarget={}));function y(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=y;function v(i,n){const s=n?i?n.keys.filter(B=>i.keys.indexOf(B)===-1):[...n.keys]:[],c=i?n?i.keys.filter(B=>n.keys.indexOf(B)===-1):[...i.keys]:[],p=[];if(n&&i){for(const B of i.keys)if(n.keys.indexOf(B)!==-1){const _=C(i.contents,B),Q=C(n.contents,B);h.equals(_,Q)||p.push(B)}}const w=[],x=B=>{const _={};for(const Q of B)for(const ne of Q.identifiers)_[o(ne)]=Q;return _},F=n?x(n.overrides):{},U=i?x(i.overrides):{};if(Object.keys(F).length)for(const B of s){const _=F[B];_&&w.push([(0,D.overrideIdentifierFromKey)(B),_.keys])}if(Object.keys(U).length)for(const B of c){const _=U[B];_&&w.push([(0,D.overrideIdentifierFromKey)(B),_.keys])}if(Object.keys(F).length&&Object.keys(U).length)for(const B of p){const _=U[B],Q=F[B];if(_&&Q){const ne=v({contents:_.contents,keys:_.keys,overrides:[]},{contents:Q.contents,keys:Q.keys,overrides:[]});w.push([(0,D.overrideIdentifierFromKey)(B),[...ne.added,...ne.removed,...ne.updated]])}}return{added:s,removed:c,updated:p,overrides:w}}t.compare=v;function E(i,n){const s=[];for(const c of Object.keys(i))if(D.OVERRIDE_PROPERTY_PATTERN.test(c)){const p={};for(const w in i[c])p[w]=i[c][w];s.push({identifiers:[(0,D.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(p),contents:A(p,n)})}return s}t.toOverrides=E;function A(i,n){const s=Object.create(null);for(let c in i)a(s,c,i[c],n);return s}t.toValuesTree=A;function a(i,n,s,c){const p=n.split("."),w=p.pop();let x=i;for(let F=0;F<p.length;F++){let U=p[F],B=x[U];switch(typeof B){case"undefined":B=x[U]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${p.slice(0,F+1).join(".")} is ${JSON.stringify(B)}`);return}x=B}if(typeof x=="object"&&x!==null)try{x[w]=s}catch(F){c(`Ignoring ${n} as ${p.join(".")} is ${JSON.stringify(x)}`)}else c(`Ignoring ${n} as ${p.join(".")} is ${JSON.stringify(x)}`)}t.addToValueTree=a;function u(i,n){const s=n.split(".");I(i,s)}t.removeFromValueTree=u;function I(i,n){const s=n.shift();if(n.length===0){delete i[s];return}if(Object.keys(i).indexOf(s)!==-1){const c=i[s];typeof c=="object"&&!Array.isArray(c)&&(I(c,n),Object.keys(c).length===0&&delete i[s])}}function C(i,n,s){function c(x,F){let U=x;for(const B of F){if(typeof U!="object"||U===null)return;U=U[B]}return U}const p=n.split("."),w=c(i,p);return typeof w=="undefined"?s:w}t.getConfigurationValue=C;function b(i,n,s){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in i?O.isObject(i[c])&&O.isObject(n[c])?b(i[c],n[c],s):s&&(i[c]=n[c]):i[c]=n[c])})}t.merge=b;function d(){const i=R.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=d;function r(){const i=Object.create(null),n=R.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let s in n){let c=n[s].default;a(i,s,c,p=>console.error(`Conflict in default settings: ${p}`))}return i}t.getDefaultValues=r;function o(i){return`[${i}]`}t.keyFromOverrideIdentifier=o;function e(i,n,s){const c=i.inspect(n),p=i.inspect(s);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:c.defaultValue}t.getMigratedSettingValue=e}),define(ee[109],te([0,1,58,45,22,8,19,9,30,27,25,2,12]),function(q,t,h,O,S,R,T,D,l,f,y,v,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class A{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,f.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,f.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const s of S.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[s],p=i[s];p&&(typeof c=="object"&&typeof p=="object"?(c=T.deepClone(c),this.mergeContents(c,p)):c=p),n[s]=c}return new A(n,this.keys,this.overrides)}merge(...e){const i=T.deepClone(this.contents),n=T.deepClone(this.overrides),s=[...this.keys];for(const c of e){this.mergeContents(i,c.contents);for(const p of c.overrides){const[w]=n.filter(x=>S.equals(x.identifiers,p.identifiers));w?this.mergeContents(w.contents,p.contents):n.push(T.deepClone(p))}for(const p of c.keys)s.indexOf(p)===-1&&s.push(p)}return new A(i,s,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&R.isObject(e[n])&&R.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=T.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?T.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,f.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,f.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=A;class a extends A{constructor(){const e=(0,f.getDefaultValues)(),i=(0,f.getConfigurationKeys)(),n=[];for(const s of Object.keys(e))l.OVERRIDE_PROPERTY_PATTERN.test(s)&&n.push({identifiers:[(0,l.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(e[s]),contents:(0,f.toValuesTree)(e[s],c=>console.error(`Conflict in default settings file: ${c}`))});super(e,i,n)}}t.DefaultConfigurationModel=a;class u{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new A}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!R.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:s,overrides:c,restricted:p}=this.doParseRaw(e,i);this._configurationModel=new A(n,s,c),this._restrictedConfigurations=p||[]}doParseContent(e){let i={},n=null,s=[],c=[],p=[];function w(F){Array.isArray(s)?s.push(F):n&&(s[n]=F)}let x={onObjectBegin:()=>{let F={};w(F),c.push(s),s=F,n=null},onObjectProperty:F=>{n=F},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{let F=[];w(F),c.push(s),s=F,n=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:w,onError:(F,U,B)=>{p.push({error:F,offset:U,length:B})}};if(e)try{h.visit(e,x),i=s[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return i}doParseRaw(e,i){const n=y.Registry.as(l.Extensions.Configuration).getConfigurationProperties(),s=this.filter(e,n,!0,i);e=s.raw;const c=(0,f.toValuesTree)(e,x=>console.error(`Conflict in settings file ${this._name}: ${x}`)),p=Object.keys(e),w=(0,f.toOverrides)(e,x=>console.error(`Conflict in settings file ${this._name}: ${x}`));return{contents:c,keys:p,overrides:w,restricted:s.restricted}}filter(e,i,n,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:e,restricted:[]};const c={},p=[];for(let w in e)if(l.OVERRIDE_PROPERTY_PATTERN.test(w)&&n){const x=this.filter(e[w],i,!1,s);c[w]=x.raw,p.push(...x.restricted)}else{const x=i[w],F=x?typeof x.scope!="undefined"?x.scope:3:void 0;x?.restricted&&p.push(w),(F===void 0||s.scopes===void 0||s.scopes.includes(F))&&(s.skipRestricted&&x?.restricted||(c[w]=e[w]))}return{raw:c,restricted:p}}}t.ConfigurationModelParser=u;class I extends v.Disposable{constructor(e,i,n,s){super();this.userSettingsResource=e,this.scopes=i,this.fileService=s,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(E.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new A}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=I;class C{constructor(e,i,n=new A,s=new A,c=new O.ResourceMap,p=new A,w=new O.ResourceMap,x=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=s,this._folderConfigurations=c,this._memoryConfiguration=p,this._memoryConfigurationByResource=w,this._freeze=x,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new O.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new A,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(e):s.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const s=this.getConsolidateConfigurationModel(i,n),c=this.getFolderConfigurationModelForResource(i.resource,n),p=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,w=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),x=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),F=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),U=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),B=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,_=c?i.overrideIdentifier?c.freeze().override(i.overrideIdentifier).getValue(e):c.freeze().getValue(e):void 0,Q=i.overrideIdentifier?p.override(i.overrideIdentifier).getValue(e):p.getValue(e),ne=s.getValue(e),se=S.distinct(S.flatten(s.overrides.map(Z=>Z.identifiers))).filter(Z=>s.getOverrideValue(e,Z)!==void 0);return{defaultValue:w,userValue:x,userLocalValue:F,userRemoteValue:U,workspaceValue:B,workspaceFolderValue:_,memoryValue:Q,value:ne,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:x!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:B!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:c?.freeze().getValue(e),override:i.overrideIdentifier?c?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:Q!==void 0?{value:p.getValue(e),override:i.overrideIdentifier?p.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(s=>l.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const c=(0,l.overrideIdentifierFromKey)(s),p=this._defaultConfiguration.getKeysForOverrideIdentifier(c),w=e.getKeysForOverrideIdentifier(c),x=[...w.filter(F=>p.indexOf(F)===-1),...p.filter(F=>w.indexOf(F)===-1),...p.filter(F=>!T.equals(this._defaultConfiguration.override(c).getValue(F),e.override(c).getValue(F)))];return[c,x]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:c}=(0,f.compare)(this.localUserConfiguration,e),p=[...i,...n,...s];return p.length&&this.updateLocalUserConfiguration(e),{keys:p,overrides:c}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:c}=(0,f.compare)(this.remoteUserConfiguration,e);let p=[...i,...n,...s];return p.length&&this.updateRemoteUserConfiguration(e),{keys:p,overrides:c}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:s,overrides:c}=(0,f.compare)(this.workspaceConfiguration,e);let p=[...i,...n,...s];return p.length&&this.updateWorkspaceConfiguration(e),{keys:p,overrides:c}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:s,updated:c,removed:p,overrides:w}=(0,f.compare)(n,i);let x=[...s,...c,...p];return(x.length||!n)&&this.updateFolderConfiguration(e,i),{keys:x,overrides:w}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:s,removed:c,overrides:p}=(0,f.compare)(i,void 0);return{keys:[...n,...s,...c],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const s=i.getFolder(e);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const c=this._memoryConfigurationByResource.get(e);c&&(n=n.merge(c))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(e);s?(i=n.merge(s),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:s,keys:c}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:s,keys:c}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),s=this.parseConfigurationModel(e.workspace),c=e.folders.reduce((p,w)=>(p.set(D.URI.revive(w[0]),this.parseConfigurationModel(w[1])),p),new O.ResourceMap);return new C(i,n,new A,s,c,new A,new O.ResourceMap,!1)}static parseConfigurationModel(e){return new A(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=C;function b(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const e=new Set,i=new Map;for(const s of o)s.keys.forEach(c=>e.add(c)),s.overrides.forEach(([c,p])=>{const w=(0,O.getOrSet)(i,c,new Set);p.forEach(x=>w.add(x))});const n=[];return i.forEach((s,c)=>n.push([c,[...s.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=b;class d{constructor(e,i,n,s){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=s,this._previousConfiguration=void 0;const c=new Set;e.keys.forEach(w=>c.add(w)),e.overrides.forEach(([,w])=>w.forEach(x=>c.add(x))),this.affectedKeys=[...c.values()];const p=new A;this.affectedKeys.forEach(w=>p.setValue(w,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!T.equals(n,s)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,f.toValuesTree)({[i]:!0},()=>{}),s;for(;typeof n=="object"&&(s=Object.keys(n)[0]);){if(e=e[s],!e)return!1;n=n[s]}return!0}}t.ConfigurationChangeEvent=d;class r extends d{constructor(e,i,n,s){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=s}}t.AllKeysConfigurationChangeEvent=r}),define(ee[110],te([0,1,25,30,2,27,109,12,4,20]),function(q,t,h,O,S,R,T,D,l,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class y extends S.Disposable{constructor(E,A){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,f.extUriBiasedIgnorePathCase,A)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new l.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(h.Registry.as(O.Extensions.Configuration).onDidUpdateConfiguration(a=>this.onDidDefaultConfigurationChange(a))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,A){const a=typeof E=="string"?E:void 0,u=(0,R.isConfigurationOverrides)(E)?E:(0,R.isConfigurationOverrides)(A)?A:{};return this.configuration.getValue(a,u,void 0)}updateValue(E,A,a,u){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const A=this.configuration.toData(),a=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(a,A,1)}onDidDefaultConfigurationChange(E){const A=this.configuration.toData(),a=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel,E);this.trigger(a,A,6)}trigger(E,A,a){const u=new T.ConfigurationChangeEvent(E,{data:A},this.configuration);u.source=a,u.sourceConfig=this.getTargetConfiguration(a),this._onDidChangeConfiguration.fire(u)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=y}),define(ee[55],te([0,1,83,13,30,25,16]),function(q,t,h,O,S,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,O.createDecorator)("requestService");function D(a){return a.res.statusCode&&a.res.statusCode>=200&&a.res.statusCode<300||a.res.statusCode===1223}t.isSuccess=D;function l(a){return a.res.statusCode===204}async function f(a){if(!D(a))throw new Error("Server returned "+a.res.statusCode);return l(a)?null:(await(0,T.streamToBuffer)(a.stream)).toString()}t.asText=f;async function y(a){if(!D(a))throw new Error("Server returned "+a.res.statusCode);if(l(a))return null;const I=(await(0,T.streamToBuffer)(a.stream)).toString();try{return JSON.parse(I)}catch(C){throw C.message+=`:
`+I,C}}t.asJson=y;function v(a){A(a)}t.updateProxyConfigurationsScope=v;let E;function A(a){const u=R.Registry.as(S.Extensions.Configuration);E&&u.deregisterConfigurations([E]),E={id:"http",order:15,title:(0,h.localize)(0,null),type:"object",scope:a,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,h.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,h.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,h.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,h.localize)(4,null),(0,h.localize)(5,null),(0,h.localize)(6,null),(0,h.localize)(7,null)],default:"override",description:(0,h.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,h.localize)(9,null),restricted:!0}}},u.registerConfiguration(E)}A(2)}),define(ee[111],te([0,1,112,8]),function(q,t,h,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function S(T,D){return T.protocol==="http:"?D.HTTP_PROXY||D.http_proxy||null:T.protocol==="https:"&&(D.HTTPS_PROXY||D.https_proxy||D.HTTP_PROXY||D.http_proxy)||null}async function R(T,D,l={}){const f=(0,h.parse)(T),y=l.proxyUrl||S(f,D);if(!y)return null;const v=(0,h.parse)(y);if(!/^https?:$/.test(v.protocol||""))return null;const E={host:v.hostname||"",port:v.port||(v.protocol==="https"?"443":"80"),auth:v.auth,rejectUnauthorized:(0,O.isBoolean)(l.strictSSL)?l.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((A,a)=>{q(["http-proxy-agent"],A,a)}))(E):new(await new Promise((A,a)=>{q(["https-proxy-agent"],A,a)}))(E)}t.getProxyAgent=R}),define(ee[113],te([0,1,29,16]),function(q,t,h,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function S(R,T,D){let l=D&&D.get("storage.serviceMachineId",0)||null;if(l)return l;try{const y=(await T.readFile(R.serviceMachineIdResource)).value.toString();l=(0,h.isUUID)(y)?y:null}catch(f){l=null}if(!l){l=(0,h.generateUuid)();try{await T.writeFile(R.serviceMachineIdResource,O.VSBuffer.fromString(l))}catch(f){}}return D&&D.store("storage.serviceMachineId",l,0,1),l}t.getServiceMachineId=S}),define(ee[114],te([0,1,13,12,2,8,66,4]),function(q,t,h,O,S,R,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const l="__$__targetStorageMarker";t.IStorageService=(0,h.createDecorator)("storageService");var f;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(f=t.WillSaveStateReason||(t.WillSaveStateReason={}));var y;(function(u){u[u.GLOBAL=0]="GLOBAL",u[u.WORKSPACE=1]="WORKSPACE"})(y=t.StorageScope||(t.StorageScope={}));var v;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(v=t.StorageTarget||(t.StorageTarget={}));class E extends S.Disposable{constructor(I={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=I,this._onDidChangeValue=this._register(new O.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new S.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,S.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(I,C){C===l?(I===0?this._globalKeyTargets=void 0:I===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:I})):this._onDidChangeValue.fire({scope:I,key:C,target:this.getKeyTargets(I)[C]})}emitWillSaveState(I){this._onWillSaveState.fire({reason:I})}get(I,C,b){return this.getStorage(C)?.get(I,b)}getBoolean(I,C,b){return this.getStorage(C)?.getBoolean(I,b)}getNumber(I,C,b){return this.getStorage(C)?.getNumber(I,b)}store(I,C,b,d){if((0,R.isUndefinedOrNull)(C)){this.remove(I,b);return}this.withPausedEmitters(()=>{this.updateKeyTarget(I,b,d),this.getStorage(b)?.set(I,C)})}remove(I,C){this.withPausedEmitters(()=>{this.updateKeyTarget(I,C,void 0),this.getStorage(C)?.delete(I)})}withPausedEmitters(I){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{I()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(I,C){const b=[],d=this.getKeyTargets(I);for(const r of Object.keys(d))d[r]===C&&b.push(r);return b}updateKeyTarget(I,C,b){const d=this.getKeyTargets(C);typeof b=="number"?d[I]!==b&&(d[I]=b,this.getStorage(C)?.set(l,JSON.stringify(d))):typeof d[I]=="number"&&(delete d[I],this.getStorage(C)?.set(l,JSON.stringify(d)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(I){return I===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(I){const C=this.get(l,I);if(C)try{return JSON.parse(C)}catch(b){}return Object.create(null)}isNew(I){return this.getBoolean(t.IS_NEW_KEY,I)===!0}async flush(){this._onWillSaveState.fire({reason:f.NONE}),await D.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const I=this.getStorage(0)?.items??new Map,C=this.getStorage(1)?.items??new Map;return a(I,C,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class A extends E{constructor(){super();this.globalStorage=this._register(new T.Storage(new T.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new T.Storage(new T.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(I=>this.emitDidChangeValue(1,I))),this._register(this.globalStorage.onDidChangeStorage(I=>this.emitDidChangeValue(0,I)))}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(I){}}t.InMemoryStorageService=A;async function a(u,I,C,b){const d=c=>{try{return JSON.parse(c)}catch(p){return c}},r=new Map,o=new Map;u.forEach((c,p)=>{r.set(p,c),o.set(p,d(c))});const e=new Map,i=new Map;I.forEach((c,p)=>{e.set(p,c),i.set(p,d(c))}),console.group(`Storage: Global (path: ${C})`);let n=[];r.forEach((c,p)=>{n.push({key:p,value:c})}),console.table(n),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${b})`);let s=[];e.forEach((c,p)=>{s.push({key:p,value:c})}),console.table(s),console.groupEnd(),console.log(i)}t.logStorage=a}),define(ee[115],te([0,1,14,33,29,9]),function(q,t,h,O,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function T(f){if(h.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}async function D(f,y,v,E,A,a,u,I,C,b){const d=Object.create(null);d["common.machineId"]=u,d.sessionID=(0,S.generateUuid)()+Date.now(),d.commitHash=A,d.version=a,d["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,h.PlatformToString)(h.platform),d["common.nodePlatform"]=O.platform,d["common.nodeArch"]=E,d["common.product"]=b||"desktop";const r=l(I||[]);r&&(d["common.msftInternal"]=r);let o=0;const e=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),h.isLinuxSnap&&(d["common.snap"]="true");const i=T(v);i&&(d["common.platformDetail"]=i);try{const n=await f.readFile(R.URI.file(C));d["common.source"]=n.value.toString().slice(0,30)}catch(n){}return d}t.resolveCommonProperties=D;function l(f){const y=O.env.USERDNSDOMAIN;if(!y)return!1;const v=y.toLowerCase();return f.some(E=>v===E)}t.verifyMicrosoftInternalDomain=l}),define(ee[42],te([0,1,13]),function(q,t,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,h.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,h.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(ee[116],te([0,1,7,23,24,19,42,55,49,21,26,15,17,9,41,114,113,13]),function(q,t,h,O,S,R,T,D,l,f,y,v,E,A,a,u,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var b;(function(H){H[H.None=0]="None",H[H.IncludeVersions=1]="IncludeVersions",H[H.IncludeFiles=2]="IncludeFiles",H[H.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",H[H.IncludeSharedAccounts=8]="IncludeSharedAccounts",H[H.IncludeVersionProperties=16]="IncludeVersionProperties",H[H.ExcludeNonValidated=32]="ExcludeNonValidated",H[H.IncludeInstallationTargets=64]="IncludeInstallationTargets",H[H.IncludeAssetUri=128]="IncludeAssetUri",H[H.IncludeStatistics=256]="IncludeStatistics",H[H.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",H[H.Unpublished=4096]="Unpublished"})(b||(b={}));function d(...H){return String(H.reduce((W,J)=>W|J,0))}var r;(function(H){H[H.Tag=1]="Tag",H[H.ExtensionId=4]="ExtensionId",H[H.Category=5]="Category",H[H.ExtensionName=7]="ExtensionName",H[H.Target=8]="Target",H[H.Featured=9]="Featured",H[H.SearchText=10]="SearchText",H[H.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},e={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},n={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:b.None,criteria:[],assetTypes:[]};class s{constructor(W=n){this.state=W}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(W,J=this.state.pageSize){return new s({...this.state,pageNumber:W,pageSize:J})}withFilter(W,...J){const P=[...this.state.criteria,...J.length?J.map(g=>({filterType:W,value:g})):[{filterType:W}]];return new s({...this.state,criteria:P})}withSortBy(W){return new s({...this.state,sortBy:W})}withSortOrder(W){return new s({...this.state,sortOrder:W})}withFlags(...W){return new s({...this.state,flags:W.reduce((J,P)=>J|P,0)})}withAssetTypes(...W){return new s({...this.state,assetTypes:W})}get raw(){const{criteria:W,pageNumber:J,pageSize:P,sortBy:g,sortOrder:L,flags:k,assetTypes:M}=this.state;return{filters:[{criteria:W,pageNumber:J,pageSize:P,sortBy:g,sortOrder:L}],assetTypes:M,flags:k}}get searchText(){const W=this.state.criteria.filter(J=>J.filterType===r.SearchText)[0];return W&&W.value?W.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(W=>String(W.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function c(H,W){const J=(H||[]).filter(P=>P.statisticName===W)[0];return J?J.value:0}function p(H){const W="Microsoft.VisualStudio.Code.Translation.";return H.files.filter(P=>P.assetType.indexOf(W)===0).reduce((P,g)=>{const L=U(H,g.assetType);return L&&P.push([g.assetType.substring(W.length),L]),P},[])}function w(H){if(H.properties){const W=H.properties.filter(g=>g.key===o.Repository),J=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),P=W.filter(g=>J.test(g.value))[0];return P?{uri:P.value,fallbackUri:P.value}:null}return U(H,o.Repository)}function x(H){return{uri:`${H.fallbackAssetUri}/${o.VSIX}?redirect=true`,fallbackUri:`${H.fallbackAssetUri}/${o.VSIX}`}}function F(H){const W=U(H,o.Icon);if(W)return W;const J=O.DefaultIconPath;return{uri:J,fallbackUri:J}}function U(H,W){return H.files.filter(P=>P.assetType===W)[0]?{uri:`${H.assetUri}/${W}`,fallbackUri:`${H.fallbackAssetUri}/${W}`}:null}function B(H,W){const J=H.properties?H.properties.filter(g=>g.key===W):[],P=J.length>0&&J[0].value;return P?P.split(",").map(g=>(0,S.adoptToGalleryExtensionId)(g)):[]}function _(H){const W=H.properties?H.properties.filter(J=>J.key===e.Engine):[];return W.length>0&&W[0].value||""}function Q(H){const W=H.properties?H.properties.filter(P=>P.key===e.LocalizedLanguages):[],J=W.length>0&&W[0].value||"";return J?J.split(","):[]}function ne(H){return H.indexOf("preview")!==-1}function se(H,W,J,P,g){const L={manifest:U(W,o.Manifest),readme:U(W,o.Details),changelog:U(W,o.Changelog),license:U(W,o.License),repository:w(W),download:x(W),icon:F(W),coreTranslations:p(W)};return{identifier:{id:(0,S.getGalleryExtensionId)(H.publisher.publisherName,H.extensionName),uuid:H.extensionId},name:H.extensionName,version:W.version,date:W.lastUpdated,displayName:H.displayName,publisherId:H.publisher.publisherId,publisher:H.publisher.publisherName,publisherDisplayName:H.publisher.displayName,description:H.shortDescription||"",installCount:c(H.statistics,"install"),rating:c(H.statistics,"averagerating"),ratingCount:c(H.statistics,"ratingcount"),assetUri:A.URI.parse(W.assetUri),webExtension:!!H.tags?.includes(O.WEB_EXTENSION_TAG),assetTypes:W.files.map(({assetType:k})=>k),assets:L,properties:{dependencies:B(W,e.Dependency),extensionPack:B(W,e.ExtensionPack),engine:_(W),localizedLanguages:Q(W)},telemetryData:{index:(P.pageNumber-1)*P.pageSize+J,querySource:g},preview:ne(H.flags)}}let Z=class{constructor(W,J,P,g,L,k,M){this.requestService=W,this.logService=J,this.environmentService=P,this.telemetryService=g,this.fileService=L,this.productService=k;const m=k.extensionsGallery;this.extensionsGalleryUrl=m&&m.serviceUrl,this.extensionsControlUrl=m&&m.controlUrl,this.commonHeadersPromise=ce(k.version,this.environmentService,this.fileService,M)}api(W=""){return`${this.extensionsGalleryUrl}${W}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(W,J){const P=[];let{total:g,firstPage:L,getPage:k}=await this.query({names:W,pageSize:W.length},J);P.push(...L);for(let M=1;P.length<g&&(L=await k(M,J),L.length);M++)P.push(...L);return P}async getCompatibleExtension(W,J){return this.getCompatibleExtensionByEngine(W,J)}async getCompatibleExtensionByEngine(W,J){const P=(0,O.isIExtensionIdentifier)(W)?null:W;if(P&&P.properties.engine&&(0,l.isEngineValid)(P.properties.engine,this.productService.version,this.productService.date))return P;const{id:g,uuid:L}=P?P.identifier:W;let k=new s().withFlags(b.IncludeAssetUri,b.IncludeStatistics,b.IncludeCategoryAndTags,b.IncludeFiles,b.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");L?k=k.withFilter(r.ExtensionId,L):k=k.withFilter(r.ExtensionName,g);const{galleryExtensions:M}=await this.queryGallery(k,y.CancellationToken.None),[m]=M;if(!m||!m.versions.length)return null;if(J){const z=m.versions.filter(V=>V.version===J)[0];if(z){const V=se(m,z,0,k);if(V.properties.engine&&(0,l.isEngineValid)(V.properties.engine,this.productService.version,this.productService.date))return V}return null}const N=await this.getLastValidExtensionVersion(m,m.versions);return N?se(m,N,0,k):null}async query(W,J){const P=y.CancellationToken.isCancellationToken(W)?{}:W,g=y.CancellationToken.isCancellationToken(W)?W:J;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let L=P.text||"";const k=(0,R.getOrDefault)(P,$=>$.pageSize,50);let M=new s().withFlags(b.IncludeLatestVersionOnly,b.IncludeAssetUri,b.IncludeStatistics,b.IncludeCategoryAndTags,b.IncludeFiles,b.IncludeVersionProperties).withPage(1,k).withFilter(r.Target,"Microsoft.VisualStudio.Code");L?(L=L.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($,K,Y)=>(M=M.withFilter(r.Category,Y||K),"")),L=L.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($,K,Y)=>(M=M.withFilter(r.Tag,Y||K),"")),L=L.replace(/\bfeatured(\s+|\b|$)/g,()=>(M=M.withFilter(r.Featured),"")),L=L.trim(),L&&(L=L.length<200?L:L.substring(0,200),M=M.withFilter(r.SearchText,L)),M=M.withSortBy(0)):P.ids?M=M.withFilter(r.ExtensionId,...P.ids):P.names?M=M.withFilter(r.ExtensionName,...P.names):M=M.withSortBy(4),typeof P.sortBy=="number"&&(M=M.withSortBy(P.sortBy)),typeof P.sortOrder=="number"&&(M=M.withSortOrder(P.sortOrder));const{galleryExtensions:m,total:N}=await this.queryGallery(M,g),z=m.map(($,K)=>se($,$.versions[0],K,M,P.source)),V=async($,K)=>{if(K.isCancellationRequested)throw(0,h.canceled)();const Y=M.withPage($+1),{galleryExtensions:ie}=await this.queryGallery(Y,K);return ie.map((re,ae)=>se(re,re.versions[0],ae,Y,P.source))};return{firstPage:z,total:N,pageSize:M.pageSize,getPage:V}}async queryGallery(W,J){if(!this.isEnabled())throw new Error("No extension gallery service configured.");W=W.withFlags(W.flags,b.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,d(b.Unpublished));const P=await this.commonHeadersPromise,g=JSON.stringify(W.raw),L={...P,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(g.length)},k=new Date().getTime();let M,m,N=0;try{if(M=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:g,headers:L},J),M.res.statusCode&&M.res.statusCode>=400&&M.res.statusCode<500)return{galleryExtensions:[],total:N};const z=await(0,D.asJson)(M);if(z){const V=z.results[0],$=V.extensions,K=V.resultMetadata&&V.resultMetadata.filter(Y=>Y.metadataType==="ResultCount")[0];return N=K&&K.metadataItems.filter(Y=>Y.name==="TotalCount")[0].count||0,{galleryExtensions:$,total:N}}return{galleryExtensions:[],total:N}}catch(z){throw m=z,z}finally{this.telemetryService.publicLog2("galleryService:query",{...W.telemetryData,requestBodySize:String(g.length),duration:new Date().getTime()-k,success:!!M&&(0,D.isSuccess)(M),responseBodySize:M?.res.headers["Content-Length"],statusCode:M?String(M.res.statusCode):void 0,errorCode:m?(0,h.isPromiseCanceledError)(m)?"canceled":(0,h.getErrorMessage)(m).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(N)})}}async reportStatistic(W,J,P,g){if(!this.isEnabled())return;const k={...await this.commonHeadersPromise,Accept:"*/*;api-version=4.0-preview.1"};try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${W}/extensions/${J}/${P}/stats?statType=${g}`),headers:k},y.CancellationToken.None)}catch(M){}}async download(W,J,P){this.logService.trace("ExtensionGalleryService#download",W.identifier.id);const g=(0,S.getGalleryExtensionTelemetryData)(W),L=new Date().getTime(),k=z=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...g,duration:z}),M=P===1?"install":P===2?"update":"",m=M?{uri:`${W.assets.download.uri}&${M}=true`,fallbackUri:`${W.assets.download.fallbackUri}?${M}=true`}:W.assets.download,N=await this.getAsset(m);await this.fileService.writeFile(J,N.stream),k(new Date().getTime()-L)}async getReadme(W,J){if(W.assets.readme){const P=await this.getAsset(W.assets.readme,{},J);return await(0,D.asText)(P)||""}return""}async getManifest(W,J){if(W.assets.manifest){const P=await this.getAsset(W.assets.manifest,{},J),g=await(0,D.asText)(P);return g?JSON.parse(g):null}return null}async getCoreTranslation(W,J){const P=W.assets.coreTranslations.filter(g=>g[0]===J.toUpperCase())[0];if(P){const g=await this.getAsset(P[1]),L=await(0,D.asText)(g);return L?JSON.parse(L):null}return null}async getChangelog(W,J){if(W.assets.changelog){const P=await this.getAsset(W.assets.changelog,{},J);return await(0,D.asText)(P)||""}return""}async getAllVersions(W,J){let P=new s().withFlags(b.IncludeVersions,b.IncludeCategoryAndTags,b.IncludeFiles,b.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");W.identifier.uuid?P=P.withFilter(r.ExtensionId,W.identifier.uuid):P=P.withFilter(r.ExtensionName,W.identifier.id);const g=[],{galleryExtensions:L}=await this.queryGallery(P,y.CancellationToken.None);return L.length&&(J?await Promise.all(L[0].versions.map(async k=>{let M;try{M=await this.getEngine(k)}catch(m){}M&&(0,l.isEngineValid)(M,this.productService.version,this.productService.date)&&g.push({version:k.version,date:k.lastUpdated})})):g.push(...L[0].versions.map(k=>({version:k.version,date:k.lastUpdated})))),g}async getAsset(W,J={},P=y.CancellationToken.None){const g=await this.commonHeadersPromise,L={type:"GET"},k={...g,...J.headers||{}};J={...J,...L,headers:k};const M=W.uri,m=W.fallbackUri,N={...J,url:M};try{const z=await this.requestService.request(N,P);if(z.res.statusCode===200)return z;const V=await(0,D.asText)(z);throw new Error(`Expected 200, got back ${z.res.statusCode} instead.

${V}`)}catch(z){if((0,h.isPromiseCanceledError)(z))throw z;const V=(0,h.getErrorMessage)(z);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:M,message:V});const $={...J,url:m};return this.requestService.request($,P)}}async getLastValidExtensionVersion(W,J){const P=this.getLastValidExtensionVersionFromProperties(W,J);return P||this.getLastValidExtensionVersionRecursively(W,J)}getLastValidExtensionVersionFromProperties(W,J){for(const P of J){const g=_(P);if(!g)return null;if((0,l.isEngineValid)(g,this.productService.version,this.productService.date))return P}return null}async getEngine(W){const J=_(W);if(J)return J;const P=U(W,o.Manifest);if(!P)throw new Error("Manifest was not found");const g={"Accept-Encoding":"gzip"},L=await this.getAsset(P,{headers:g}),k=await(0,D.asJson)(L);if(k)return k.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(W,J){if(!J.length)return null;const P=J[0],g=await this.getEngine(P);return(0,l.isEngineValid)(g,this.productService.version,this.productService.date)?{...P,properties:[...P.properties||[],{key:e.Engine,value:g}]}:this.getLastValidExtensionVersionRecursively(W,J.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const W=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},y.CancellationToken.None);if(W.res.statusCode!==200)throw new Error("Could not get extensions report.");const J=await(0,D.asJson)(W),P=new Map;if(J)for(const g of J.malicious){const L=P.get(g)||{id:{id:g},malicious:!0,slow:!1};L.malicious=!0,P.set(g,L)}return[...P.values()]}};Z=fe([he(0,D.IRequestService),he(1,v.ILogService),he(2,f.IEnvironmentService),he(3,T.ITelemetryService),he(4,E.IFileService),he(5,a.IProductService),he(6,(0,C.optional)(u.IStorageService))],Z),t.ExtensionGalleryService=Z;async function ce(H,W,J,P){const g={"X-Market-Client-Id":`VSCode ${H}`,"User-Agent":`VSCode ${H}`},L=await(0,I.getServiceMachineId)(W,J,P);return g["X-Market-User-Id"]=L,g}t.resolveMarketplaceHeaders=ce}),define(ee[117],te([0,1,40,84,18,13,27,30,2,19,25]),function(q,t,h,O,S,R,T,D,l,f,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let v=class{constructor(a,u){this._configurationService=u,this._experimentProperties={},this._disposables=new l.DisposableStore,this._cleanupPatterns=[],this._appender=a.appender,this._commonProperties=a.commonProperties||Promise.resolve({}),this._piiPaths=a.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!a.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let I of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,S.escapeRegExpCharacters)(I),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(I=>{const C=/^[a-f0-9]+$/i.test(I["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!C})}))}setExperimentProperty(a,u){this._experimentProperties[a]=u}setEnabled(a){this._enabled=a}_updateUserOptIn(){const a=this._configurationService?.getValue(E);this._userOptIn=a?a.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const a=await this._commonProperties;let u=a.sessionID,I=a["common.instanceId"],C=a["common.machineId"],b=a["common.firstSessionDate"],d=a["common.msftInternal"];return{sessionId:u,instanceId:I,machineId:C,firstSessionDate:b,msftInternal:d}}dispose(){this._disposables.dispose()}publicLog(a,u,I){return this.isOptedIn?this._commonProperties.then(C=>{u=(0,f.mixin)(u,C),u=(0,f.mixin)(u,this._experimentProperties),u=(0,f.cloneAndChange)(u,b=>{if(typeof b=="string")return this._cleanupInfo(b,I)}),this._appender.log(a,u)},C=>{console.error(C)}):Promise.resolve(void 0)}publicLog2(a,u,I){return this.publicLog(a,u,I)}publicLogError(a,u){return this.sendErrorTelemetry?this.publicLog(a,u,!0):Promise.resolve(void 0)}publicLogError2(a,u){return this.publicLogError(a,u)}_cleanupInfo(a,u){let I=a;if(u){const C=[];for(let o of this._cleanupPatterns)for(;;){const e=o.exec(a);if(!e)break;C.push([e.index,o.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(I="";;){const o=d.exec(a);if(!o)break;!b.test(o[0])&&C.every(([e,i])=>o.index<e||o.index>=i)&&(I+=a.substring(r,o.index)+"<REDACTED: user-file-path>",r=d.lastIndex)}r<a.length&&(I+=a.substr(r))}for(let C of this._cleanupPatterns)I=I.replace(C,"");return I}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=fe([he(1,(0,R.optional)(T.IConfigurationService))],v),t.TelemetryService=v;const E="telemetry";y.Registry.as(D.Extensions.Configuration).registerConfiguration({id:E,order:110,type:"object",title:(0,O.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:h.default.privacyStatementUrl?(0,O.localize)(2,null,h.default.privacyStatementUrl):(0,O.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(ee[56],te([0,1,27,19,8,4]),function(q,t,h,O,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(a,u){return Promise.resolve(void 0)}publicLog2(a,u){return this.publicLog(a,u)}publicLogError(a,u){return Promise.resolve(void 0)}publicLogError2(a,u){return this.publicLogError(a,u)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class T{async publicLog(u,I,C){}async publicLogError(u,I,C){}}t.NullEndpointTelemetryService=T;function D(...a){return{log:(u,I)=>a.forEach(C=>C.log(u,I)),flush:()=>R.Promises.settled(a.map(u=>u.flush()))}}t.combinedAppender=D,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(a,u){return u.onDidChangeConfiguration(I=>{I.source!==6&&a.publicLog2("updateConfiguration",{configurationSource:(0,h.ConfigurationTargetToString)(I.source),configurationKeys:E(I.sourceConfig)})})}t.configurationTelemetry=l;function f(a){const u=Object.create(null),I=Object.create(null),C=Object.create(null);v(a,C);for(let b in C){b=b.length>150?b.substr(b.length-149):b;const d=C[b];typeof d=="number"?I[b]=d:typeof d=="boolean"?I[b]=d?1:0:typeof d=="string"?u[b]=d.substring(0,1023):typeof d!="undefined"&&d!==null&&(u[b]=d)}return{properties:u,measurements:I}}t.validateTelemetryData=f;function y(a){if(!a)return"none";let u="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(C=>{a.indexOf(`${C}+`)===0&&(u=C)}),u}t.cleanRemoteAuthority=y;function v(a,u,I=0,C){if(!!a)for(let b of Object.getOwnPropertyNames(a)){const d=a[b],r=C?C+b:b;Array.isArray(d)?u[r]=(0,O.safeStringify)(d):d instanceof Date?u[r]=d.toISOString():(0,S.isObject)(d)?I<2?v(d,u,I+1,r+"."):u[r]=(0,O.safeStringify)(d):u[r]=d}}function E(a){if(!a)return[];const u=[];return A(u,"",a),u}function A(a,u,I){I&&typeof I=="object"&&!Array.isArray(I)?Object.keys(I).forEach(C=>A(a,u?`${u}.${C}`:C,I[C])):a.push(u)}}),define(ee[118],te([0,1,7,19,56]),function(q,t,h,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function R(D){const l=await new Promise((y,v)=>{q(["applicationinsights"],y,v)});let f;return l.defaultClient?(f=new l.TelemetryClient(D),f.channel.setUseDiskRetryCaching(!0)):(l.setup(D).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),f=l.defaultClient),D.indexOf("AIF-")===0&&(f.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),f}class T{constructor(l,f,y){this._eventPrefix=l,this._defaultData=f,this._defaultData||(this._defaultData=Object.create(null)),typeof y=="function"?this._aiClient=y():this._aiClient=y,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient)),this._asyncAIClient.then(f=>{l(f)},f=>{(0,h.onUnexpectedError)(f),console.error(f)})}}log(l,f){!this._aiClient||(f=(0,O.mixin)(f,this._defaultData),f=(0,S.validateTelemetryData)(f),this._withAIClient(y=>y.trackEvent({name:this._eventPrefix+"/"+l,properties:f.properties,measurements:f.measurements})))}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(f=>{f.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=T}),define(ee[119],te([0,1,11,3]),function(q,t,h,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function S(R,T){const D=Object.create(null),l=(y,v)=>{const E=JSON.parse(y);D[v]=E};if(T){const y=[],v=await h.Promises.readdir(T);for(const A of v)try{(await h.Promises.stat((0,O.join)(T,A))).isDirectory()&&y.push(A)}catch{}const E=[];for(const A of y)(await h.Promises.readdir((0,O.join)(T,A))).filter(u=>u==="telemetry.json").length===1&&E.push(A);for(const A of E){const a=(await h.Promises.readFile((0,O.join)(T,A,"telemetry.json"))).toString();l(a,A)}}let f=(await h.Promises.readFile((0,O.join)(R,"telemetry-core.json"))).toString();return l(f,"vscode-core"),f=(await h.Promises.readFile((0,O.join)(R,"telemetry-extensions.json"))).toString(),l(f,"vscode-extensions"),JSON.stringify(D,null,4)}t.buildTelemetryMessage=S}),define(ee[43],te([0,1,72,3,36,4,11,130,131,8]),function(q,t,h,O,S,R,T,D,l,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class y extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=y;function v(o){const e=o.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function E(o){if(o instanceof y)return o;let e;return/end of central directory record signature not found/.test(o.message)&&(e="CorruptZip"),new y(e,o)}function A(o,e,i,n,s,c){const p=O.dirname(e),w=O.join(n,p);if(!w.startsWith(n))return Promise.reject(new Error(h.localize(0,null,e)));const x=O.join(n,e);let F;return c.onCancellationRequested(()=>{F&&F.destroy()}),Promise.resolve(T.Promises.mkdir(w,{recursive:!0})).then(()=>new Promise((U,B)=>{if(!c.isCancellationRequested)try{F=(0,S.createWriteStream)(x,{mode:i}),F.once("close",()=>U()),F.once("error",B),o.once("error",B),o.pipe(F)}catch(_){B(_)}}))}function a(o,e,i,n){let s=(0,R.createCancelablePromise)(()=>Promise.resolve()),c=0;return n.onCancellationRequested(()=>{s.cancel(),o.close()}),new Promise((p,w)=>{const x=new R.Sequencer,F=U=>{U.isCancellationRequested||(c++,o.readEntry())};o.once("error",w),o.once("close",()=>s.then(()=>{n.isCancellationRequested||o.entryCount===c?p():w(new y("Incomplete",new Error(h.localize(1,null,c,o.entryCount))))},w)),o.readEntry(),o.on("entry",U=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(U.fileName)){F(n);return}const B=U.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(B)){const ne=O.join(e,B);s=(0,R.createCancelablePromise)(se=>T.Promises.mkdir(ne,{recursive:!0}).then(()=>F(se)).then(void 0,w));return}const _=I(o,U),Q=v(U);s=(0,R.createCancelablePromise)(ne=>x.queue(()=>_.then(se=>A(se,B,Q,e,i,ne).then(()=>F(ne)))).then(null,w))})})}function u(o,e=!1){return new Promise((i,n)=>{(0,D.open)(o,e?{lazyEntries:!0}:void 0,(s,c)=>{s?n(E(s)):i((0,f.assertIsDefined)(c))})})}function I(o,e){return new Promise((i,n)=>{o.openReadStream(e,(s,c)=>{s?n(E(s)):i((0,f.assertIsDefined)(c))})})}function C(o,e){return new Promise((i,n)=>{const s=new l.ZipFile;e.forEach(p=>{p.contents?s.addBuffer(typeof p.contents=="string"?Buffer.from(p.contents,"utf8"):p.contents,p.path):p.localPath&&s.addFile(p.localPath,p.path)}),s.end();const c=(0,S.createWriteStream)(o);s.outputStream.pipe(c),s.outputStream.once("error",n),c.once("error",n),c.once("finish",()=>i(o))})}t.zip=C;function b(o,e,i={},n){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let c=u(o,!0);return i.overwrite&&(c=c.then(p=>T.Promises.rm(e).then(()=>p))),c.then(p=>a(p,e,{sourcePathRegex:s},n))}t.extract=b;function d(o,e){return u(o).then(i=>new Promise((n,s)=>{i.on("entry",c=>{c.fileName===e&&I(i,c).then(p=>n(p),p=>s(p))}),i.once("close",()=>s(new Error(h.localize(2,null,e))))}))}function r(o,e){return d(o,e).then(i=>new Promise((n,s)=>{const c=[];i.once("error",s),i.on("data",p=>c.push(p)),i.on("end",()=>n(Buffer.concat(c)))}))}t.buffer=r}),define(ee[120],te([0,1,43,77]),function(q,t,h,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function S(R){return(0,h.buffer)(R,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch(D){throw new Error((0,O.localize)(0,null))}})}t.getManifest=S}),define(ee[121],te([0,1,39,2,11,3,15,23,24,4,9,21,89,78,41,43,14,22,10,17,20,29,7]),function(q,t,h,O,S,R,T,D,l,f,y,v,E,A,a,u,I,C,b,d,r,o,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",s="extracting",c="deleting",p="renaming";let w=class extends O.Disposable{constructor(F,U,B,_,Q){super();this.beforeRemovingExtension=F,this.fileService=U,this.logService=B,this.environmentService=_,this.productService=Q,this._devSystemExtensionsPath=null,this.systemExtensionsPath=_.builtinExtensionsPath,this.extensionsPath=_.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new f.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(F){const U=[];(F===null||F===0)&&U.push(this.scanSystemExtensions().then(null,B=>Promise.reject(new D.ExtensionManagementError(this.joinErrors(B).message,i)))),(F===null||F===1)&&U.push(this.scanUserExtensions(!0).then(null,B=>Promise.reject(new D.ExtensionManagementError(this.joinErrors(B).message,n))));try{const B=await Promise.all(U);return(0,C.flatten)(B)}catch(B){throw this.joinErrors(B)}}async scanUserExtensions(F){this.logService.trace("Started scanning user extensions");let[U,B]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return B=B.filter(_=>!U[new l.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version).key()]),F&&(B=(0,l.groupByExtension)(B,Q=>Q.identifier).map(Q=>Q.sort((ne,se)=>h.rcompare(ne.manifest.version,se.manifest.version))[0])),this.logService.trace("Scanned user extensions:",B.length),B}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(F,U,B){const _=F.key(),Q=R.join(this.extensionsPath,`.${(0,o.generateUuid)()}`),ne=R.join(this.extensionsPath,_);try{await S.Promises.rm(ne)}catch(Z){try{await S.Promises.rm(ne)}catch(ce){}throw new D.ExtensionManagementError((0,A.localize)(0,null,ne,F.id),c)}await this.extractAtLocation(F,U,Q,B);let se=await this.scanExtension(y.URI.file(Q),1);if(!se)throw new Error((0,A.localize)(1,null,Q));await this.storeMetadata(se,{installedTimestamp:Date.now()});try{await this.rename(F,Q,ne,Date.now()+2*60*1e3),this.logService.info("Renamed to",ne)}catch(Z){try{await S.Promises.rm(Q)}catch(ce){}if(Z.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.logService.info(`Rename failed because of ${(0,e.getErrorMessage)(Z)}. Deleted from extracted location`,Q),Z}try{se=await this.scanExtension(y.URI.file(ne),1)}catch(Z){}if(se)return se;throw new Error((0,A.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(F,U){return this.setMetadata(F,U),await this.storeMetadata(F,{...U,installedTimestamp:F.installedTimestamp}),F}async storeMetadata(F,U){U.isMachineScoped=U.isMachineScoped||void 0,U.isBuiltin=U.isBuiltin||void 0,U.installedTimestamp=U.installedTimestamp||void 0;const B=R.join(F.location.fsPath,"package.json"),_=await S.Promises.readFile(B,"utf8"),{manifest:Q}=await this.parseManifest(_);return Q.__metadata=U,await S.Promises.writeFile(B,JSON.stringify(Q,null,"	")),F}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...F){const U=F.map(B=>new l.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version));await this.withUninstalledExtensions(B=>{U.forEach(_=>B[_.key()]=!0)})}async setInstalled(F){await this.withUninstalledExtensions(_=>delete _[F.key()]);const B=(await this.scanExtensions(1)).find(_=>new l.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version).equals(F))||null;return B?(await this.storeMetadata(B,{installedTimestamp:Date.now()}),this.scanExtension(B.location,1)):null}async withUninstalledExtensions(F){return this.uninstalledFileLimiter.queue(async()=>{let U;try{U=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(_){if(_.code!=="ENOENT")throw _}let B={};if(U)try{B=JSON.parse(U)}catch(_){}return F&&(F(B),Object.keys(B).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(B)):await S.Promises.rm(this.uninstalledPath)),B})}async removeExtension(F,U){this.logService.trace(`Deleting ${U} extension from disk`,F.identifier.id,F.location.fsPath),await S.Promises.rm(F.location.fsPath),this.logService.info("Deleted from disk",F.identifier.id,F.location.fsPath)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.withUninstalledExtensions(U=>delete U[new l.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()])}async extractAtLocation(F,U,B,_){this.logService.trace(`Started extracting the extension from ${U} to ${B}`);try{await S.Promises.rm(B)}catch(Q){throw new D.ExtensionManagementError(this.joinErrors(Q).message,c)}try{await(0,u.extract)(U,B,{sourcePath:"extension",overwrite:!0},_),this.logService.info(`Extracted extension to ${B}:`,F.id)}catch(Q){try{await S.Promises.rm(B)}catch(ne){}throw new D.ExtensionManagementError(Q.message,Q instanceof u.ExtractError&&Q.type?Q.type:s)}}async rename(F,U,B,_){try{await S.Promises.rename(U,B)}catch(Q){if(I.isWindows&&Q&&Q.code==="EPERM"&&Date.now()<_)return this.logService.info(`Failed renaming ${U} to ${B} with 'EPERM' error. Trying again...`,F.id),this.rename(F,U,B,_);throw new D.ExtensionManagementError(Q.message||(0,A.localize)(3,null,U,B),Q.code||p)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const F=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return F;const U=this.scanDevSystemExtensions(),[B,_]=await Promise.all([F,U]);return[...B,..._]}async scanExtensionsInDir(F,U){const B=new f.Limiter(10),_=await this.fileService.resolve(y.URI.file(F));return _.children?(await Promise.all(_.children.filter(ne=>ne.isDirectory).map(ne=>B.queue(async()=>U===1&&(0,r.basename)(ne.resource).indexOf(".")===0?null:this.scanExtension(ne.resource,U))))).filter(ne=>ne&&ne.identifier):[]}async scanExtension(F,U){try{const B=await this.fileService.resolve(F);if(B.children){const{manifest:_,metadata:Q}=await this.readManifest(F.fsPath),ne=B.children.find(({name:H})=>/^readme(\.txt|\.md|)$/i.test(H))?.resource,se=B.children.find(({name:H})=>/^changelog(\.txt|\.md|)$/i.test(H))?.resource,Z={id:(0,l.getGalleryExtensionId)(_.publisher,_.name)},ce={type:U,identifier:Z,manifest:_,location:F,readmeUrl:ne,changelogUrl:se,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:U===0};return Q&&(this.setMetadata(ce,Q),ce.installedTimestamp=Q.installedTimestamp),ce}}catch(B){U!==0&&this.logService.trace(B)}return null}async scanDefaultSystemExtensions(){const F=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",F.length),F}async scanDevSystemExtensions(){const F=this.getDevSystemExtensionsList();if(F.length){const U=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",U.length),U.filter(B=>F.some(_=>(0,l.areSameExtensions)(B.identifier,{id:_})))}else return[]}setMetadata(F,U){F.publisherDisplayName=U.publisherDisplayName||null,F.publisherId=U.publisherId||null,F.identifier.uuid=U.id,F.isMachineScoped=!!U.isMachineScoped,F.isBuiltin=F.type===0||!!U.isBuiltin}async removeUninstalledExtensions(){const F=await this.getUninstalledExtensions(),U=await this.scanAllUserExtensions(),B=new Set;for(const ne of U)F[new l.ExtensionIdentifierWithVersion(ne.identifier,ne.manifest.version).key()]||B.add(ne.identifier.id.toLowerCase());const _=(0,l.groupByExtension)(U,ne=>ne.identifier);await f.Promises.settled(_.map(async ne=>{const se=ne.sort((Z,ce)=>h.rcompare(Z.manifest.version,ce.manifest.version))[0];B.has(se.identifier.id.toLowerCase())||await this.beforeRemovingExtension(se)}));const Q=U.filter(ne=>F[new l.ExtensionIdentifierWithVersion(ne.identifier,ne.manifest.version).key()]);await f.Promises.settled(Q.map(ne=>this.removeUninstalledExtension(ne)))}async removeOutdatedExtensions(){const F=await this.scanAllUserExtensions(),U=[],B=(0,l.groupByExtension)(F,_=>_.identifier);U.push(...(0,C.flatten)(B.map(_=>_.sort((Q,ne)=>h.rcompare(Q.manifest.version,ne.manifest.version)).slice(1)))),await f.Promises.settled(U.map(_=>this.removeExtension(_,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(F=>F.name)}joinErrors(F){const U=Array.isArray(F)?F:[F];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((B,_)=>new Error(`${B.message}${B.message?",":""}${_ instanceof Error?_.message:_}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(b.FileAccess.asFileUri("",q).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(F){const U=[S.Promises.readFile(R.join(F,"package.json"),"utf8").then(ne=>this.parseManifest(ne)),S.Promises.readFile(R.join(F,"package.nls.json"),"utf8").then(void 0,ne=>ne.code!=="ENOENT"?Promise.reject(ne):"{}").then(ne=>JSON.parse(ne))],[{manifest:B,metadata:_},Q]=await Promise.all(U);return{manifest:(0,E.localizeManifest)(B,Q),metadata:_}}parseManifest(F){return new Promise((U,B)=>{try{const _=JSON.parse(F),Q=_.__metadata||null;U({manifest:_,metadata:Q})}catch(_){B(new Error((0,A.localize)(4,null)))}})}};w=fe([he(1,d.IFileService),he(2,T.ILogService),he(3,v.INativeEnvironmentService),he(4,a.IProductService)],w),t.ExtensionsScanner=w}),define(ee[122],te([0,1,76,3,11,2,43,23,24,21,4,12,39,9,40,14,15,97,28,42,49,20,29,95,13,10,26,120,101,121,102,103,17,7,8]),function(q,t,h,O,S,R,T,D,l,f,y,v,E,A,a,u,I,C,b,d,r,o,e,i,n,s,c,p,w,x,F,U,B,_,Q){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const ne="unsetUninstalled",se="downloading",Z="validating",ce="local",H="unknown";let W=class extends R.Disposable{constructor(m,N,z,V,$,K,Y){super();this.environmentService=m,this.galleryService=N,this.logService=z,this.downloadService=V,this.telemetryService=$,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new v.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new v.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new v.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new v.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const ie=this._register(K.createInstance(F.ExtensionsLifecycle));this.extensionsScanner=this._register(K.createInstance(x.ExtensionsScanner,ae=>ie.postUninstall(ae))),this.manifestCache=this._register(new C.ExtensionsManifestCache(m,this)),this.extensionsDownloader=this._register(K.createInstance(w.ExtensionsDownloader));const re=this._register(new U.ExtensionsWatcher(this,Y,m,z));this._register(re.onDidChangeExtensionsByAnotherSource(({added:ae,removed:me})=>{ae.length&&this._onDidInstallExtensions.fire(ae.map(pe=>({identifier:pe.identifier,operation:0,local:pe}))),me.forEach(pe=>this._onDidUninstallExtension.fire({identifier:pe}))})),this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(ae=>ae.cancel()),this.uninstallingExtensions.forEach(ae=>ae.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(m){this.logService.trace("ExtensionManagementService#zip",m.identifier.id);const N=await this.collectFiles(m),z=await(0,T.zip)((0,o.joinPath)(this.environmentService.tmpDir,(0,e.generateUuid)()).fsPath,N);return A.URI.file(z)}async unzip(m){return this.logService.trace("ExtensionManagementService#unzip",m.toString()),(await this.install(m)).identifier}async getManifest(m){const N=await this.downloadVsix(m),z=O.resolve(N.fsPath);return(0,p.getManifest)(z)}async collectFiles(m){const N=async V=>{let $=await S.Promises.readdir(V);$=$.map(ie=>O.join(V,ie));const K=await Promise.all($.map(ie=>S.Promises.stat(ie)));let Y=Promise.resolve([]);return K.forEach((ie,re)=>{const ae=$[re];ie.isFile()&&(Y=Y.then(me=>[...me,ae])),ie.isDirectory()&&(Y=Y.then(me=>N(ae).then(pe=>[...me,...pe])))}),Y};return(await N(m.location.fsPath)).map(V=>({path:`extension/${O.relative(m.location.fsPath,V)}`,localPath:V}))}async canInstall(m){return!0}async install(m,N={}){this.logService.trace("ExtensionManagementService#install",m.toString());const z=await this.downloadVsix(m),V=O.resolve(z.fsPath),$=await(0,p.getManifest)(V);if($.engines&&$.engines.vscode&&!(0,r.isEngineValid)($.engines.vscode,a.default.version,a.default.date))throw new Error(h.localize(0,null,(0,l.getGalleryExtensionId)($.publisher,$.name),a.default.version));return this.installExtension($,V,N)}async installFromGallery(m,N={}){if(!this.galleryService.isEnabled())throw new Error(h.localize(1,null));try{m=await this.checkAndGetCompatibleVersion(m)}catch(V){throw this.logService.error((0,_.getErrorMessage)(V)),P(this.telemetryService,"extensionGallery:install",(0,l.getGalleryExtensionTelemetryData)(m),void 0,V),V}const z=await this.galleryService.getManifest(m,c.CancellationToken.None);if(z===null){const V=new D.ExtensionManagementError(`Missing manifest for extension ${m.identifier.id}`,Z);throw this.logService.error("Failed to install extension:",m.identifier.id,V.message),P(this.telemetryService,"extensionGallery:install",(0,l.getGalleryExtensionTelemetryData)(m),void 0,V),V}return this.installExtension(z,m,N)}async downloadVsix(m){if(m.scheme===s.Schemas.file)return m;if(!this.downloadService)throw new Error("Download service is not available");const N=(0,o.joinPath)(this.environmentService.tmpDir,(0,e.generateUuid)());return await this.downloadService.download(m,N),N}createInstallVSIXExtensionTask(m,N,z){return new k(m,N,z,this.galleryService,this.extensionsScanner,this.logService)}createInstallFromGalleryExtensionTask(m,N){return new L(m,N,this.extensionsDownloader,this.telemetryService,this.extensionsScanner,this.logService)}createInstallExtensionTask(m,N,z){return(0,Q.isString)(N)?this.createInstallVSIXExtensionTask(m,N,z):this.createInstallFromGalleryExtensionTask(N,z)}async installExtension(m,N,z){if(!(0,Q.isString)(N)){let ie=this.installingExtensions.get(new l.ExtensionIdentifierWithVersion(N.identifier,N.version).key());if(ie)return this.logService.info("Extensions is already requested to install",N.identifier.id),ie.waitUntilTaskIsFinished();z={...z,installOnlyNewlyAddedFromExtensionPack:!0}}const V=[],$=[],K=this.createInstallExtensionTask(m,N,z);(0,Q.isString)(N)||this.installingExtensions.set(new l.ExtensionIdentifierWithVersion(K.identifier,m.version).key(),K),this._onInstallExtension.fire({identifier:K.identifier,source:N}),this.logService.info("Installing extension:",K.identifier.id),V.push({task:K,manifest:m});let Y=!1;try{if(z.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",K.identifier.id);else try{const re=await this.getAllDepsAndPackExtensionsToInstall(K.identifier,m,!!z.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:ae,manifest:me}of re)if(Y=Y||!!me.extensionDependencies?.some(pe=>(0,l.areSameExtensions)({id:pe},K.identifier)),this.installingExtensions.has(new l.ExtensionIdentifierWithVersion(ae.identifier,ae.version).key()))this.logService.info("Extension is already requested to install",ae.identifier.id);else{const pe=this.createInstallExtensionTask(me,ae,{...z,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new l.ExtensionIdentifierWithVersion(pe.identifier,me.version).key(),pe),this._onInstallExtension.fire({identifier:pe.identifier,source:ae}),this.logService.info("Installing extension:",pe.identifier.id),V.push({task:pe,manifest:me})}}catch(re){throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",K.identifier.id),this.logService.error(re),re}const ie=V.reduce((re,{task:ae,manifest:me})=>(re.set(ae.identifier.id.toLowerCase(),{task:ae,manifest:me}),re),new Map);for(;ie.size;){let re;const ae=[...ie.values()].filter(({manifest:de})=>!de.extensionDependencies?.some(ve=>ie.has(ve.toLowerCase())));ae.length?re=ie.size===1?ae:ae.filter(({task:de})=>!(de===K&&!Y)):(this.logService.info("Found extensions with circular dependencies",ae.map(({task:de})=>de.identifier.id)),re=[...ie.values()]);const pe=(await Promise.allSettled(re.map(async({task:de})=>{try{const ve=await de.run();$.push({local:ve,identifier:de.identifier,operation:de.operation,source:de.source})}catch(ve){throw this.logService.error("Error while installing the extension:",de.identifier.id),this.logService.error(ve),ve}finally{ie.delete(de.identifier.id.toLowerCase())}}))).reduce((de,ve)=>(ve.status==="rejected"&&de.push(ve.reason),de),[]);if(pe.length)throw J(pe)}return $.forEach(({identifier:re})=>this.logService.info("Extensions installed successfully:",re.id)),this._onDidInstallExtensions.fire($),$.filter(({identifier:re})=>(0,l.areSameExtensions)(re,K.identifier))[0].local}catch(ie){if(V.forEach(({task:re})=>re.cancel()),$.length)try{await this.extensionsScanner.setUninstalled(...$.map(({local:re})=>re)),this.logService.info("Rollback: Uninstalled extensions",...$.map(({identifier:re})=>re.id))}catch(re){this.logService.warn("Error while rolling back extensions",(0,_.getErrorMessage)(re))}throw this.logService.error("Failed to install extension:",K.identifier.id,(0,_.getErrorMessage)(ie)),this._onDidInstallExtensions.fire(V.map(({task:re})=>({identifier:re.identifier,operation:1,source:re.source}))),ie instanceof Error&&(ie.name=ie&&ie.code?ie.code:H),ie}finally{for(const{task:ie,manifest:re}of V)if(!(0,Q.isString)(ie.source)){const ae=new l.ExtensionIdentifierWithVersion(ie.identifier,re.version).key();this.installingExtensions.delete(ae)||this.logService.warn("Installation task is not found in the cache",ae)}}}async getAllDepsAndPackExtensionsToInstall(m,N,z){if(!this.galleryService.isEnabled())return[];let V=await this.getInstalled();const $=[m,...V.map(ie=>ie.identifier)],K=[],Y=async(ie,re)=>{const ae=re.extensionDependencies||[];if(re.extensionPack){const me=z?V.find(pe=>(0,l.areSameExtensions)(pe.identifier,ie)):void 0;for(const pe of re.extensionPack)me&&me.manifest.extensionPack&&me.manifest.extensionPack.some(de=>(0,l.areSameExtensions)({id:de},{id:pe}))||ae.every(de=>!(0,l.areSameExtensions)({id:de},{id:pe}))&&ae.push(pe)}if(ae.length){const me=[...$,...K.map(de=>de.gallery.identifier)],pe=ae.filter(de=>me.every(ve=>!(0,l.areSameExtensions)(ve,{id:de})));if(pe.length){const de=await this.galleryService.query({names:pe,pageSize:ae.length},c.CancellationToken.None);for(const ve of de.firstPage){if(me.find(Le=>(0,l.areSameExtensions)(Le,ve.identifier)))continue;const De=await this.checkAndGetCompatibleVersion(ve);if(!await this.canInstall(De)){this.logService.info("Skipping the extension as it cannot be installed",De.identifier.id);continue}const we=await this.galleryService.getManifest(De,c.CancellationToken.None);if(we===null)throw new D.ExtensionManagementError(`Missing manifest for extension ${De.identifier.id}`,Z);K.push({gallery:De,manifest:we}),await Y(De.identifier,we)}}}};return await Y(m,N),V=await this.getInstalled(),K.filter(ie=>!V.some(re=>(0,l.areSameExtensions)(re.identifier,ie.gallery.identifier)))}async checkAndGetCompatibleVersion(m){if(await this.isMalicious(m))throw new D.ExtensionManagementError(h.localize(2,null,m.identifier.id),D.INSTALL_ERROR_MALICIOUS);const N=await this.galleryService.getCompatibleExtension(m);if(!N)throw new D.ExtensionManagementError(h.localize(3,null,m.identifier.id,a.default.version),D.INSTALL_ERROR_INCOMPATIBLE);return N}async reinstallFromGallery(m){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",m.identifier.id),!this.galleryService.isEnabled())throw new Error(h.localize(4,null));const N=await this.findGalleryExtension(m);if(!N)throw new Error(h.localize(5,null));await this.extensionsScanner.setUninstalled(m);try{await this.extensionsScanner.removeUninstalledExtension(m)}catch(z){throw new Error(h.localize(6,null,(0,b.toErrorMessage)(z)))}await this.installFromGallery(N)}async isMalicious(m){const N=await this.getExtensionsReport();return(0,l.getMaliciousExtensionsSet)(N).has(m.identifier.id)}async uninstall(m,N={}){this.logService.trace("ExtensionManagementService#uninstall",m.identifier.id);const z=await this.getInstalled(1),V=z.find($=>(0,l.areSameExtensions)($.identifier,m.identifier));if(!V)throw new Error(h.localize(7,null,m.manifest.displayName||m.manifest.name));try{await this.checkForDependenciesAndUninstall(V,z,N)}catch($){throw J($)}}async updateMetadata(m,N){return this.logService.trace("ExtensionManagementService#updateMetadata",m.identifier.id),m=await this.extensionsScanner.saveMetadataForLocalExtension(m,{...m.manifest.__metadata||{},...N}),this.manifestCache.invalidate(),m}async updateExtensionScope(m,N){return this.logService.trace("ExtensionManagementService#updateExtensionScope",m.identifier.id),m=await this.extensionsScanner.saveMetadataForLocalExtension(m,{...m.manifest.__metadata||{},isMachineScoped:N}),this.manifestCache.invalidate(),m}async findGalleryExtension(m){if(m.identifier.uuid){const N=await this.findGalleryExtensionById(m.identifier.uuid);return N||this.findGalleryExtensionByName(m.identifier.id)}return this.findGalleryExtensionByName(m.identifier.id)}async findGalleryExtensionById(m){return(await this.galleryService.query({ids:[m],pageSize:1},c.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(m){return(await this.galleryService.query({names:[m],pageSize:1},c.CancellationToken.None)).firstPage[0]}async checkForDependenciesAndUninstall(m,N,z){try{await this.preUninstallExtension(m);const V=z.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(m,N);await this.uninstallExtensions(m,V,N,z)}catch(V){throw await this.postUninstallExtension(m,new D.ExtensionManagementError(V instanceof Error?V.message:V,ce)),V}await this.postUninstallExtension(m)}async uninstallExtensions(m,N,z,V){const $=[m,...N];if(!V.donotCheckDependents)for(const K of $)this.checkForDependents(K,$,z,m);await y.Promises.settled([this.uninstallExtension(m),...N.map(K=>this.doUninstall(K))])}checkForDependents(m,N,z,V){const $=this.getDependents(m,z);if($.length){const K=$.filter(Y=>N.indexOf(Y)===-1);if(K.length)throw new Error(this.getDependentsErrorMessage(m,K,V))}}getDependentsErrorMessage(m,N,z){return z===m?N.length===1?h.localize(8,null,z.manifest.displayName||z.manifest.name,N[0].manifest.displayName||N[0].manifest.name):N.length===2?h.localize(9,null,z.manifest.displayName||z.manifest.name,N[0].manifest.displayName||N[0].manifest.name,N[1].manifest.displayName||N[1].manifest.name):h.localize(10,null,z.manifest.displayName||z.manifest.name,N[0].manifest.displayName||N[0].manifest.name,N[1].manifest.displayName||N[1].manifest.name):N.length===1?h.localize(11,null,z.manifest.displayName||z.manifest.name,m.manifest.displayName||m.manifest.name,N[0].manifest.displayName||N[0].manifest.name):N.length===2?h.localize(12,null,z.manifest.displayName||z.manifest.name,m.manifest.displayName||m.manifest.name,N[0].manifest.displayName||N[0].manifest.name,N[1].manifest.displayName||N[1].manifest.name):h.localize(13,null,z.manifest.displayName||z.manifest.name,m.manifest.displayName||m.manifest.name,N[0].manifest.displayName||N[0].manifest.name,N[1].manifest.displayName||N[1].manifest.name)}getAllPackExtensionsToUninstall(m,N,z=[]){if(z.indexOf(m)!==-1)return[];z.push(m);const V=m.manifest.extensionPack?m.manifest.extensionPack:[];if(V.length){const $=N.filter(Y=>!Y.isBuiltin&&V.some(ie=>(0,l.areSameExtensions)({id:ie},Y.identifier))),K=[];for(const Y of $)K.push(...this.getAllPackExtensionsToUninstall(Y,N,z));return[...$,...K]}return[]}getDependents(m,N){return N.filter(z=>z.manifest.extensionDependencies&&z.manifest.extensionDependencies.some(V=>(0,l.areSameExtensions)({id:V},m.identifier)))}async doUninstall(m){try{await this.preUninstallExtension(m),await this.uninstallExtension(m)}catch(N){throw await this.postUninstallExtension(m,new D.ExtensionManagementError(N instanceof Error?N.message:N,ce)),N}await this.postUninstallExtension(m)}async preUninstallExtension(m){if(!await S.Promises.exists(m.location.fsPath))throw new Error(h.localize(14,null));this.logService.info("Uninstalling extension:",m.identifier.id),this._onUninstallExtension.fire(m.identifier)}async uninstallExtension(m){let N=this.uninstallingExtensions.get(m.identifier.id);return N||(N=(0,y.createCancelablePromise)(async()=>{const z=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...z.filter(V=>(0,l.areSameExtensions)(V.identifier,m.identifier)))}),this.uninstallingExtensions.set(m.identifier.id,N),N.finally(()=>this.uninstallingExtensions.delete(m.identifier.id))),N}async postUninstallExtension(m,N){if(N)this.logService.error("Failed to uninstall extension:",m.identifier.id,N.message);else if(this.logService.info("Successfully uninstalled extension:",m.identifier.id),m.identifier.uuid)try{await this.galleryService.reportStatistic(m.manifest.publisher,m.manifest.name,m.manifest.version,"uninstall")}catch(V){}P(this.telemetryService,"extensionGallery:uninstall",(0,l.getLocalExtensionTelemetryData)(m),void 0,N);const z=N?N instanceof D.ExtensionManagementError?N.code:H:void 0;this._onDidUninstallExtension.fire({identifier:m.identifier,error:z})}getInstalled(m=null){return this.extensionsScanner.scanExtensions(m)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}getExtensionsReport(){const m=new Date().getTime();return(!this.reportedExtensions||m-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=m),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const m=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${m.length} reported extensions from service`),m}catch(m){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};W=fe([he(0,f.INativeEnvironmentService),he(1,D.IExtensionGalleryService),he(2,I.ILogService),he(3,(0,n.optional)(i.IDownloadService)),he(4,d.ITelemetryService),he(5,n.IInstantiationService),he(6,B.IFileService)],W),t.ExtensionManagementService=W;function J(M){const m=Array.isArray(M)?M:[M];return m.length===1?m[0]instanceof Error?m[0]:new Error(m[0]):m.reduce((N,z)=>new Error(`${N.message}${N.message?",":""}${z instanceof Error?z.message:z}`),new Error(""))}function P(M,m,N,z,V){const $=V?V instanceof D.ExtensionManagementError?V.code:H:void 0;M.publicLogError(m,{...N,success:!V,duration:z,errorcode:$})}class g{constructor(m,N,z,V){this.identifier=m,this.source=N,this.extensionsScanner=z,this.logService=V,this.barrier=new y.Barrier,this._operation=1}get operation(){return this._operation}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,y.createCancelablePromise)(m=>this.install(m))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,y.createCancelablePromise)(m=>new Promise((N,z)=>{const V=m.onCancellationRequested(()=>{V.dispose(),z((0,_.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}async installExtension(m,N){try{const z=await this.unsetUninstalledAndGetLocal(m.identifierWithVersion);if(z)return m.metadata?this.extensionsScanner.saveMetadataForLocalExtension(z,m.metadata):z}catch(z){throw u.isMacintosh?new D.ExtensionManagementError(h.localize(15,null),ne):new D.ExtensionManagementError(h.localize(16,null),ne)}return this.extract(m,N)}async unsetUninstalledAndGetLocal(m){if(!await this.isUninstalled(m))return null;this.logService.trace("Removing the extension from uninstalled list:",m.id);const z=await this.extensionsScanner.setInstalled(m);return this.logService.info("Removed the extension from uninstalled list:",m.id),z}async isUninstalled(m){return!!(await this.extensionsScanner.getUninstalledExtensions())[m.key()]}async extract({zipPath:m,identifierWithVersion:N,metadata:z},V){let $=await this.extensionsScanner.extractUserExtension(N,m,V);return this.logService.info("Extracting completed.",N.id),z&&($=await this.extensionsScanner.saveMetadataForLocalExtension($,z)),$}}class L extends g{constructor(m,N,z,V,$,K){super(m.identifier,m,$,K);this.gallery=m,this.options=N,this.extensionsDownloader=z,this.telemetryService=V}install(m){return this.installGalleryExtension(this.gallery,this.options,m)}async installGalleryExtension(m,N,z){const V=new Date().getTime();try{const K=(await this.extensionsScanner.scanExtensions(null)).find(re=>(0,l.areSameExtensions)(re.identifier,m.identifier));K&&(this._operation=2);const Y=await this.downloadInstallableExtension(m,this._operation);Y.metadata.isMachineScoped=N.isMachineScoped||K?.isMachineScoped,Y.metadata.isBuiltin=N.isBuiltin||K?.isBuiltin;const ie=await this.installExtension(Y,z);K&&E.neq(K.manifest.version,m.version)&&await this.extensionsScanner.setUninstalled(K);try{await this.extensionsDownloader.delete(A.URI.file(Y.zipPath))}catch(re){}return P(this.telemetryService,this.getTelemetryEvent(this._operation),(0,l.getGalleryExtensionTelemetryData)(m),new Date().getTime()-V,void 0),ie}catch($){throw P(this.telemetryService,this.getTelemetryEvent(this._operation),(0,l.getGalleryExtensionTelemetryData)(m),new Date().getTime()-V,$),$}}getTelemetryEvent(m){return m===2?"extensionGallery:update":"extensionGallery:install"}async downloadInstallableExtension(m,N){const z={id:m.identifier.uuid,publisherId:m.publisherId,publisherDisplayName:m.publisherDisplayName};let V;try{this.logService.trace("Started downloading extension:",m.identifier.id),V=(await this.extensionsDownloader.downloadExtension(m,N)).fsPath,this.logService.info("Downloaded extension:",m.identifier.id,V)}catch($){throw new D.ExtensionManagementError(J($).message,se)}try{const $=await(0,p.getManifest)(V);return{zipPath:V,identifierWithVersion:new l.ExtensionIdentifierWithVersion(m.identifier,$.version),metadata:z}}catch($){throw new D.ExtensionManagementError(J($).message,Z)}}}class k extends g{constructor(m,N,z,V,$,K){super({id:(0,l.getGalleryExtensionId)(m.publisher,m.name)},N,$,K);this.manifest=m,this.zipPath=N,this.options=z,this.galleryService=V}async install(m){const N=new l.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),V=(await this.extensionsScanner.scanExtensions(1)).find(K=>(0,l.areSameExtensions)(this.identifier,K.identifier)),$=await this.getMetadata(this.identifier.id,m);if(V)if($.isMachineScoped=this.options.isMachineScoped||V.isMachineScoped,$.isBuiltin=this.options.isBuiltin||V.isBuiltin,this._operation=2,N.equals(new l.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version)))try{await this.extensionsScanner.removeExtension(V,"existing")}catch(K){throw new Error(h.localize(17,null,this.manifest.displayName||this.manifest.name))}else E.gt(V.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(V);else{const K=await this.unsetUninstalledAndGetLocal(N);if(K)try{await this.extensionsScanner.removeExtension(K,"existing")}catch(Y){throw new Error(h.localize(18,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:this.zipPath,identifierWithVersion:N,metadata:$},m)}async getMetadata(m,N){try{const z=(await this.galleryService.query({names:[m],pageSize:1},N)).firstPage[0];if(z)return{id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId}}catch(z){}return{}}}}),define(ee[123],te([0,1,132,112,2,8,7,111,27,15,16,21,98]),function(q,t,h,O,S,R,T,D,l,f,y,v,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let A=class extends S.Disposable{constructor(u,I,C){super();this.environmentService=I,this.logService=C,this.configure(u.getValue()),this._register(u.onDidChangeConfiguration(()=>this.configure(u.getValue()),this))}configure(u){this.proxyUrl=u.http&&u.http.proxy,this.strictSSL=!!(u.http&&u.http.proxyStrictSSL),this.authorization=u.http&&u.http.proxyAuthorization}async request(u,I){this.logService.trace("RequestService#request",u.url);const{proxyUrl:C,strictSSL:b}=this,d={...process.env,...await(0,E.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},r=u.agent?u.agent:await(0,D.getProxyAgent)(u.url||"",d,{proxyUrl:C,strictSSL:b});return u.agent=r,u.strictSSL=b,this.authorization&&(u.headers={...u.headers||{},"Proxy-Authorization":this.authorization}),this._request(u,I)}async getNodeRequest(u){return((0,O.parse)(u.url).protocol==="https:"?await new Promise((b,d)=>{q(["https"],b,d)}):await new Promise((b,d)=>{q(["http"],b,d)})).request}_request(u,I){return new Promise(async(C,b)=>{let d;const r=(0,O.parse)(u.url),o=u.getRawRequest?u.getRawRequest(u):await this.getNodeRequest(u),e={hostname:r.hostname,port:r.port?parseInt(r.port):r.protocol==="https:"?443:80,protocol:r.protocol,path:r.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,R.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(e.auth=u.user+":"+u.password),d=o(e,i=>{const n=(0,R.isNumber)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...u,url:i.headers.location,followRedirects:n-1},I).then(C,b);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,h.createGunzip)())),C({res:i,stream:(0,y.streamToBufferReadableStream)(s)})}}),d.on("error",b),u.timeout&&d.setTimeout(u.timeout),u.data&&typeof u.data=="string"&&d.write(u.data),d.end(),I.onCancellationRequested(()=>{d.abort(),b((0,T.canceled)())})})}async resolveProxy(u){}};A=fe([he(0,l.IConfigurationService),he(1,v.INativeEnvironmentService),he(2,f.ILogService)],A),t.RequestService=A}),define(ee[133],te([0,1,31,36,134,11,3,4,40,52,50,100,21,88,23,122,116,42,56,117,115,55,123,27,110,118,15,10,105,119,106,17,107,2,41,96,9,104,53,7,28,16,33]),function(q,t,h,O,S,R,T,D,l,f,y,v,E,A,a,u,I,C,b,d,r,o,e,i,n,s,c,p,w,x,F,U,B,_,Q,ne,se,Z,ce,H,W,J,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class g extends _.Disposable{constructor(M){super();this.argv=M,(0,S.gracefulify)(O),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[M,m]=await this.initServices();return M.invokeFunction(async N=>{const z=N.get(c.ILogService),V=N.get(U.IFileService),$=N.get(E.INativeEnvironmentService),K=N.get(a.IExtensionManagementCLIService);return z.info("CLI main",this.argv),this.registerErrorHandler(z),await this.doRun($,K,V),(0,D.raceTimeout)((0,b.combinedAppender)(...m).flush(),1e3)})}async initServices(){const M=new f.ServiceCollection,m={_serviceBrand:void 0,...l.default};M.set(Q.IProductService,m);const N=new A.NativeEnvironmentService(this.argv,m);M.set(E.INativeEnvironmentService,N),await Promise.all([N.appSettingsHome.fsPath,N.extensionsPath].map(ae=>ae?R.Promises.mkdir(ae,{recursive:!0}):void 0));const z=(0,c.getLogLevel)(N),V=[];V.push(new w.SpdLogLogger("cli",(0,T.join)(N.logsPath,"cli.log"),!0,z)),z===c.LogLevel.Trace&&V.push(new c.ConsoleLogger(z));const $=this._register(new c.MultiplexLogService(V));M.set(c.ILogService,$);const K=this._register(new F.FileService($));M.set(U.IFileService,K);const Y=this._register(new B.DiskFileSystemProvider($));K.registerProvider(p.Schemas.file,Y);const ie=this._register(new n.ConfigurationService(N.settingsResource,K));M.set(i.IConfigurationService,ie),await ie.initialize(),M.set(o.IRequestService,new y.SyncDescriptor(e.RequestService)),M.set(a.IExtensionManagementService,new y.SyncDescriptor(u.ExtensionManagementService)),M.set(a.IExtensionGalleryService,new y.SyncDescriptor(I.ExtensionGalleryService)),M.set(a.IExtensionManagementCLIService,new y.SyncDescriptor(ne.ExtensionManagementCLIService)),M.set(ce.ILocalizationsService,new y.SyncDescriptor(Z.LocalizationsService));const re=[];if(N.isBuilt&&!N.isExtensionDevelopment&&!N.disableTelemetry&&m.enableTelemetry){m.aiConfig&&m.aiConfig.asimovKey&&re.push(new s.AppInsightsAppender("monacoworkbench",null,m.aiConfig.asimovKey));const{appRoot:ae,extensionsPath:me,installSourcePath:pe}=N,de={appender:(0,b.combinedAppender)(...re),sendErrorTelemetry:!1,commonProperties:(async()=>{let ve;try{const De=await R.Promises.readFile((0,T.join)(N.userDataPath,"storage.json"));ve=JSON.parse(De.toString())[C.machineIdKey]}catch(De){De.code!=="ENOENT"&&$.error(De)}return(0,r.resolveCommonProperties)(K,(0,h.release)(),(0,h.hostname)(),process.arch,m.commit,m.version,ve,m.msftInternalDomains,pe)})(),piiPaths:[ae,me]};M.set(C.ITelemetryService,new y.SyncDescriptor(d.TelemetryService,[de]))}else M.set(C.ITelemetryService,b.NullTelemetryService);return[new v.InstantiationService(M),re]}registerErrorHandler(M){(0,H.setUnexpectedErrorHandler)(m=>{const N=(0,W.toErrorMessage)(m,!0);!N||M.error(`[uncaught exception in CLI]: ${N}`)})}async doRun(M,m,N){if(this.argv["install-source"])return this.setInstallSource(M,N,this.argv["install-source"]);if(this.argv["list-extensions"])return m.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return m.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return m.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return m.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,x.buildTelemetryMessage)(M.appRoot,M.extensionsPath))}asExtensionIdOrVSIX(M){return M.map(m=>/\.vsix$/i.test(m)?se.URI.file((0,T.isAbsolute)(m)?m:(0,T.join)((0,P.cwd)(),m)):m)}async setInstallSource(M,m,N){await m.writeFile(se.URI.file(M.installSourcePath),J.VSBuffer.fromString(N.slice(0,30)))}}async function L(k){const M=new g(k);try{await M.run()}finally{M.dispose()}}t.main=L})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/87d692b7bf1eb5a663b3e62620a6e7e436e1838c/core/vs/code/node/cliProcessMain.js.map
